%### REDIO.SL

(GLOBAL
 '(!*FORMFEED ORIG!* RCCNUMS!* BTIME!* LNNUM!* MAXLN!* TITLE!*
   PGNUM!*))

(DE INITIO NIL
 (PROG NIL
    (SETQ !*FORMFEED T)         % Print form-feeds
    (SETQ ORIG!* 0)             % Left margin
    (LINELENGTH 78)             % Right margin
    (SETQ MAXLN!* 46)           % Lines per page
    (SETQ TITLE!* NIL)          % Title on page
    (SETQ LNNUM!* 0)            % Line number
    (SETQ PGNUM!* 1)))          % Page number

(DS LPOSN () LNNUM!*)

(INITIO)

(DS CLOCK () (TIME))

(DE SETPGLN (P L)
 (PROG NIL (COND (P (SETQ MAXLN!* P))) (COND (L (LINELENGTH L)))) )

(DE SETPAGE (TITLE PAGE)
 (PROG NIL (SETQ TITLE!* TITLE) (SETQ PGNUM!* PAGE)) )

(DS PRTNUM (N) (PRIN2 N))

(DS PRTATM (U) (PRIN2 U))

(DE PRTLST (U)
 (COND ((ATOM U) (PRIN2 U)) (T (FOREACH X IN U DO (PRIN2 X)))) )

(DE LSPRINT (U N)
 (PROG (E)
    (SPACES2 N)
    (WHILE U
     (PROGN (SETQ E (GETES (CAR U))) (SETQ U (CDR U))
      (COND
        ((NOT (LESSP (CAR E) (DIFFERENCE (LINELENGTH NIL) (POSN))))
         (NEWLINE N)))
      (PRINCN E)
      (PRINC '! ) ) ) ) )

(DE PRINCN (E) (WHILE (SETQ E (CDR E)) (PRINC (CAR E))))

(DE SPACES (N) (REPEATS N (PRINC '! )))

(DE SPACES2 (N)
 (PROG (X)
    (SETQ X (DIFFERENCE N (POSN)))
    (COND ((LESSP X 1) (NEWLINE N)) (T (SPACES X))) ) )

(DE UNDERLINE2 (N)
 (COND
   ((NOT (LESSP N (LINELENGTH NIL)))
    (PROGN (SETQ N (DIFFERENCE (LINELENGTH NIL) (POSN)))
     (REPEATS (ADD1 N) (PRINC '!-))
     (NEWLINE 0)))
   (T (REPEATS (ADD1 (DIFFERENCE N (POSN))) (PRINC '!-))) ) )

(DE NEWLINE (N)
 (PROG NIL
  (COND
   (!*NOFPAG (TERPRI))
   (T (SETQ LNNUM!* (PLUS LNNUM!* 1))
      (COND ((NOT (LESSP LNNUM!* MAXLN!*)) (NEWPAGE)) (T (TERPRI))) ) )
  (SPACES (PLUS ORIG!* N))))

(DE NEWPAGE NIL
 (PROG (A)
    (SETQ A NIL)
    (SETQ LNNUM!* 0)
    (COND ((NOT (EQUAL (POSN) 0)) (NEWLINE 0)))
    (COND ((NOT (EQUAL A 0)) (FORMFEED)))
    (COND (TITLE!* (PROGN (SPACES2 5) (PRTLST TITLE!*))))
    (SPACES2 (DIFFERENCE (LINELENGTH NIL) 4))
    (COND
      (PGNUM!*
       (PROGN (PRIN2 PGNUM!*) (SETQ PGNUM!* (PLUS PGNUM!* 1))) )
      (T (SETQ PGNUM!* 2)))
    (NEWLINE 10)
    (NEWLINE 0) ) )

(DE FORMFEED NIL
 (COND
   (!*FORMFEED (EJECT))
   (T
    (PROGN (TERPRI)
     (PRIN2 " ========================================= ")
     (TERPRI) ) ) ) )

(DE REMPROPSS (ATMLST LST)
 (WHILE ATMLST
  (PROGN
   (WHILE LST
    (PROGN (REMPROP (CAR ATMLST) (CAR LST)) (SETQ LST (CDR LST))))
   (SETQ ATMLST (CDR ATMLST)) ) ) )

(DE REMFLAGSS (ATMLST LST)
 (WHILE LST
  (PROGN (REMFLAG ATMLST (CAR LST)) (SETQ LST (CDR LST))) ) )

(DE UNION (X Y)
 (COND
   ((NULL X) Y)
   (T
    (UNION (CDR X)
     (COND ((MEMBER (CAR X) Y) Y) (T (CONS (CAR X) Y))) ) ) ) )

(DS FILEMK (U) U)

(DE RCCBLD NIL
    (FORL I 127 (PUT (ASCII I) 'RCC I))
    (SETQ RCCNUMS!* (CONS 1 NIL))
    (REPEATS 7
     (SETQ RCCNUMS!* (CONS (TIMES (CAR RCCNUMS!*) 128) RCCNUMS!*)) ) )

(RCCBLD)

(DE GETES (U)
 (PROG (E)
    (COND
      ((NOT (IDP U))
       (RETURN (PROGN (SETQ E (EXPLODE U)) (CONS (LENGTH E) E))) ) )
    (COND
      ((NOT (SETQ E (GET U 'RCCNAM)))
       (PROGN (SETQ E (EXPLODE U)) (SETQ E (CONS (LENGTH E) E))
        (PUT U 'RCCNAM E) ) ) )
    (RETURN E) ) )

(DS GETRCC (CHAR) (GET CHAR 'RCC))

(DE GETORD (U)
 (PROG (E N NN)
    (COND ((NOT (IDP U)) (GO L1)))
    (COND ((SETQ N (GET U 'RCCORD)) (RETURN (CONS U N))))
 L1 (SETQ E (GETES U))
    (SETQ N 0)
    (SETQ NN RCCNUMS!*)
    (WHILE (AND (SETQ E (CDR E)) NN)
     (PROGN (SETQ N (PLUS (TIMES (GETRCC (CAR E)) (CAR NN)) N)) 
      (SETQ NN (CDR NN)) ) )
    (COND ((IDP U) (PUT U 'RCCORD N)))
    (RETURN (CONS U N))))

(DS NEWNODE (ELEM) (LIST ELEM NIL))

(DS SORT (LST) (TREE2LST (TREESORT LST) NIL))

(DE TREESORT (LST)
 (PROG (TREE)
    (COND ((NULL LST) (RETURN NIL)))
    (SETQ TREE (NEWNODE (GETORD (CAR LST))))
    (WHILE (SETQ LST (CDR LST)) (PUTTREE (GETORD (CAR LST)) TREE))
    (RETURN TREE) ) )

(DE PUTTREE (ELEM NODE)
 (PROG NIL
  DWN
    (COND ((GREATERP (CDR ELEM) (CDAR NODE)) (GO RGT)))
    (COND ((CADR NODE) (PROGN (SETQ NODE (CADR NODE)) (GO DWN))))
    (RPLACA (CDR NODE) (NEWNODE ELEM))
    (RETURN NIL)
  RGT
    (COND ((CDDR NODE) (PROGN (SETQ NODE (CDDR NODE)) (GO DWN))))
    (RPLACD (CDR NODE) (NEWNODE ELEM))
    (RETURN NIL) ) )

(DE TREE2LST (TREE LST)
 (WHILE TREE
  (SETQ LST (CONS (CAAR TREE) (TREE2LST (CDDR TREE) LST)))
  (SETQ TREE (CADR TREE)) )
 LST )

%### REDIO.SL end
