%### LGLOBL.SL

(SETGLOBALS
 (SHPVRNR!*     059)            % SHEEP version.
 (SHPEXT!*      LAM)            % Default extension.
 (SAVEXT!*      SHO)            % Sheep save extension.
 (PRTEXT!*      LST)            % Sheep WRITE extension.
 (FOEXT!*       FO)             % Sheep FOIN extension.
 (ROEXT!*       RO)             % Reduce FOIN output extension.
 !*CPLXNUM                      % True if version with complex numbers.
%ALT!*                          % Altmode (Escape)
%FF!*                           % Form-feed
 HALF!*                         % 1/2
 MIHALF!*                       % -1/2
 ROOTTWO!*                      % sqrt(2)
 ROOTHALF!*                     % sqrt(1/2)
 IMNT!*                         % imaginary unit (I or (0 1))
 (SWITCHES      (ESUBS))        % List of switches.
 DEFDIFLIS!*!*                  % List of properties for new Varset.
 (NAMTYPES!*    (NAM NAMF))     % List of NAM types for PRT.
 (SUBLISTS!*    (ESUL MSUL PSUL)) % List of subst lists.
 (VARMAXMIN     1)              % Minimum number of variables allowed.
 VARSETLIS!*                    % List variable sets.
 VARSETALIS!*                   % Aliases for variable sets
 (HELPBAS!*     (TENSORS SWITCHES)) % Basic nodes for help facility.
 PARSW!*
 (UP            !/!/)           % Line control for PRTL.
 (DOWN          !/!*)           % Line control for PRTL.
 (BREAK         !/!*!/)         % Line break in PRTL.
 (PNEWLN        !*!/!*) )       % New line in PRTL.

(BOTHTIMES (SETGLOBALS
  (DIFPAR       1)
  (BASPAR       2)
  (TIMPAR       4)
  (TRIGPAR      8)
  (SUMPAR       16)
  (CPLXPAR      32)
  (TPXPAR       64) ))



(DEFLIST (LIST (LIST 'ALT!* ALT!*) (LIST 'FF!* FF!*) (LIST 'TAB!* TAB!*)
               (LIST 'UP UP) (LIST 'DOWN DOWN)
               (LIST 'BREAK BREAK) (LIST 'PNEWLN PNEWLN) )
         'PRTLCTRL)

(SETFLUIDS
 ESUBS
 (ESUP          (SUBL ESUL))
 (MSUP          (SUBL MSUP1))
 (MSUP1         (SUBL MSUBS MSUL))
 (PSUP          (SUBL PSUL))
 (SUPLS!*       (ESUP MSUP MSUP1 PSUP))
 (ESUL          (SUBS))         % Initial ESUBS subst list.
 (MSUL          (SUBS))         % Initial MSUBS subst list.
 (PSUL          (SUBS))         % Initial PSUBS subst list.
 (LASUB!*       ESUL)
 (FILELINELENGTH!*      76)     % Line length for files.
 (DEFAULTDIMENSION!*    4)
 (REDEOL!*      !$)             % End of command for FPRT.
 GLOBALPREFIX!*
 PARSPREFIX!*
 HELPFN!*
 !*!*SUBSTW
 SUBLARG!*
 (QWQ           0)              % Workspace for FOIN
 !*!*PLUSSW
 !*VERRS
 SUBS
 (POWER!*       10)
 (EXPANDLIM!*   4)
 (PRINLIMIT!*   100)
 (PRINDEFAULT!* ALL)
 (PARDEEP!*     0)
 (LNP!*         48)
 (SUBMTIMES!*   3)
 !*FPRT
 (CRDIF!*       DF1)
 (CRTYPE!*      DF1)
 DFDIF!*
 (DIFFORDER!*   2)
 CHINPRO
 MINSW
 TENALIAS!*                     % Put here as FOIN needs it.
 !*REORDSW
 COLL!*         )

(ADDHLP NIL 'ESUBS "Do ESUL substitutions")

(NEWSWITCHES
 (TPSSW
  "(EXPERIMENTAL) Compute terms of specified order in power series" )
 (CFILFO        "Interactive FOIN also when not standard input")
 (NOORDEXP      "(EXPERIMENTAL) Less natural but faster ordering")
% (NORATORDN "Not arithmetic but faster ordering of rational numbers")
 (NOLEXORD      "Not lexical but faster ordering of functions")
% (INCREASORD   "(EXPERIMENTAL) Order with small exponents first")
 (IMAGFIRST     "(EXPERIMENTAL) Order imaginary part before real part")
 (NOOPWEIGHT
  "(EXPERIMENTAL) Do not use weights when ordering operators" )
 (ORDPLMAIN     "(EXPERIMENTAL) Order terms on factor")
 (NOEXPAND      "Do not use distributive law to simplify")
 (NOSIMP        "(OBSOLETE) Suppress some simplification")
 (POTSIM        "Some more simplification")
 (NOALLSIMP
  "Do not simplify all subexpressions when more simplification" )
 (NOALLSUBS    "(EXPERIMENTAL) Do not substitute in all subexpressions")
 (MSUBS         "Multiple MSUL substitutions")
 (SUBPOT        "Substitute when basis matches and exponent divides")
 (NODGNV        "Do not replace inverse of a sum with a symbol")
 (NONAM         "No NAM substitutions in output")
 (NOPRT         "No multiple line output")
 (PSUBS         "PSUL substitutions in output")
 (PVARNUM       "Use variable number in formal derivative output")
 (RATPAR        "Put parentheses around rational numbers")
 (PTEVAR        "Use variable name in index output")
 (NOREDARY      "Output indexed object as id in REDOUT") % Was NOFARY.
 (NOOFIT        "Do not fit output to file into pages")
 (FITIN         "Fit into pages also for tty")
 (NOZERO        "Do not print zero components")
 (NOCHKLONG     "Do not check for long output when output to terminal")
 (FILECHKLONG   "Check for long output also when output to file")
 (NOASKLONG     "Not interactive when long output")
 (TEXMODE       "(Experimental) Output for TeX phototypesetting") )

(MACROTIME
 (FLAG '(DFUN EFUN HELP INFN MACRO PARSF PRT PRTLFFN NAMFN SIMP3FN
         SHSMPFN SIMPXFN EXPTFN SUBLOP SUBSFN SIMP2FN SWITCHFN BIGGFN)
       'COMPILE) )

(STVRMX 'DF1 DEFAULTDIMENSION!*)

(SETSYSTYPE 'SHVERS SHPVRNR!*)

%### LGLOBL.SL end
