%### SHIMP1.SL

% Implementation specific code for Sheep, part 1, functions that can
% be defined before loading the implementation independent code.
% Codemist Standard Lisp (CSL) version.

% This file was created by dividing shcmbl into two parts shimp1 and
% shimp2 to be loaded before and after the bulk of the Sheep code. JEA.

(SETGLOBALS ALT!* FF!*)          % Emergency fix.
%(SETGLOBALS
% ((ALT!*        (ASCII 27)))    % Altmode (escape) character.
% ((FF!*         !$FF!$)) )      % Form-feed.

(NOTLOADTIME (REMFLAG '(BIGGID2 TSTPARSW) 'LOSE))

(DMACRO SETENQQ (!&DS X Y) (SETEN 'X 'Y))

(DMACRO XMEXPT (!&DS BAS EX)
 (SLET ((VR!$ EX)) (COND
   ((AZEROP VR!$) 1)
   ((AONEP VR!$) BAS)
   (T (SMEXPT BAS VR!$)) )) )

(DMACRO XMMULTC (SW MSW NL !&REST L)
 (SLET ((BODY (LIST '(VR!$1 VR!$2 MINSW) 'PROG)))
  (COND (MSW (XPUSH BODY '(SETQ MINSW T))))
  (FOREACH X IN L DO (SETQ BODY (CONSA
    '(XPUSH VR!$2 VR!$1)
    (LIST 'COND (LIST (LIST 'AZEROP (LIST 'SETQ 'VR!$1 X)) '(RETURN 0)))
    BODY )))
  (REVERSIP (RPLACA BODY
    (LIST 'RETURN
     (LIST 'SMMULTC '(CONS VR!$1 VR!$2) NL 'MINSW SW) ) )) ) )

(DMACRO XMDOMULC (!&DS X Y MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (AZEROP (SETQ VR!$1 X)) (AZEROP (SETQ VR!$2 Y))) 0)
   (T (DOMULCW VR!$1 VR!$2 MINSW)) ) ) )

(DMACRO XMDFMQ (!&DS X Y VR VT MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (AZEROP (SETQ VR!$1 X)) (SNUMP (SETQ VR!$2 Y))) 0)
   (T (IDFMQ VR!$1 VR!$2 VR VT MINSW)) ) ) )

(DMACRO XMDFMQL (!&DS X Y VRL VT MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (AZEROP (SETQ VR!$1 X)) (SNUMP (SETQ VR!$2 Y))) 0)
   (T (IDFMQL VR!$1 VR!$2 VRL VT MINSW)) ) ) )

(DMACRO XMDFMQ2L (!&DS X Y VR1L VT1 VR2L VT2 MSW)
 (SLET ((MINSW MSW) VR!$1 VR!$2)
  (COND
   ((OR (SNUMP (SETQ VR!$1 X)) (SNUMP (SETQ VR!$2 Y))) 0)
   (T (IDFMQ2L VR!$1 VR!$2 VR1L VT1 VR2L VT2 MINSW)) ) ) )

(DMACRO XMPLUS (!&REST L)
 (CONS 'SHCOLLECT (FOREACH X IN L COLLECT (LIST 'SMADDTERM X))) )

(DMACRO XMRTIMES (!&DS X Y)
 (SLET ((VR!$1 X))
  (COND
   ((AZEROP VR!$1) 0)
   (T (SNUTIM VR!$1 Y)) ) ) )

(SAMEDEF BIGGID2 ORDERP)        % Always use lexical ordering of ids.

(DS TSTPARSW (!&REST L) (NOT (XZEROP (ILOGAND PARSW!* (PARSW . L)))))

% Special version due to the CSL strange syntax that always allow
% evaluation of atoms without error.
(DE IDVALUE (X!&)
  (COND
    ((BOUNDP X!&) (EVAL X!&)) ))

(NOTLOADTIME
  (FLAG 
    '(
      SETEQNQQ XMEXPT XMMULTC XMDOMULC
      XMDFMQ XMDFMQL XMDFMQ2L XMPLUS XMRTIMES
      BIGGID2 TSTPARSW TSTBIT IDVALUE)
    'LOSE) )

%### SHIMP1.SL end
