%### DDIFF.SL

% This file defines differentiation. Formerly called DIFF.

%(LOCALFUNCTIONS DFSUBS DFSUB)

(NEWSWITCHES
 (DONTRANS
  "(EXPERIMENTAL) Don't declare functions automatically by chain rule"
  ) )

(SETFLUIDS XXFDS!$)

% SDIF, Differentiate Sheep expression SXP!& with respect to variable
% number VNU!& in variable set VT!&. Formerly called DIFF.
(DE SDIF (SXP!& VNU!& VT!&)
 (SLET (A)
  (COND
   ((OR (SNUMP SXP!&) (EQ SXP!& IMNT!*)) 0)%Derivative of a number is 0.
   ((ATOM SXP!&)                        % Must be an id: a function.
    (COPYL (GETDIF SXP!& VNU!& VT!&)) )
   ((SETQ A (XDIFF SXP!& VNU!& VT!&)) A)% Returns NIL if unsuccessful.
   (T (EASK
           (LIST (CAR SXP!&))
           "Define differentiation function for %p" % complain!
           (LIST 'XDIFF (MKQUOTE SXP!&) (MKQUOTE VNU!&) (MKQUOTE VT!&))
           (MKDIFF SXP!& VNU!& VT!&) NIL)) ) ) )

% Differentiate SXP!& of form (fn . args)
(DE XDIFF (SXP!& VNU!& VT!&)
 (SLET ((A!& (IGET (CAR SXP!&) 'DFUN)) B!&)
  (COND
   (A!&                         % Is fn a special function?
    (FUNCALL A!& SXP!& VNU!& VT!&)) % Yes. Apply differentiation rule.
   ((NULL (SETQ A!& (IGET (CAR SXP!&) 'EFUN)))  % Is fn normal unary
    NIL)        % function? If not return NIL to indicate unsuccessful.
   ((AZEROP (SETQ B!& (DIFFC (CADR SXP!&) VNU!& VT!&))) 0)
                                        % Is derivative of arg 0?
   (T (SMTIMES2 B!& (FUNCALL A!& SXP!&))) ) ) ) % No.

(DE FOSUBL (X) (LIST 'LAMBDA '(!=X) (FOSUB X)))
 
(DE FOSUB (X)
 (SLET (A (SW (AONEP (XIPLUS (FINDCNT 'X X) (FINDCNT '!=X X)))))
  (COND
   ((EQ X 'X) (COND
     (SW '(CADR !=X))
     (T '(COPYL (CADR !=X))) ))
   ((EQ X '!=X) (COND
     (SW X)
     (T '(COPYL !=X)) ))
   ((SNUMP X) (COND
     ((EQUAL X HALF!*) 'HALF!*)
     ((EQUAL X MIHALF!*) 'MIHALF!*)
     ((SRATIONALP X) (LIST 'SNUM (SNUMQ X) (SDENQ X)))
     (T X) ))     
   ((ATOM X) (MKQUOTE X))
   ((SETQ A (GET (CAR X) 'FOSUBOPFN)) (FUNCALL A X))
   (T (FOREACH Y IN (CDR X) REPLACE (FOSUB Y)) (COND
       ((EQ (CAR X) 'TIMES)
        (COND
         ((NUMBERP (CADR X))
          (SETQ A (CADR X))
          (RPLACD X (CDDR X)) ) )
        (SETQ X
         (COND
          ((NULL (CDDR X)) (CADR X))
          ((CDDDR X)
           (LIST 'SMTIMESL (CONS 'LIST (RPLACA X '(QUOTE TIMES)))) )
          (T (RPLACA X 'SMTIMES2)) ))
        (COND
         ((NULL A) X)
         ((AEQN A -1) (LIST 'SMMINUS X))
         (T (LIST 'SNUTIMES2 A X)) ) )
       ((EQ (CAR X) 'PLUS)
        (COND
         ((CDDDR X)
          (LIST 'SMPLUSL (CONS 'LIST (RPLACA X '(QUOTE PLUS)))) )
         (T (RPLACA X 'SMPLUS2)) ))
       ((SETQ A (GET (CAR X) 'FOSUBOP)) (RPLACA X A))
       (T (CONS 'LIST (RPLACA X (MKQUOTE (CAR X))))) )) )))

(DEFLIST '((EXPT SMEXPT) (EXP SMEXP) (LOG SMLOG)) 'FOSUBOP)

(DE GETDIF (SXP!& VNU!& VT!&) 
 (OR
  (XGETDIF SXP!& VNU!& VT!&)
  (SLET (A!&)
   (AND (NOT DONTRANS)
    (SETQ A!& (GET VT!& 'RVAR))
    (TRYTRANS SXP!& VT!& A!&)
    (XGETDIF SXP!& VNU!& VT!&) ) )
  (SLET ((A!& (GET SXP!& VT!&)))
   (EASK (LIST (XTWOVARQ VT!&) (COND (A!& (IADD1 VNU!&)) (T SXP!&)))
    (COND
     (A!&
      "The number of%l variables is less than %p. Declare variables")
     (T "Declare%l function %p") )
    (LIST 'XGETDIF (MKQUOTE SXP!&) (MKQUOTE VNU!&) (MKQUOTE VT!&))
    (MKDIFF SXP!& VNU!& VT!&) NIL)) ) )

(DE XTWOVARQ (VT)
 (COND ((CDR VARSETLIS!*) (LIST '!  (XGTVTNM VT) '! ))) )

(DE XGETDIF (SXP!& VNU!& VT!&) (COND
  ((NUMBERP VNU!&) (KAR1 (GET SXP!& VT!&) VNU!&))
  (T (ALGDIFF SXP!& VNU!& VT!&)) ))

(DC PLUS DFUN (SXP VNU VT) 
 (FOREACH X IN (CDR SXP) REPLACE (SDIF X VNU VT)) 
 (SMPLUSL SXP) )

(DC TIMES DFUN (SXP VNU VT) 
 (SHCOLLECT (SLET ((OLM SXP) A B X)
   (WHILE (SETQ A (CDR OLM))
    (COND ((NOT (AZEROP (SETQ X (DIFFC (CAR A) VNU VT))))
           (RPLACD OLM NIL)
           (COND
            ((NULL (CDDR (SETQ B (NCONC (COPYL SXP) (COPYA (CDR A))))))
             (SETQ B (CADR B)) ) )
           (SMADDTERM (SMTIMES2 X B))
           (RPLACD OLM A) ))
    (SETQ OLM A) ) )) )

(DC UNSMP DFUN (SXP IX VT) (MKDIFF SXP IX VT))

(COMMENT
(DEFLIST
 '((TAN (PLUS 1 (EXPT !=X 2)))
   (COT (PLUS -1 (TIMES -1 (EXPT !=X 2))))
   (EXP !=X))
 'EFUN)
)

(DC SIN EFUN (SXP) (RPLACA SXP 'COS))

(DC TAN EFUN (SXP) (SMPLUS2 (SMEXPT SXP 2) 1))

(DC COS EFUN (SXP) (MKMIN (RPLACA SXP 'SIN)))

(DC COT EFUN (SXP) (SMMINUS (SMPLUS2 (SMEXPT SXP 2) 1)))

(DC EXP EFUN (SXP) SXP)

(DC SINH EFUN (SXP) (RPLACA SXP 'COSH))

(DC COSH EFUN (SXP) (RPLACA SXP 'SINH))

(DC TANH EFUN (SXP) (SMPLUS2 1 (SMMINUS (SMEXPT SXP 2))))       % JEA

(DC COTH EFUN (SXP) (SMPLUS2 1 (SMMINUS (SMEXPT SXP 2))))       % JEA

(DC LOG EFUN (SXP) (SMEXPT (CADR SXP) -1))

(DC EXPT DFUN (SXP VNU VT) 
 (SLET ((BAS (CADR SXP)) (EX (CADDR SXP)) A) (COND
   ((AONEP BAS) 0)
   ((SNUMP EX) (COND
     ((AZEROP (SETQ VT (SMDIFFC BAS VNU VT))) 0)
     (T (SNUTIM EX (SMTIMES2 VT (XSMEXPT BAS (SSUB1 EX) SXP)) )) ))
   (T (SETQ A (SMDIFFC BAS VNU VT))
      (SETQ VT (SMDIFFC EX VNU VT))
      (COND
       ((AZEROP A) (COND
         ((AZEROP VT) 0)
         (T (SMTIMESL (LIST 'TIMES VT SXP (XSMLOG (COPYL BAS) NIL)))) ))
       ((AZEROP VT) (SMTIMESL
         (LIST 'TIMES EX (XSMEXPT BAS (SMPLUS2 (COPYL EX) -1) SXP) A) ))
       ((AZEROP (SETQ A (SMPLUS2
           (SMTIMES2 A (COPYL EX))
           (SMTIMESL
            (LIST 'TIMES VT (COPYL BAS) (XSMLOG (COPYL BAS) NIL)) ) )))
        0)
       (T (SMTIMES2 A (COLLEX BAS (SMPLUS2 EX -1) SXP))) ) ) )) )

(XPUSH DEFDIFLIS!*!* '(DFUN . DDIFF))

(DE DDIFF (SXP VNU VT) 
 (COND 
   ((NOT (EQ (CAR SXP) VT)) (CHNDFI SXP VNU VT (CAR SXP) NIL))
   ((ATOM (CADR SXP)) (DDIFLO SXP VNU VT))
   (T (SLET ((A (CADR SXP)))
       (RPLACA (CDR SXP) (CAR A)) 
       (SUBSS1 (DDIFLO SXP VNU VT) (CAR A) A) )) ) )

(DE DIFUN (SXP VNU VT)
 (SUBSS1 (SDIF (CAR SXP) VNU VT) (CAR SXP) SXP) )

(DE DDIFLO (SXP VNU VT) 
 (COND
  ((SNUMP (SETQ VNU (GETDIF (CADR SXP) VNU VT))) 0)
  ((EQ (CAR VNU) VT)
   (SETQ VNU (CADDR VNU))
   (SETQ VT SXP)
   (UNTIL (NOT (AND (CDR VT) (IGREATERP VNU (CADR VT)))) (UNPUSH VT))
   (RPLACD VT (CONS VNU (CDR VT)))
   SXP)
  (T (SETQ VNU (COPYL VNU))
     (FOREACH X IN (CDDR SXP) DO (SETQ VNU (SDIF VNU X VT)))
     VNU) ) )

(DE DIFFC (SXP!& VNU!& VT!&) (SDIF (COPYL SXP!&) VNU!& VT!&))

(XPUSH DEFDIFLIS!*!* '(SIMP3FN . SIDF))

(DE SIDF (SXP) 
 (SLET ((VT (CAR SXP)) (A (SIMPI (CADR SXP))))
  (FOREACH X IN (CDDR SXP) DO (SETQ A (SMDIFF A (GETVAR X VT) VT)))
  A) )

(DE GETVAR (X VT) 
 (COND 
  ((AND (FIXP X) (NOT (OR (IMINUSP X) (IGREATERP X (GTVRMX VT))))) X)
  (T
   (OR
    (XGETVAR X VT)
    (EASK (LIST (XTWOVARQ VT) X) "Define%l variable %p"
          (LIST 'XGETVAR (MKQUOTE X) (MKQUOTE VT))
          NIL NIL ) ) ) ) )

(DE XGETVAR (X VT)
 (SLET ((N 0) (A (GTVRLS VT)))
  (WHILE (AND A (NOT (EQ X (CAR A)))) (UNPUSH A) (IINCR N))
  (COND (A N)) ) )

(DE CHNDFI (SXP VAR VT CRDIF!* TPSSW) 
 (SLET ((N -1))
  (RID0RT (CONS 'PLUS (FOREACH X IN (GTVRLS CRDIF!*) COLLECT
     (DFMQ SXP (IINCR N)
      (COND 
       ((AEQN X VAR) 1)
       ((FIXP X) 0)
       (T (GETDIF X VAR VT)) ) ) ))) ) )

(DE CHNDIF (SXP VAR VT VTC) (CHNDFI SXP VAR VT VTC NIL))

(DE DFMQ (SXP VAR FC) 
 (COND 
  ((AZEROP FC) 0)
  ((AONEP FC) (DIFFCRC SXP VAR))
  (TPSSW (TPDFML SXP VAR FC))
  ((AZEROP (SETQ SXP (DIFFCRC SXP VAR))) 0)
  (T (MKTIMS (COPYL FC) SXP))))

(DE DIFFCR (SXP VAR) (SDIF SXP VAR CRDIF!*))

(DE DIFFCRC (SXP VAR) (DIFFC SXP VAR CRDIF!*))

(DE DEFEFUNL (L)
 (FOREACH X IN L DO
  (COND
   ((NOT (OR (GET X 'PARSF) (GET X 'EFUN))) (PUT X 'PARSF 'RTRIG)) ) )
 (FOREACH X IN L DO
  (COND
   ((GET X 'EFUN) (WARNINGFT 110 "Derivative of %r is redefined" X)) )
  (PUTC X 'EFUN (FOSUBL (FOINP (MKDIFF (LIST X 'X) 'X CRDIF!*))))
  (COND ((EQ (GET X 'PARSF) 'RTRIG) (REMPROP X 'PARSF))) ) )
  
(DE MKDIFF (SXP VNU VT) (LIST VT SXP VNU))

(UNFLUID '(XXFDS!$))

%### DDIFF.SL end
