%### DEFTEN.SL

% The tensor definition macro DEFTEN and friends.

(FUNCTIONS TENDEFP DSCALARS DTENSORS XTENSORS XTTSR DEFTNF
           DEFTEN MKPUT MKPUTE MKTNF MKTNFL MKPRNF)

(COMPILETIME (FLAG '(DEFTENFN) 'COMPILE))   % Information for compiler.

(FLAG '(DTENSORS DSCALARS) 'EVAL)       % Do it at compile time too.

(FLAG '(DEFTEN) 'DFEXPAND)

(SETFLUIDS INDXL!* HLP!$)

(DS GETBLOQ (TN) (GET TN 'TENARY))

(DE DEFTNF (TN !*MSG)
 (COND ((NOT (EQUAL (GETFN 'MGETEN) (GETFN TN))) (MOVD TN 'MGETEN))) )

% DECLTEN is kept for a while for compatibility reasons.
(DS DECLTEN (TN!& LML!& !&REST N!&) (XDECLTEN 'TN!& 'LML!& 'N!&))

(DE TENDEFP (TN) (IGET TN 'TTYPE))

(DMACRO DSCALARS (FIL !&REST L) (LIST 'CPROGN   % Declare scalars.
  (CONS 'SETGLOBALS
   (FOREACH X IN L COLLECT (COND ((PAIRP X) (CAR X)) (T X))) )
  (LIST 'XTENSORS (MKQUOTE FIL) (MKQUOTE L)) ))

(DS DTENSORS (FIL !&REST L) (XTENSORS 'FIL 'L)) % Declare tensors.

(DE XTENSORS (FIL L)
 (FOREACH TN IN L DO (COND
   ((NOT (PAIRP TN)) (XTTSR TN NIL FIL))
   ((NULL (CDDR TN)) (XTTSR (CAR TN) (CADR TN) FIL))
   (T (XTTSR (CAR TN) (CADR TN) (CADDR TN))) )) )

(DE XTTSR (TN HLP FIL)
 (COND
  ((FLAGP TN 'LOSE)
   (WARNINGFT 152 "Tensor %p not defined, flagged LOSE" TN) )
  (T (COND (FIL (PUT TN 'TNDEFIL FIL)) (T (PUTQ TN 'TNDEFIL 'UNKNOWN)))
     (COND ((NOT (MEMQ TN TENSORS)) (SETQ TENSORS (NCONC1 TENSORS TN))))
     (COND (HLP (ADDHLP NIL TN HLP))) ) ) )

% This macro is used to define new tensors
(DMACRO DEFTEN (TN INDXL!* !&REST U)
 (PROG (HLP!$ A)
  (COND ((FLAGP TN 'LOSE)
         (WARNINGFT 154
          "Tensor %p not defined, flagged LOSE" TN)
          (RETURN NIL) ))
  (XTTSR TN NIL MODULNAM!*)
  (COND ((SETQ A (ATSOC 'PREQ U)) (XTENSORS NIL (CDR A))))
  (COND ((NOT (OR INDXL!* (ATSOC 'TTYPE U))) % No indices means:
         (XPUSH U '(TTYPE NIL)) ))       %  a scalar.
  (SETQ U (FOREACH X IN U COLLECT % Process rest of arguments.
    (COND 
     ((SETQ A (IGET (CAR X) 'DEFTENFN))
      (FUNCALL A TN (CAR X) (CDR X)) )
     (T (ERRORFT 533 "Undefined DEFTEN option %r" (CAR X))) ) ))
  (XPUSH U (LIST 'DTENSORS MODULNAM!* (LIST TN HLP!$ MODULNAM!*)))
  (XPUSH U (COND
    (INDXL!* (LIST 'DEFTNF (MKQUOTE TN) '!*MSG))
    (T (LIST 'SETGLOBALS TN)) ))
  (RETURN (CONS 'CPROGN U)) ) )

(DC HELP DEFTENFN (DUMMY1 DUMMY2 L)
 (SETQ HLP!$ (MKQUOTE (COND ((CDR L) L) (T (CAR L))))) )

(DE MKPUT (TN Y Z) (LIST 'DPUT TN Y Z))

(DE MKPUTE (TN Y Z) (LIST 'PUT (MKQUOTE TN) (MKQUOTE Y) Z))

(DE MKTNF (TN FNPROP FNBODY) (MKTNFL TN FNPROP INDXL!* FNBODY))

(DE MKTNFL (TN FNPROP VRS FNBODY)
 (COND
  ((AND (NULL (CDR FNBODY)) (IDP (CAR FNBODY)))
   (MKPUT TN FNPROP (CAR FNBODY)) )
  (T (CONSA 'DC TN FNPROP VRS FNBODY)) ))

(DE MKPRNF (TN FNPROP FNBODY) (MKTNFL TN FNPROP NIL FNBODY))

(XDEFLIST DEFTENFN                      % DEFTEN options.
 (PREFN MKPRNF) (POST MKPRNF) (PREMK MKPRNF) (WRHEAD MKPRNF)
 (WRTHED MKPRNF) (DIML MKPUT) (NAM NAMDEFTENFN) (NAMF NAMDEFTENFN)
 (BULF MKTNF) (SYMF MKTNF) (UPINDX MKPUT) (DEP MKPUT) (DELK MKPUT) )

% DEFTEN option TTYPE. Tensor symmetry type.
(DC TTYPE DEFTENFN (X DUMMY Z)
 (LIST 'DECLTX (MKQUOTE X) (MKQUOTE (XRANK (CAR Z) INDXL!*))) )

% DEFTEN option PREQ. Prerequisite tensors.
(DC PREQ DEFTENFN (X DUMMY Z)
 (CONSA 'PREQ X Z) )

(DE NAMDEFTENFN (X Y Z)         % DEFTEN option NAM
 (LIST 'ISETNAM (MKQUOTE X) (MKQUOTE Y)
  (LIST 'DOINAM (MKQUOTE (NCONS (CAR Z))))
  (COND ((CDR Z) (CONS 'PARSW (CDR Z)))) ) )

(DC TNSPCH DEFTENFN (X Y Z) (MKPUTE X Y (CAR Z)))

%### DEFTEN.SL end
