%### DTENAR.SL

(SETFLUIDS XTDIM!$ NXTDIM!$ CRTN!$)

(DE DIMENSION (N)
 (PROG1 DEFAULTDIMENSION!*
  (COND
   ((AND N (GREATERP N 0))
    (SETQ DEFAULTDIMENSION!* (SETQ DIM!* N)) ) ) ) )

(DE NOSCALAR (TN)
 (SLET ((A (GET TN 'TTYPE)))
  (COND
   (A (PAIRP A))
   (T (GET TN 'TNDEFIL)) ) ) )

% SRANK, rank of Sheep tensor. Formerly called RANK.
(DE SRANK (TN) 
 (SLET ((A (GET TN 'TTYPE)))
  (COND ((PAIRP A) (CAR A)) (T 0)) ) )

(DE GETDIM1 (TN) (CAR (GETDIML TN)))

(DE GETDIML (TN)
 (OR
  (GET TN 'DIML)
  (PROGN (GETBLO TN) (GET TN 'DIML)) ) )

(DE GETBLO (TN)
 (OR
  (GETBLOQ TN)
  (SLET (A)
   (COND
    ((NOT
      (OR
       (SETQ A (GET TN 'TTYPE))         % Definition is known.
       (AND
        (SETQ A (GET TN 'TNDEFIL))      % Declared and definition
        (NOT (EQ A 'UNKNOWN))           % is on file.
        (PROGN (MLOAD A) (SETQ A (GET TN 'TTYPE))) )
       (AND (GET TN 'FACTOR)            % Stensor definition.
            (PROGN (QTCOM0 TN NIL) (SETQ A (GET TN 'TTYPE))) ) ))
     (COND
      (A (ERRORFT 555 "Tensor %r is declared but not defined" TN))
      (T (ERRORFT 556 "Tensor expected but %r is not a tensor" TN)) ) )
    ((PAIRP A) (DTENAR TN A (GET TN 'DIML)))
    (T (QSET TN NIL) NIL) ) ) ) )

(DE XDECLTEN (TN!& LML!& N!&)
 (DECLTX TN!& (XRANK LML!& NIL))
 (COND (N!& (ISETNAM TN!& 'NAM (CAR N!&) (CDR N!&))))
 SUPPRESSANS!*)

(DE DECLTX (TN!& LIML!&) 
 (SLET ((A!& (GET TN!& 'TTYPE)))
  (COND 
   ((AZEROP (CAR LIML!&))               % A scalar.
    (COND ((FNP TN!&) (REMD TN!&)))     % Scalars may not be functions.
    (QSET TN!& NIL)                     % Initialise to value NIL.
    (SETQ LIML!& 0) (REMPROP TN!& 'PRT)
    (REMPROP TN!& 'DFUN) (REMPROP TN!& 'EFUN) )
   (T (PUTQ TN!& 'DFUN 'DIFUN) (PUTQ TN!& 'PRT 'PRTEN)) )
  (COND 
   ((NOT (MEMQ TN!& TENSORS))
    (COND ((NOT (AZEROP LIML!&)) (DEFTNF TN!& !*MSG)))
    (SETQ TENSORS (NCONC1 TENSORS TN!&)) )
   ((NOT A!&) (COND ((NOT (AZEROP LIML!&)) (DEFTNF TN!& !*MSG))))
   ((NOT (EQUAL LIML!& A!&))
    (WARNINGFT 162 "Tensor %r is redefined" TN!&)
    (COND ((COND
            ((AZEROP A!&)
             (PROG1 (IDVALUE TN!&) (XLOSE TN!& NIL)) )
            (T (DEFTNF TN!& NIL)
               (XLOSE TN!& NIL)
               (REMPROP TN!& 'TENARY) ) )
           (REMPROP TN!& 'DIML)
           (WARNINGFT 164 "All old components of %r lost" TN!&) )) ) )
  (PUTQ TN!& 'BIGGFN 'BIGGNDX)
  (PUTQ TN!& 'OPWEIGHT 40)
  (PUT TN!& 'TTYPE LIML!&) ) )

(DE DTENAR (CRTN!$ LIML XTDIM!$) 
 (SLET (NXTDIM!$ DN)
  (COND ((AND XTDIM!$ (NOT (IEQN (LENGTH XTDIM!$) (CAR LIML))))
         (ERRORFT 542 "%r can't be DIML list for %r which has rank %w"
                  XTDIM!$ CRTN!$ (CAR LIML) ) ))
  (SETQ LIML (CAR (XXDIM DEFAULTDIMENSION!* (CDR LIML))))
  (COND ((NOT (EQUAL XTDIM!$ (SETQ NXTDIM!$ (REVERSIP NXTDIM!$))))
         (COND (XTDIM!$ (WARNINGFT 166 "%p new DIML" CRTN!$)))
         (COND
          (NXTDIM!$ (PUT CRTN!$ 'DIML NXTDIM!$))
          (T (REMPROP CRTN!$ 'DIML)) ) ))
  (COND
   ((MINUSP (SETQ DN (CAR LIML)))
    (WARNINGFT 168 "Tensor %r is zero because of symmetry" CRTN!$)
    (SETQ DN NIL) )
   ((NOT (LESSP DN (GVALUE (EXPT 2 16))))
    (WARNINGFT 170
     "Tensor array for %r has %p elements"
     CRTN!$
     (ADD1 DN) ) ) )
  (PUT CRTN!$ 'TENARY
   (CONS LIML (COND (DN (MKVECT DN)))) ) ) )    % Bugfix. JEA.

(DE XMKLIML (LIML) 
 (COND 
  ((ATOM LIML) (XALIML LIML))
  ((EQCAR LIML 'DIM) (XXDIM (EVAL (CADR LIML)) (CADDR LIML)))
  (T (SLET ((A (GET (CAR LIML) 'ISYMTYP)))
      (SETQ LIML (FOREACH X IN (CDR LIML) CONC (XMKLIML X)))
      (LIST (XCASE A (UNSYMER A) 
        (XDIMCO LIML)
        (XSDIMCO LIML 1 T)
        (XSDIMCO LIML 2 NIL)
        (XSDIMCO LIML 3 T) )) )) ) )

(DE XXDIM (DIM!* LIML) (XMKLIML LIML))

(DE XALIML (N) 
 (SLET (A B)
  (REPEATS N
   (SETQ B (COND 
     ((NULL XTDIM!$) DIM!*)
     (T (POP XTDIM!$)) ))
   (XPUSH NXTDIM!$ B)
   (XPUSH A (LIST (XSUB1 B))) )
  (REVERSIP A) ) )

(DE XSDIMCO (L CX SW) 
 (SLET ((DN (CAAR L)) (N (LENGTH L)))
  (FOREACH X IN L REPLACE
   (COND
    ((EQN (CAR X) DN) (CDR X))
    (T (ERRORFT
        538
        "Symmetries of %r are not consistent with dimension of indices"
        CRTN!$ )) ) )
  (CONSA 
   (SUB1 (OVER (COND (SW (PLUS DN N)) (T (ADD1 DN))) N))
   (COND ((EQN N 2) (PLUS CX 4)) (T CX))
   DN
   L) ) )

(DE XDIMCO (L) 
 (SLET ((DMX 1) A B)
  (FOREACH X IN L DO
   (SETQ DMX (TIMES DMX (ADD1 (CAR X))))
   (COND
    ((CDR X) (XUPDIMC A B) (XPUSH A X) (SETQ B NIL))
    ((NOT (AND B (EQN (CAR B) (CAR X))))
     (XUPDIMC A B)
     (XPUSH A (SETQ B X)) )
    (T (RPLACD B (COND ((CDR B) (ADD1 (CDR B))) (T 2)))) ) )
  (XUPDIMC A B)
  (COND
   ((CDR A) (CONSA (SUB1 DMX) 0 (REVERSIP A)))
   (T (CAR A)) ) ) )

(DE XUPDIMC (A B) (COND ((AND B (CDR B))
   (RPLACA A (CONSA (SUB1 (EXPT (ADD1 (CAR B)) (CDR B))) 4 B)) )))

(DE OVER (N K)  % Partly by JEA
% N and K: Integer Result: Integer
% N*(N-1)*(N-2)*...*(N-K+1)/1*2*...(K-1)*K   i.e. binomial N over K
 (SETQ K (MIN K (DIFFERENCE N K)))
 (COND 
  ((MINUSP K) 0)
  ((ZEROP K) 1)
  ((ONEP K) N)
  (T (SLET ((M N) (L 1))
      (UNTIL (EQN L K) (SETQ M (QUOTIENT (TIMES M (DECR N)) (INCR L))))
      M )) ) )

%### DTENAR.SL end
