%### SHIMP1.SL

(NOTLOADTIME (REMFLAG
  '(TSTPARSW BIGGID2 SFEXPT SFIX SFRACTION)
  'LOSE ))

(SETGLOBALS
 ((ALT!* (INTERN (ascii 27))))          % Altmode (escape) character.
 ((FF!* (INTERN (ascii 12)))) )         % Form-feed.

(samedef 'BIGGID2 'alphalessp)  % Always use lexical ordering of ids.

(DS TSTPARSW (!&REST L) (NOT (XZEROP (boole 1 PARSW!* (PARSW . L)))))

% BAS^EX where BAS or EX is a floating point number, both are SNUMs.
% Improved version for systems where second argument to EXPT not
% have to be an integer. Added by JEA.
(DE SFEXPT (BAS EX) (COND
  ((AND (NUMBERP EX) (NOT (FLOATP EX))) (EXPT BAS EX))  % EX integer.
  (T (EXPT (SFLOAT BAS) (SFLOAT EX))) ))

% Integer part of X where X is an SNUM. Result is never greater than X.
(DE SFIX (X) (SLET (A) (COND
   ((PAIRP X)
    (SETQ A (QUOTIENT (CAR X) (CDR X)))
    (COND
     ((MINUSP (CAR X)) (SUB1 A))
     (T A) ) )
   ((NOT (FLOATP X)) X)
   (T (FIX X)) )))

% Fractional part of X where X is an SNUM. Result is never negative.
(DE SFRACTION (X) (SLET (A) (COND
   ((PAIRP X)
    (COND ((MINUSP (SETQ X (REMAINDER (CAR X) (SETQ A (CDR X)))))
           (SETQ X (PLUS X A)) ))
    (CONS X A) )
   ((NOT (FLOATP X)) 0)
   (T (DIFFERENCE X (FIX X))) )))

(NOTLOADTIME (FLAG
  '(TSTBIT TSTPARSW BIGGID2 SFEXPT SFIX SFRACTION)
  'LOSE ))

% Necessary to stop the machine independent version from being
% compiled. JEA 
(LOADTIME (FLAG '(TSTPARSW SFEXPT SFIX SFRACTION) 'LOSE))

%### SHIMP1.SL end
