%### PRTEX.SL

% Copyright (c) 1989 Lars Hornfeldt, Phys. dep. Stockholm Univ., Sweden.

% This file is autoloaded when you do (ON TEXMODE).
% It then reshapes the formula output
% so that it becomes suitable as input to text processors.
% Also involved for formulae are changes in files PRT, PRTL, and VALU.SL

% The PRTEN function is redefined here
% (becoming reasonable 400 bytes larger, so could be permanent).

% The other TeX features are only available in STENSOR.

(PRIN2 "
%*** Add to your TeX-file the following line:

\def\ph#1{\phantom #1} \input texinfo

% -to 1: define ph as phantom (necessary), and
%     2: load the file TEXINFO.TEX (copy it from sheep/doc).
") (PRIN2 "
% For plain formulae you may omit the '\input texinfo'
% if you in the output edit the @ into \.
% You may reposition the $$ that encloses each formula.
")

% (OR (GETD 'DWIM) (PRIN2 "% If turning off TEXMODE, also do (LOAD DWIM)
% "))   Removed. JEA.

(SETFLUIDS TLN!$ TROFF!*)

(DE TEXMODE!.SWITCHFN (X)
 (PUT '!/!/ 'PRTLOP (COND (X 'UP!.PRTX) (T 'UP!.PRTLOP)))
 (PUT '!/!* 'PRTLOP (COND (X 'DOWN!.PRTX) (T 'DOWN!.PRTLOP))) )

% (TEXMODE!.SWITCHFN T) Removed. JEA.

%(DE UP!.PRTLOP (DUMMY PXR) (IDECR CLN!$) (PRTL1 PXR))
%(DE DOWN!.PRTLOP (DUMMY PXR) (IINCR CLN!$) (PRTL1 PXR))

(DE UP!.PRTX (DUMMY PXR)
  (PINBF (COND ((ZEROP TLN!$) "^{")   % Baseline. Open rise
               ((MINUSP TLN!$) "}")   % Close a drop
               (T "^{") )             % Open new rise
         NIL)
  (INCR TLN!$)
  (PRTL1 PXR) )

(DE DOWN!.PRTX (DUMMY PXR)
  (PINBF (COND ((ZEROP TLN!$) "_{")   % Baseline. Open drop
               ((MINUSP TLN!$) "_{")  % Open new drop
               (T  "}") )             % Close rise
         NIL)
 (DECR TLN!$)
 (PRTL1 PXR) )

(DE MATHMODE (X)  % Simplest level. Overwritten in Stensor.
  (SETQ TLN!$ 0)
% (COND (X (TERPRI)))
  (PRIN2 "$$") )

(DE PRTEN (SXP)
 (COND
  ((NULL (CDR SXP)) (VALU (CAR SXP)))
  ((NOT !*FPRT)
   (SLET ((B (CAR SXP)) (VTL (GTVRLS CRDIF!*)) UPL INX)
    (SLET ((UPIN (GET B 'UPINDX)) (TNSP (GET B 'TNSPCH))) %:LH 2 SLETs?
     (RPLACA SXP (VALU B))
     (FOREACH X IN (CDR SXP) REPLACE
      (COND
       ((NOT (NUMBERP X)) (SETQ X (VALU X)))
       (PTEVAR (SETQ X (VALU (KAR1 VTL X)))) )
      (COND           % This COND only for UP/DOWN
       (TEXMODE (SETQ INX (ADD1 (OR INX 0))))
       ((NULL INX)    % For first index, we are on base line
        (COND ((SETQ B (AATSOC 0 TNSP)) (SETQ X (CONS (CDR B) X))))
        (SETQ UPL (AMEMQ (SETQ INX 1) UPIN))
        (SETQ X (CONS (COND (UPL UP) (T DOWN)) X))    % Bugfix. JEA.
        (AND TROFF!* (SETQ X (CONS "\s-4" X))) )
       ((AMEMQ (IINCR INX) UPIN)  % Later index, to be up
         (COND ((NOT UPL) (SETQ UPL T) (SETQ X (CONSA UP UP X)))) )
       (UPL
        (SETQ UPL NIL)
        (SETQ X (CONSA DOWN DOWN X)) ) ) % Down, after up
      (COND ((SETQ B (AATSOC INX TNSP)) (SETQ X (CONS X (CDR B)))))
      X)
     (SETPARSW BASPAR)
     (COND
      (TEXMODE (SETQ INX 0) (SETQ UPL NIL)
         (FOREACH X IN (CDR SXP) REPLACE    % phantom space:
               (SETQ TNSP (LIST "@ph{" (SUBST '!\!, '!, X) "}"))
               (COND ((MEMQ (INCR INX) UPIN) (SETQ UPL (CONS X UPL))
                         TNSP)
                     (UPIN (SETQ UPL (CONS TNSP UPL)) X)
                     (T  X) ) )
%        (LIST (CAR SXP) "_{" (CDR SXP) "}^{" (REVERSE UPL) "}")
         (CONS (CAR SXP)
               (NCONC (AND (LESSP (LENGTH UPIN) (LENGTH (CDR SXP)))
                           (LIST "_{" (CDR SXP) "}") )          % DOWN
                      (AND UPL (LIST "^{" (REVERSE UPL) "}")) )) )  % UP
      (T (CONSA SXP (COND (UPL DOWN) (T UP)) TROFF!*))  % Bugfixes. JEA.
          ) ) ) )  % base
  ((OR NOREDARY TPSSW) SXP)
  (T (VTRIG (FOREACH X IN SXP REPLACE (VALU X)))) ) )

%### PRTEX.SL end
