%### SHIMP2.SL

% Implementation specific code for Sheep, part 2, functions that have
% better be defined after loading the implementation independent code.
% Portable Standard Lisp (PSL) version.

(NOTLOADTIME (REMFLAG '(HELP) 'LOSE))   % Defined in PSL.
(NOTLOADTIME (REMFLAG '(SFEXPT) 'LOSE)) % Defined in the present file.

% To get around the compiler macro problems on SUN-3:
(IFP
 (AND
  (EQ 'SUN (SYSTYPE 'MACHINE))
  (NOT (EQN 4 (SYSTYPE 'MACHINEVERS))) )
 (REMFLAG '(COLIST) 'LOSE) )

% To get around the RPLACD compiler problems on DECstations:
(IFP
 (AND
  (EQN 3.4 (SYSTYPE 'LISPVERS))
  (EQ 'MIPS_DEC (SYSTYPE 'MACHINE)) )
 (CPROGN
  (REMFLAG '(PLORDN) 'LOSE)

(DE PLORDN (MR PR) 
 (SLET ((C (CAR MR)) (NX (CDR PR)) AP A B)
  (SETQ AP (COND 
    ((SNUMP C) (SETQ A 3) NIL)
    ((NOT (EQCAR C 'TIMES)) (SETQ A 0) (RPLACA ATRM!$ C))

    ((SNUMP (CADR C)) (SETQ A 2) (CDDR C))
    (T (SETQ A 1) (CDR C)) ))
  (WHILE
   (AND NX (EQ 'GOON (SETQ C (BIGGTERM AP (COND
        ((SNUMP (SETQ C (CAR NX))) (SETQ B 3) NIL)
        ((NOT (EQCAR C 'TIMES)) (SETQ B 0) (RPLACA BTRM!$ C))
        ((SNUMP (CADR C)) (SETQ B 2) (CDDR C))
        (T (SETQ B 1) (CDR C)) )))))
   (SETQ PR NX) (UNPUSH NX) )
  (RPLACA ATRM!$ NIL)
  (RPLACA BTRM!$ NIL)
  (COND
   ((OR (NULL NX) C) (RPLACD PR MR) (RPLACD MR NX))
   ((PROGN (SETQ C (CAR NX))
     (SETQ C (XCASE (MAX B A) NIL
       (LIST 'TIMES 2 C)
       (RPLACD C (CONS 2 (CDR C)))
       (COND
        ((AZEROP (SETQ MR (COND
                  ((IEQN B A) (SPLUS (CADR C) (CADAR MR)))
                  (T (COND ((ILESSP B A) (SETQ C (CAR MR))))
                     (SADD1 (CADR C)) ) )))
         NIL)
        ((NOT (AONEP MR)) (RPLACA (CDR C) MR) C)
        ((CDDR (PLORDNRPLACD C)) C)
        (T (CADR C)) )
       (COND ((NOT (AZEROP (SETQ MR (SPLUS C (CAR MR))))) MR)) )) )
    (RPLACA NX C) )
   (T (RPLACD PR (CDR NX))) ) ) )

(DE PLORDNRPLACD (C) (RPLACD C (CDDR C)))

  ))

% BAS^EX where BAS or EX is a floating point number, both are SNUMs.
% Improved function if definitions of LOG and EXP are available
% (defined in PSL module MATHLIB). Function added by JEA.
(DE SFEXPT (BAS EX) (COND
  ((AND (NUMBERP EX) (NOT (FLOATP EX))) (EXPT BAS EX))  % EX integer.
  ((AND (FNP 'LOG) (FNP 'EXP)) (EXP (STIMES (LOG (SFLOAT BAS)) EX)))
  (T (XMKEXPT BAS EX)) ))

% Complete definition of PSL-specific switch FLUSH defined in Slisp.
(IFP (EQ 'VMS (SYSTYPE 'OS))
 (SETQ SWITCHES (APPEND SWITCHES (SETDIFFQ '(FLUSH) SWITCHES))) )

(SETQ RESIDEFUNCTIONS!* '(RESIDETENSORS))       % For MKSIDEFAP.

(DE RESIDETENSORS (TL) (SLET (X) (COND % Remove compile time tensor def
   ((NULL TL) (CONS TENALIAS!* (COPYT TENSORS)))    % for side module.
   (T (SETQ TENALIAS!* (CAAR TL))
      (SETQ X (SETDIFFQ TENSORS (SETQ TL (CDAR TL))))
      (FOREACH TN IN X DO (MAKEUNBOUND TN)
       (FOREACH Z IN '(HELP TNDEFIL LOSE) DO (REMPROP TN Z)) )
      (SETQ TENSORS TL)
      X) )))

%### SHIMP2.SL end
