%### SHIMP1.SL

% Implementation specific code for Sheep, part 1, functions that can
% be defined before loading the implementation independent code.
% Portable Standard Lisp (PSL) version.

(SETGLOBALS
 ((ALT!*        (INT2ID 27)))   % Altmode (escape) character.
 ((FF!*         (INT2ID 12))) ) % Form-feed.

% Trying to fix the ON/OFF problem in PSL.
%(REMOB 'ON)
%(REMOB 'OFF)
(REMFLAG '(ON OFF) 'IGNORE)

%(NOTLOADTIME (REMFLAG '()
% EASK FOCONFIRM FOING BIGGID2 TSTPARSW
%  'LOSE ))                             % Defined in the present file.

% BAS^EX where BAS or EX is a floating point number, both are SNUMs.
% Improved function if definitions of LOG and EXP are available
% (defined in PSL module MATHLIB). Function added by JEA.
(DE SFEXPT (BAS EX)
 (COND
  ((AND (NUMBERP EX) (NOT (FLOATP EX))) (EXPT BAS EX))  % EX integer.
  ((AND (FNP 'LOG) (FNP 'EXP)) (EXP (STIMES (LOG (SFLOAT BAS)) EX)))
  (T (XMKEXPT BAS EX)) ))

% ERO           -list of %-operator values to be substituted into:
% ERSTR         -a string that may have %-operators,
% EASKFORM!*    -expression that failed to evaluate, thereby causing
%               dialogue
% The last two arguments may be nil:
%       FOARG!* -Only after keyword "FOINP" that starts FOIN-asking:
%               indicate which tensor component etc being assigned
%       HELPFN!* -Function or string, used in case user responds
%               keyword "HELP"
%(DE EASK (ERO ERSTR EASKFORM!* FOARG!* HELPFN!*)
% (SLET (B!& (C!& ASKREPEAT!*))
%  (UNTIL (OR B!& (IMINUSP (IDECR C!&)))
%   (COND
%    (ERSTR (MSGOUT3 NIL ERSTR ERO))
%    (T (EPRTO ERO NIL)) )
%   (SETQ B!& (STDIN (PROMPTER "now" (ERRSETT (EVAL (READ))))))
%   (SETQ B!& (COND
%     ((NOT (PAIRP B!&)) NIL)
%     ((EQ (CAR B!&) 'FOINP) (STDIN (FOINP FOARG!*)))
%     ((EQ (CAR B!&) 'HELP) (QHELP HELPFN!*) (SETQ C!& ASKREPEAT!*) NIL)
%     (T (CHKQUIT (CAR B!&)) (EVAL EASKFORM!*)) ) ) )
%  (COND
%   (B!&)
%   (T (ERRORFT 480 "Asking too many times")) ) ) )

%(DE FOCONFIRM (X NODSIMPI)
% (COND ((AND X (NULL NODSIMPI)) (SETQ QWQ (SETQ X (SIMPI X)))))
% (COND
%  ((AND !*INT (OR (STDINP) CFILFO))
%   (STDIN
%    (EPRTO X FOARG!$)
%    (COND
%     ((FOIN1 "?" T))
%     ((NOT NODSIMPI) X)
%     ((EQ CHT!$ '!;) (FOCONFIRM X NIL))
%     (T (SIMPI X)) ) ) )
%  (NODSIMPI (SIMPI X))
%  (T X) ) )

% (DE FOING () (FOINGE (FOIN1 "=" T)))

%(DS TSTPARSW (!&REST L) (NOT (XZEROP (ILOGAND PARSW!* (PARSW . L)))))

% To get around the compiler macro problems on SUN-3:
(IFP
 (AND
  (EQ 'SUN (SYSTYPE 'MACHINE))
  (NOT (EQN 4 (SYSTYPE 'MACHINEVERS))) )
 (CPROGN
  (DE COLIST (N X)
   (COND ((GREATERP N 0) (CONS X (COLIST (SUB1 N) X)))) )
  (FLAG '(COLIST) 'LOSE) ))

% To get around the compiler problems on DECstations:
(IFP
 (AND
  (EQN 3.4 (SYSTYPE 'LISPVERS))
  (EQ 'MIPS_DEC (SYSTYPE 'MACHINE)) )
  (FLAG '(PLORDN) 'LOSE) )

(NOTLOADTIME (FLAG '(SFEXPT)            % Defined in shimp2.
% EASK FOCONFIRM FOING BIGGID2 TSTPARSW
  'LOSE ))
%(NOTLOADTIME (FLAG '(HELP) 'LOSE))     % Defined in PSL.

%### SHIMP1.SL end
