%### SEARSH.SL

% To set search list to be used while making Sheep.

% Fix for the Atari that doesn't know its current directory and
% for VMS PSL version 3.2 that can not find files relative to
% current directory. PSL bug gone in version 3.2A.
%
% This code will work without changes provided that all sources are
% keept in subdirectories under one common directory correctly given
% as TOPDIR!* when Sheep Lisp is built and that all subdirectories
% have their default names.
%
% Otherwise you must here set CURRENTDIR!* to the full specification
% of the current directory (including VMS or Atari device), i.e. to the
% directory where this file is found at your installation).
(IFP
 (OR
  (EQ 'ATARI (SYSTYPE 'MACHINE))        % Fix needed for Atari (Culisp).
  (AND
    (EQ 'PSL (SYSTYPE 'LISPSYSTEM))
    (NOT (GETD 'GETSTARTUPNAME))        % Exclude Unix.
    (NOT (GETFN 'MACHINENAME)) ) )  % Exclude VMS PSL 3.2A and later.
 (SETQ CURRENTDIR!*
  (ADDSUBDIR (ADDSUBDIR TOPDIR!* "shpsrc") (GET 'LISPSYS 'SUBDRS)) ) )

% Set up search list to be used when making Sheep.
(SETQ MSEARCHLIS!* '(NIL))

(ADDSUBDIRS (LIST (COND ((BOUNDP 'CURRENTDIR!*) CURRENTDIR!*)))
 '((".." NIL SHPSRCEXT SL) ) )

(IFP (EQ 'NONE (GET 'FLOADEXT 'SUBDRS)) NIL
 (ADDSUBDIRS (LIST TOPDIR!*)
  '(("shpbin" FLOADEXT)                 % Sheep binary directory.
    ("slbin" FLOADEXT) ) ) )            % Sheep Lisp binary directory.

(SETQ MSEARCHLIS!* (NCONC MSEARCHLIS!* '(HERELIST)))

(ADDSUBDIRS (LIST TOPDIR!*)
 '(("metrics" NIL)
   (("slsrc" LISPSYS) NIL FLOADEXT SLLSPEXT)
   ("slsrc" NIL SL)
   (("clasrc" LISPSYS) NIL FLOADEXT SHPSRCEXT)
   ("clasrc" NIL SHPSRCEXT)
   ("stslib" FLOADEXT STS DEF HLP)
   (("stssrc" LISPSYS) NIL FLOADEXT SL BLF)
   ("stssrc" NIL FLOADEXT STS SL BLF)
   (NIL NIL)                            % TOPDIR itself
   (("shpsrc" LISPSYS) NIL FLOADEXT SHPSRCEXT SL)
   ("shpsrc" NIL SHPSRCEXT SL) ) )

(ADDSUBDIRS NIL LISPLIBDIR!*)           % Lisp library directories.

%### SEARSH.SL end
