%### SHPMCF.SL

% SHEEP macros that are macros also for interpreter.

(BOTHTIMES (FLAG '(NEWSWITCHES IFSHPVERGE) 'DFEXPAND))

(SETFLUIDS !$MSW)                       % Sign switch.

(DS IFSHPVERGE (X !&REST L) (IFP (XSHPVERGE X) . L))

(DE XSHPVERGE (X)
 (NOT (LESSP SHPVRNR!* (COND
    ((FLOATP X) (FIX (TIMES 1000.001 (DIFFERENCE X 2))))
    (T X) ))) )

(DMACRO NEWSWITCHES (!&REST L) (SLET (A B)
  (SETQ A (FOREACH X IN L COLLECT (COND
     ((PAIRP X)
      (XPUSH B (CONSA 'ADDHLP NIL (MKQUOTE (CAR X)) (CDR X)))
      (CAR X) )
     (T X) )))
  (LIST 'CPROGN (LIST 'FLUID (MKQUOTE A))
   (MKPROGN B)
   (LIST 'SETQ 'SWITCHES
    (LIST 'APPEND 'SWITCHES
     (LIST 'SETDIFFQ (MKQUOTE A) 'SWITCHES) ) ) ) ))

% Some macros that are moved here from other modules

% From PRTL.SL
% Call PRTLF2 with all but first arg collected in a list.
% See further PRTLF2 in PRTL.SL. 
(DS PRTLF (ST !&REST AR)
 (PRTLF2 ST (LIST . AR)) )

% From FUNS.SL
% Get VARS list for variable set VT.
(DS GTVRLS (VT) (GET VT 'VARS))

% Get VARMAX for variable set VT.
(DS GTVRMX (VT) (GET VT 'VARMAX))

% Get FUNS list for variable set VT.
(DS GTFNLS (VT) (GET VT 'FUNS))

% Set FUNS list for variable set VT.
(DS STFNLS (VT L) (PUT VT 'FUNS L))

% Set VARS list for variable set VT.
(DS STVRLS (VT L) (PUT VT 'VARS L))

% Set VARMAX for variable set VT.
(DS STVRMX (VT N) (PUT VT 'VARMAX N))

(DS VARSETNAME (!&REST L) (XVARSETNAMEL 'L) SUPPRESSANS!*)

(DS VARSET (X) (XVARSET 'X))

(DS VARS (!&REST L) (VARSL 'L))

(DS FUNS (!&REST L!&) (FUNSL 'L!&))

(DS REMFUNS (!&REST L) (REMFUNSL 'L))



(DS VARMAX (!&REST L) (VARMAXL 'L))

(DS PRFUNS (!&REST FNL!&) (PRFUNSL 'FNL!&))

% From DDIFF.SL
(DS DEFEFUN (!&REST L) (DEFEFUNL 'L) SUPPRESSANS!*)

% From VALU.SL
(COMMENT                % Removed because of bootstrapping problems.
(DMACRO NEWPARSWITCHES (!&REST L)
 (SLET
  ((A (COND (PARSWITCHES!* (EVAL (CAR (LASTPAIR PARSWITCHES!*))))
            (T 1) )))
  (LIST 'PROGN
   (CONS 'SETGLOBALS 
    (FOREACH X IN L COLLECT (LIST X (SETQ A (TIMES A 2)))) )
   (SUBST L 'L
    '(BOTHTIMES
      (SETQ PARSWITCHES!* (NCONC PARSWITCHES!* (COPYT 'L)))) ) ) ) )
)

(DS PARSW (!&REST L) (GVALUE (PLUS . L)))

(DS SETPARSW (!&REST L) (SETQ PARSW!* (PARSW . L)))

(DMACRO TSTPARSW (!&REST L)
 (SLET ((A (FOREACH X IN L COLLECT (LIST 'TSTBIT 'PARSW!* (EVAL X)))))
  (COND
   ((CDR A) (CONS 'OR A))
   (T (CAR A)) ) ) )

(DS TEXT (!&REST L) (CONS 'TXT 'L))

(DS NAM (!&REST L) (DONAM 'L 'NAM) SUPPRESSANS!*)

(DS NAMF (!&REST L) (DONAM 'L 'NAMF) SUPPRESSANS!*)

(DMACRO DEFNAM (ID L !&REST PL) (IDEFNAM ID 'NAM L PL))

(DE IDEFNAM (ID TYP L PL)
 (LIST 'ISETNAM (MKQUOTE ID) (MKQUOTE TYP)
  (LIST 'DOINAM (MKQUOTE (NCONS L)))
  (COND (PL (CONS 'PARSW PL))) ) )

(DMACRO DEFNAMF (ID L !&REST PL) (IDEFNAM ID 'NAMF L PL))

(DS NAMUC (!&REST L) (DONAMC T 'NAM 'L))

(DS NAMLC (!&REST L) (DONAMC NIL 'NAM 'L))

% From SUBL1.SL
(DS SETSUP (SU !&REST L) (ISETSUP 'SU NIL NIL NIL 'L))

(DS NEWSUP (SU !&REST L) (ISETSUP 'SU 1 T T 'L))

(DS REMSUB (!&REST L)
 ((LAMBDA (A)    
   (PRINTF "%w substitutions removed" (COND ((AZEROP A) "No") (T A)))
   SUPPRESSANS!*)
  (REMSUB1 'L)) )  

(DS USESUL (SUL !&REST L) (USESUL2 'SUL 'L))

(DS MOVSUL (X !&REST L) (XMOVSUL 'X 'L))

(DS NEWSUL (!&REST L) (XNEWSUL 'L) SUPPRESSANS!*)

(DS SETNSUB (!&REST L) (XSETNSUB 'L) SUPPRESSANS!*)

(DS SETSUB (!&REST L) (XSETSUBL 'L))

(DS PRSUB (!&REST L) (XPRSUB 'L) SUPPRESSANS!*)

% From BIGGER.SL
(DS SMMINUSP (X) (SMLESSP X 0))

(DS SETENQ (TN X) (SETEN 'TN X))



(DMACRO SMTIMC (!&REST L) (ISHTIMES L T))
% Multiply and copy sheep expressions.

(DMACRO SHTIMES (!&REST L) (ISHTIMES L NIL))
% Multiply and copy when necessary.
% This is the normal. SMTIM(C) are obsolete.

(DE ISHTIMES (L SW)
% L: list of s-expressions that will evaluate to shp-expressions.
% SW: is true to copy all.
 (COND
  ((NULL L) 1)
  ((NULL (CDR L))               % *a = a Analyze single expr with?
   (TQCOPY (CAR L) SW) )        % copy
  (T (SLET (!$MSW NL NM CSW VD VRL Y)
      (SETQ L (FOREACH X IN L CONC      % Look at each s-expression.
        (COND
         ((NOT (SETQ Y (SNUMEVP X)))    % If it not evaluates to a
          (SETQ X (SMCDC X))            % sheep number then analyze
          (COND ((CAR X) (SETQ VD T)))  % single expression.
          (COND ((NULL (CADR X)) (SETQ CSW T)))
          (LIST X) )
         ((SNUMP Y) (SETQ NM (COND (NM (SNUTIM NM Y)) (T Y))) NIL)
         (T (XPUSH NL X) NIL) )))   % Put on list NL and remove from L.
      (COND
       ((NULL CSW) (SETQ SW T))
       ((NOT SW) (SETQ VD T)) )
      (COND (NM (XPUSH NL NM)))
      (SETQ NM (COND
        ((NULL NL) 1)
        ((CDR NL) (CONS 'STIMES NL))
        (T (CAR NL)) ))      
      (COND
       ((NULL L) NM)
       ((NULL (CDR L)) (SNUTIMQ NM (ZMCDC (CAR L))))
       ((AND SW (NULL (CDDR L)))
        (SNUTIMQ NM (XIDOMULC (CAR L) (CADR L) !$MSW)) )
       (T (FOREACH X IN L REPLACE
           (SETQ VRL (CAR X)) (SETQ CSW (OR (CADR X) SW))
           (SETQ X (XMCDC X CSW VRL))
           (COND
            ((NULL VRL) (COND ((AND CSW VD) (LIST 'XCOPY X)) (T X)) )
            ((CDDR VRL)
             (LIST 'SMDIFFL X (CONS 'LIST (CDR VRL)) (CAR VRL)) )
            (T (LIST 'SMDIFF X (CADR VRL) (CAR VRL))) ) )
          (CONSA 'XMMULTC (NOT VD) !$MSW NM L) ) ) )) ) )

(DE SNUTIMQ (NM SX) (COND
  ((AONEP NM) SX)
  (T (LIST 'SNUTIM NM SX)) ))

(DE SMCDC (X)
 (SLET (CSW CJSW VRL VT VT1 TN AL)
  (WHILE (COND
    ((EQCAR X 'SHMINUS) (SETQ !$MSW (NOT !$MSW)) T)
    ((EQCAR X 'SHCONJ) (SETQ CJSW (NOT CJSW)) T)
    ((AND (EQCAR X 'SHDIFF) (NOT CJSW)   % Bugfix. JEA
      (OR (NULL (SETQ VT1 (CDDDR X)))
       (COND
        ((NULL VT) (SETQ VT (CAR VT1)))
        (T (EQUAL VT (CAR VT1))) ) ) )
     (SETQ VRL (CONS (CADDR X) VRL)) )      
    ((EQCAR X 'SHCOPY) (SETQ CSW T)) )
   (SETQ X (CADR X)) )
  (COND ((AND !$MSW (EQCAR X 'SHTIMES))
         (SETQ X (CONSA 'SHTIMES (LIST 'SHMINUS (CADR X)) (CDDR X)))
         (SETQ !$MSW NIL) ))
  (COND ((AND VRL (NULL VT)) (SETQ VT 'CRDIF!*)))
  (COND
   ((NOT (PAIRP X)) (COND
     ((TENP (TENALIAS X)) (SETQ TN (MKQUOTE X)))
     (T (SETQ CSW T)) ))
   ((EQ (CAR X) 'GETEN) (SETQ TN (CADR X)) (SETQ AL (CADDR X)))
   ((EQ (CAR X) 'GETSCL) (SETQ TN (CADR X)))
   ((EQ (CAR X) 'SHGETEN)
    (SETQ TN (CADR X))
    (COND ((CDDR X) (SETQ AL (CONS 'LIST (CDDR X))))) )
   ((TENP (CAR X))
    (SETQ TN (MKQUOTE (CAR X)))
    (COND ((CDR X) (SETQ AL (CONS 'LIST (CDR X))))) ) )
  (COND
   (TN (SETQ CSW 'XGETEN) (SETQ X (LIST TN AL CJSW)))
   (CJSW (SETQ X (LIST 'CONJOF X))) )
  (CONSA (COND (VRL (CONS VT VRL))) CSW X) ) )
% If a tensor is accessed the result is
%  (<diff variables> . <XGETEN call>)
%  else (<diff variables> . <copy switch> . <expression>)

(DE ZMCDC (X)
% Used to make a call from result of SMCDC by functions that do
% not defer copying (plus etc.).
 (SLET ((VRL (CAR X)) (CSW (CADR X)))
  (UNPUSH X)
  (COND
   ((EQ CSW 'XGETEN)
    (NCONC1 (RPLACA X (COND (VRL 'ZGETEN) (T 'CZGETEN))) !$MSW) ) %LH
   (T (UNPUSH X)
      (COND
       (CSW (COND ((NULL (SETQ CSW VRL)) (SETQ X (COND
                     ((EQCAR X 'CONJOF)
                      (LIST 'CPLXCONJ (RPLACA X 'DOCOPY)) )
                     (T (LIST 'DOCOPY X)) )))))
       ((EQCAR X 'CONJOF) (RPLACA X 'CPLXCONJ)) )
      (COND
       (!$MSW
        (SETQ X (LIST (COND (CSW 'NSMMINUS) (T 'SMMINUS)) X)) ) ) ) )
  (COND
   ((NULL VRL) X)
   ((CDDR VRL)
    (LIST (COND (CSW 'SMDIFFCL) (T 'SMDIFFL)) X
          (CONS 'LIST (CDR VRL)) (CAR VRL) ) )       % JEA
   (T (LIST (COND (CSW 'SMDIFFC) (T 'SMDIFF))
            X (CADR VRL) (CAR VRL) )) ) ) )

(DE XMCDC (X CSW VRL) (PROGN
  (SETQ X (CDDR X))
  (COND
   ((EQ CSW 'XGETEN) (CONS (COND (VRL 'CXGETEN) (T 'XGETEN)) X))
   ((NOT VRL) X)
   (CSW (COND
     ((EQCAR X 'CONJOF) (LIST 'CPLXCONJ (RPLACA X 'COPYL)))
     (T (LIST 'COPYL X)) ))
   ((EQCAR X 'CONJOF) (RPLACA X 'CPLXCONJ))
   (T X) ) ))

(DE XIDOMULC (X Y MSW)
 (SLET ((VRL1 (CAR X)) (VRL2 (CAR Y)))
  (SETQ X (XMCDC X (CADR X) NIL))
  (SETQ Y (XMCDC Y (CADR Y) NIL))
  (COND ((AND VRL1 (NULL VRL2)) (EXCHANGE VRL1 VRL2) (EXCHANGE X Y)))
  (COND
   ((NULL VRL2) (LIST 'XMDOMULC X Y MSW))
   ((NULL VRL1) (COND
     ((CDDR VRL2)
      (LIST 'XMDFMQL X Y (CONS 'LIST (CDR VRL2)) (CAR VRL2) MSW) )
     (T (LIST 'XMDFMQ X Y (CADR VRL2) (CAR VRL2) MSW)) ))
   (T (LIST 'XMDFMQ2L X Y (CONS 'LIST (CDR VRL1)) (CAR VRL1)
            (CONS 'LIST (CDR VRL2)) (CAR VRL2) MSW )) ) ) )

(DMACRO SMPLUC (!&REST L) (ISMPLU L T))

(DMACRO SHPLUS (!&REST L) (ISMPLU L NIL))

(DE ISMPLU (L SW) (COND
  ((NULL L) 0)
  ((NULL (CDR L)) (TQCOPY (CAR L) SW))
  ((NULL (CDDR L))
   (LIST 'SMPLUS2 (TQCOPY (CAR L) SW) (TQCOPY (CADR L) SW)) )
  (T (CONS 'XMPLUS (FOREACH X IN L COLLECT (TQCOPY X SW)))) ))

(DE TQCOPY (X SW) (COND
  ((SNUMEVP X) X)
  (T (SLET (!$MSW)
           (ZMCDC (SMCDC (COND (SW (LIST 'SHCOPY X)) (T X)))) )) ))

(DMACRO SHCOLLECT (!&REST L)
 (CONSA 'PROG '(COLL!*) (APPEND1 L '(RETURN (PLUSEND COLL!*)))) )

(DMACRO SHADDTERM (X) (LIST 'SMADDTERM (TQCOPY X NIL)))

(FLAG '(HALF!* MIHALF!*) 'SNUMCONST)

(DMACRO SHEXPT (BAS EX) (LIST 'XMEXPT (TQCOPY BAS NIL) (TQCOPY EX NIL)))

(DMACRO SHRTIMES (NRG X)
 (LIST
  (COND
   ((SNUMEVP NRG) 'SNUTIM)
   (T 'XMRTIMES) )
  NRG
  (TQCOPY X NIL) ) )

(DE SNUMEVP (X) (COND
 ((PAIRP X)
  (COND ((AND (EQ (CAR X) 'QUOTE) (SNUMP (CADR X))) (CADR X))) )
 ((NUMBERP X) X)
 ((FLAGP X 'SNUMCONST) (COND
   ((CONSTANTP X) (EVAL X))
   (T X) )) ))

(DMACRO SHDIFF (!&MACRO !&REST X) (TQCOPY X NIL))

(DMACRO SHCONJ (!&MACRO !&REST X) (TQCOPY X NIL))

(DMACRO SHMINUS (!&MACRO !&REST X) (TQCOPY X NIL))

(DMACRO SHCOPY (!&MACRO !&REST X) (TQCOPY  X NIL))

(DMACRO SHGETEN (TN !&REST L)
 (LIST 'CZGETEN TN (COND (L (CONS 'LIST L))) NIL NIL) )

(DMACRO ADDTO (X Y) (LIST 'SETQ X (LIST 'SMPLUS2 (TQCOPY Y NIL) X)))

%### SHPMCF.SL end
