%### SUMBOU.SL

%:fil SUMBOU.SL Functions to SUMmate between BOUndaries,used in
% TCOMPed files
% Copyright (c) 1989 Lars Hornfeldt, Phys. dep. Stockholm Univ., Sweden.

(DE CMULT (L) (SMMULTC L 1 NIL T))
% (DM PLSMN (L) (CONS (QUOTE XMPLUS) (CDR L)))

(SETFLUIDS INDX1 INDX2 INDX3 INDX4 INDX5 INDX6 INDX7 INDX8 X!*
           NOSEQUENCE ANS!* NZA!* NZB!* !*1 !*2 !*3 !*4 !*5 !*6 !*7 !*8)

(NEWSWITCHES (
 FORCEIT
 "Redeclare tsr-arrays,allow <A i<+<B j< etc.Use only when sure")) %:nsw

(DFEXPR QDECLTEN (!&REST L)             % Q-uareful, or
 (COND
  ((OR FORCEIT (NOT (GET (CAR L) 'TTYPE))) % overriding previous declaration?
   (XDECLTEN (CAR L) (CADR L) NIL) ) ) )
%(DFEXPR QDECLTEN (!&REST L) (AND        % Q-uareful, or
%  (OR FORCEIT (NOT (GET (CAR L) 'TTYPE))) % overriding previous declaration?
%% (OR FORCEIT (NOT (TENP (CAR L))))     % overriding previous declaration?
%  (XDECLTEN (CAR L) (CADR L) NIL) ))

(DE PUTX!* (V) (PUT X!* (CAR V) (CDR V)))  %:b
(IFP (GETFN 'PUTL) ()
(DE PUTL (X!* L)      %:b (PUTL atm ((p1 . v1)..))/sps
 (FOREACH X IN L DO (PUTX!* X)) )
)
(DE ADANZ (X) (SETQ ANS!* (SMPLUS2 X ANS!*)))

  % SUMmate over *1 [from its crnt val to zero] : EXpression
(DE SUM!*1 (!*1 EX)
 (WHILE (NOT (IMINUSP (IDECR !*1))) (ADANZ (EVAL EX))) )
%(DE SUM!*1 (!*1 EX) (PROG NIL 
%  L (COND ((MINUSP (SETQ !*1 (SUB1 !*1)) ))
%          ((ADANZ (EVAL EX)) (GO L)) )))

  % SUMmate over Dmy [frm Low to Upper BOUndary] : EXpression
(DE SUMBOU (D L U EX)
 (SET D U)
 (WHILE (NOT (ILESSP (SET D (ISUB1 (EVAL D))) L)) (EVAL EX)) )
% (PROG NIL
%    (SET D U)
%L   (COND ((NOT (GREATERP L (SET D (SUB1 (EVAL D)))))
%           (EVAL EX)
%           (GO L) ))))

%   NoZero DO. If A nonzro, eval B. If nonzro, Eval DO,which combines A and B
(DE NOZDO (NZA!* NZB!* D) (COND
  ((OR (AZEROP NZA!*) (AZEROP (SETQ NZB!* (EVAL NZB!*)))) 0)
  (T (EVAL D)) ))

% Part two: Previously file SUMBOM.STS, being a Macro-change of SUMBOU.STS.
%hlp    FUM!*1 and FUMBOU  - used in lisp-compilable BLF-files.
% (Might have command (COMPILETIME (LOAD "STE:SUMBOM.STS")) in .BLF-file.)
% When compiling a .BLF, all SUM... are turned into FUM...  through sumboM.
% In order to run compiled .BLF-files, keep also FUM-functions in sheep:
   % FUM!*1 AND FUMBOU are as SUM!* and SUMBOU except for the last
   % argument: That should in F-UM... be a F-unction of no arguments,
   % whereas it in the S-UM... functions should be the corresponding body;
   % ie a S-expression. The advantage with functional arguments (LAMBDA..)
   % is that they are possible to Lisp-compile (if surrounded by FUNCTION).
   % For that effect, this file must be present when compiling the .BLF-file.

(DE FUM!*1 (!*1 EX)                     % SUM!*1 with FU-nctional arg
 (WHILE (NOT (IMINUSP (IDECR !*1))) (ADANZ (FUNCALL EX))) )
% (PROG NIL
%  L (COND ((MINUSP (SETQ !*1 (SUB1 !*1)) ))
%          ((ADANZ (FUNCALL EX)) (GO L)) )))    % Run fun of no args

(DE FUMBOU (D L U EX)                   % SUMBOU with FU-nctional arg
    (SET D U)
    (WHILE (NOT (ILESSP (SET D (ISUB1 (EVAL D))) L)) (FUNCALL EX)) )
% (PROG NIL
%    (SET D U)
%L   (COND ((NOT (GREATERP L (SET D (SUB1 (EVAL D)))))
%           (FUNCALL EX)                % Run fun of no args
%           (GO L) ))))

%### SUMBOU.SL end
