%### TNPARS.SL

(SETFLUIDS CONSTR!$)

(LOCALFUNCTIONS ITNPARSE NOSELERR)

(DMACRO WMTNVL (!&MACRO FN !&REST L) (IMTNVL FN L T))

(DMACRO MTNVL (!&MACRO FN !&REST L) (IMTNVL FN L NIL))

(DE IMTNVL (FN L SW)
 (LIST 'SWMAPCAN (MKQUOTE L) SW (LIST 'FUNCTION (GET FN 'TEVL))) )

(COMMENT % JEA's version moved to TENVAL.SL
(DE SWMAPCAN (L!& SW!& FN!&) (COND
  ((FOREACH X!& IN (TNPARSE L!&) CONC (FUNCALL FN!& X!& SW!&)))
  (T SUPPRESSANS!*) )) )

(DE SWMAPNIL (L SW FN)
 (SLET (A)
  (SETQ L (TNPARSE L))
  (WHILE (AND L (NULL (SETQ A (FUNCALL FN (CAR L) SW)))) (UNPUSH L))
  (COND (A (CONS A L))) ) )
  
(DE TTNPARSE (L) (ITNPARSE L T))

(DE TNPARSE (L) (ITNPARSE L NIL))

(DE ITNPARSE (L SW) (SLET ((TN LATEN!*) A B C)
  (COND 
   ((NULL L) (SETQ L LTNARG!*))
   ((NOT SW) (SETQ LTNARG!* L)) )
  (WHILE L
   (COND
    ((EQ (SETQ B (CAR L)) 'ALL)
     (SETQ L (APPEND VALUES (APPEND TENSORS (CDR L)))))
    ((EQ B 'TENSORS) (SETQ L (APPEND TENSORS (CDR L))))
    ((EQ B 'VALUES) (SETQ L (APPEND VALUES (CDR L))))
    ((SETQ C (IGET B 'DEFA)) (SETQ L (APPEND C (CDR L))))
    ((SETQ C (IGET B 'DEFAQ)) (SETQ A (REVERSEX C A)) (SETQ L NIL))
    ((SETQ C (IGET B 'TNPARSFN)) (SETQ L (FUNCALL C (CDR L))))
    ((AND (PAIRP B) (SETQ C (IGET (CAR B) 'TNPARSFN)))
     (SETQ L (NCONC (FUNCALL C (CDR B)) (CDR L))) )
    (T (XPUSH A (COND 
         ((OR (PAIRP B) (STRINGP B)) (NOSELERR B SW) (UNPUSH L) B)
         (T (COND ((AND (IDP B) (NOT (MEMQ B '(FROM TO))))
                   (SETQ TN (TENALIAS B))
                   (COND ((NULL SW) (SETQ LATEN!* TN)))
                   (UNPUSH L) ))
            (SETQ B (SETQ C NIL))
            (COND
             ((NULL L) TN)
             ((NUMBERP (CAR L))
              (NOSELERR (CAR L) SW)           
              (SETQ B (LIST (CAR L))) 
              (WHILE
               (AND (UNPUSH L) (NUMBERP (CAR L)))
               (XPUSH B (CAR L)) )
              (ONEELM TN (REVERSIP B)) )
             (T (SETQ B (COND ((EQCAR L 'FROM) (NOSELERR (CAR L) SW)
                               (WHILE
                                (AND (UNPUSH L) L (NUMBERP (CAR L)))
                                (XPUSH B (CAR L)) )
                               (REVERSIP B) )))
% Bugfixes, EQCAR rater than (EQ (CAR L) 'FROM) and similar for TO. JEA.
                (SETQ C (COND ((EQCAR L 'TO) (NOSELERR (CAR L) SW)
                               (WHILE
                                (AND (UNPUSH L) L (NUMBERP (CAR L)))
                                (XPUSH C (CAR L)) )
                               (REVERSIP C) )))
                (COND
                 ((OR B C) (RANGE TN B C))
                 (T TN) ) ) ) ) ) ) ) ) )
  (REVERSIP A) ))

(DE NOSELERR (X SW)
 (COND (SW (ERRORFT 557 "%r is not a tensor name in TNSELECT" X))) )

(DC TENSORS HELP ()
 (LLHELP "The following 'tensors' are defined:" TENSORS) )

(DMACRO DEFTENALIAS (NM !&REST L)
 (SETQ TENALIAS!* L)
 (LIST 'PROGN
  (LIST 'FLAG
   (MKQUOTE (FOREACH X IN L COLLECT (CAR X)))
   '(QUOTE TNALIAS) )
  (LIST 'DPUT NM 'TENALIAS L) ) )

(DE TENALIAS (TN)
 (SLET ((A (ATSOC TN TENALIAS!*)))
  (COND
   (A (CDR A))
   (T TN) ) ) )

(DE TENREVALIAS (TN)
 (SLET ((A (RATSOC TN TENALIAS!*)))
  (COND
   (A (CAR A))
   (T TN) ) ) )

(DE SETFRAME (X)
 (SLET ((A (GET X 'FRAMEFILE)))
  (COND (A (MLOAD A)))
  (SETFR X (GET X 'FRAMETYPE)) ) )

(DE SETFR (X Y)
 (COND ((NULL Y) (ERRORFT 560 "Unknown frame type %r" X)))
 (SETQ FRAMETYPE!* Y)
 (SETQ TENALIAS!* (GET Y 'TENALIAS))
 (APPLYQ (GET X 'FRAMEEV))
 (SETQ X (OR (GET X 'FRAMENAM) X))
 (COND ((NOT (EQ FRAME X)) (TRYLOSDEP FRAME)))
 (SETQ FRAME X) )

(DMACRO LORENTZ (!&MACRO FN) (LIST 'SETFRAME (MKQUOTE FN)))

(FOREACH X IN '(NULLT HNULL EUCLIDEAN CONST GFRAME CORD) DO
 (MOVD X 'LORENTZ) )

(DEFLIST '((LORENTZ FRAME) (NULLT FRAME) (HNULL FRAME) (EUCLIDEAN FRAME)
           (CONST FRAME) (CORD CORD) (GFRAME GFRAME))
         'FRAMEFILE)

(PUT 'TNSELECT 'TNPARSFN 'TTNPARSE)

(DC UNION TNPARSFN (L)
 (SLET (A)
  (FOREACH TN IN (TTNPARSE L) DO
   (COND ((NOT (MEMBER TN A)) (XPUSH A TN))) )
  (REVERSIP A) ) )

(DC SETDIFF TNPARSFN (L)
 (SLET (A (B (TTNPARSE (CAR L))))
  (SETQ L (TTNPARSE (CDR L)))
  (FOREACH TN IN B DO (COND ((NOT (MEMBER TN L)) (XPUSH A TN))))
  (REVERSIP A) ) )

(DC XN TNPARSFN (L)
 (SLET ((A (TTNPARSE (LIST (CAR L)))))
  (FOREACH X IN (CDR L) DO
   (SETQ X (TTNPARSE (LIST X)))
   (FOREACH Y ON A DO
    (COND ((NOT (MEMBER (CAR Y) X)) (RPLACA Y NIL))) ) )
  (DELQIP NIL A) ) )

(DC INPUT TNPARSFN (L) (SLET (CONSTR!$)
  (FOREACH TN IN (TTNPARSE L) CONC
   (COND ((NOT (OR (MEMQ TN CONSTR!$) (NOTALLMADEP TN) (BUILDABLE TN)))
          (LIST TN) )) ) ))

(DE BUILDABLE (TN)
 (SLET ((A (GET TN 'PREQ)))
  (COND
   ((NULL A) NIL)
   (T (WHILE (AND A (OR (MEMQ (CAR A) CONSTR!$)
                        (ALLMADEP (CAR A))
                        (BUILDABLE (CAR A)) ))
       (UNPUSH A) )
      (COND ((NULL A) (XPUSH CONSTR!$ TN) T)) ) ) ) )

(DC MODULE TNPARSFN (L)
 (FOREACH TN IN TENSORS CONC
 (COND ((MEMQ (IGET TN 'TNDEFIL) L) (LIST TN))) ) )

(DC TOUCHED TNPARSFN (L) (ITNGTN L 'TENARY))

(DC ALLEXIST TNPARSFN (L)
 (FOREACH TN IN (TTNPARSE L) CONC
  (COND
   ((AND (GET TN 'TENARY) (CHKTENP (FUNCTION RETARG) TN))
    (LIST TN) ) ) ) )

(DC ALLNULL TNPARSFN (L)
 (FOREACH TN IN (TTNPARSE L) CONC
  (COND ((OR (NOT (GET TN 'TENARY)) (CHKTENP (FUNCTION NULL) TN))
         (LIST TN) )) ) )

(DC TESTALL TNPARSFN (L)
 (SLET ((FN (CAR L)))
  (FOREACH TN IN (TTNPARSE (CDR L)) CONC
   (COND ((AND (GET TN 'TENARY) (CHKTENP FN TN)) (LIST TN))) ) ) )

(DC TESTGET TNPARSFN (L) (ITNGTN (CDR L) (CAR L)))

(DC TESTFLAG TNPARSFN (L) (ITNFLTN (CDR L) (CAR L)))

(DE ITNFLTN (L TYP)
 (FOREACH TN IN (TTNPARSE L) CONC (COND ((FLAGP TN TYP) (LIST TN)))) )

(DC ALLZERO TNPARSFN (L)
 (FOREACH TN IN (TTNPARSE L) CONC (COND ((TALLZEROP TN) (LIST TN)))) )

(DC BUILD TNPARSFN (L) (ITNGTN L 'BULF))

(DE ITNGTN (L TYP)
 (FOREACH TN IN (TTNPARSE L) CONC (COND ((GET TN TYP) (LIST TN)))) )

(DC NOT TNPARSFN (L) (SETDIFFQ TENSORS (TTNPARSE L)))

(DC DEPENDSON TNPARSFN (L) (XDEPENDSON L))

(DS TNSELECT (!&REST L) (TTNPARSE 'L))

(DS DEFA (X !&REST L) (XDEFA 'X 'L))

(DE XDEFA (X L) (COND
  ((NULL X) (FOREACH Y IN L DO (REMPROP Y 'DEFA) (REMPROP Y 'DEFAQ)))
  ((EQ (CAR L) 'TNPARSE) (SETDEFA X (CDR L) T))
  (T (SETDEFA X L NIL)) ))

(DE SETDEFA (X L SW)
 (SLET ((A (OR (GET X 'DEFA) (GET X 'DEFAQ))) LTNARG!*)
  (COND (L (REMPROP X (COND (SW 'DEFA) (T 'DEFAQ)))
           (COND
            (SW (PUT X 'DEFAQ (TNPARSE L)))
            (T (PUT X 'DEFA L)) ) ))
  A) )

(DS FILEWRITE (FIL !&REST BODY)
 (FILEOUT (OUTFILENAME NIL 'FIL PRTEXT!*) (TITLE)
  (SWMAPCAN 'BODY NIL (FUNCTION XWRITE)) ) )

%(DMACRO FILEWRITE (FIL !&REST BODY)
% (LIST 'OUTF FIL '(TITLE)
%  (LIST 'SWMAPCAN (MKQUOTE BODY) NIL '(FUNCTION XWRITE)) ) )

(DS SAVETN (FIL !&REST BODY)
 (FILEOUT (OUTFILENAME NIL 'FIL SAVEXT!*) (PRIN2 "%SHEEP save") (TERPRI)
  (SWMAPCAN 'BODY T (FUNCTION XLPRINT)) ) )

%(DMACRO SAVETN (FIL !&REST BODY)
% (LIST 'OUTF FIL '(PRIN2 "%SHEEP save") '(TERPRI)
%  (LIST 'SWMAPCAN (MKQUOTE BODY) T '(FUNCTION XLPRINT)) ) )

(DMACRO RESTORETN (FIL)
 (LIST 'LOADX (MKQUOTE FIL) 'MSEARCHLIS!* (MKQUOTE (LIST SAVEXT!*))
       '(QUOTE N) NIL) )

(DS DTINPUT (TNX SHX) (TINPUT 'TNX 'SHX))

% REDOUT, file output in Reduce format. Formerly called FOUT.
% Updated version of REDOUT to output DEPENDencies and ARRAY sizes.
% This version of REDOUT contains code originally by JEFS.
(DS REDOUT (FIL !&REST BODY) (XREDOUT 'FIL 'BODY))

(DE XREDOUT (FIL BODY)
 (FILEOUT (OUTFILENAME NIL FIL FOEXT!*) (PRIN2 "%SHEEP Fsave") (TERPRI)
  (WRITEALLFUNDEPS)
  (SWMAPCAN BODY T (FUNCTION XLFPRT))
  (PRIN2T "END$") ) )

% REDIN, read in Reduce style file. Formerly called FIN.
(DS REDIN (FIL) (REDINXPR 'FIL))

(DE REDINXPR (FIL) (SLET ((INFN!* 'FOINRR))
  (LOADX FIL MSEARCHLIS!* (LIST ROEXT!* FOEXT!*) 'N NIL) ))

(DS LOSDEP (!&REST L) (EXPRLOSDEP 'L))

(DS KEEP (!&REST L) (XKEEP 'L))

(DS NOTKEEP (!&REST L) (XNOTKEEP 'L))

(DS TNPRIN (!&REST L) (XTNPRIN 'L))

(DS NOTTNPRIN (!&REST L) (XNOTTNPRIN 'L))

(DS TITLE (!&REST NTITL) (XTITLE 'NTITL) SUPPRESSANS!*)

(DS PREQ (TN !&REST L) (XPREQ 'TN 'L))

(DS TNVL (!&REST L) (TNVLL 'L))

(DE TNVLL (L)
 (FOREACH X IN L DO
  (COND
   ((CADR X) (MOVD (CADR X) 'WMTNVL) (PUT (CADR X) 'TEVL (CADDR X))) )
  (COND
   ((CAR X) (MOVD (CAR X) 'MTNVL) (PUT (CAR X) 'TEVL (CADDR X))) ) ) )

% W(A)SYMBOLIC added by JEA.
(TNVL (RPL WRPL XRPL) (LREAD WLREAD XLREAD) (LFREAD WLFREAD XLFREAD)
 (LSTAT NIL XLSTAT) (LINIT WLINIT XLINIT)
 (SYMBOLIC WSYMBOLIC XSYMBOLIC) (ASYMBOLIC WASYMBOLIC XASYMBOLIC)
 (TPSINIT NIL XTPSINIT) (LSIMP WLSIMP XLSIMP) (LAPLY WLAPLY XLAPLY)
 (SYMMETRIZE NIL XSYMMETRIZE) (MAKE WMAKE XMAKE)
 (REMAKE WREMAKE XREMAKE) (WRITE AWRITE XWRITE) (LFPRT ALFPRT XLFPRT)
 (ALLTENP NIL XALLTENP) (ISALLZEROP NIL XALLZEROP)
 (LPRINT ALPRINT XLPRINT) )

(DS LOSE (!&REST L) (LOSEL (TNPARSE 'L) NIL) SUPPRESSANS!*)

(DS LOSND (!&REST L) (LOSEL (TNPARSE 'L) T) SUPPRESSANS!*)

(DS ZINPUT (!&REST L) (SLET ((LINITFN!* 'RETZERO))
  (SWMAPCAN 'L NIL (FUNCTION XLINIT))
  (FOLOOP) ))

(DS ZMAKE (!&REST L) (SWMAPNIL 'L NIL (FUNCTION XZMAKE)))

(DS WZMAKE (!&REST L) (SWMAPNIL 'L T (FUNCTION XZMAKE)))

% (WINPUT) writes all tensors that seem to have been input rather than
% calculated from others.
(DS WINPUT () (WRITE (INPUT TENSORS)))

% You normally want NOZERO to be on when doing (PRINPUT).
% Changed back from DS to DE as in my original version. JEA.
(DE PRINPUT NIL
 (PVARS)
 (PRFUNS)
 (PRSUB LISTS)
 (WRITE (INPUT TENSORS)) )

%### TNPARS.SL end
