%### EXINTI.SL ======================================================
%
%       EXINTI.SL
%       ---------
%
%       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
%
%
%       This file contains definitions of some extensions to Standard
%       Lisp. As many definitions are in the form of FEXPRs, this
%       file should only be used with the interpreter. When compiling,
%       the file EXCOMI.SL should be used instead.
%
%====================================================================

(FUNCTIONS REEVALFORM ERRSET
           MAPRPLC MAPRPL I!$!*PROGN REPEATS WHILE UNTIL PROG1 XCASE)

(ENTRYPOINTS REEVALFORM ERRSET
             MAPRPLC MAPRPL REPEATS WHILE UNTIL PROG1 XCASE)

(LOCALFUNCTIONS I!$!*PROGN)

(SETFLUIDS ERS!*BODY)

% Create a form that can be evaluated again without reevaluating the
% arguments.
(DFEXPR REEVALFORM (RVF!&FN !&REST RVF!&ARGS)
 (CONS
  RVF!&FN
  (FOREACH RVF!&X IN RVF!&ARGS COLLECT (MKQUOTE (EVAL RVF!&X))) ) )

(DFEXPR ERRSET (ERS!*BODY ERS!&SW)
 (PLET ((!*ERRMSG (EVAL ERS!&SW)) (SFVR!& (CAPTURESFSTKS)))
  (UNBINDSFSTKS SFVR!&
   (ERRORSET ERS!*BODY !*ERRMSG (AND !*ERRMSG !*BACKTRACE)) ) ) )

% MAPRPL and MAPRPLC replaces each element in a list and returns the
% list.
(DE MAPRPLC (L FN)
 (FOREACH X ON L DO (RPLACA X (FUNCALL FN (CAR X))))
 L)

(DE MAPRPL (L FN)
 (FOREACH X ON L DO (RPLACA X (FUNCALL FN X)))
 L)

(DE I!$!*PROGN (IPRG!&U) (FOREACH IPRG!&X IN IPRG!&U DO (EVAL IPRG!&X)))

% REPEATS(COUNT:integer,[XPR:form]):NIL
% The XPRs are evaluated COUNT times.
(DFEXPR REPEATS (RP!&C !&REST RP!&L)
 (SETQ RP!&C (EVAL RP!&C))
 (WHILE (NOT (XMINUSP (XDECR RP!&C))) (I!$!*PROGN RP!&L)) )

(DFEXPR WHILE (WH!&TST !&REST WH!&L)
 (PROG ()
   (GO A)
 B (I!$!*PROGN WH!&L)
 A (COND ((EVAL WH!&TST) (GO B))) ) )

(COMMENT
(DFEXPR REPEAT (!&REST RP!&L) (COND (RP!&L 
   (PROG (RP!&A RP!&)
  B (SETQ RP!&A RP!&L)
  A (COND ((CDR RP!&A)
           (EVAL (CAR RP!&A))
           (SETQ RP!&A (CDR RP!&A))
           (GO A) ))
    (COND ((NULL (EVAL (CAR RP!&A))) (GO B))) ) ))) )

(DFEXPR UNTIL (UN!&TST !&REST UN!&L)
 (PROG ()
 B (I!$!*PROGN UN!&L)
   (COND ((NULL (EVAL UN!&TST)) (GO B))) ) )

% PROG1([XPR:form]):any
% Evaluates the XPR from left to right and returns the value of the
% first XPR.
(DFEXPR PROG1 (PR1!&A !&REST PR1!&L)
 (SETQ PR1!&A (EVAL PR1!&A))
 (I!$!*PROGN PR1!&L)
 PR1!&A)

% XCASE is called as XCASE(X,Z,Y(0),Y(1),...,Y(n)).
% If the value of X is a number in the range 0:n then Y(X) is evaluated,
% otherwise Z is evaluated. 
(DMACRO XCASE (XC!&CS XC!&D !&REST XC!&L)
 (COND
   ((AND
     (FIXP (SETQ XC!&CS (EVAL XC!&CS)))
     (SETQ XC!&L (CNDR XC!&L XC!&CS)) )
    (CAR XC!&L) )
   (T XC!&D) ) )

(DPUT XCASE MACEXPDFN MACEXPDL1)

%### EXINTI.SL end
