;;;### MKSL.SL ========================================================
;;;
;;;       MKSL.SL
;;;       -------
;;;
;;;       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
;;;       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
;;;       S-113 46  Stockholm, Sweden.
;;;
;;;       This file contains the commands executed in Portable Standard
;;;       Lisp (PSL) to build a compiled Sheep Lisp.
;;;
;;;====================================================================

(LOAD "slcpload")

;;;(LOAD COMPILER)

(SETQ !*COMP NIL)

(setf *common-lisp-readtable* *readtable*)

(setf *readtable* *standard-lisp-readtable*)

(in-package 'standard-lisp)

(COND ((NOT (GETD 'INCLUDE)) (LOAD "ldint.sl")))

%(COND ((NOT (GETD '!$ERRFORM)) (INCLUDE "excom.sl")))

% To get faster code (at the expence of longer compilation time).
(PROCLAIM '(OPTIMIZE (COMPILATION!-SPEED 0)))
% Turn on messages from compiler.
(COMPILER!-OPTIONS :MESSAGES T)

(SETQ !*COMP T)

(INCLUDE "exfn1.sl")
%(FASLOUT "exslmc") (DSKIN "excom.sl") (FASLEND)
%(INCLUDE "excom.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(INCLUDE "load.sl")
(INCLUDE "../newnam.sl")

(SETQ !*COMP NIL)

(SETQ DATE!* (DATETIME))

%(SAVERUN SLISP)

%### MKSL.SL end
