%### EXINT.SL =======================================================
%
%       EXINT.SL
%       --------
%
%       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains some changes to EXINTI.SL that adapts it to
%       PSL.
%
%====================================================================

(DMACRO XCASE (XC!&CS XC!&D !&REST XC!&L) (SLET ((CNT 0))
  (COND (XC!&D (SETQ XC!&D (NCONS (LIST NIL XC!&D)))))
  (FOREACH X IN XC!&L DO
   (XPUSH XC!&D (LIST (NCONS CNT) X))
   (SETQ CNT (ADD1 CNT)) )
  (CONSA 'CASE XC!&CS XC!&D) ))

(FLAG '(XCASE) 'LOSE)                   % Defined in the present file.
(FLAG '(PROG1) 'LOSE)                   % Defined in Standard Lisp.

(FLAG '(REEVALFORM ERRSET REPEATS WHILE UNTIL) 'LOSE)

(INCLUDE "../exinti.sl")

(REMFLAG '(REEVALFORM ERRSET REPEATS WHILE UNTIL) 'LOSE)

(DMACRO REEVALFORM (!&REST L) (MKERRFORM L))

(DMACRO ERRSET (BODY SW) (SLET ((N (GENSYM)))
  (LIST 'PLET (LIST (LIST '!*ERRMSG SW))
   (LIST 'SLET
    (LIST (LIST N (LIST 'ERRORSET (MKERRFORM BODY)
                        (LIST 'AND '!*ERRDEBUG '!*ERRMSG)
                        (LIST 'AND '!*ERRDEBUG '!*BACKTRACE) )))
    (CONSA 'COND
     (LIST (LIST 'AEQN N 739) '(ERROR 739 EMSG!*))
     (NCONC1
      (COND
       ((NULL SW) NIL)
       (T (LIST (LIST
            (LIST 'AND '!*ERRMSG (LIST 'ATOM N))
             (LIST 'ERRORSET
              (LIST 'LIST '(QUOTE ERROR)
                           (LIST 'MKQUOTE N) '(QUOTE EMSG!*) )
              '!*ERRMSG '!*BACKTRACE) ))) )
      (LIST 'T N) ) ) ) ) ))

(DMACRO ERRSET (BODY SW) (LIST
  (LIST 'LAMBDA '(!*ERRMSG SFER!&)
   (LIST 'UNBINDSFSTKS 'SFER!&
    (LIST 'ERRORSET (MKERRFORM BODY) '!*ERRMSG
     '(AND !*ERRMSG !*BACKTRACE) ) ) )
  SW '(CAPTURESFSTKS) ))

(DMACRO REPEATS (C !&REST BODY) (SLET ((A (GENSYM)))
  (LIST 'PROG (LIST A)
      (LIST 'SETQ A C)
 'LAB (LIST 'COND (LIST (LIST 'XMINUSP (LIST 'XDECR A)) '(RETURN NIL)))
      (CONS 'PROGN BODY)
      '(GO LAB) ) ))

(DMACRO WHILE (TST !&REST BODY)
 (CONSA
  'PROG '()
   '(GO LAB2)
   'LAB1
   (APPEND BODY
    (LIST 'LAB2 (LIST 'COND (LIST TST '(GO LAB1)))) ) ) )

(DMACRO UNTIL (TST !&REST BODY)
 (CONSA 'PROG '()
  'LAB
  (APPEND1 BODY
   (COND
     (TST (LIST 'COND (LIST (LIST 'NOT TST) '(GO LAB))))
     (T '(GO LAB)) )) ) )

(FLAG '(REEVALFORM ERRSET REPEATS WHILE UNTIL) 'LOSE)

(INCLUDE "../excomi.sl")

(REMFLAG '(REEVALFORM ERRSET REPEATS WHILE UNTIL) 'LOSE)

(REMFLAG '(XCASE) 'LOSE)                % Defined in the present file.
(REMFLAG '(PROG1) 'LOSE)                % Defined in Standard Lisp.

%### EXINT.SL end
