%### EXFN2.SL =======================================================
%
%       EXFN2.SL
%       --------
%
%       Copyright (c) 1992 by Jan E. Aman, Institute of Theoretical
%       Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains some changes to EXFN2I.SL that adapts it to
%       Codemist Standard Lisp (CSL).
%
%====================================================================

(SETFLUIDS PG!_NUM!* LI!_NUM!* PROMPT!* LINELENGTH!* !*LOWER
 !*TTYECHO !*INT !*IPRN MODULNAM!* LOADMSGTAB!* NOSAVE)

(SETGLOBALS
 ((TAB!*        TAB))           % Tab.
 TOPDIR!*
 INITPROMPT!*
 !!COMMANDLINE
 (SAVEDO!*
  (LOADARG!* HERE HERELIST !*INT CLOC!*         % FIL!*
   ARGV!* CURRENTDIR!*) ) )

(USEDFLAGS COMPILE)

(NOTLOADTIME (FLAG '(INITLINEFN) 'COMPILE))

(SAMEDEF XPLUS IPLUS)

(SAMEDEF XTIMES ITIMES)

(SAMEDEF XADD1 IADD1)

(SAMEDEF XSUB1 ISUB1)

(SAMEDEF XMINUS IMINUS)

(SAMEDEF XDIFFERENCE IDIFFERENCE)

(SAMEDEF XQUOTIENT IQUOTIENT)

(SAMEDEF XREMAINDER IREMAINDER)

(SAMEDEF XEQN EQ)

(SAMEDEF XLESSP ILESSP)

(SAMEDEF XGREATERP IGREATERP)

(SAMEDEF XMINUSP IMINUSP)

(SAMEDEF XZEROP AZEROP)

(SAMEDEF XIPLUS IPLUS)

(SAMEDEF XITIMES ITIMES)

(SAMEDEF XIADD1 IADD1)

(SAMEDEF XISUB1 ISUB1)

(SAMEDEF XIMINUS IMINUS)

(SAMEDEF XIDIFFERENCE IDIFFERENCE)

(SAMEDEF XIQUOTIENT IQUOTIENT)

(SAMEDEF XIREMAINDER IREMAINDER)

(SAMEDEF XIEQN EQ)

(SAMEDEF XILESSP ILESSP)

(SAMEDEF XIGREATERP IGREATERP)

(SAMEDEF XIMINUSP IMINUSP)

(SAMEDEF XIZEROP AZEROP)

(SAMEDEF XAMEMQ MEMQ)

(SAMEDEF XAATSOC ATSOC)

(SAMEDEF AMEMQ MEMQ)

(SAMEDEF AATSOC ATSOC)

(SAMEDEF AEQN EQ)

(SAMEDEF IEQN EQ)

% RPLACW, COPY, PLIST defined in CSL.

(DS FOREACHID (X !&REST L) (FOREACH X IN (OBLIST) DO . L))  % JEA

% GETFN, FNP defined in EXFN2I.SL. Is there an improvement???

%(DE GETFNTYPE (X)
% (COND
%  ((NOT (SETQ X (GETD X))) NIL)
%  ((MEMQ (SETQ X (CAR X)) '(EXPR SUBR)) 'EXPR)
%  ((MEMQ X '(FEXPR FSUBR)) 'FEXPR)
%  (T X) ) )

(DS FEXPRCALL (FN ARGS) (EVAL (CONS FN ARGS)))
% APPLY on a FEXPR doesn't compile ok in Culisp.

% INTERNP ?

% ORDERP defined in CSL.

(SAMEDEF LEXP ORDERP)

% STDINP, STDOUTP defined after include of exfn2i.sl.

% UNREADCH not defined.

%(DE SKIPWHITE ()
% (WHILE
%  (MEMQ (TYIPEEK)
%   (GVALUE (LIST (CODE!-CHAR BLANK) (CODE!-CHAR TAB!*)
%                 (CODE!-CHAR !$EOL!$) (CODE!-CHAR !$FF!$) )) )
%  (TYI) ) )

% PRIN2T defined after include of exfn2i.sl.

% TTAB and SPACES are already defined in CSL.

(DS BELL () (TYO 7))

% PGLINE ?

% CSL will reset LINELENGTH whenever restarted after a PRESERVE so
% the LINELENGTH function have to redefined to save it argument.
%(COND ((NOT (GETD 'CSLLINELENGTH)) (MOVD 'CSLLINELENGTH 'LINELENGTH)))

%(DE LINELENGTH (N) (COND (N (SETQ LINELENGTH!* N))) (CSLLINELENGTH N))

% SETPROMPTER, PROMPTER, PROMPT defined after include of exfn2i.sl.

% SETFOLDCASE defined after include of exfn2i.sl.

(DE READCHCASE () (SLET ((A (READCH))) (COND
  ((AND !*LOWER (LITER A)) (ULCASE A NIL))
  (T A) )))

% SETGCMESSAGE defined after include of exfn2i.sl.

(SETGLOBALS GCMSGSTK!*)
(COND ((NOT (MEMQ 'GCMSGSTK!* SFSTKS!*)) % No PUSHQ defined so do it
       (SETQ SFSTKS!* (CONS 'GCMSGSTK!* SFSTKS!*)) ))   % this way.
(DEFLIST '((GCMSGSTK!* VERBOS)) 'SFSTKFN)
(FLAG '(GCMSGSTK!*) 'LASTONLY)

% GCMESSAGE(SW:boolean,[SXPR:form]):any
% Evaluate all SXPR while gcmessage status temporarily is set to SW.
(DS GCMESSAGE (SW !&REST L)
 (XPUSH GCMSGSTK!* (VERBOS (COND (SW 1) (T 0))))
 (PROG1 (PROGN . L) (VERBOS (POP GCMSGSTK!*))) )

% I!$PRNEVL defined after include of exfn2i.sl.

% RESET defined after include of exfn2i.sl.

(IFP (NOT !*RSHEEP) (DE QUIT () (STOP 0)))

(IFP (NOT !*RSHEEP) (SAMEDEF BYE QUIT))

% TIME defined in CSL, however, GCTIME is already excluded.

% The following functions are defined in Codemist Standard Lisp (CSL).
(FLAG '(EVENP
%       GCD
        IPLUS ITIMES IADD1 ISUB1 IMINUS IDIFFERENCE IQUOTIENT
        IREMAINDER ILESSP IGREATERP IMINUSP
%       IZEROP
        RPLACW COPY SUBLA
%       EXPLODEC  Bad fix
        SPACES TTAB)
      'LOSE)

% The following functions are defined in the present file.
(FLAG '(XPLUS XTIMES XADD1 XSUB1 XMINUS XDIFFERENCE XQUOTIENT
        XREMAINDER XEQN XLESSP XGREATERP XMINUSP XZEROP
        XIPLUS XITIMES XIADD1 XISUB1 XIMINUS XIDIFFERENCE XIQUOTIENT
        XIREMAINDER XIEQN XILESSP XIGREATERP XIMINUSP XIZEROP
        XAMEMQ XAATSOC
        AMEMQ AATSOC AEQN
        IEQN
%       GETFNTYPE EXPRP MACROP FEXPRP
        FEXPRCALL
%       INTERNP ULCASE
%       CONCATIDL MAKEID MAKESTR
        STDINP STDOUTP
%       SKIPWHITE
        PRIN2T IOCHAN
%       PGLINE
%       FILEIN
        SETPROMPTER RESTOREPROMPT PROMPTER PROMPT
        SETFOLDCASE
        READCHCASE SETGCMESSAGE GCMESSAGE I!$PRNEVL
        QUIT RESET DATETIME SHPDEBUG)
      'LOSE)

% The following functions are not needed.
% (FLAG '(GCD1 EXPLODECHELP) 'LOSE)

(INCLUDE "../exfn2i.sl")

% (REMFLAG '(GCD1 EXPLODECHELP) 'LOSE) Bad fix

(REMFLAG '(XPLUS XTIMES XADD1 XSUB1 XMINUS XDIFFERENCE XQUOTIENT
        XREMAINDER XEQN XLESSP XGREATERP XMINUSP XZEROP
        XIPLUS XITIMES XIADD1 XISUB1 XIMINUS XIDIFFERENCE XIQUOTIENT
        XIREMAINDER XIEQN XILESSP XIGREATERP XIMINUSP XIZEROP
        XAMEMQ XAATSOC
        AMEMQ AATSOC AEQN
        IEQN
%       GETFNTYPE EXPRP MACROP FEXPRP
        FEXPRCALL
%       INTERNP ULCASE
%       CONCATIDL MAKEID MAKESTR
        STDINP STDOUTP
%       SKIPWHITE
        PRIN2T IOCHAN
%       PGLINE
%       FILEIN
        SETPROMPTER RESTOREPROMPT PROMPTER PROMPT
        SETFOLDCASE
        READCHCASE SETGCMESSAGE GCMESSAGE I!$PRNEVL
        QUIT RESET DATETIME SHPDEBUG)
      'LOSE)

(REMFLAG '(GCD EVENP
        IPLUS ITIMES IADD1 ISUB1 IMINUS IDIFFERENCE IQUOTIENT IREMAINDER
        ILESSP IGREATERP IMINUSP
%       IZEROP
        RPLACW COPY SUBLA
%       EXPLODEC  Bad fix
        SPACES TTAB)
      'LOSE)

% Standard input in CSL is not nil.
(DE STDINP () (SLET ((A (RDS NIL)) (B (RDS A))) (EQ A B)))

% Standard input in CSL is not nil.
(DE STDOUTP () (SLET ((A (WRS NIL)) (B (WRS A))) (EQ A B)))

% Checks if there is a CSL module with specified name, c.f. FILEP.
% Misfeature: It loads the module.
%(DE MODULEP (X)
%  (COND ((PAIRP (SETQ X (ERRSET (LOAD!-MODULE X) NIL))) T)) )

(SAMEDEF PRIN2T PRINTC)

% PROMPT is a noop as CSL prompts.
(DE PROMPT () NIL)

(SAMEDEF SETPROMPTER SETPCHAR)

(SETGLOBALS PROMPTSTK!*)
(COND ((NOT (MEMQ 'PROMPTSTK!* SFSTKS!*))
       (SETQ SFSTKS!* (CONS 'PROMTSTK!* SFSTKS!*)) ))
(DEFLIST '((PROMPTSTK!* SETPROMPTER)) 'SFSTKFN)
(FLAG '(PROMTSTK!*) 'LASTONLY)
(DS PROMPTER (PRM !&REST L)
  (PROG1
    (PROGN (XPUSH PROMPTSTK!* (SETPROMPTER PRM)) . L)
    (SETPROMPTER (POP PROMPTSTK!*)) ))

(DE RESTOREPROMPT NIL
  (PROGN
    (SETPROMPTER INITPROMPT!*)
    NIL ))

% SETFOLDCASE(SW:boolean):boolean
% Sets character folding status and returns old value. If character
% folding is true, then upper and lower case characters are folded
% into one character set, upper or lower depending on system. Which
% it is can be seen in SHPCASEUP!*.
(DE SETFOLDCASE (SW) (PROG1 !*LOWER (SETQ !*LOWER SW)))

% SETGCMESSAGE(SW:boolean):boolean
% Sets gcmessage status and returns old value. If gcmessage is true,
% then on most systems a message is printed when a garbage collection
% occurs.
(DE SETGCMESSAGE (SW) (NOT (EQ 0 (VERBOS (COND (SW 1) (T 0))))))

(DE I!$PRNEVL (PRNEVL!$X PRESW!$ POSTV!$)
 (COND (PRESW!$ (TERPRI)))  % Fix for Culisp and CSL. Change original?
 (SETQ PRNEVL!$X (EVAL PRNEVL!$X))
 (COND ((NOT (AND POSTV!$ (EQ PRNEVL!$X POSTV!$)))
        (QTRPRI) (PRIN1 PRNEVL!$X) (TERPRI) ))
 PRNEVL!$X)

% Cannot be compiled in CSL.
(NOCOMP)        % Turn compilation off, save old value. Dirty fix.
(DE RESET () (THROW NIL NIL)) % Not for CSL?
(RESTORECOMP)   % Restore old value of !*COMP.

% Operating system uses lower case for commands, file names etc.
(SETCONSTANTS (!*OSCASEUP NIL))

(SETCONSTANTS
 (!*ILISPCASEUP NIL)
 (!*SHPCASEUP NIL) )

% Suppress compiler timings or messages.
%(IFP (BOUNDP '!*NOTIME) (SETQ !*NOTIME T) (SETQ !*PWRDS NIL))

% NEWLISPTOP defined after include of exfn2i.sl.

% EXTRAINIT defined after include of exfn2i.sl.

(IFP (EQ (SYSTYPE 'MACHINE) 'ATARI)
 (SETQ !!COMMANDLINE NIL)  % No command line interpreter yet on Atari
 (SETQ !!COMMANDLINE NIL) )% Anyone for Unix?

% Initialise !*INT to NIL if BATCHP or argument is true.
(NOTLOADTIME (DS SETBATCH (QBT) (NOT (OR QBT (BATCHP)))))

(IFP !!COMMANDLINE (CPROGN

(SETFLUIDS DUMPDIR IMAGEDIR CORESIZE)

(SETGLOBALS ARGV!*)

(DE INITCOMMANDLINE ()
% Bugfix for Culisp version 1.08 and 1.09 only (?). JEA.
 (IFORL X ((ARGV -1) 1 -1) (XPUSH ARGV!* (ARGV X)))
 ARGV!*)

(DS NEXTONCOMLIN () (SLET ((AAAA ARGV!*))
   (COND (AAAA (SETQ ARGV!* (CDR ARGV!*))))
   AAAA ))

(DE SEXPRFROMCOM ()
 (SLET ((A (CHKERARGV)) B)
  (WHILE
   (AND (NOT (PAIRP (SETQ B (ERRSET (REREADSTRING A) NIL))))
    (SETQ B (NEXTONCOMLIN)) )
   (SETQ A (CONCATID A " " B)) )
  (COND
   (B (CAR B))
   (T (REREADSTRING A)) ) ) )

(DE REREADSTRING (X) (COMPRESS (EXPLODEC X)))

% Culisp switch -I to specify directory for Lisp image.
% Example '/usr/hlh/lisp -I /users/sheep/shp/sheep'.
(DC !I INITLINEFN ()
 (SETQ TOPDIR!* (PREFIXOF (SETQ IMAGEDIR (CHKERARGV)))) NIL)

% Culisp switch -D to specify dump directory.
% Example '/usr/hlh/lisp -I /usr/hlh/image -D /users/sheep/shp/slisp'.
(DC !D INITLINEFN () (SETQ DUMPDIR (CHKERARGV)) NIL)

% Culisp switch -S for memory size, e.g. add ' -S 3M' (note spacing)
% to your command line to get 3 Megabytes.
(DC !S INITLINEFN () (SETQ CORESIZE (CHKERARGV)) NIL)

(DC !Q INITLINEFN () NIL)       % Start quietly.

(DC !T INITLINEFN () NIL)       % Unsets traps, for system debugging.

(DC !O INITLINEFN () NIL)       % To enable Culisp options (see manual).
% Note: Unfortunately you have to stand some complaints from sheep as
% you say e.g. 'sheep -ON1' as sheep would interpret N1 as further
% switches while Culisp require that argument N1 follows O with no
% space in between. JEA

%(DC !M INITLINEFN () NIL)      % Was this one used in old Culisps? JEA

(IFP (FNP 'BACKGROUNDP) (FLAG '(SETBATCH) 'LOSE))
(FLAG
 '(INITCOMMANDLINE NEXTONCOMLIN SEXPRFROMCOM)
 'LOSE)  % These have been defined in the present file.
))                              % End of IFP !!COMMANDLINE

(FLAG
 '(
%  SLISPTOP
   NEWLISPTOP
   SETBATCH
   EXTRAINIT
   ) 'LOSE)  % These have been defined in the present file.

(INCLUDE "../slini.sl")

(REMFLAG
 '(
%  SLISPTOP
   NEWLISPTOP
   SETBATCH
   EXTRAINIT
   INITCOMMANDLINE NEXTONCOMLIN SEXPRFROMCOM)
 'LOSE)  % These have been defined in the present file.

(DE NEWLISPTOP () (PROG (!*ERRMSG STK!&VL)
 (UNTIL NIL
% (IFP (BOUNDP 'RESET!*)
%  (FOREACH VR IN RESET!* DO (STNIL VR)) )
  (RESTOREPROMPT)
  (SETQ STK!&VL (CAPTURESFSTKS))
  (COND
   ((OR (NULL !*BACKTRACE) (AZEROP !*BACKTRACE)) (SETQ !*BACKTRACE 1)) )
  (ERRORSET '(CATCH NIL (XSLISPTOP)) (SETQ !*ERRMSG !*BACKTRACE))
  (PRINCL "Returning to top level")
  (TERPRI)
  (UNBINDSFSTKS NIL STK!&VL) ) ))

(DE EXTRAINIT () (LINELENGTH LINELENGTH!*))

(DE FASLOUT (U)
   (PROG NIL
      (TERPRI)
      (COND
         ((GETD 'BEGIN)
            (PRIN2T "FASLOUT: IN files;  or type in expressions")
            (PRIN2T "When all done, execute FASLEND;") )
         (T
            (PRIN2T "FASLOUT: (RDF files) or type in expressions")
            (PRIN2T "When all done, execute (FASLEND)") ))
      (COND ((NOT (ATOM U)) (SETQ U (CAR U))))
      (COND
         ((NOT (START!-MODULE U))
            (PROGN
               (PRIN2T "+++ Failed to open FASL output file")
               (RETURN NIL))))
      (SETQ FASLMOD_NAME U)
      (SETQ DFPRINTSAVE DFPRINT!*)
      (SETQ DFPRINT!* 'S!:FSLOUT1)
      (SETQ !*DEFN (SETQ !*COMP T))
%     (S!:FASL_SUPERVISOR)
    ))

(FLAG '(FASLEND) 'IGNORE)

(SAMEDEF DATETIME DATE)

% X!& and its value will be left as garbage in the saved image.
(DMACRO SAVERUN (!&REST X) (LIST 'ISAVERUN (MKQUOTE (CAR X))))
(DE ISAVERUN (X!&)
 (SETQ !*ERRMSG (SETQ !*IPRN T))
 (FOREACH Y IN SFSTKS!* DO (STNIL Y))
 (FOREACH Y IN SAVEDO!* DO (COND ((PAIRP Y) (EVAL Y)) (T (STNIL Y))))
 (SETQ MODULNAM!* 'UNKNOWN)
 (SETQ LOADMSGTAB!* 0)
 (SETQ LINELENGTH!* (LINELENGTH NIL))   % CSL restores it to 80.
 (COND (X!& (ERRORFT 419 "No argument allowed to SAVERUN in CSL")))
%(COND (X!& (COND ((NOT (FILEP X!&))
%                  (SYSTEM (BLDMSG "mkdir %w" X!&)) ))
%           (DUMPFILE X!&) ))           % No DUMPFILE in CSL.
 (COND
  ((AND (BOUNDP 'NOSAVE) NOSAVE)
   (PRIN2T "Ready to be saved") )
  (T (PRIN2T "About to save")
     (PRESERVE 'SLISPINIT) )) )

% SHPDEBUG(SW:boolean or number):Number
(DE SHPDEBUG (X)
 (PROG1 !*SHPDEBUG
  (COND
   ((NULL X) (SETQ X 1))
   ((NOT (NUMBERP X)) (SETQ X 5)) )
  (SETQ !*SHPDEBUG X)
  (COND
   ((AZEROP X) (VERBOS X) (SETQ !*MSG (SETQ !*LOADMSG NIL)))
   ((IGREATERP X 1)
    (VERBOS (COND ((IGREATERP X 5) X) (T 1)))
    (SETQ !*BACKTRACE (SETQ !*MSG (SETQ !*LOADMSG (SETQ !*ERRMSG T))))
     ) ) ) )

%### EXFN2.SL end
