%### SYSTYP.SL ======================================================
%
%       SYSTYP.SL
%       --------
%
%       Copyright (c) 1992 by Jan E. Aman, Institute of Theoretical
%       Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file contains the SYSTYPE commands that tells which host
%       etc. that you have. Edit it appropriately for your site.
%
%====================================================================

% Most things will be figured out from CSL, Unix environment variables
% etc. The SITE defaults to "matematik.su.se" (Maths at Univ. of
% Stockholm) for Unix-installations and VANADIS (Physics at Univ.
% of Stockholm) for VMS installations.

% Change operating system version etc. if different from that
% given below.

(IFP (GETENV "HOST")
 (SETSYSTYPE 'NODE (GETENV "HOST")) )

% DOMAINNAME is to be defined in .shpmanrc (or here).
% Specify SITE if not clear from DOMAIN specification.
(IFP (GETENV "DOMAINNAME")
 (SETSYSTYPE 'DOMAIN (GETENV "DOMAINNAME")) )

(IFP (GETENV "MACHINE")
 (PROG (MA)
  (SETQ MA (INTERN (COMPRESS (EXPLODE2 (GETENV "MACHINE")))))
  (COND
   ((EQ MA 'SUN4)
    (SETSYSTYPE 'MACHINE 'SUN)
    (SETSYSTYPE 'MACHINEVERS 4))
   ((EQ MA 'SUN)
    (SETSYSTYPE 'MACHINE 'SUN)
    (SETSYSTYPE 'MACHINEVERS 3))
   (T (SETSYSTYPE 'MACHINE MA))) ) )

% (SETSYSTYPE 'MACHINEVERS 5000)

(SETSYSTYPE 'OS 'UNIX)
(SETSYSTYPE 'OSTYPE 'BSD)
(SETSYSTYPE 'OSVERS 4.3)

(SETSYSTYPE 'LISPSYSTEM 'CSL)           % Codemist Standard Lisp (CSL).

(SETSYSTYPE 'LISPVERS 1.17)

%### SYSTYP.SL end
