%### SYSTYP.SL ======================================================
%
%       SYSTYP.SL
%       --------
%
%       Copyright (c) 1992 - 2011 by Jan E. Aman,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file contains the SYSTYPE commands that tells which host
%       etc. that you have. Edit it appropriately for your site.
%
%====================================================================

% Most things will be figured out from CSL, Unix environment variables
% etc.

% Change operating system version etc. if different from that
% given below.

(IFP (GETENV "HOST")
 (SETSYSTYPE 'NODE (GETENV "HOST")) )

% DOMAINNAME is to be defined in .shpmanrc (or here).
% Specify SITE if not clear from DOMAIN specification.
(IFP (AND (GETD 'GETENV) (GETENV "DOMAINNAME")
          (NOT (MEMBER (GETENV "DOMAINNAME") '("" "(none)"))) )
 (SETSYSTYPE 'DOMAIN (GETENV "DOMAINNAME")) )

(IFP (GETENV "MACHINE")
 (PROG (MA)
  (SETQ MA (INTERN (COMPRESS (EXPLODE2 (GETENV "MACHINE")))))
  (COND
   ((EQ MA 'SUN4)
    (SETSYSTYPE 'MACHINE 'SUN)
    (SETSYSTYPE 'MACHINEVERS 4))
   ((EQ MA 'SUN)
    (SETSYSTYPE 'MACHINE 'SUN)
    (SETSYSTYPE 'MACHINEVERS 3))
   (T (SETSYSTYPE 'MACHINE MA))) )
 (IFP (GETENV "HOSTTYPE")
  (SETSYSTYPE 'MACHINE
   (INTERN (COMPRESS (EXPLODE2 (GETENV "HOSTTYPE")))) ) ) )

(IFP (GETENV "OS")
 (SETSYSTYPE 'OS (GETENV "OS"))
 (PROGN
  (SETSYSTYPE 'OS 'UNIX)
  (IFP
   (EQUAL "linux" (GETENV "OSTYPE"))
   (PROGN                               % This test should pick up the
    (SETSYSTYPE 'OSTYPE 'LINUX)         % Linux case.
    (IFP (GETENV "HOSTTYPE")
     (SETSYSTYPE 'MACHINE
      (INTERN (COMPRESS (EXPLODE2 (GETENV "HOSTTYPE")))) )
     (SETSYSTYPE 'MACHINE 'PC) )        % Anything compatible with
    (SETSYSTYPE 'MACHINEVERS 686) )     % PC.
   (SETSYSTYPE 'OSTYPE 'GNU) ) ) )

(SETSYSTYPE 'LISPSYSTEM 'CSL)           % Codemist Standard Lisp (CSL).

(SETSYSTYPE 'LISPVERS 6.04)

%### SYSTYP.SL end
