%### EXCOM.SL =======================================================
%
%       EXCOM.SL
%       --------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%       This file contains some changes to EXCOMI.SL that adapts it to
%       Cambridge Lisp.
%
%====================================================================

(SETFLUIDS VBLS IVBLS)

% This is a help routine to force arguments to a function to be
% evaluated before an ERRSET or CATCH. The purpose of this is that
% variables shouldn't have to be declared FLUID. This works for
% references to local variables, but it can't SETQ them.
(DE MKERRFORM (X)
 (SLET (VBLS IVBLS (!$INERRSET T))
  (!$ERRFORM (SETQ X (MACEXPD X)))
  (COND
   ((OR (ATOM X) (NULL VBLS)) (MKQUOTE X))
   ((NOFORMS X)
    (CONS 'LIST
     (FOREACH Y IN X COLLECT (COND
       ((MEMQ Y VBLS) (LIST 'MKQUOTE Y))
       (T (MKQUOTE Y)) )) ) )
   (T (CONSA 'LIST
       (LIST 'FUNCTION (LIST 'LAMBDA VBLS X))
       (FOREACH Y IN VBLS COLLECT (LIST 'MKQUOTE Y)) )) ) ) )

(CMMACRO ERRSET (BODY SW) (LIST
  (LIST 'LAMBDA '(!*ERRMSG SFER!&)
   (LIST 'UNBINDSFSTKS 'SFER!&
    (LIST 'ERRORSET (MKERRFORM BODY) '!*ERRMSG) ) )
  SW '(CAPTURESFSTKS) ) )

(COMMENT
% To be used when Culisp can open compile ERRORSET correctly
(CMMACRO ERRSET (!&DS BODY SW)
 ((LAMBDA (!*ERRMSG SFER!&)
   (UNBINDSFSTKS SFER!& (ERRORSET 'BODY !*ERRMSG)) )
  SW (CAPTURESFSTKS) ) ) )

% (CMMACRO ERRSET (BODY SW) (LIST 'ERRORSET (MKERRFORM BODY) SW))

(FLAG '(ERRSET MKERRFORM) 'LOSE) % Defined in the present file.

% CATCH can still not (1.03) be compiled, but NEWLISPTOP can be compiled
% by removing the COMPFN for CATCH.   Gone in version 1.06 (?). JEA
(IFP (LESSP 1.06 (SYSTYPE 'LISPVERS))
% Culisp open compilation of CATCH is buggy in old versions.
 (REMPROP 'CATCH 'COMPFN)
% Culisp open compilation of ERRORSET is buggy in old versions.
 (REMPROP 'ERRORSET 'COMPFN) )

% WHILE defined in Cambridge Lisp but replaced for Reduce.
(IFP (NOT !*RSHEEP) (FLAG '(WHILE) 'LOSE))
% (FLAG '(WHILE) 'LOSE)

(INCLUDE "../excomi.sl")

% WHILE defined in Cambridge Lisp but replaced for Reduce.
(IFP (NOT !*RSHEEP) (REMFLAG '(WHILE) 'LOSE))
% (REMFLAG '(WHILE) 'LOSE)

(REMFLAG '(ERRSET MKERRFORM) 'LOSE)

%### EXCOM.SL end
