%### LDINT.SL =======================================================
%
%       LDINT.SL
%       --------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%
%       This file loads the files into Cambridge Lisp to build
%       an interpreted Sheep Lisp.
%
%====================================================================

(CAR!-NIL!-LEGAL NIL)

(COND
  ((GETD 'EDIT) (RDF 'atari!.sl))       %:Atari
  (T            (RDF 'cubugs!.sl)) )

(RDF 'inclde!.sl)

(INCLUDE "exfn1.sl")

% Used for testing which system is running.
(SETQ !*RSHEEP NIL)

(IFP
 (GETD 'EDIT)
 (INCLUDE "sytypa.sl")          %:Atari
 (INCLUDE "systyp.sl") )

(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(INCLUDE "load.sl")

% List of extensions searched for:
(SETQ MEXTLIS!* '(PSEUDO!-FILE SL))
(DPUT SLLSPEXT SUBDRS SL)       % Extension for Sheep Lisp sources.
(DPUT SHPSRCEXT SUBDRS SHP)     % Source extension for Sheep.

(IFP
 (NOT (AND (EQ 'ATARI (SYSTYPE 'MACHINE)) (LESSP (SYSTYPE 'MEMORY) 2)))
 (INCLUDE "../newnam.sl") )     %:Atari skip luxury

%(INCLUDE "smodul.sl") Original version.
(INCLUDE "sidmod.sl")  % Newer version.

(PROGN (REMD 'IINCLUDE) NIL)

(SETPROMPTER "SL> ")

% Set up search list. MSEARCHLIS!* is reset in SSLISP.INI. JEA.
(SETQ MSEARCHLIS!*
 '(NIL HERELIST ".." "../.." "../../shpsrc/culisp" "../../shpsrc"))

% Clean remains from Culisp limited history function.
(SETQ INITS!* '((UNSET '!^) (UNSET '!^!^) (UNSET '!^!^!^)
                (UNSET '!#) (UNSET '!#!#) (UNSET '!#!#!#) )

%### LDINT.SL end
