%### PRINTF.SL ======================================================
%
%       PRINTF.SL
%       ---------
%
%       Copyright (c) 1984 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden and
%       Jan E. Aman, School of Mathematical Sciences, Queen Mary
%       College (U. of London), Mile End Road, London E1 4NS, UK.
%
%       This file contains some changes to PRNTFI.SL that adapts it to
%       Cambridge Lisp.
%
%====================================================================

% Changing limitating parameters in Culisp:
(SETFLUIDS
 (!*PRINTDEPTH  100)            % Default is 40 only.
 (!*PRINTLENGTH 10000) )        % Default is 2000 only.

(DE BLDMSG2 (ST AR)
 (SLET (FN CH)
  (SETQ ST (EXPLODEC ST))
  (CLEARBUFF)
  (WHILE ST
   (COND
    ((OR (NOT (EQ (SETQ CH (CAR ST)) '!%))
      (EQ (SETQ CH (CAR (UNPUSH ST))) '!%))
     (PACK CH NIL) )
    ((SETQ FN (GET CH 'BLDMSGFN0)) (FUNCALL FN))
    ((NULL (SETQ FN (GET CH 'BLDMSGFN1)))
     (ERRORFT 425 "Unknown BLDMSG code %p" CH) )
    ((NULL AR) (ERRORFT 426 "Missing BLDMSG argument"))
    (T (FUNCALL FN (CAR AR)) (UNPUSH AR)) )
   (UNPUSH ST) )
  (MKSTRING) ))

(DC !n BLDMSGFN0 () (PACK !$EOL!$ NIL))

(DC !b BLDMSGFN1 (X) (REPEATS X (PACKBYTE 32)))

(XDEFLIST BLDMSGFN1 (w PACK))

(DE PEXPLODE (X) (FOREACH Y IN (EXPLODEN X) DO (PACKBYTE Y)))

(DE EXPLODEL (X)
 (COND
  ((NULL X) (PACKBYTE 32))
  ((PAIRP X)
   (PACK (CAR X) NIL)
   (FOREACH Y IN (CDR X) DO (PACKBYTE 32) (PACK Y NIL)) )
  (T (PACK X NIL)) ) )

% This is the same as the system independent, but it has to be done
% here so that we can flag w LOSE below in order to stop the BLDMSGFN1
% for w.
(XDEFLIST PRINTFFN1 (!w PRIN2))

(FLAG
 '(BLDMSG2 !n!.BLDMSGFN0 !b!.BLDMSGFN1 !w
   EXPLODEL BOXEXPLODE PEXPLODE
   EXPLOLIS EXPLOVEC PEXPLODEC EXPLOLISC EXPLOVECC)
 'LOSE)

(INCLUDE "../prntfi.sl")

(REMFLAG
 '(BLDMSG2 !n!.BLDMSGFN0 !b!.BLDMSGFN1 !w !p
   EXPLODEL BOXEXPLODE PEXPLODE
   EXPLOLIS EXPLOVEC PEXPLODEC EXPLOLISC EXPLOVECC)
 'LOSE)

%### PRINTF.SL end
