%### EXCOM.SL =======================================================
%
%       EXCOM.SL
%       --------
%
%       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
%
%       This file contains some changes to EXCOMI.SL that adapts it to
%       Franz Lisp.
%
%====================================================================

(FLUID '(MODULNAM!*))

(GLOBAL '(PUTCHR!*))

% To compile, this function must be present.
(DE PUTClisztfn (X)
 (let ((FN (CADR X)) (TYP (CADDR X)) (PROP (CADDDR X)))
  (COND
   ((ILOS!$PUT (I!$EV FN) (I!$EV TYP)))
   ((AND (QUOTEP TYP) (get (CADR TYP) 'COMPILE))
    (let ((NM (MKQUOTE (concat
                         (COND ((QUOTEP FN) (CADR FN)) (T (GENSYM)))
                         PUTCHR!*
                         (CADR TYP) ))))
     (PUTDlisztfn (LIST 'PUTD NM '(QUOTE EXPR) PROP))
     (d!-doeval (LIST 'PUT FN TYP NM)) ) )
   (T (d!-doeval (CONS 'PUTC (CDR X)))) ) ))

% CMMACRO is similar to DMACRO. It is used when there is two
% definitions of a function: a FEXPR for the interpreter and a MACRO
% for the compiler. The MACRO is then defined by CMMACRO. In many
% systems CMMACRO can make a COMPILERMACRO or something else instead
% of a MACRO.
(DE CMMACROlisztfn (U) (let ((FN (CADR U)) NM)
  (COND ((NOT (ILOS!$PUT FN 'cmacro))
         (SETQ NM (concat FN PUTCHR!* 'cmacro))
         (d!-doeval (LIST
                      'PUT
                      (MKQUOTE FN)
                      '(QUOTE cmacro)
                      (MKQUOTE NM) ))
         (PUTDlisztfn (!$MACFEX NM (CADDR U) (CDDDR U) 'MACRO))
         (PUT FN 'cmacro NM) )) ))

(DEFLIST '((PUTC PUTClisztfn) (CMMACRO CMMACROlisztfn)) 'lisztfn)

% This is a help routine for the macro definition of MAPRPL and MAPRPLC.
(DE MAPR!$FN (L FN SW) (let (A (X (GENSYM)))
  (SETQ SW (COND (SW (LIST 'CAR X)) (T X)))
  (SETQ SW (COND
    ((AND (PAIRP FN) (MEMQ (CAR FN) '(FUNCTION QUOTE)))
     (LIST (CADR FN) SW) )
    (T (LIST 'FUNCALL (SETQ A (GENSYM)) SW)) ))
  (SETQ X (LIST 'map
    (LIST 'FUNCTION (LIST 'LAMBDA (LIST X) (LIST 'RPLACA X SW)))
    L))
  (COND
   (A (LIST 'SLET (LIST (LIST A FN)) X))
   (T X) ) ) )
   
%REPEATS(COUNT:integer,[XPR:form]):NIL
%The XPRs are evaluated COUNT times.
(DMACRO REPEATS!.cmacro (C !&REST BODY) (SLET ((A (GENSYM)))
  (CONSA 'do (LIST (LIST A (LIST '!1!- C) (LIST '!1!- A)))
   (LIST (LIST '!< A 0) NIL) BODY) ))

(DS WHILE!.cmacro (TST !&REST BODY)
 (do NIL ((NOT TST) NIL) . BODY) )

(DEFLIST '((REPEATS REPEATS!.cmacro) (WHILE WHILE!.cmacro)) 'cmacro)
 
(eval!-when (eval compile)
 (FLAG '(MAPR!$FN REPEATS WHILE) 'LOSE) % Defined in this file.
 (FLAG '(THROWQ ERRSET CATCHQ UNWINDPROTECT PROG1) 'LOSE) )
        % Will be defined in exfn2.sl.

(INCLUDE "../excomi.sl")

(eval!-when (eval compile)
 (REMFLAG '(MAPR!$FN REPEATS WHILE) 'LOSE)
 (REMFLAG '(THROWQ ERRSET CATCHQ UNWINDPROTECT PROG1) 'LOSE) )

(declare (special v!-ofile v!-root liszt!-read))

(SETQ liszt!-read 
 '(LAMBDA ()
    (SETQ liszt!-read 'slisp!-read)
    (SETQ MODULNAM!* (cond
      ((not (getd 'FILNAM)) v!-root)
      (t (CADR (FILNAM (cond (v!-ofile) (t v!-root))))) ))
    (slisp!-read) ) )

%### EXCOM.SL end
