%### EXFN1.SL =======================================================
%
%       EXFN1.SL
%       --------
%
%       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
%       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
%
%       This file contains some changes to EXFN1I.SL that adapts it to
%       Franz Lisp.
%
%====================================================================

(FLUID '(!*MACROEXPAND))

(samedef 'FUNCALL 'funcall)

(DF LOCALFUNCTIONS (L) (COND ((getd 'localf) (funcall 'localf L))))

(mapcar 'samedef '(BOUNDP ATSOC REVERSIP NCONS)
                 '(boundp assq  nreverse ncons) )

(DE MOVD (X Y)
 (putd X
  (COND
   ((getd Y))
   (T (ERROR 0 (LIST Y "is not defined"))) ) ) )

% This is the same as the MacLisp LET. The name PLET is used to avoid
% collision with Reduce LET.
%PLET(VARS:list,[XPR:form]):any
% The elements of VARS are either a pair (VAR:id . ARG:form) or an id
% VAR which is equivalent to a pair (VAR . NIL).
% The VAR are bound to the ARG (this is done in parallel for all VAR),
% the XPR are evaluated, the old bindings of the VAR are restored and
% the value of the last XPR is returned.
% The PLET is (but this is no guarantee) implemented as a macro
% expanding into a LAMBDA:  ((LAMBDA VRS (PROGN [XPR])) . ARGS)
% where VRS is a list of the VAR and ARGS is a list of the ARG.

(samedef 'PLET 'let)

(samedef 'SLET 'let!*)

(samedef 'CONCATID 'concat)

(DF DECLAREFEXPR (L) (COND ((getd '!*fexpr) (funcall '!*fexpr L))))

%(samedef 'DO 'do) %has to be done before DO for FOREACH ????

(DE PUTC (X Y Z) (COND
  ((ILOS!$PUT X Y) NIL)
  ((NOT (EQCAR Z 'LAMBDA)) (PUT X Y Z) X)
  (T (PUT X Y (PUTD (concat X PUTCHR!* Y) 'EXPR Z))
     X) ))

% CMMACRO is similar to DMACRO. It is used when there is two
% definitions of a function: a FEXPR for the interpreter and a MACRO
% for the compiler. The MACRO is then defined by CMMACRO. In many
% systems CMMACRO can make a COMPILERMACRO or something else instead
% of a MACRO.
(DM CMMACRO (U) (let ((FN (CADR U)) NM) (COND
   ((ILOS!$PUT FN 'cmacro) NIL)
   (T (SETQ NM (concat FN PUTCHR!* 'cmacro))
      (LIST 'PROGN '(quote compile)
       (!$MACFEX NM (CADDR U) (CDDDR U) 'MACRO)
       (LIST 'DPUT FN 'cmacro NM) ) ) )))

(DM CPROGN (U) (CONS 'PROGN (CONS '(QUOTE compile) (CDR U))))

(eval!-when (eval compile)
 (FLAG '(CPROGN) 'DFEXPAND)
 (FLAG '(DE QSET IFP) 'LOSE)  % These have been defined in SLFUNS.L.
 (FLAG '(XCOND XCOND!* THROWVALUE!$) 'LOSE) % Not needed.
 (FLAG '(FUNCALL LOCALFUNCTIONS CMMACRO BOUNDP ATSOC REVERSIP
         NCONS MOVD CPROGN PLET SLET DECLAREFEXPR PUTC CONCATID
         CONCATIDHELP)
       'LOSE) )  % These have been defined in the present file.

(INCLUDE "../exfn1i.sl")

(eval!-when (eval compile) 
 (REMFLAG '(DE QSET IFP) 'LOSE)
 (REMFLAG '(XCOND XCOND!* THROWVALUE!$) 'LOSE)
 (REMFLAG '(XCOND) 'LOSE)
 (REMFLAG '(FUNCALL LOCALFUNCTIONS CMMACRO BOUNDP ATSOC REVERSIP
            NCONS MOVD CPROGN PLET SLET DECLAREFEXPR PUTC CONCATID
            CONCATIDHELP)
          'LOSE) )

(INCLUDE "systyp.sl")  % Moved here from exfn2.sl. JEA.

%### EXFN1.SL end
