;### REATAB.L =======================================================
;
;       REATAB.L
;       --------
;
;       Copyright (c) 1982 by Inge Frick, Institute of Theoretical
;       Physics, Vanadisvagen 9, S-113 46 Stockholm, Sweden.
;
;       This file defines the Standard Lisp readtable in two versions
;       depending on which version of Franz Lisp they should be used.
;       Look for the macro IFP.
;
;====================================================================

(IFP (getd 'getsyntax)
 (progn 'compile
  (setsyntax 3 'vsplicing-macro 'rBELL)
  (setsyntax 7 'vsplicing-macro 'rBELL) )
 (progn 'compile
  (setsyntax 3 'splicing 'rBELL)
  (setsyntax 7 'splicing 'rBELL) ) )

(setq FRANZREADTABLE readtable)

(setq readtable (makereadtable t))

(IFP (getd 'getsyntax)
  (progn 'compile
  (add-syntax-class 'ssign '(csign escape-always separator))
  (add-syntax-class 'speriod '(cperiod escape-always separator))
  (add-syntax-class 'sdelimit
   '(csingle-character-symbol escape-always separator))
  (add-syntax-class 'sstring-delimiter
   '(cstring-delimiter escape-always separator))
  (setsyntax 3 'vsplicing-macro 'rBELL)
  (setsyntax 7 'vsplicing-macro 'rBELL)
  (setsyntax 8 'sdelimit)
  (setsyntax 10 'vsplicing-macro 'rLF)
  (setsyntax 12 'vsplicing-macro 'rFF)
  (setsyntax 33 'vescape)
  (setsyntax 34 'sstring-delimiter)
  (setsyntax 35 'sdelimit)
  (setsyntax 36 'sdelimit)
  (setsyntax 37 'splicing 'zapline)
  (setsyntax 38 'sdelimit)
  (setsyntax 42 'sdelimit)
  (setsyntax 43 'ssign)
  (setsyntax 44 'sdelimit)
  (setsyntax 46 'speriod)
  (setsyntax 47 'sdelimit)
  (do x 58 (add1 x) (greaterp x 64) (setsyntax x 'sdelimit))
  (setsyntax 91 'vmacro 'rVect)
  (do x 92 (add1 x) (greaterp x 96) (setsyntax x 'sdelimit))
  (setsyntax 123 'vleft-bracket)
 (quote (setsyntax 124 'sdelimit))
  (setsyntax 125 'vright-bracket)
  (setsyntax 126 'sdelimit)
  (setsyntax 45 'ssign)
 )
 (progn 'compile
  (setsyntax 3 'splicing 'rBELL)
  (setsyntax 7 'splicing 'rBELL)
  (setsyntax 8 203)
  (setsyntax 10 'splicing 'rLF)
  (setsyntax 12 'splicing 'rFF)
  (setsyntax 33 143)
  (setsyntax 35 204)
  (setsyntax 36 204)
  (setsyntax 37 'splicing 'zapline)
  (setsyntax 38 204)
  (setsyntax 42 204)
  (setsyntax 44 204)
  (setsyntax 47 204)
  (do x 58 (add1 x) (greaterp x 64) (setsyntax x 204))
  (setsyntax 91 'macro 'rVect)
  (do x 92 (add1 x) (greaterp x 96) (setsyntax x 204))
  (setsyntax 123 198)
  (quote (setsyntax 124 204))
  (setsyntax 125 199)
  (setsyntax 126 204)
 ) )

(setq SLISPREADTABLE readtable)

(setq readtable (makereadtable t))

(IFP (getd 'getsyntax) (setsyntax 124 204) (setsyntax 124 'sdelimit))

(setq XSLISPREADTABLE readtable)

(setq readtable SLISPREADTABLE)

