%### PRNTFI.SL ======================================================
%
%       PRNTFI.SL
%       ---------
%
%       Copyright Inge Frick, Institute of Theoretical Physics,
%       Vanadisvagen 9, S-113 46 Stockholm, Sweden
%
%
%       This file defines PRINTF, BLDMSG and ERRORFT.
%
%====================================================================

(FUNCTIONS BLDMSG BLDMSG2 EXPLODEL PEXPLODE EXPLOLIS EXPLOVEC
           PEXPLODEC EXPLOLISC EXPLOVECC WARNINGFT ERRORPRINTF
           PRINTF MSGOUT PRINTF2 PRIN2L ERRORFT ERRORFT3)

(USEDPROPERTIES BLDMSGFN0 BLDMSGFN1 PRINTFFN0 PRINTFFN1)

(USEDFLAGS COMPILE)

(SETFLUIDS (!*MSGTOFILE T))

(NOTLOADTIME
 (FLAG '(BLDMSGFN0 BLDMSGFN1 PRINTFFN0 PRINTFFN1) 'COMPILE) )

(DS BLDMSG (ST !&REST AR) (BLDMSG2 ST (LIST . AR)))

(DE BLDMSG2 (ST AR)
 (SLET ((A (EXPLODEC ST)) B C)
  (SETQ ST (SETQ B (CONS NIL A)))
  (WHILE A
   (COND
    ((NOT (EQ (CAR A) '!%)) (SETQ B A) (SETQ A (CDR A)))
    ((EQ (CAR (SETQ A (CDR A))) '!%) (RPLACD B A))
    (T (COND
        ((SETQ C (GET (CAR A) 'BLDMSGFN0)) (SETQ C (FUNCALL C)))
        ((NULL (SETQ C (GET (CAR A) 'BLDMSGFN1)))
         (ERRORFT 425 "Unknown BLDMSG code %r" (CAR A)) )
        ((NULL AR) (ERRORFT 426 "Missing BLDMSG argument"))
        (T (SETQ C (FUNCALL C (CAR AR))) (SETQ AR (CDR AR))) )
       (RPLACD (SETQ B (LASTPAIR (RPLACD B C))) (SETQ A (CDR A))) ) ) )
  (MAKESTR (CDR ST)) ) )

(DC !n BLDMSGFN0 ()
 (EXPLODEC !$EOL!$) )

(DC !b BLDMSGFN1 (X) (SLET (A) (REPEATS X (XPUSH A '! )) A))

(DC !r BLDMSGFN1 (X) (CONS '!' (NCONC1 (PEXPLODE X) '!')))

(XDEFLIST BLDMSGFN1 (!p PEXPLODE) (!w PEXPLODEC) (!l EXPLODEL))

(DE EXPLODEL (X)
 (COND
  ((NULL X) (LIST '! ))
  ((PAIRP X) (EXPLOLISC X))
  (T (PEXPLODEC X)) ) )

(NOTLOADTIME
 (DS BOXEXPLODE (X) (IFP (FNP 'BOX) (EXPLODE (BOX X)) (LIST '!?))) )

(DE PEXPLODE (X)
 (COND
  ((PAIRP X)
   (CONS '!( (NCONC (PEXPLODE (CAR X))
     (NCONC1 (EXPLOLIS (CDR X)) '!)) )) )
  ((OR (IDP X) (STRINGP X) (NUMBERP X)) (EXPLODE X))
  ((VECTORP X) (CONS '![ (NCONC1 (EXPLOVEC X (UPBV X)) '!])))
  ((CODEP X) (CONS '!# (CONS '!# (BOXEXPLODE X))))
  (T (CONS '!# (BOXEXPLODE X))) ) )

(DE EXPLOLIS (X)
 (COND
  ((NULL X) NIL)
  ((NOT (PAIRP X)) (APPEND '(!  !. ! )  (PEXPLODE X)))
  (T (CONS '!  (NCONC (PEXPLODE (CAR X)) (EXPLOLIS (CDR X))))) ) )

(DE EXPLOVEC (X N)
 (COND
  ((XZEROP N) (PEXPLODE (GETV X 0)))
  (T (NCONC
      (EXPLOVEC X (XSUB1 N))
      (CONS '!, (PEXPLODE (GETV X N))) )) ) )

(DE PEXPLODEC (X)
 (COND
  ((PAIRP X)
   (CONS '!( (NCONC (PEXPLODEC (CAR X))
     (NCONC1 (EXPLOLISC (CDR X)) '!)) )) )
  ((OR (IDP X) (STRINGP X) (NUMBERP X)) (EXPLODEC X))
  ((VECTORP X) (CONS '![ (NCONC1 (EXPLOVECC X (UPBV X)) '!])))
  (T (PEXPLODE X)) ) )

(DE EXPLOLISC (X)
 (COND
  ((NULL X) NIL)
  ((NOT (PAIRP X)) (APPEND '(!  !. ! )  (PEXPLODEC X)))
  (T (CONS '!  (NCONC (PEXPLODEC (CAR X)) (EXPLOLISC (CDR X))))) ) )

(DE EXPLOVECC (X N)
 (COND
  ((XZEROP N) (PEXPLODEC (GETV X 0)))
  (T (NCONC
      (EXPLOVECC X (XSUB1 N))
      (CONS '!, (PEXPLODEC (GETV X N))) )) ) )

(DS ERRORPRINTF (ST !&REST AR) (MSGOUT NIL ST (LIST . AR)))

% To be kept for some time for compatibility. JEA.
(DS WARNINGF (ST !&REST AR) (MSGOUT "*** " ST (LIST . AR)))

% WARNINGFT redefined to include warning message numbers not yet used
% but available for possible future use. Straight forward definition:
%(DS WARNINGFT (DUMMY ST !&REST AR) (MSGOUT ST "*** " (LIST . AR)))% JEA
% Safer definition accepting also calls without warning numbers:
(DMACRO WARNINGFT (!&REST L)
 (COND ((AND L (NUMBERP (CAR L))) (SETQ L (CDR L)))) % JEA.
 (LIST 'MSGOUT "*** " (MKQUOTE (CAR L)) (CONS 'LIST (CDR L))) )

(DE MSGOUT (PR ST AR) (PROG (SW)
  (COND ((NOT !*MSG) (RETURN NIL)))
  (COND ((NOT (SETQ SW (STDOUTP))) (STDOUT (MSGOUT3 PR ST AR))))
  (COND ((OR SW !*MSGTOFILE) (MSGOUT3 PR ST AR))) ))

(DE MSGOUT3 (PR ST AR)
 (QTRPRI) (COND (PR (PRIN2 PR))) (PRINTF2 ST AR) (TERPRI) )

(DS PRINTF (ST !&REST AR) (PRINTF2 ST (LIST . AR)))

(DE PRINTF2 (ST AR)
 (SLET ((A (EXPLODEC ST)))
  (WHILE A
   (COND
    ((OR (NOT (EQ (CAR A) '!%)) (EQ (CAR (SETQ A (CDR A))) '!%))
     (PRINC (CAR A)) )
    ((SETQ ST (GET (CAR A) 'PRINTFFN0)) (FUNCALL ST))
    ((NULL (SETQ ST (GET (CAR A) 'PRINTFFN1)))
     (ERRORFT 427 "Unknown PRINTF code %r" (CAR A)) )
    ((NULL AR) (ERRORFT 428 "Missing PRINTF argument"))
    (T (FUNCALL ST (CAR AR)) (SETQ AR (CDR AR))) )
   (SETQ A (CDR A)) ) ) )
  
(XDEFLIST PRINTFFN0 (!f QTRPRI) (!n TERPRI))

(DE ERRPRIN (X) (PRIN2 '!') (PRIN1 X) (PRIN2 '!') X)

(XDEFLIST PRINTFFN1
 (!p PRIN1) (!w PRIN2) (!r ERRPRIN) (!l PRIN2L) (!e EVAL)
 (!b SPACES) (!t TTAB) )

(DE PRIN2L (X)
 (COND
% ((NULL X) (PRINC '! ))                % What the PSL manual says.
  ((NULL X) NIL)                        % What PSL does. JEA
  ((NOT (PAIRP X)) (PRIN2 X))
  (T (WHILE
      (PROGN (PRIN2 (CAR X)) (PAIRP (SETQ X (CDR X))))
      (PRINC '! ))
     (COND (X (PRINC '! ) (PRIN2 X))) ) ) ) % For dotted pairs etc. JEA

(DS ERRORFT (NM ST !&REST AR) (ERRORFT3 NM ST (LIST . AR)))

(DE ERRORFT3 (NM ST AR) (ERROR NM (BLDMSG2 ST AR)))

% Remove privisional help function for ERRORFT3 defined in exfn1.sl.
(PROGN (REMD 'XERRORFT3) NIL)

%### PRNTFI.SL end
