%### EXFN1.SL =======================================================
%
%       EXFN1.SL
%       --------
%
%       Copyright (c) 1988 - 2011 by Jan E. Aman and Inge Frick,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file contains some changes to EXFN1I.SL that adapts it to
%       PSL.
%
%====================================================================

(SETQ !!MACEXPD NIL)

% Use the following command to force the use of Sheep macro expansion.
% (SETQ !!MACEXPD T)

% COMMENT defined in PSL module COMMON.

% Defined as in exfn1i, defined here as it is needed for bootstrap.
(DM IFP (U!&)
 (COND
  ((EVAL (CADR U!&)) (CADDR U!&))
  ((CDDDR U!&) (CADDDR U!&)) ))

(IFP (NOT (GETD 'MACROEXPAND)) (SETQ !!MACEXPD T))

% MACROEXPAND defined in PSL module USEFUL.
(IFP !!MACEXPD NIL (COPYD 'MACEXPD 'MACROEXPAND))

(DM ERRORFT (U) (LIST 'ERROR (CADR U) (CONS 'BLDMSG (CDDR U))))

(GLOBAL '(PSLPA1FN PA1))

% Called PA1FN in PSL version 3.2 and 3.2A, called PASS!-1!-FUNCTION
% in PSL version 3.4. Test can be used only if compiler is loaded.
(SETQ PSLPA1FN (IFP (GET 'COND 'PA1FN) 'PA1FN 'PASS!-1!-FUNCTION))

% Called !&PA1 in PSL version 3.2 and 3.2A, probably what is
% called RECURSIVE!-PASS!-1 in PSL version 3.4.
% Test can be used only if compiler is loaded.
(SETQ PA1 (IFP (GET 'COND 'PA1FN) '!&PA1 'RECURSIVE!-PASS!-1))

(DE CMPA1 (X VBLS) (PROG (Y)
  (SETQ Y (APPLY (GET (CAR X) 'COMPILERMACRO) (LIST X)))
  (COND
   ((EQUAL Y X)
    (REMPROP (CAR X) PSLPA1FN)
    (SETQ Y  (APPLY PA1 (LIST Y VBLS)))
    (PUT (CAR X) PSLPA1FN 'CMPA1) )
   (T
    (SETQ Y (APPLY PA1 (LIST Y VBLS))) ) )
  (RETURN Y) ))

(COPYD 'MOVD 'COPYD)

(MOVD 'ASCII 'INT2ID)

(FLAG '(XCOND) 'LOSE)                   % Not needed.
(FLAG '(MKQUOTE EQCAR ATSOC REVERSIP NCONS XCONS
        DE COMPILETIME BOTHTIMES LOADTIME)
      'LOSE)                            % Defined in Bare PSL.
% UNIONQ defined but gives trouble as it reverses first argument.
(IFP (MEMQ 'USEFUL OPTIONS!*)           % Defined in PSL Module USEFUL.
 (FLAG '(FUNCALL) 'LOSE) )
(IFP (MEMQ 'COMMON OPTIONS!*)           % Defined in PSL Module COMMON.
 (FLAG '(COMMENT BOUNDP) 'LOSE) )
(IFP !!MACEXPD NIL
 (FLAG '(MACEXPD MACEXPDL1 MACEXPDL MACEXPDCOND) 'LOSE) )
(FLAG '(IFP ERRORFT CMMACRO
%       ADDHLP
        MOVD)
 'LOSE)                                 % Defined in this file.

(IFP (AND (GETD' GETENV) (EQUAL "alpha" (GETENV "MACHINE")))
 (FLAG '(PUTD) 'LOSE) NIL)              % Trouble with PUTD on Alpha

(INCLUDE "../exfn1i.sl")

(IFP (AND (GETD' GETENV) (EQUAL "alpha" (GETENV "MACHINE")))
 (REMFLAG '(PUTD) 'LOSE) NIL)           % Trouble with PUTD on Alpha

(REMFLAG '(XCOND) 'LOSE)                % Not needed.
(REMFLAG '(MKQUOTE EQCAR ATSOC REVERSIP NCONS XCONS
           DE COMPILETIME BOTHTIMES LOADTIME)
         'LOSE)                         % Defined in Bare PSL.
% UNIONQ defined but gives trouble as it reverses first argument.
(IFP (MEMQ 'USEFUL OPTIONS!*)           % Defined in PSL Module USEFUL.
 (REMFLAG '(FUNCALL) 'LOSE) )
(IFP (MEMQ 'COMMON OPTIONS!*)           % Defined in PSL Module COMMON.
 (REMFLAG '(COMMENT BOUNDP) 'LOSE) )
(IFP !!MACEXPD NIL
 (REMFLAG '(MACEXPD MACEXPDL1 MACEXPDL MACEXPDCOND) 'LOSE) )
(REMFLAG '(IFP ERRORFT CMMACRO
%          ADDHLP
           MOVD)
 'LOSE)                                 % Defined in this file.

(IFP !!MACEXPD NIL
 (REMPROPL '(COND LAMBDA PROG QUOTE GO) 'MACEXPDFN) )
% COND, LAMBDA and PROG have got a MACROEXPAND!-FUNC in PSL,
% QUOTE and GO haven't got any.

(DMACRO CMMACRO (FN ARGS !&REST BODY)
  (LIST 'CPROGN
    (LIST 'DPUT FN PSLPA1FN 'CMPA1)
    (!$MACFEX FN ARGS BODY 'COMPILERMACRO) ))

(FLAG '(COMPILERMACRO) 'MACROARG)       % First arg is function name.

% Must have one arg that is bound to list of args.
(FLAG '(COMPILERMACRO) 'FNARY)

% COMPILERMACROs have better be compiled.
(NOTLOADTIME (FLAG '(COMPILERMACRO) 'COMPILE))

% This is for the HELP in module HELP of PSL. Not complete.
%(DE ADDHLP (HLPLIS FN HLP)
%  (SLET ((EVHLPLIS (EVAL HLPLIS)))
%    (COND
%      ((AND HLPLIS (NOT (MEMQ FN EVHLPLIS)))
%       (SET HLPLIS (NCONC EVHLPLIS (LIST FN))) ))
%    (COND
%     ((STRINGP HLP) (PUT FN 'HELPSTRING HLP))
%     (HLP (PUT FN 'HELPFUNCTION HLP)) ) ) )

(DMACRO TRA (!&REST L)
 (PROGN (MLOAD 'DEBUG) (LIST 'EVTR (MKQUOTE L))) )
(DMACRO UNTRA (!&REST L)
 (PROGN (MLOAD 'DEBUG) (LIST 'EVUNTR (MKQUOTE L))) )

(DMACRO PP (!&REST L) (PROGN (MLOAD 'PP) (CONS 'PP L)))
(DE PRETTYPRINT (L)
 (PROGN (MLOAD 'PP) (EVAL (LIST 'PRETTYPRINT (MKQUOTE L)))) )

% It is important to define GRIND very early.
(DE GRIND (AT!&)
 (PROG (PR!&)
  (TERPRI)
% (MLOAD 'PP)   % Needed only if pp.b is not found in pl:
  (COND
   ((NOT (IDP AT!&)) (ERRORFT 437 "%p is not an identifier" AT!&))
   ((SETQ PR!& (GETD AT!&))
    (PRIN2 "FnDef: ") (TERPRI) (PRETTYPRINT PR!&) ))
  (COND
   ((BOUNDP AT!&)
    (PRIN2 "Value: ") (TERPRI) (PRETTYPRINT (EVAL AT!&)) ))
  (PRIN2 "Property list of ") (PRIN2 AT!&)
  (COND
% PROP in PSL is what other Lisp often have as PLIST. In PSL PLIST
% is a macro avoiding to have to type quote.
   ((NOT (SETQ PR!& (PROP AT!&)))
    (PRIN2 " is empty") (TERPRI) (TERPRI) )
   (T (PRIN2 " :") (TERPRI)
    (FOREACH PA!& IN (PROP AT!&) DO
     (COND
      ((NOT (PAIRP PA!&))
       (PRIN1 AT!&) (PRIN2 " flagged ") (PRIN1 PA!&) (TERPRI) )
      ((NOT (MEMQ (CAR PA!&) '(!*LAMBDALINK TYPE)))
       (PRETTYPRINT PA!&) ) ) ) ) ) ))

%### EXFN1.SL end
