%### INCLDE.SL ======================================================
%
%       INCLDE.SL
%       ---------
%
%       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file defines a temporary version of INCLUDE that is
%       needed for bootstrapping.
%
%====================================================================

(FLUID '(CURRENTDIR!* !*IPRN !*ECHO))

(SETQ !*IPRN T)         % INCLUDE normally prints out.

% This definition of INCLUDE is temporary, to be used in bootstrapping.
%
% See LOAD.SL for the final definition.
(DF INCLUDE (U)
 (PROG (OLDCH Y X W)
  (COND
   (CURRENTDIR!*
    (COND
     ((OR
       (AND                                             % Back up one
        (EQCAR (SETQ Y (EXPLODE2 (CAR U))) '!.)         % directory
        (EQCAR (CDR Y) '!.)                             % level, but
        (OR                                             % only one.
         (EQCAR (CDDR Y) '!/ )                          % Unix style.
         (EQCAR (CDDR Y) '!\ ) ) )                      % DOS style.
       (AND
        (EQCAR (SETQ Y (EXPLODE2 (CAR U))) '![ )        % ] VMS style
        (EQCAR (CDR Y) '!-)
        (EQCAR (CDDR Y) '!] ) ) )                       % [
      (SETQ U (SETQ X (EXPLODE2 CURRENTDIR!*)))
      (COND
       ((MEMQ '!/ U)                                    % Unix style
        (WHILE (AND (SETQ U (MEMQ '!/ (CDR U))) (CDR U)) (SETQ W U)) )
       ((MEMQ '!\ U)                                    % DOS style
        (WHILE (AND (SETQ U (MEMQ '!\ (CDR U))) (CDR U)) (SETQ W U)) )
       (T (WHILE
           (AND (SETQ U (MEMQ '!. U)) (CDR U))
           (SETQ U (CDR (SETQ W U))) )
          (RPLACA W '!]) ) )                            % [
      (RPLACD W (CDDDR Y))
      (PROG (!*RAISE) (SETQ !*RAISE NIL)
       (SETQ U (COMPRESS (CONS '!" (NCONC X (LIST '!" ))))) ) )
     (T (SETQ U (CAR U))) ) )
% No CURRENTDIR!* given:
   ((AND
     (NOT (GETD 'GETSTARTUPNAME))       % Not Unix (i.e. VMS or DOS386).
     (EQCAR (SETQ Y (EXPLODE2 (CAR U))) '!.)    % Back up one
     (EQCAR (CDR Y) '!.)                        % directory
     (EQCAR (CDDR Y) '!/ ) )                    % level, but
    (PROG (!*RAISE) (SETQ !*RAISE NIL)          % only one.
     (SETQ U
      (COMPRESS
       (APPEND 
        (COND
         ((AND                                  % Test for DOS386
           (GETD 'GETENV)
           (EQCAR (CDR (MEMQ '!: (EXPLODE2 (GETENV "PATH")))) '!\ ) )
          '(!" !. !. !\ ) )                     % For DOS386
         (T '(!" ![ !- !] )) )                  % For VMS
        (NCONC (CDDDR Y) (LIST '!")) ) ) ) ) )
   (T (SETQ U (CAR U))) )
  (SETQ OLDCH (RDS (OPEN U 'INPUT)))
  (TERPRI) (PRINC "Including file: ") (PRINC U) (TERPRI)
NEXTRD
  (SETQ Y (READ))
  (COND
   ((EQ Y !$EOF!$)
    (CLOSE (RDS OLDCH))
    (TERPRI) (PRINC U) (PRINC " done include") (TERPRI)
    (RETURN "Finished loading") )
   ((NOT (PAIRP (SETQ X (ERRORSET Y T T))))
    (COND ((NOT !*ECHO) (PRINT Y)))
    (ERROR 440 "Error return") )
   (!*IPRN (PRINT (CAR X))) )
  (GO NEXTRD) ) )

%### INCLDE.SL end
