%### LDINT.SL =======================================================
%
%       LDINT.SL
%       --------
%
%       Copyright (c) 1988 - 2011 by Jan E. Aman and Inge Frick,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file contains the essential part of the commands executed
%       in Portable Standard Lisp (PSL) to build interpreted Sheep Lisp.
%
%====================================================================

(SETQ !*BREAK NIL)              % Don't use PSL break by default.

(SETQ !*PRINTLOADNAMES T)       % Message as PSL modules are loaded.

% NBIG (rather NBARITH) redefines them incorrectly.
% ZEROP buggy in PSL 3.4 20-Feb-90 (for sun4), FLOATLESSP and
% FLOATGREATERP in PSL 3.4 2-Feb-92 (for mips_dec). JEA.
(FLAG '(ZEROP FLOATLESSP FLOATGREATERP) 'LOSE)
% (LOAD NBIG)                   % For some old version of PSL
(LOAD NBIG32)                   % PSL bignums (modern 32-bit version)

(SETQ !*USERMODE NIL)           % Allow redefinitions of functions.

(SETQ !*EOLINSTRINGOK T)        % Allow end of line in strings.

(DSKIN "inclde.sl")

(COND
 ((AND
   (GETD' GETENV)               % A test for DOS386 (or Windows)
   (EQCAR (CDR (MEMQ '!: (EXPLODE2 (GETENV "PATH")))) '!\ ) )
  (LOAD ADDR2ID)                % Provisional fix. Enables debugging.
  (COND
   ((NOT (GETENV "PWD"))        % Perhaps a test for not DOS386.
    (INCLUDE "dos386.sl") ) ) ) % Set up directories for DOS386.
                                % Should be done only for PSL 3.4?
 ((GETD 'GETSTARTUPNAME)        % Test for Unix-PSL.
  (LOAD ADDR2ID) )              % Provisional fix. Enables debugging.
                                % Should be done only for PSL 3.4?
 ((GETD 'MACHINENAME)           % A test for VMS PSL 3.2A (or later).
  (INCLUDE "dirfix.sl") ) )     % Load fix for VMS version before 3.2A.

(INCLUDE "exfn1.sl")

% Used for testing which system is running.
(SETQ !*RSHEEP NIL)

(INCLUDE "systyp.sl")
(INCLUDE "exint.sl")
(INCLUDE "exfn2.sl")
(INCLUDE "printf.sl")
(MOVD 'OINCLUDE 'INCLUDE)       % May be omitted when everything works.
(INCLUDE "load.sl")

% List of extensions searched for:
(SETQ MEXTLIS!* '(LAP B SL))
(DPUT SLLSPEXT SUBDRS SL)       % Extension for Sheep Lisp sources.
(DPUT SHPSRCEXT SUBDRS SHP)     % Source extension for Sheep.

%(FLAG '(YESP) 'LOSE)
%(OINCLUDE "../newnam.sl")      % INCLUDE should also work here.
%(REMFLAG '(YESP) 'LOSE)

(SETPROMPTER "SL> ")

% Set TOPDIR!* to be two levels up from current directory. JEA.
%(IFP (GETD 'GETENV)             % Unix case.
% (SETQ TOPDIR!* (PREFIXOF (PREFIXOF (GETENV "PWD")))) )

% Set up search list. MSEARCHLIS!* is reset in SSLISP.INI. JEA.
(SETQ MSEARCHLIS!* '(NIL HERELIST))
(ADDSUBDIRS (LIST TOPDIR!*)
 '(NIL "slbin" (("slsrc" LISPSYS)) "slsrc"
   (("shpsrc" LISPSYS)) "shpsrc" ) )

(ADDSUBDIRS NIL LISPLIBDIR!*)   % Lisp library directories.

(SETQ MLIST!* OPTIONS!*)        % Keep information on PSL modules.

%### LDINT.SL end
