%### PRINTF.SL ======================================================
%
%       PRINTF.SL
%       ---------
%
%       Copyright (c) 1988 by Jan E. Aman and Inge Frick, Institute of
%       Theoretical Physics, University of Stockholm, Vanadisvagen 9,
%       S-113 46  Stockholm, Sweden.
%
%       This file is all that PSL needs to replace prntfi.sl as only
%       WARNINGFT and MSGOUT are needed, everything else is already
%       defined in PSL.
%
%====================================================================

(SETFLUIDS (!*MSGTOFILE T))

% Defined as in prntfi.sl
% WARNINGFT redefined to include warning message numbers not yet used
% but available for possible future use. Strightforward definition:
%(DS WARNINGFT (DUMMY ST !&REST AR) (MSGOUT ST "*** " (LIST . AR)))% JEA
% Safer definition accepting also calls without warning numbers:
(DMACRO WARNINGFT (!&REST L)
 (COND ((AND L (NUMBERP (CAR L))) (SETQ L (CDR L)))) % JEA.
 (LIST 'MSGOUT "*** " (MKQUOTE (CAR L)) (CONS 'LIST (CDR L))) )

% Note! MSGOUT and MSGOUT3 are explicitly called from SHEEP (ASKIN and
% EASK). Also a provisional MSGOUT is used in bootstrapping.
% Defined as in prntfi.sl
(DE MSGOUT (PR ST AR) (PROG (SW)
  (COND ((NOT !*MSG) (RETURN NIL)))
  (COND ((NOT (SETQ SW (STDOUTP))) (STDOUT (MSGOUT3 PR ST AR))))
  (COND ((OR SW !*MSGTOFILE) (MSGOUT3 PR ST AR))) ))

% PSL specific.
(DE MSGOUT3 (PR ST AR)
 (QTRPRI) (COND (PR (PRIN2 PR))) (APPLY 'PRINTF (CONS ST AR)) (TERPRI) )

%### PRINTF.SL
