%### SYSTYP.SL ======================================================
%
%       SYSTYP.SL
%       --------
%
%       Copyright (c) 1988, 1998, 2011  by Jan E. Aman and Inge Frick,
%       Department of Physics, Stockholm University,
%       SE-106 91  Stockholm, Sweden.
%
%       This file contains the SYSTYPE commands that tells which host
%       etc. that you have. Edit it appropriately for your site.
%
%====================================================================

% Most things will be figured out from PSL, Unix environment variables
% etc. The SITE defaults to VANADIS (Physics at Univ. of Stockholm)
% for VMS installations.

% Change SITE and operating system version etc. if different
% from that given below.

(IFP (AND (GETD 'GETENV) (GETENV "HOST"))
 (SETSYSTYPE 'NODE
  (COND ((NOT (EQUAL "" (GETENV "HOST"))) (GETENV "HOST"))) )
 (IFP (AND (GETD 'MACHINENAME) (EXPLODE2 (MACHINENAME)))
  (SETSYSTYPE 'NODE
   (INTERN (COMPRESS (EXPLODE2 (MACHINENAME)))) )
  (IFP (NOT (GETD 'GETENV))
   (SETSYSTYPE 'NODE 'VANA) ) ) )       % Default node for VMS PSL 3.2.

% DOMAINNAME is to be defined in startlisp and startreduce (or here).
% Specify SITE if not clear from DOMAIN specification.
(IFP (AND (GETD 'GETENV) (GETENV "DOMAINNAME")
          (NOT (MEMBER (GETENV "DOMAINNAME") '("" "(none)"))) )
 (SETSYSTYPE 'DOMAIN (GETENV "DOMAINNAME"))
 (IFP
  (NOT (OR (GETD 'GETENV)
           (AND (GETD 'MACHINENAME) (EXPLODE2 (MACHINENAME))) ))
  (PROGN
   (SETSYSTYPE 'SITE 'VANADIS)          % Default site and domain for
   (SETSYSTYPE 'DOMAIN "physto.se") ) ) ) % VMS PSL 3.2.

(SETSYSTYPE 'LISPSYSTEM 'PSL)           % Portable Standrard Lisp (PSL).

(IFP 
 (AND (GETD 'GETSTARTUPNAME) (GETSTARTUPNAME))
 (PROGN                                 % This is the Unix case
  (SETSYSTYPE 'OS 'UNIX)
  (IFP
   (AND (GETD 'GETENV) (EQUAL "linux" (GETENV "OSTYPE")))
   (PROGN                               % This test should pick up the
    (SETSYSTYPE 'OSTYPE 'LINUX)         % Linux case.
    (IFP (GETENV "HOSTTYPE")
     (SETSYSTYPE 'MACHINE
      (INTERN (COMPRESS (CDR (EXPLODE2 (GETENV "HOSTTYPE"))))) )
     (SETSYSTYPE 'MACHINE 'PC) )        % Anything compatible with
%   (SETSYSTYPE 'MACHINEVERS 486)       % IBM PC.
    (SETSYSTYPE 'LISPVERS 4.2) )
   (PROGN                               % Unix, not Linux:
    (SETSYSTYPE 'OSTYPE 'BSD)
    (SETSYSTYPE 'OSVERS 4.4)
% (BOUNDP '!*!*LOW!-CASE) is a test for lower case PSL
    (SETSYSTYPE 'LISPVERS (IFP (BOUNDP '!*!*LOW!-CASE) 4.2 3.4)) ) )
  (IFP (AND (GETD 'GETENV) (GETENV "MACHINE"))
   (PROG (MA)
    (SETQ MA (INTERN (COMPRESS (EXPLODE2 (GETENV "MACHINE")))))
    (COND
     ((EQ MA 'SUN4)
      (SETSYSTYPE 'MACHINE 'SUN)
      (SETSYSTYPE 'MACHINEVERS 4))
     ((EQ MA 'SUN)
      (SETSYSTYPE 'MACHINE 'SUN)
      (SETSYSTYPE 'MACHINEVERS 3))
% Set in Unix if there was an environment variable MACHINE was set.
     (T (SETSYSTYPE 'MACHINE MA)) ) ) ) )
 (IFP
% This test should most probably pick up the DOS/Windows case.
  (AND
   (GETD 'GETENV)
   (EQCAR (CDR (MEMQ '!: (EXPLODE2 (GETENV "PATH")))) '!\ ) )
  (COND
   ((GETENV "PWD")                      % Perhaps a test for not DOS386.
    (PROGN
     (IFP (GETENV "OS")
      (SETSYSTYPE 'OS (GETENV "OS"))
      (SETSYSTYPE 'OS 'WINDOWS) )
     (SETSYSTYPE 'MACHINE 'PC)
     (SETSYSTYPE 'MACHINEVERS 686)
     (SETSYSTYPE 'LISPVERS 4.2) ) )
   (T (PROGN
     (SETSYSTYPE 'OS 'DOS386)
     (SETSYSTYPE 'MACHINE 'PC)          % Anything compatible with
%    (SETSYSTYPE 'MACHINEVERS 486)      % IBM PC
     (SETSYSTYPE 'LISPVERS 4.2) )) )
  (PROGN
   (SETSYSTYPE 'OS 'VMS)                % VMS:
   (SETSYSTYPE 'MACHINE 'VAX)
   (IFP (GETD 'HARDWAREVERSION)
    (SETSYSTYPE 'MACHINEVERS (HARDWAREVERSION))
    (SETSYSTYPE 'MACHINEVERS 8530) ) ) % VAX-8530 default for 3.2.
   (IFP (GETD 'SOFTWAREVERSION)
    (SETSYSTYPE 'OSVERS (COMPRESS (CDR (EXPLODE2 (SOFTWAREVERSION)))))
    (SETSYSTYPE 'OSVERS 5.1) )
   (IFP (GETD 'MACHINENAME)
    (SETSYSTYPE 'LISPVERS '!3!.2A)
    (SETSYSTYPE 'LISPVERS '!3!.2) ) ) )

%### SYSTYP.SL end
