







                         MANUAL FOR





  CCCCCCCC  LL           AAAAAA      SSSSSSSS    SSSSSSSS    IIIIII
  CCCCCCCC  LL           AAAAAA      SSSSSSSS    SSSSSSSS    IIIIII
CC          LL         AA      AA  SS          SS              II
CC          LL         AA      AA  SS          SS              II
CC          LL         AA      AA  SS          SS              II
CC          LL         AA      AA  SS          SS              II
CC          LL         AA      AA    SSSSSS      SSSSSS        II
CC          LL         AA      AA    SSSSSS      SSSSSS        II
CC          LL         AAAAAAAAAA          SS          SS      II
CC          LL         AAAAAAAAAA          SS          SS      II
CC          LL         AA      AA          SS          SS      II
CC          LL         AA      AA          SS          SS      II
  CCCCCCCC  LLLLLLLLL  AA      AA  SSSSSSSS    SSSSSSSS      IIIIII
  CCCCCCCC  LLLLLLLLL  AA      AA  SSSSSSSS    SSSSSSSS      IIIIII




                           ----

                  Classification Programs
                       for Geometries
                   in General Relativity



                    Author: Jan E. Aman

              Institute of Theoretical Physics
                   University of Stockholm
                         Vanadisv. 9
                     S-113 46  Stockholm
                           Sweden


             Third provisional edition, may 1987




                       TABLE OF CONTENTS


1.  INTRODUCTION AND ACKNOWLEDGEMENTS

2.  CLASSIFICATION OF A METRIC
        2.1    Classification with Unix Shell Script.
        2.1.1    Output on terminal
        2.1.1    Batch (background)
        2.1.1.1    Batch (background) under unix
        2.1.1.2    Batch under VAX/VMS
        2.1.2    List of available shell scripts
        2.2    Classification without command file

3.  CONSTRUCTION OF A METRIC FILE
        3.1    Metrics using complex quantities or coordinates.
        3.2    Various ways to input a metric.
        3.3    Where will SHEEP look for necessary files?
        3.4    Some hints for preparing your own metric files.

4.  SELECTED METRIC FILES
        4.1    Comments on the collection of metric files.
        4.2    Interpretation of File Names.
        4.3    References in the ready-made metric files.
        4.4    Selected list of ready-made metric files.

5.  LIST OF AND SHORT DESCRIPTION OF PROGRAM MODULES
        5.1    Introduction to description of program modules.
        5.2    List of program modules with short description.

6.  SOME IMPORTANT FUNCTIONS USED IN PROGRAMS

7.  REFERENCES

APPENDIX A.  SOME EXAMPLES OF METRIC FILES
APPENDIX A.1    Schwarzschild metric given in diagonal form.
APPENDIX A.2    Plane gravitational wave in complex coordinates.
APPENDIX A.3    Metric file for Kinnersley type II.A

APPENDIX B.  EXAMPLE OF A MODULE OF TENSOR PROGRAM


1.  INTRODUCTION AND ACKNOWLEDGEMENTS


     This  preliminary  short  manual  of  classification programs for
geometries  in  general  relativity written for SHEEP[1,2,3].  It also
describes  a  collection  of  general  relativity  metrics written for
SHEEP. Files with the described programs and metrics are included when
SHEEP is distributed. The main purpose with this manual is to give the
most  essential  information  for  the  use  of  these  classification
programs. The reader is assumed to be somewhat familiar with SHEEP.

     The  most  important  classification  program  is the program for
invariant  classification  of  geometries.  For theory of this classi-
fication see [4,5],  for an examplified description of the implemented
algorithm including the facility for complex numbers in module  hlpfns
and funtst (see below) see  [6].  Some  results  obtained  using  this
classification  program  are  found in [7,8,9,10,11].

     In general the described programs are available for SHEEP2 both
running on top of Franz Lisp on VAXes running VMS or Unix and for
Cambridge University Lisp (Culisp) running on Orion from High Level
Hardware. There also exist versions of many modules for the older
assembler coded version SHEEP1 for DEC-machines.

     Although most of the programs and metric files mentioned here are
written  by  the author of this manual some of the program modules and
metric files are written entierly or partly by other authors.  Program
modules  mainly  written  by  other authors are cord (Frick),  frmdef,
spcurv  (MacCallum)  and  ptrvlr  (Joly).   Information  on  author is
normally included in program modules and sometimes in metric files.

     This  work  had  not been possible without close cooperation with
the author of SHEEP, Inge Frick, since many of the program modules use
undocumented  internal  facilities in SHEEP.  In many cases he,  or we
jointly,   have  made  changes  to  SHEEP  in  order  to  improve  the
possibilities of using internal SHEEP functions from other programs. I
am  indebted im Anders Karlhede for cooperation and discussions on the
implementation  of  his  algorithm  for  invariant  classification  of
geometries.  I wish to thank Bertel Laurent,  Ian Cohen and Inge Frick
for  taking  up studies of the equivalence problem and for encouraging
me to implement the classification procedure by Karlhede.  Furthermore
I wish to thank Malcolm MacCallum, Gordon Joly and Jim Skea from Queen
Mary College, London for adding new modules of program and new metrics
and or encouraging me to improve my programs.


2.  CLASSIFICATION OF A METRIC

     This  chapter  describes  how to classify a metric provided there
already exists a correct metric file.


2.1    CLASSIFICATION WITH A UNIX SHELL SCRIPT

2.1.1 Output on terminal


% classify kiia.nud       Runs the classification program for
                          Kinnersley type II.A on the terminal.

2.1.1    Batch (background)

2.1.1.1    Batch (background) under unix


% classify kiia.nud > /dev/null &
                          Runs the same classification as a background
                          job. Result in kiianud.res. Additional
                          messages intended for the terminal are lost.

% classify kiia.nud > kiianud.log &
                          As above but also saves messages in a log file.

2.1.1.2    Batch under VAX/VMS


$ SHPCOJ SYS$BATCH CLASSI KIIA.NUD
                          Performs the same classification in
                          a batch-job. result will be found in
                          file KIIA.LOG.


2.1.2    List of available shell scripts


Command files for standard demonstrations or for batch-jobs.

classify        To do invariant classification of geometries up to
                the necessary order of differentiation.

cdrdem          Demonstrates a CORD calculation.

gfrdem          Demonstrates a GFRAME calculation.


2.2 CLASSIFICATION WITHOUT COMMAND FILE

Start classi. With proper setup in your initialisation files
this is done with

% classi

or rather e.g.

% classi -S 3M

in order to get 3 megabytes of memory. (A reasonable amount)

Load the metric.  The command to load e.g. schwar.dia is

SHP> (LOAD "schwar.dia") .

     If you wish to have a description on your input as interpreted by
SHEEP  you  are  now  recommended to issue the command (PRINPUT) thats
prints the input.

     To  check the input metric from a easily readable format by issue
command  (WMAKE DS2) to display the line element and (WMAKE FORMSU) to
display the frame vectors.

     The  command  (CLASSIFY0)  will  now give you Petrov type,  Ricci
spinor  and  curvature scalar.  The number of functionally independent
functions found so far will be given.  Check that presented quantities
can not be simplified into zero. If this is not a standard dyad please
change dyad by adding a dyad transformation before continuing.

     The  command  (CLASSIFY1) will now give you the first symmetrised
derivative  of PSI,  PHI and LAMBDA.  Those quantities are checked for
functionally independent functions.  Also the squares of the covariant
derivatives PSI and PHI are calculated and from them the square of the
Riemannian.

     Giving  the  command  (CLASSIFY2)  performs the corresponding for
second  covariant derivatives.  You may continue to higher derivatives
but there will seldom be any need for them.

     The command (CLASSIFY) will perform classification as above and stop
in accordance with the algorithm.







3.  CONSTRUCTION OF A METRIC FILE


     Some  few  metric files are given in appendix A as examples.  See
also chapter 2 in SHEEP Users guide [1], [2] and [3].

The commands normally included in a metric file are:

(LOAD module)  Specify modules that must be loaded before this metric
            can be interpreted. E.g. (LOAD DIANUL). The command
            PRELOAD often found in existing files means the same thing.

(TITLE      A title (with name of file and references) can be given
" ... ")    as a Lisp string.

(CLEAR)     Clears all metric dependent data and resets switches to
            off position etc.

(OFF ALL) (ON ...)   Make sure the switches you wish on, are on.
            It is recommended to always turn NOZERO on, turn on PTVAR
            for *.CRD and *.LOR files, turn on POTSOM for *.NUL files.

NAM         See [1].

VARS        See [1].

FUNS        See [1]. Note that the SPEC facility is very useful.

RPL         See [1]. Give values both to some scalars you need to
            introduce (e.g. A for 1-2m/r in SCHWAR.*) and to "tensors",
            e.g. to ZUD.

NEWSUL      Define a new substitution list. If first argument is a number
            it specifies how many pairs of substitutions to put on that
            substitution list. All remaining arguments are given to 
            SETSUB, see [1]. Normally two arguments, number of substitution
            pairs and name of the substitution list.

USESUL      Defines the use of a substitution list. First argument is
            the name of a substitution list. All other arguments are
            names of tensors for which to use substitutions when making
            them.
            

3.1    Metrics using complex quantities or coordinates.


    By default all quantities are assumed to be real but if any complex
coordinates or functions are used they all have to be declared with one
of the functions below. The switch COMPLX will then be switched on.

REAL        For real quantities.

UNITARY     Defines the complex conjugate to be the quotient of 1 and the
            argument.

IMAGINARY   Defines complex conjugate to be minus argument.

COMPLEX     Defines it to be complex in general.

DEFCONJL    Defines mutually complex conjugates, e.g.
(DEFCONJL (Z ZST) (W WST)) defines Z and ZST to be complex conjugates
            and so also W and WST.


3.2    Various ways to input a metric.


Module IZUD allows you to input tetrad vectors as IZUD rather than ZUD.
The purpose is to e.g. perform a dyad transformation.

Module NUDDNU enables you to input covariant null vectors LD ND MD.

Module NUDNUL enables you to input contravariant null vectors LU NU MU.

Module DYTRSP enables you to perform a dyad transformation given as
the 2*2 matrix DYTR. This dyad transformation is performed between
IZUD and ZUD.


3.3    Where will SHEEP look for necessary files?


If you just ask for a file name without specifying directory SHEEP
will try to look for that file in all directories specified by
the list MSEARCHLIS!*.


3.4    Some hints for preparing your own metric files


  *  Study special cases first. E g if you want the Kerr-Newman metric
     first study Schwarzschild, then Kerr and Reisner-Nordstrom.

  *  Use FRAME unless you have got very strong reasons to use CORD. If
     you are not yet familiar with the FRAME formalism it is well worth
     the effort to study it. When using FRAME note that if you obtain a
     correct line element (DS2 or GDD) you have thereby proven that your
     input in frame notation is correct.

  *  Never allow a polynomial in the denominator. Introduce a new
     quantity representing that polynomial instead. If the determinant
     (ZDET or GDET) is a sum cure that with substitution or introduction
     of a new quantity.

  *  Be careful when typing substitution lists. No one else will check
     them. A set of incorrect substitutions may prove anything.

  *  Calculate derivatives (preferably with SHEEP) of introduced
     quantities. If you can simplify them specify the derivatives
     with the FUNS/SPEC facility e g (FUNS F (F SPEC X Y)).

  *  Save most of the remaining substitutions to RIE. Attempts to
     make sophisticated substitutions in LIE/GAM may make it worse.



4.  SELECTED METRIC FILES

4.1   Comments on the collection of metric files

     Note that this list contains only a selection from a large set of
metrics.   The metrics listed below will normally simplify the Riemann
and Weyl tensors to a reasonably simplified form.  The Riemannian will
sometimes not be completely simplified (also not for vacuum metric).

     Most of the files perform all calculations including substitution
without  additional  commands,   some (e g MINKPN,  SCHWIC) do however
require  additional  action  by  the  operator  to simplify everything
completely.

     For  some  metrics  the  command (ON PSUBS) changes printout from
showing  symbols defined only for efficiency (e g to avoid polynomials
in the denominator) to show expressions in conventional notation.


4.2   Interpretation of File Names


     Metric file names consist of two parts separated by a dot.  The part
after the dot is called extension.  That part of the file name is used to
indicate which type the file is of. Several extensions are used for SHEEP
metric files.

*.crd   Metrics in coordinate form for CORD (the coordinate version
        of SHEEP).
*.lor   Metrics in a Lorentz tetrad for FRAME (the frame version of
        SHEEP).
*.hnl   Metrics in half-null tetrad for FRAME
*.nul   Metrics in null tetrad for FRAME
*.dia   Diagonal metrics in a special diagonal form for FRAME.
        Calculations are done in null tetrad.
*.nud   Metrics input as contravariant components of null vectors.
*.spi   File also includes a dyad transformation in order to get
        the spinor PSI on a standardised form.
*.gfr   File for general (non-constant) frame using module GFRAME.

     The file name (extension excluded) is meant to indicate both the
geometry (e.g.  Schwarzschild) and the coordinate system used, e g
Eddington-Finkelstein coordinates. As some old-fashioned operating systems
only allow six plus three characters in a file name some of the names may
be hard to decipher. Names are standardised for compatibility.


4.3    References in the ready-made metric files


     References are normally included in each file.  Reference is made
either  to  original  articles  or  to  well known  standard textbooks.
References  to  the  latter  are  in  a  shorthand  notation  with the
following key:

Hawking-Ellis      Ref. [12]

Gravitation        Ref. [13]

Landau-Lifshitz    Ref. [14]

Exact Solutions    Ref. [15]


4.4    Selected list of ready-made metric files


curzon.dia              Curzon metric in Curzon coordinates.
curwlc.dia              Curzon metric in Weyl-Levy-Civita coordinates.
desitt.crd,.lor,.dia    de Sitter space-time.
desit2.crd,.lor,.dia    de Sitter in a second coordinate system.
antdes.crd,.lor,.dia    Anti - de Sitter.
ades2 .crd,.lor,.dia    Anti - de Sitter in a second coordinate system.
bondi .crd,.lor,.hnl,   Bondi metric.
      .nul
curwlc.dia,.dia         Curzon metric.
godel .crd,.lor,.nul,   Godel's universe.
      .spi
godel2.crd,.lor,.nul,   Godel's universe in a second coordinate system.
      .spi
friedm.dia              Friedman-Robertson-Walker universe.
friedc.dia              D:o closed model.
friedo.dia              D:o open model.
friedp.dia              D:o parabolic (border) case.
harris.shp              Common part for all Harrison metric files.
hiii1 .dia              Harrison metric III-1
hiii2 .dia              Harrison metric III-2
hiii3 .dia              Harrison metric III-3
hiii4a.dia              Harrison metric III-4(a)
hiii4b.dia              Harrison metric III-4(b)
hiii4c.dia              Harrison metric III-4(c)
hiii7a.dia              Harrison metric III-7(a)
hiii7b.dia              Harrison metric III-7(b)
hiii7c.dia              Harrison metric III-7(c)
hiii8 .dia              Harrison metric III-8
hiii9a.dia              Harrison metric III-9(a)
hiii9b.dia              Harrison metric III-9(b)
hiii9c.dia              Harrison metric III-9(c)
h12a  .dia              Harrison metric III-12(a)
h12b  .dia              Harrison metric III-12(b)
h12c  .dia              Harrison metric III-12(c)
hauser.crd,.nul,.spi    Hauser's type N twisting solution.
kerr  .lor,.nul         Kerr in Boyer-Lindquist coordinates.
kerrke.nul              Kerr in Kerr coordinates.
kerrnw.lor,.nul,.nud    Kerr-Newman in Boyer-Lindquist coordinates.
      .spi
ki    .nud              Kinnersley Case I
kip   .nud              Kinnersley Case I, case C=1/2 (NUT)
kin   .nud              Kinnersley Case I, case C=-1/2
kiz   .nud              Kinnersley Case I, case C=0
kiia  .nud              Kinnersley Case II.A (Kerr-NUT)
kiiaa .nud              Kinnersley Case II.A, special case a=0 (NUT)
kiial .nud              Kinnersley Case II.A, special case l=0 (Kerr)
kiiala.nud              Kinnersley Case II.A, a=l=0 (Schwarzschild)
kiib  .nud              Kinnersley Case II.B
kiic  .nud              Kinnersley Case II.C
kiid  .nud              Kinnersley Case II.D
kiibcd.nud              Kinnersley Case II.BCD (II.B, C and D joined)
kiie  .nud              Kinnersley Case II.E
kiiemb.nud              Kinnersley Case II.E, special case m=b=0 (peculiar)
kiif  .nud              Kinnersley Case II.F
kiiia .nud              Kinnersley Case III.A
kiva  .nud              Kinnersley Case IV.A
kival .nud              Kinnersley Case IV.A, special case l=0
kivala.nud              Kinnersley Case IV.A, special case l=a=0
kivb  .nud              Kinnersley Case IV.B
minkow.crd,.lor,.nul    Minkowski flat space in spherical coordinates.
      .dia
minknu.crd,.hnl         Minkowski in double null coordinates.
minkpn.crd,.nul         Minkowski in Penrose null coordinates.
renord.crd,.lor,.dia    Reisner-Nordstrom in Schwarzschild coordinates.
schwar.crd,.lor,.hnl,   Schwarzschild metric in Schwarzschild coordinates.
      .nul,.dia
schwef.crd,.hnl,.nul    Schwarzschild metric in Eddington-Finkelstein
      .spi              coordinates.
schwis.crd,.lor,.dia    Schwarzschild in isotropic spherical coordinates.
      .nul
schwic.crd,.lor,.nul    Schwarzschild in isotropic Cartesian coordinates.
schwnu.hnl,.nul,.spi    Schwarzschild in double null coordinates.
schwin.lor,.dia         Interior Schwarzschild metric.
sphsym.crd,.dia         General spherical symmetric metric.
spsyfl.lor,.dia         Spherically symmetric perfect fluid.
stasph.lor,.dia         Static spherically symmetric metric.
taunut.lor,.nul,.spi    Taub-NUT.
weylme.crd,.lor         Weyl metric.
weyllc.crd,.dia         Weyl (axially symmetric stationary) metric in
                        Weyl-Levy-Civita coordinates.
wave  .crd,.nul,.spi    Plane wave.
wavez .spi              Plane Wave in complex coordinates.
witten.lor,.dia         Witten-Esposito metric.


5.  LIST OF AND SHORT DESCRIPTION OF PROGRAM MODULES

5.1   Introduction to description of program modules


     This is a short description of a set of SHEEP programs.  In
general the described programs exist both for the old assembler coded
DEC-version of SHEEP, SHEEP1, and for SHEEP2 - the Extended Standard
Lisp based version available on VAX/VMS on top of Franz Lisp and for
High Level Hardware Orion on top of Cambridge University Lisp.

     The mentioned files include programs that enable SHEEP to
calculate other tensors and quantities than those that SHEEP1 was
originally designed to calculate. Examples are the Weyl tensor, the
line element in a nice form, contravariant components of the Einstein
tensor, covariant derivatives of the Riemann tensor.

     Also included is a program for Petrov classification of metrics
written in null tetrad for FRAME and an example of the initialisation
file (SHEEP.INI) for people who prefer lower case letters in
sin, cos etc.

Programs listed file by file. Most files include further
documentation.

sheep.ini       Example of initialisation file for SHEEP.
                Keep this file under the name sheep.ini in your
                current directory and SHEEP will read it every time
                you start SHEEP.

cord.hlp        Explains what tensors CORD calculates and their
                definitions, cf SHEEP manual.

frame.hlp       Explains what tensors FRAME calculates and their
                definitions.


5.2    List of program modules with short description


Program  modules.   All  source codes have extension SHP.  If compiled
versions exist their extension are FSL on DEC and O on Franz Lisp based
systems (on VAX) and k on Cambridge Lisp based systems (Orion).

CORD            Defines the CORD tensors in new SHEEP2. For
                definitions consult [1] or the file cord.hlp.

FRAME           Defines the FRAME tensors in new SHEEP2. Definitions
                are given in the file frame.hlp. It differs from the
                definitions given in [1] in the respect that you give
                the quantities ZDD rather than ZUD. The ordering of the
                indices on LIE has been changed.

FRMDEF          (Re-)defines functions to set standard tetrads, NULLT,
                HNULL, LORENTZ and CARTESIAN to make this kind of
                definitions more flexible.

HLPFNS          A basic module with generally useful additions to
                SHEEP. Used by most other modules. Examples: Defining
                new substitution list and tell SHEEP for what
                calculations you wish to use them. Functions used for
                definition of new tensor formulas by most other
                modules.

                Enables the use of complex functions and coordinates in
                SHEEP. Also handles the problems of canonical represen-
                tation that arises as e g:

                f real,  z and w mutually complex coordinates

                                   *
                ==> f,    = (f,   )
                      zww      zzw

INVTRG          Defines differentiation rules for inverse trigonometric
                functions (arcsin, arccos, arctan, arccot).

DS2CRD          To write the line element DS2 nicely in CORD. Example of
                use Define your metric (GDD). Give commands:
                (PRELOAD DS2CRD)      Load this module
                (WMAKE DS2)           Make and write DS2

DS2FRM          To write the line element DS2 nicely for FRAME. Also
                enables calculation the one-forms often denoted by a fat
                omega (FORMSU and FORMSD) and the line element from them
                (DS2F).
		Included in the FRAME module in SHEEP2.

WEYLTC          Defines the Weyl tensor for CORD. Load file and give e g
                command (WMAKE WEYL).

WEYLTF          To calculate the Weyl tensor in FRAME.

ELDYNC          To perform electrodynamical calculations in CORD. Give
                the 4-potential AD as well as the metric and you can
                calculate the electrodynamical field-tensor FDD, the
                corresponding Energy-momentum tensor times 8 pi (KTDD).
                This tensor equals the Einstein tensor (EIN) in a
                electro-vacuum metric.

ELDYNF          For electrodynamical calculations in FRAME. Some of the
                metric files (see METRIC.HLP) e g RENORD.* and KERRNW.*
                have got a 4-potential AD defined.

EINDVC          To calculate the divergence of the Einstein tensor, i.e.
                the equations of motion. This divergence is identical to
                0  if your Einstein tensor has been calculated correctly
                from a metric (e g with SHEEP) but when one has used too
                many  tricks,   or  input the Einstein tensor by hand, a
                check  may  be  wise.  It also defines the contravariant
                components of the Einstein tensor EINUU.

EINDVF          The same for FRAME.

EINSQC          Calculates mixed Einstein tensor contracted once with
                itself in CORD (SHEEP2).

EINSQF          D:o for FRAME (SHEEP2).

EINSQ           D:o for either CORD or FRAME (SHEEP1).

FRMCRD          To calculate the coordinate components from the FRAME
                components of the same tensor. It defines coordinate
                of Riemann (RIEC), Ricci tensor (RICC), Weyl tensor
                (WEYLC), Einstein tensor (EINC) and mixed components of
                Einstein tensor (EINMC).

DRIEF           To calculate the first covariant derivative of the
                Riemann tensor in FRAME (DRIEF).

D2RIEF          To calculate its second covariant derivative (D2RIEF).

D3RIEF          Third covariant derivative (D3RIEF).

INVRDF          Squares (scalars) of the covariant derivatives of the
                Riemann tensor, Ricci tensor and curvature scalar in
                FRAME. It is normally more efficient to use spinors
                to obtain these quantities, see module EQUSPI.

CURVEF          Calculates the acceleration of a curve given by
                specification of the four coordinates as functions of
                parameter P as well as the metric. If the acceleration
                is 0 the curve is a geodetic curve.

COTRAF          Addition to above program to enable coordinate
                transformation.

DIANUL          Enables you to give diagonal metrics in a simple form
                and use null tetrad. Give as components of the vector GD
                square roots of diagonal components of metric.

ATENS           Redefines SHEEP:s tenval functions to enable handling of
                spinors as well as tensors. SHEEP1 only.

DTENS           Functions used to handle spinors and other quantities. SHEEP1.
                
CLASSI          Top level package for invariant classification. Defines
                e.g. CLASSIFY0, CLASSIFY1, CLASSIFY2.

DYTRSP          Dyad transformation DYTR.

EQUSPI          Defines PSI, PHI, LAMBDA and their derivatives PSID, PHID
                LAMBDAD, their symmetrised derivatives DPSI, DPHI, DLAMBDA,
                their second order symmetrised derivatives D2PSI, D2PHI,
                D2LAMBDA as well as scalar like the squares of DPSI, DPHI
                etc.

EQU7SP          Continuation up to 7th order derivatives.

PTRVSP          Performs Petrov classification of metrics given in null
                tetrad in FRAME. Load file and give command (PETROV).
                The invariants IINV and JINV, normally called I and J
                will be calculated (if necessary). (OPETROV) follows
                algorithm in [16]. (PETROV) uses a probably more
                efficient algorithm.

PTRVLR          Petrov classification from Lorentz tetrad using the
                Q-matrix method, see e.g. [15].

PSITST          Enables Petrov classification with PTRVSP also for
                Lorentz and half null tetrads.

SPCURV          To calculate Newman-Penrose quantities without first
                calculating RIEF.

FUNTST          Program to check for new functionally independent
                functions. (FUNTST tsr) tests all components of
                tensor tsr. (FNTSINT) restarts the procedure,
                forgetting about already found functions.

FUNTS4          Part of FUNTST special to dimension 4.

FUNTS2          Part of FUNTST special to dimension 2.

GROUP           Some tensors necessary for isotropy group classification
                according to [17].
	
SPINOR          Programs for spinors, also defines the spin coefficients
                SGAM.

SYMSPI          To handle symmetrised spinors.

IZUD            Allows input of IZUD, allowing for a dyad transformation.

NUDDNU          To input covariant null vectors LD, ND and MD.

NUDNUL          To input contravariant null vectors LU, NU, MU.

HARRIS          Common part of Harrison Metrics [18].

KINNER          Common part of Kinnersley D Vacuum Metrics [19].

6.  SOME IMPORTANT FUNCTIONS USED IN PROGRAMS


TENDEF defines new tensors in SHEEP.
An extension of the original SHEEP function DECLTEN having only
the first 2 or 3 arguments of TENDEF.	
It has 8 arguments (or only 2,3,4 or 5 first)
1: Tensor name (internal)
2: Symmetry type (TTYPE!*)
3: Print name (NAM-subst) if list, every element
   will be evaluated
4: UPINDX (contravariant)
5: TNSPCH (Tensor Spec Chars). This arg will be evaluated.
6: PREQ-list (tensors used in BULF)
7: DELK-list
8: BULF (Building function)

For  examples of use see appendix B.  In order to make TENDEF work the
same  way  in both versions of SHEEP the BULF have to be defined as an
s-expression in terms of tensor indices INDX1, INDX2, INDX3 etc.


7.  REFERENCES


 1.  I.  Frick,  "SHEEP,  users  guide",  Preprint,  Inst.  of  Theor.
     Physics, Univ. of Stockholm (1977).

 2.  I.  Frick,  "The  computer algebra system SHEEP,  what it can and
     cannot  do  in  general relativity",  Preprint,  Inst.  of Theor.
     Physics, Univ. of Stockholm (1977).

 3.  R.A. d'Inverno and I. Frick, "Interacting with SHEEP". to appear
     in Gen. Rel. Grav. (1981).

 4.  A. Karlhede, Gen. Rel. Grav. 12 (1980) 693.

 5.  A. Karlhede, Gen. Rel. Grav. 12 (1981) 963.

 6.  J.E. Aman and A. Karlhede, "An  Algorithmic  Classification of
     Geometries in General Relativity".  Proceedings of the 1981 ACM
     Symposium on Symbolic and Algebraic  Computation  (Symsac '81)
     (1981) 79.

 7.  J.E. Aman  and  A.  Karlhede "A Computer-Aided Complete
     Classification of Geometries in General Relativity. First
     Results", Phys. Lett. 80A (1980) 229.

 8.  A. Karlhede  and  J.E. Aman  "Classifying  Geometries  in General
     Relativity",  Abstracts of contributed papers,  9th International
     Conference on General Relativity and Gravitation (1980) 104.

 9.  A. Karlhede  and J.E. Aman "A Classification of the Vacuum D Met-
     rics", Preprint, University of Stockholm (1981).
 
10.  A. Karlhede  and  J.E. Aman "Inequivalent Metrics with Equal Spin
     Coefficients", to appear in Gen. Rel. Grav. (1981).

11.  A. Karlhede,  U. Lindstrom  and  J.E. Aman  "A Note  on  a Local 
     Effect at the Schwarzschild Sphere", to appear in Gen. Rel. Grav.
     (1981).

12.  S.W.   Hawking  and G.F.R.  Ellis:  "The large scale structure of
     space-time", Cambridge University Press (1973).

13.  C.W.  Misner,  K.P.  Thorne & J.A.  Wheeler:  "Gravitation", W.H.
     Freeman and Company, San Francico (1973).

14.  L.D.  Landau and E.M. Lifshitz: "The Classical Theory of Fields",
     fourth ed, Pergamon Press (1975).

15.  D.  Kramer,  H.  Stephani,  M.A.H. MacCallum and E. Herlt, "Exact
     Solutions  of  Einstein's Field Equations",  VEB Deutscher Verlag
     der Wissenschaften and Cambridge University Press (1980).

16.  R.A.  d'Inverno and R.A.  Russel-Clark,  J. Math. Phys. 12 (1971)
     1258.

17.  A.  Karlhede and M.A.H.  MacCallum,  "On Determining the Isometry
     Group  of  a  Riemannian Manifold" to appear in Gen.  Rel.  Grav.
     (1981).

18.  B.K. Harrison, Phys. Rev. 116 (1959) 1285.
19.  W. Kinnersley, J. Math. Phys. 10 (1969) 1195.


APPENDIX A.

     SOME EXAMPLES OF METRIC FILES.

APPENDIX A.1   Schwarzschild metric given in diagonal form.

The input is given in terms of the vector GD from MODULE DIANUL.  This
is  equivalent  to the diagonal components of ZUD in a Lorentz tetrad,
although  the calculations will here be performed in a null tetrad.  A
substitution  list  is  defined with NEWSUL and set up with USESUL for
automatic use when the Riemannian in FRAME (RIEF), the Ricci tensor in
CORD or SPCURV are calculated.



(PRELOAD DIAINP)

(TITLE "
SCHWAR.DIA
Schwarzschild metric in null tetrad
empty space")

(OFF ALL) (ON NOZERO)

(NAM T R M)
t $ r $ m $

(VARS T R H P)  % (t,r,theta,phi)

(RPL A)
1 -2*M/R $

(FUNS (M) A)

(NEWSUL RIESUL)
A $  :A $
(USESUL RIESUL RIEF SPCURV RICC)
(MOVSUL PSUL RIESUL)

(RPL GD)
A^(1/2) $  A^(-1/2) $  R $  R*SIN H $



APPENDIX A.2    Plane gravitational wave in complex coordinates.

Coordinates Z and ZST are defined to be mutually complex conjugate.
D is a complex-valued unknown function of the (real) variable U.
A dyad transformation into a standard dyad have been included.


(PRELOAD DYTRSP)

(TITLE "
WAVEZ.SPI
Plane wave in null tetrad
Vacuum
Petrov type N
Hawking-Ellis p178
Landau-Lifshitz paragraph 109, the problem")

(OFF ALL) (ON NOZERO COMPLX)

(NAM U V X Y Z D)
u $ v $ x $ y $ z $ d $
(PUT 'ZST 'NAM (LIST (LIST 'z UP '!* DOWN)))

(REAL U V H)
(DEFCONJL (Z ZST))
(COMPLEX D)

(VARS U V Z ZST)        % (u,v,z=x+iy,z!*=x-iy)

(RPL H)
RE(Z^2*CONJ(D)^2) $

(FUNS (D U) H)          % d(u)=(f(u)-ig(u))^(1/2),H(u,y,z)

(RPL IZUD)
   1 $   0 $         0 $         0 $
-H/2 $  -1 $         0 $         0 $
   0 $   0 $  2^(-1/2) $         0 $
   0 $   0 $         0 $  2^(-1/2) $

(RPL DYTR1)
CONJ D^(-1/2) $             0 $
            0 $  CONJ D^(1/2) $

(NULLT IFRAME)



APPENDIX A.3   Metric file for Kinnersley type II.A

     We  here first present the file KINNER.SHP which is in common for
all  the  Kinnersley  metrics.   Metrics  are  given  as contravariant
components of null vectors l,  n and m.  The null vector l has a fixed
choice for all Kinnersley D vacuum metrics.


%### KINNER.SHP

(PRELOAD NUDNUL DYTRSP)

% Common part of all Kinnersley vacuum Petrov type D solutions.

(OFF ALL) (ON NOZERO COMPLX)

(NAM U R X Y A B L M)
u $ r $ x $ y $ a $ b $ l $ m $

(VARS U R X Y)  % (u,r,x,y)

(RPL LU)
0 $  1 $  0 $  0 $

%### KINNER.SHP end




The file KIIA.NUD (Kinnersley II.A).
Complex quantities are used but the coordinates are real.
MIL symbolises m+il while MILST is m-il. They are defined
to be mutually complex conjugates. A number of differentials are
specified with the SPEC facility in FUNS.
A dyad transformation in a standard dyad is included.


(PRELOAD KINNER)

(TITLE "
KIIA.NUD
Petrov class D, Kinnersley Case II.A (Kerr-NUT)
W Kinnersley, J. Math. Phys. vol.10, p1195 (1969).")

(NAM MIL MILST Z)
m+il $ m-il $ z $

(REAL U R X Y M L A S F)
(DEFCONJL (MIL MILST))
(COMPLEX Z)

(RPL M Z S F)
(MIL +MILST) /2 $
R +I*L -I*A*COS X $
(R^2 -2*:M*R -L^2 +A^2)/2/Z/CONJ Z $
A^2*SIN X ^2/2/Z/CONJ Z $

(FUNS (A) (L) (MIL) (MILST) Z (Z SPEC X) S (S SPEC R X) F (F SPEC R X))
I*(2*F*Z*CONJ Z)^(1/2) $
-S*(1/Z +1/CONJ Z)*Z&R +(Z +CONJ Z -2*:M)/2/Z/CONJ Z $
-S*(1/Z -1/CONJ Z)*Z&X $
-F*(1/Z +1/CONJ Z)*Z&R $
-F*(1/Z -1/CONJ Z)*Z&X
 +2*(2*F*Z*CONJ Z)^(1/2)*((Z -CONJ Z)*I/2 +L)/2/Z/CONJ Z $

(NEWSUL LIESUL)
R $  (Z +CONJ Z)/2 $
(USESUL LIESUL ZDU LIE)

(NEWSUL 4 RIESUL)
S $  :S $
F $  (-Z*CONJ Z +R^2 +L^2 -2*L*((Z -CONJ Z)*I/2 +L) +A^2)/2/Z/CONJ Z $
R $  (Z +CONJ Z)/2 $
L $  (MIL -MILST)/2/I $
(USESUL RIESUL RIEF SPCURV)

(NEWSUL D2PSISUL)
MILST $  MIL -2*I*((Z -CONJ Z)*I/2 +L) -Z +CONJ Z $
(USESUL D2PSISUL D2PSI)

(RPL NU)
(R^2 +L^2 +A^2)/Z/CONJ Z $  -S $  0 $  A/Z/CONJ Z $

(RPL MU)
-I*(Z*CONJ Z -R^2 -L^2 -A^2)*(F*Z*CONJ Z)^(-1/2)/CONJ Z/2 $  0 $
  2^(-1/2)/CONJ Z $  I*A*(F*Z*CONJ Z)^(-1/2)/2/CONJ Z $

(RPL DYTR1)
0                  $  -(S*CONJ Z/Z)^(-1/4) $
(S*CONJ Z/Z)^(1/4) $   0                   $




APPENDIX B.  EXAMPLE OF A MODULE OF TENSOR PROGRAM.


     The  module  ELDYNF for electrodynamical calculations in FRAME is
given  here  as  an  illustration  how  the function TENDEF is used to
define  tensor formulas.  The documentation on the formulas used below
is a part of the actual source code for this module.


%### ELDYNF.SHP

(COMPILETIME (LOAD HLPMAC))

(PRELOAD HLPFNS)
(POSTLOAD FRAME)

% Program for calculations of electrodynamical quantities in curved
% space-time with the FRAME version of SHEEP.

(DSCALARS ELDYNF
 (GAUGEF "Gauge condition (must be zero)")
 (FSCLF "Invariant 2(H^2-E^2)")
 (FSCLSTF "Invariant -2 E.H") )

(DTENSORS ELDYNF
 (ADC "4-potential in coordinate components")
 (ADF "4-potential in frame components")
 (CGAMF "Contracted Ricci rotation coefficients")
 (FDDF "Electromagnetic field tensor")
 (HHU "Skew symmetric product of HUUs")
 (KJF "Frame components of 4-current")
 (KJC "Coordinate components of 4-current")
 (ETA4U "Contravariant components of antisymmetric unit tensor")
 (FSTF "Dual of electromagnetic field tensor")
 (KJSTF "-2*Divergence of FSTF")
 (APZUD "Anti-symmetric product of ZUDs")
 (FDDC "Coordinate components of electromagnetic field tensor")
 (KTF "Energy-momentum tensor times 8 pi")
 (KTMF "Mixed components of energy momentum tensor") )

%                                               4-potential in
% ADC     A                                     coordinate components.
%          i                                    User input.

%                       i
% ADF     A       = A Z                         Frame components of
%          A         i A                        4-potential.

%                    AC           A
% CGAMF   gam     = H  C     = gam
%            B          ACB        BA

%          A         AB      i
% GAUGEF  A       = H  (A   Z   +A gam )        Gauge condition.
%           ;A           A,i B    A   B         Must be zero.

%                         i        k   C
% FDDF    F       = A   Z   -A   Z   -A C    = 2A       Electromagnetic
%          AB        B,i A    A,k B      CAB     [A;B]  field tensor.

%           ABCD         AC BD   AD BC
% HHU     HH      = 1/2(H  H   -H  H  )
%

%                       BC        i                 BCDE               C
% KJF     Kj      = -2(H  (F    Z   +F  gam ) -1/2HH    F  C   ) = -2F
%           A               AB,i C    AB   C             BC ADE       A ;C

%                       A
% KJC     Kj      = Kj Z                        4-current times 8 pi.
%           i         A  i

%                     ABCD                      Invariant, known as
% FSCLF   F       = HH    F  F                     2   2
%                          AB CD                2(H  -E )

%         * AB          ABCD
% FSTF     F      = 1/2e    F                   Dual of electromagnetic
%                            CD                 field tensor.

%         *  A         * AC    i  * AC          AE* BC          * AC
% KJSTF    Kj     = -2( F    Z   + F  gam  -1/2H   F  C   ) = -2 F
%                          ,i C          C             EBC          ;C

%          *              * AB
% FSCLSTF F       = 1/2F   F                    Invariant known as -2 E.H
%                       AB

%          AB            A  B    B  A
% APZUD   Z       = 1/2(Z  Z   -Z  Z  )
%            ij           i  j    i  j

%                       AB
% FDDC    F       = F  Z
%          ij        AB   ij

%                      CD
% KTF     KT      = -2H  F  F   +1/2H  FSCLF    Energy-momentum tensor
%           AB            CA DB      AB         times 8 pi.

%           A        AC
% KTMF    KT      = H  KT                       D:o, mixed components.
%            B           CB

% (EINMAX)    A function testing if a metric fulfils the coupled
%             Einstein-Maxwell equations by checking if KJF KJSTF
%             (Maxwell's equation's) and EINEQSF (Einstein's equations)
%             are all zero (fulfilled).

% (EINMAXM)   The same but checks the mixed components EINEQSMF instead.

% This file was written by Jan E. Aman, Univ. of Stockholm

(NEWTENALIAS FRAME
 (AD . ADC) (CGAM . CGAMF) (GAUGE . GAUGEF) (FDD . FDDF)
 (FSCL . FSCLF) (FST . FSTF) (FSCLST . FSCLSTF) (KJST . KJSTF)
 (KT . KTF) (KTM . KTMF) )

(TENDEF ADC D A)
(DEFZEROMSG ADC "Zero electromagnetic potential")

(TENDEF ADF D A NIL NIL (ADC ZDU) NIL
 (SIMPE (SHCONTR K (SHTIMES (ZDU INDX1 K) (ADC K)))) )
(DEFZEROMSG ADF "Zero electromagnetic potential")

(TENDEF FDDF A F NIL NIL (ADF HUU ZDU LIE) NIL
 (SIMPE (SHCOLLECT
   (SHADDDIFFBAR (ADF INDX2) INDX1)
   (SHADDDIFFBAR (SHMINUS (ADF INDX1)) INDX2)
   (SHADDCONTR (K L)
    (SHTIMES (HUU K L) (SHMINUS (SHTIMES (ADF K) (LIE L INDX1 INDX2)))) ) )) )
(DEFZEROMSG FDDF "Zero electromagnetic field")

(TENDEF GAUGEF SCL ('A UP 'A DOWN DOWN '!;A UP)
 NIL NIL (ADF HUU ZDU CGAMF) NIL
 (SIMPE (SHCONTR (K L) (SHTIMES (HUU K L) (SHPLUS
     (SHDIFFBAR (ADF K) L)
     (SHTIMES (ADF K) (CGAMF L)) )))) )
(DEFZEROMSG GAUGEF "Fulfils gauge condition")

(TENDEF HHU R HH (1 2 3 4) NIL (HUU) NIL
 (SIMPE (SHRTIMES HALF!* (SHPLUS
    (SHTIMES (HUU INDX1 INDX3) (HUU INDX2 INDX4))
    (SHMINUS (SHTIMES (HUU INDX1 INDX4) (HUU INDX2 INDX3))) ))) )

(TENDEF KJF D (K (LC j)) NIL NIL (FDDF HUU HHU ZDU LIE CGAMF) NIL
 (SIMPE (SHRTIMES -2 (SHPLUS
    (SHCONTR (K L) (SHTIMES (HUU K L) (SHPLUS
      (SHDIFFBAR (FDDF INDX1 K) L)
      (SHTIMES (FDDF INDX1 K) (CGAMF L)) )))
    (SHRTIMES MIHALF!* (SHCONTR (NOSYM (ASYM I K) (ASYM L M))
      (SHTIMES (HHU I K L M) (SHTIMES (FDDF I K) (LIE INDX1 L M))) )) ))) )
(DEFZEROMSG KJF
 "No electromagnetic 4-current (fulfils first Maxwell equation)" )

(TENDEF KJC D (K (LC j)) NIL NIL (KJF ZUD) NIL
 (SIMPE (SHCONTR K (SHTIMES (KJF K) (ZUD K INDX1)))) )
(DEFZEROMSG KJ
 "No electromagnetic 4-current (fulfils first Maxwell equation)" )

(TENDEF FSCLF SCL F NIL NIL (FDDF HHU) NIL
 (SIMPE (SHCONTR (SYM (ASYM I K) (ASYM L M))
   (SHTIMES (HHU I K L M) (SHTIMES (FDDF I K) (FDDF L M))) )) )

(NEWSWITCHES (NEGETAUSIGN "ETA4U
(0,1,2,3)=-1"))

(TENDEF ETA4U (ASYM 4) (LC n) (1 2 3 4) NIL (FRAME HINV) NIL (COND
  ((GETEUCLIDEAN) (SHEXPT HINV HALF!*))
  ((GETONETIMEDIM)
   (SHMINIF NEGETAUSIGN (SHEXPT (SHMINUS HINV) HALF!*)))
  (T (PRIN2 "Assuming 3+1 space in definition of ETA4U")
   (SHMINIF NEGETAUSIGN (SHEXPT (SHMINUS HINV) HALF!*))) ))
(DEFFRAME ETA4U FRAME)

(TENDEF FSTF A (UP '!* DOWN 'F) (1 2) NIL (FDDF ETA4U) NIL
 (SIMPE (SHRTIMES HALF!*                % Earlier MIHALF!*
   (SHCONTR (ASYM K L) (SHTIMES (ETA4U INDX1 INDX2 K L) (FDDF K L))) )) )

(TENDEF KJSTF D (UP !* DOWN K (LC j)) (1) NIL (FSTF HUU LIE CGAMF ZDU) NIL
 (SIMPE (SHRTIMES -2 (SHCONTR K (SHPLUS
    (SHDIFFBAR (FSTF INDX1 K) K)
    (SHTIMES (FSTF INDX1 K) (CGAMF K))
    (SHRTIMES MIHALF!* (SHTIMES (HUU INDX1 K)
      (SHCONTR (ASYM L M) (SHTIMES (LIE K L M) (FSTF L M))) )) )))) )
(DEFZEROMSG KJSTF "Fulfils second Maxwell equation")

(TENDEF FSCLSTF SCL F!* NIL NIL (FDDF FSTF) NIL
 (SIMPE (SHRTIMES HALF!*
   (SHCONTR (ASYM K L) (SHTIMES (FDDF K L) (FSTF K L))) )) )

(TENDEF APZUD AA Z (1 2) NIL (ZUD) NIL
 (SIMPE (SHRTIMES HALF!* (SHPLUS
    (SHTIMES (ZUD INDX1 INDX3) (ZUD INDX2 INDX4))
    (SHMINUS (SHTIMES (ZUD INDX1 INDX4) (ZUD INDX2 INDX3)))))))

(TENDEF FDDC A F NIL NIL (FDDF APZUD) NIL
 (SIMPE (SHCONTR (ASYM K L) (SHTIMES (APZUD K L INDX1 INDX2) (FDDF K L)))) )

(TENDEF KTF S KT NIL NIL (FDDF FSCLF HUU HDD) NIL
 (SIMPE (SHPLUS
   (SHRTIMES -2 (SHCONTR (K L) (SHTIMES (HUU K L)
      (SHTIMES (FDDF K INDX1) (FDDF L INDX2)) )))
   (SHRTIMES HALF!* (SHTIMES (HDD INDX1 INDX2) FSCLF)) )) )

(TENDEF KTMF DD KT (1) NIL (KTF HUU) NIL
 (SIMPE (SHRAISEH INDX1 (KTF INDX1 INDX2))))

% Coupled Einstein-Maxwell equations. Zero for electrovacuum.
(DE EINMAX NIL (PROGN (SWMAPCAN '(KJF KJSTF EINEQSF) T (FUNCTION XMAKE)) (COND
   ((ALLZEROP KJF KJSTF EINEQSF) (TERPRI)
    (PRIN2L
     "Electrovac solution (fulfils coupled Einstein-Maxwell equations)")
    (TERPRI) (TERPRI) NIL)
   (T (PRIN2L "Not electrovac") (TERPRI) NIL) )))

% Coupled Einstein-Maxwell equations, mixed components. Zero for electrovacuum.
(DE EINMAXM NIL (PROGN (SWMAPCAN '(KJF KJSTF EINEQSMF) T (FUNCTION XMAKE))
  (COND
   ((ALLZEROP KJF KJSTF EINEQSMF) (TERPRI)
    (PRIN2L
     "Electrovac solution (fulfils coupled Einstein-Maxwell equations)")
    (TERPRI) (TERPRI) NIL)
   (T (PRIN2L "Not electrovac") (TERPRI) NIL))))

%### ELDYNF.SHP end
