


















          XXXXXX   XX   XX   XXXXXXX   XXXXXXX   XXXXXX
         XX        XX   XX   XX        XX        XX   XX
         XX        XX   XX   XX        XX        XX   XX
          XXXXX    XXXXXXX   XXXXX     XXXXX     XXXXXX
              XX   XX   XX   XX        XX        XX
              XX   XX   XX   XX        XX        XX
         XXXXXX    XX   XX   XXXXXXX   XXXXXXX   XX



                             MANUAL


                        Author: I. Frick

                Institute of Theoretical Physics
                     University of Stockholm
                           Vanadisv. 9
                       S-113 46  Stockholm
                             Sweden




                        TABLE OF CONTENTS


1.  INTRODUCTION
        1.1  HOW TO READ THIS MANUAL                      1-1
        1.2  CHARACTER CONVENTIONS                        1-2
        1.3  TALKING TO THE COMPUTER
        1.4  LISP                                         1-3

2.  EXAMPLES ON HOW TO USE SHEEP
        2.1  HOW TO COMPUTE THE RICCI TENSOR
             FROM A GIVEN METRIC.                         2-1
        2.2  A SUBSTITUTION                               2-5
        2.3  A TETRAD CALCULATION                         2-6
        2.3.1    Stating The Problem
        2.3.2    An Input File                            2-7
        2.3.3    Dialogue                                 2-8
        2.4  A PERTURBATION CALCULATION                   2-11
        2.4.1    Stating The Problem
        2.4.2    An Input File                            2-12
        2.4.3    Dialogue                                 2-13

3.  SWITCHES AND CONSTANTS
        3.1  CONTROL OF SWITCHES                          3-1
        3.2  IMPLEMENTATION OF SWITCHES
        3.3  CONSTANTS                                    3-2

4.  INTERNAL REPRESENTATION AND RELATED FUNCTIONS
        4.1  SYNTAX FOR INTERNAL REPRESENTATION           4-1
        4.2  EXAMPLES OF THE INTERNAL REPRESENTATION      4-2
        4.3  FUNCTIONS THAT GENERATE SHEEP EXPRESSIONS    4-3

5.  SIMPLIFICATION
        5.1  SIMP                                         5-1
        5.2  THE SIMPLIFICATION FUNCTIONS                 5-2

6.  SUBSTITUTIONS
        6.1  WHAT CAN BE SUBSTITUTED                      6-1
        6.2  MANIPULATING PAIRS ON THE SUBSTITUTION LISTS 6-2
        6.2.1    Arguments That Specify Substitution Pairs
        6.2.2    PRSUB And REMSUB                         6-3
        6.2.3    SETSUB
        6.2.4    Extra Arguments Of SETSUB

7.  DIFFERENTIATION AND FUNCTIONS
        7.1  FUNCTION AND VARIABLE DECLARATIONS           7-2
        7.1.1    FUNS
        7.1.2    REMFUNS                                  7-3
        7.1.3    VARS
        7.1.4    VARMAX                                   7-4
        7.2  FUNCTIONS FOR DIFFERENTIATION                7-5
        7.3  DEFINING NEW SHEEP OPERATORS                 7-6

8.  FORMULA INPUT (FOIN)
        8.1  FOIN                                         8-1
        8.1.1    Informal Syntax Description
        8.1.2    Meaning Of Some Operators                8-2




        8.1.3    Different Modes Of FOIN                  8-3
        8.1.4    Syntax Error Handling

9.  FORMULA OUTPUT
        9.1  PRT                                          9-1
        9.2  FPRT                                         9-2

10.  TENSOR IMPLEMENTATION AND NEW TENSORS
        10.1  IMPLEMENTATION OF TENSORS                   10-1
        10.2  THE PROPERTY LIST OF TENSORS
        10.3  DEFINING NEW TENSORS                        10-2

11.  TENVAL FUNCTIONS
        11.1  ARGUMENTS OF TENVAL FUNCTIONS               11-1
        11.2  THE INDIVIDUAL TENVAL FUNCTIONS             11-2
        11.3  MESSAGES WHEN RUNNING TENVAL FUNCTIONS      11-6
        11.4  CONTINUING A HALTED TENVAL FUNCTION         11-7
        11.5  STEPWISE EXECUTION OF TENVAL FUNCTIONS      11-8
        11.6  SOME RELATED FUNCTIONS
        11.7  SOME IDENTIFIER VALUES                      11-9

12.  FILE MANIPULATION
        12.1  READING OR PRINTING DISK FILES              12-1
        12.1.1    Saving Expressions In Disk Files
        12.1.2    REDUCE Interface
        12.1.3    Reading Commands From Disk files        12-2
        12.1.4    Writing On The Line Printer
        12.2  OUTF AND INF

13.  TRUNCATED POWER SERIES
        (To be written)

14.  THE CORD PACKAGE
        14.1  THE CORD TENSORS                            14-1
        14.2  ALTERNATIVE ALGORITHM                       14-2
        14.3  CONTROL OF GDET

15.  THE FRAME PACKAGE
        15.1  THE FRAME TENSORS                           15-1
        15.2  ALTERNATIVE ALGORITHM                       15-2
        15.3  CONTROL OF ZDET                             15-3
        15.4  STANDARD FRAME METRICS


                           APPENDICES

A.  THE FUNCTIONS AND COMMANDS IN SHEEP                   A-1

B.  THE SWITCHES IN SHEEP                                 B-1

C.  SOME VALUES
        (To be written)

D.  DIAGNOSTIC AND ERROR MESSAGES
        D.1  ORDINARY ERROR MESSAGES                      D-1
        D.2  CALLS FOR DECLARATION                        D-4
        D.3  DIAGNOSTIC MESSAGES




E.  FOIN CHARACTER INTERPRETATION                         E-1

F.  LISP DEFINITIONS OF SOME FUNCTIONS
        F.1  SOME HELP ROUTINES                           F-1
        F.2  THE SIMPLIFIER                               F-4
        F.3  PRT, FPRT VALU AND PRT FUNCTIONS             F-6
        f.3.1    PRT And FPRT
        F.3.2    VALU                                     F-8
        F.4  DIFF AND EFUN, DFUN FUNCTIONS                F-12
        F.5  CORD TENSORS                                 F-14
        F.5.1    Symmetry Functions                       F-15
        F.5.2    Tensor Definitions
        F.5.3    The Weyl Tensor                          F-20

G.  INSTALLING SHEEP                                      G-1

H.  GETTING MORE STORAGE                                  H-1

    INDEX













                           CHAPTER 1

                          INTRODUCTION



SHEEP is a computer algebra system  designed  primarily  for  the
needs  of  General  Relativity,  but it can also be used in other
fields.

   SHEEP can:

     1.  Read, write, simplify, substitute into and differentiate
         algebraic expressions.

     2.  Define tensors and tensor algorithms.

     3.  Manipulate tensor components.

     4.  Calculate the Einstein tensor from a given metric  in  a
         tetrad or in a coordinate frame.

     5.  Perform perturbation calculations.




1.1  HOW TO READ THIS MANUAL

This manual is a preliminary version  and  several  chapters  are
still   missing.    It   can   be   used  at  several  levels  of
understanding.

   To calculate one of the built  in  tensors,  like  the  Ricci,
Riemann  or Einstein tensor it is enough in the beginning to look
at the examples in chapter 2, with some help from the definitions
in  chapters 14 and 15.  The section "TALKING TO THE COMPUTER" in
this chapter will also prove useful.

   To process more complicated metrics, it will be  necessary  to
know  how substitutions are made, as is discussed in 5.1 and 6.1.
Chapter 11 gives more information about how to manipulate  tensor
components  and  values.  Chapter 12 discusses commands that save
expressions on disk and then recalls them.

   To do a calculation that is not built into SHEEP, new  tensors
can  be  defined.   This  is  discussed in chapters 10 and 4.  To
combine these new tensors with series expansions, a knowledge  of

INTRODUCTION                                             Page 1-2


chapter 13 is necessary.



1.2  CHARACTER CONVENTIONS

Some characters that are used by SHEEP, do not print in  a  usual
way  and  some characters are sometimes used as peculiar national
characters.  For these characters the following  conventions  are
used:
In this manual ASCII code     meaning
-- ---- ------ ----- ----     -------
^C               3            Control-C
^G               7            Control-G or bell
^O              17            Control-O
^U              25            Control-U
<cr>            15            Return or carriage return
<alt>           33            Altmode or escape or control-[
<sp>            40            Space
#               43            Number sign
$               44            Dollar
@              100            Commercial at sign
<del>          177            Delete or rubout



1.3  TALKING TO THE COMPUTER

The following characters are useful when talking to the computer:

Character      meaning
---------      -------

^C             Leave SHEEP and go to  the  monitor.   To  stop  a
               running calculation two ^C after another are used.
               To get back into SHEEP the  monitor  commands  REE
               and  CONT can be used.  With CONT you get get back
               into SHEEP, at the point where you left.  With REE
               you get the message:
                                     Debug?
               If you answer with anything else than Y, then  you
               get  back to the top level of SHEEP, if you answer
               Y, then you also get back to the  top  level,  but
               all  variable  values  are what they were when you
               left SHEEP.  They can then be restored to toplevel
               values by typing ^G (see below).

^G             Takes you back to the toplevel of SHEEP  if  typed
               when SHEEP expects input.

^O             Suppress printout to the TTY.

^U             Delete  current  input  line,   i.e.   all   typed
               characters back to last <cr> or <alt>.

INTRODUCTION                                             Page 1-3


<del>          Delete last typed character if it wasn't  <cr>  or
               <alt>.



1.4  LISP

SHEEP consists of several LISP functions  that  are  loaded  into
LISP  and  the  top  level  of  SHEEP  is  the top level of LISP.
Because of this a few LISP terms will be explained here.

   An identifier is a string of characters that are  loaded  into
the  memory in a special way, together with a list of properties,
the property list of the identifier.  Identifiers can have values
associated.
                           (SETQ A B)
Sets identifier A to the value of B.  I.e. the value of B becomes
the  value  of  A.   To set A to B (and not to the value of B), B
must be quoted.  This is easiest done by using the character  "'"
that  has  a special meaning to the LISP function READ that reads
the input to LISP.  It has to effect that the value  of  'var  is
var, so that
                           (SETQ A 'B)
sets A to B.

   A FEXPR is a function with an indefinite number of  arguments.
It  operates  on its arguments directly, without evaluating them.
Almost all user oriented commands in SHEEP are FEXPRs.  They  are
primarily  meant  to  be  used  at  the top level and not so much
inside functions.

   An EXPR is a function with a specific number of arguments,  it
operates  on  the  values of these arguments.  All functions that
are used inside SHEEP, are EXPRs.













                           CHAPTER 2

                  EXAMPLES ON HOW TO USE SHEEP



In the following examples  "<cr>"  stands  for  carriage  return,
"<sp>" stands for space and "<alt>" stands for altmode (or escape
or control-[ on some terminals).  In the left  hand  column  user
input  is underlined, the rest in that column is computer output.
The right hand column only contains comments.



2.1  HOW TO COMPUTE THE RICCI TENSOR FROM A GIVEN METRIC.

We want to compute the Ricci tensor for the metric:

  2      2   -1  2   2       2     2           2
dS  = AdT  -A  dR  -R (dTHETA  +SIN (THETA)dPHI )

where A is a function of T and R.

First log in to the computer.  Then do the following:

Input/Output                  Comment



.RUN CORD<cr>                 Start the  version  of  SHEEP  that
 ------------
                              computes  tensor  components  in  a
                              coordinate frame.

SHEEP-77-01-26                Latest update of SHEEP

*(ON NOZERO DIAGONAL)<cr>     Turn on  the  switches  NOZERO  and
 ------------------------
                              DIAGONAL.
                              NOZERO  means  that  only  non-zero
                              components are printed by the write
                              command.
                              DIAGONAL tells the system that  off
                              diagonal  components  of the metric
                              are zero,  so  that  only  diagonal
                              components have to be inserted.

EXAMPLES ON HOW TO USE SHEEP                             Page 2-2


NIL                           A list of the arguments to ON  that
                              were  on  previously.  DIAGONAL and
                              NOZERO where both off so  the  list
                              is empty i.e. NIL.

*(MAKE RIC)<cr>               Make the components  of  the  Ricci
 --------------
                              tensor.

G
 00                           The   system   can't    find    the
                              components  of  the  metric,  so it
                              asks for them.

=A$<cr>                       "=" prompter means that input  goes
 ------
                              to the formula input function FOIN,
                              that reads formulas in mathematical
                              (infix)  notation.   "$"  indicates
                              end of the  input  to  FOIN.   This
                              input means that G00 is set to A.

G
 11                           Ask for G11.  As  DIAGONAL  is  on,
                              the system doesn't ask for G01, G02
                              or G03,  it  knows  that  they  are
                              zero.   The  system  never asks for
                              G10 as that component is  found  by
                              symmetry.

=-1/A;<cr>                    ";" is another way to end input  to
 ---------
                              FOIN, it tells the system to:

  -1
-A                            Write out the input and

?$<cr>                        ask  for  confirmation.   The   "?"
 -----
                              prompter       indicates       that
                              confirmation or the correct formula
                              is expected.
                              By writing only the  end  character
                              "$",   the   previous   formula  is
                              confirmed.

G
 22                           Asks for G22

=-R^2<alt>                    "<alt>"  has  the  same  effect  as
 ---------
                              "$<cr>".

G
 33

EXAMPLES ON HOW TO USE SHEEP                             Page 2-3


=-R^2*SIN(S)^A;<cr>           S is  used  as  third  variable  as
 ------------------
                              there  is  no theta on the printer.
                              End with ";" to see if the input is
                              correct.

  2   A
-R SIN S                      It was not correct.   There  is  an
                              exponent A instead of 2.

?-R^2*SIN(S)^2;<cr>           Input the corrected formula with  a
 ------------------
                              ";"  at end to see if it is correct
                              this time.

  2   2
-R SIN S                      O.k.

?<alt>                        Confirm.
 -----

GDF                           The system starts to make GDF  i.e.
                              the derivatives of the metric.

A DECLARE FUNCTION            The  system  didn't  know  how   to
                              differentiate A.

NOW*(FUNS (A T R))<cr>        Declare A as a function of T and R.
    ------------------

T DECLARE VARIABLE            T was not known as variable to  the
                              system

NOW*(VARS T R S)<cr>          Declare T R and S as variables 0, 1
    ----------------
                              and 2.

 ENDED                        The system has finished making GDF.

GAM  ENDED                    Makes Christoffel  symbol  of  1:st
                              type.

GDET  ENDED                   Makes determinant of the metric.

GINV  ENDED                   Makes 1/GDET.

GDET LOST                     Delete GDET as it isn't needed  any
                              more.  This saves space.  (There is
                              a KEEP command that can be used  to
                              inhibit  the  automatic deletion of
                              some tensors.)

GUU  ENDED                    The contravariant metric.

GINV LOST

EXAMPLES ON HOW TO USE SHEEP                             Page 2-4


GDF LOST

GAMU  ENDED                   Christoffel symbol of 2:nd type

RIE  ENDED                    Covariant Riemann tensor.

GAMU LOST

GAM LOST

RIC  ENDED                    Covariant Ricci tensor.

NIL                           Finished

*(WRITE RIC)<cr>              Write the Ricci tensor
 ---------------

               -1       -2   2      -1
R  =1/2AA    +R  AA   -A  A    +1/2A  A
 00      ,RR       ,R      ,T          ,TT

       -1 -1
R  = -R  A  A
 01          ,T

       -1 -1      -4   2      -3          -1
R  = -R  A  A   +A  A    -1/2A  A    -1/2A  A
 11          ,R      ,T          ,TT         ,RR

R  =1 -A -RA
 22         ,R

       2         2            2
R  =SIN (S) -RSIN (S)A   -ASIN (S)
 33                   ,R

NIL                           Finished WRITE command.

*(WMAKE RSCL)<cr>             Make  and   write   the   curvature
 ----------------
                              scalar.

RIE LOST

RICM  ENDED                   Mixed Ricci tensor

      -2          -2     -1       -3   2   -2
R= -2R   +A    +2R  A +4R  A   -2A  A    +A  A
           ,RR              ,R       ,T       ,TT

NIL                           Finished WMAKE command.

*(SAVE SWRIC RIC RSCL)<cr>    Save  RIC  and  RSCL  in  the  file
 -------------------------
                              SWRIC.LAM for later use.

EXAMPLES ON HOW TO USE SHEEP                             Page 2-5


(SWRIC NIL)                   Saved



2.2  A SUBSTITUTION

If A is set to 1-2M/R, then  the  previous  example  becomes  the
Schwarschild  metric.   Let  us do this substitution in the Ricci
tensor and see if it becomes zero.

Input/Output                  Comments



*(SETSUB ESUL (DIFF 2))<cr>   Define  ESUBS  substitutions,  i.e.
 --------------------------
                              substitutions   that   change   the
                              expressions in memory, as  distinct
                              from substitutions that only affect
                              the   output.    (DIFF 2)   defines
                              substitutions  of derivatives up to
                              order 2.

1  FOR  =A<alt>               1 means that this will be the first
         ------
                              substitution   pair   on  the  ESUL
                              substitution list.  For A  and  its
                              derivatives

  SUBSTITUTE  =1-2M/R<alt>    substitute    1-2M/R    and     its
               -----------
                              derivatives.

M DECLARE FUNCTION            We had forgotten to declare M as  a
                              function.

NOW*(FUNS (M))<cr>            Declare  M  as  a  function  of  no
    --------------
                              variables i.e. a constant.

6                             The  ESUL  substitution  list   now
                              contains 6 substitution pairs.

*(PRSUB ALL)<cr>              Print all pairs on the substitution
 ---------------
                              list.

ESUL                          The ESUL substitution list.

1  FOR  A     SUBSTITUTE  0
         ,TT

2  FOR  A     SUBSTITUTE  0
         ,RT


EXAMPLES ON HOW TO USE SHEEP                             Page 2-6


                              -3
3  FOR  A     SUBSTITUTE   -4R  M
         ,RR

4  FOR  A    SUBSTITUTE  0
         ,T

                           -2
5  FOR  A    SUBSTITUTE  2R  M
         ,R

                            -1
6  FOR  A  SUBSTITUTE  1 -2R  M

NIL

*(ON ESUBS)<cr>               Turn on the ESUBS  switch  so  that
 --------------
                              ESUBS  substitutions  will  be made
                              every time that the  simplification
                              function SIMP is called.

NIL                           ESUBS was off previously.

*(LSIMP RIC)<cr>              Call SIMP  (i.e.  in  our  case  do
 ---------------
                              substitutions)  for  each component
                              of RIC.

RIC  ENDED

NIL

*(WRITE)<cr>                  Write RIC.
 -----------

RIC ALL FOUND ZERO            All specified  components  (in  our
                              case  all  RIC)  were zero.  As the
                              switch NOZERO is on,  no  component
                              is  written  but  a message that no
                              non-zero  component  was  found  is
                              given.



2.3  A TETRAD CALCULATION

2.3.1  Stating The Problem

The Bondi metric is:

  2      -1 2B   2 2 2G   2    2B         2 2G
dS  = (VR  E   -U R E  )dT  +2E  dTdR +2UR E  dTdH -

  2  2G  2   -2G   2     2
-R (E  dH  +E   SIN (H)dF )

EXAMPLES ON HOW TO USE SHEEP                             Page 2-7


where U, V, B and G are arbitrary functions of T, R and H (we use
T,  R,  H,  F,  B  and  G, instead of u, r, theta, phi, betha and
gamma).
We use a tetrad with two null vectors and  two  orthogonal  space
like vectors so that

  2    AB                2    2
dS  = H  W W  = 2W W  -W   -W
          A B     0 1   2    3

A set of covariant vectors fulfilling this condition is:

      B
W  = E dT
 0

      B      -1
W  = E (1/2VR  dT +dR)
 1

       G
W  = RE (-UdT +dH)
 2

       -G
W  = RE  SIN(H)dF
 3

The problem is to calculate the tetrad components of the  Riemann
tensor for this metric.



2.3.2  An Input File

As the metric is a bit complicated, first prepare a file with the
commands  that  define  the  metric  and then load that file into
SHEEP.  Of course it is possible to input the  commands  directly
into SHEEP instead of using a file, but a file makes it easier to
start again if something goes wrong.
Use a text editor e.g. SOS, to make the file BONDI.HNL


File content                  Comment


(TITLE "BONDI METRIC IN HALF NULL TETRAD")        The       title
                              defined by this command, is printed
                              on the TTY when the file is  loaded
                              and on the line printer output from
                              the LPTWRITE command.

(VARS T R H F)                Define the variables.

EXAMPLES ON HOW TO USE SHEEP                             Page 2-8


(FUNS (B T R H) (G T R H) (U T R H) (V T R H))    Declare B, G, U
                              and V as functions of T, R and H.

(ON NOZERO)                   Turn on the NOZERO switch, so  that
                              only   non   zero   components  are
                              printed by the WRITE command.

(RPL ZDD)                     Define the covariant components  of
                              the tetrad vectors, defined by
E^B$
0$                                      i
0$                            W  = Z  dX
0$                             A    Ai
1/2V/R*E^B$
E^B$
0$
0$
-U*R*E^G$
0$
R*E^G$
0$
0$
0$
0$
R/E^G*SIN H$

(HNULL)                       Define HDD and HUU to be the metric
                              for  a tetrad with two null vectors
                              and   two   orthogonal   space-like
                              vectors as tetrad vectors.  This is
                              the last command on the file.



2.3.3  Dialogue



With the file completed, we now start the dialogue with SHEEP

Input/Output                  Comment


.RUN FRAME<cr>                Start the  version  of  SHEEP  that
 -------------
                              computes  tensor  components  in  a
                              moving (tetrad) frame.

SHEEP-77-01-26                Latest update of SHEEP

*(DSKIN (BONDI.HNL))<cr>      Call in the file BONDI.HNL from the
 -----------------------
                              disk  memory.   This  will generate
                              the following output.

EXAMPLES ON HOW TO USE SHEEP                             Page 2-9


BONDI METRIC IN HALF NULL TETRAD        The title

NIL                           The value of the title  command  is
                              the  previous  title.  As there was
                              no previous  title,  the  value  is
                              NIL.

(T R H F)                     The value of the  VARS  command  is
                              the list of variables.

(V U G B)                     The value of the  FUNS  command  is
                              the list of declared functions.

NIL                           NOZERO was not on previously.

ZDD  ENDED                    ZDD is inserted.

NIL                           Value of the RPL command.

NIL                           Value of the HNULL command.

FINISHED-LOADING              Value of the DSKIN  command.   This
                              ends  the loading of the file.  Now
                              start the computations.

*(WMAKE GDD)<cr>              Make and print the metric tensor to
 ---------------
                              control  that  the  choice of frame
                              vectors is correct.

        -1 2B   2 2G 2
G   = VR  E   -R E  U
 00

       2B
G   = E
 01

       2 2G
G   = R E  U
 02

         2 2G
G   =  -R E
 22

         2 -2G   2
G   =  -R E   SIN (H)
 33

*(MAKE RIC)<cr>               Make the Ricci tensor.
 --------------

EXAMPLES ON HOW TO USE SHEEP                            Page 2-10


ASD  ENDED                    ASD (antisymmetric  differentiation
                              of ZDD) is made.

ZUD  ENDED                    The first index of ZDD  is  raised,
                              to form ZUD.

ZDET  ENDED                   The determinant of ZUD.

ZINV  ENDED                   1/ZDET.

ZDET LOST                     ZDET is deleted as it is not needed
                              any more.

ZDU  ENDED                    The contravariant components of the
                              tetrad  vectors.   The  inverse  of
                              ZUD.

ZINV LOST

ZUD LOST

APZ  ENDED                    Antisymmetric tensor product of two
                              ZDU.

LIE  ENDED                    The structure coefficients for  the
                              outer derivative.

ASD LOST

APZ LOST

GAM  ENDED                    The Ricci rotation coefficients.

RIE                           The  calculation  of  the   Riemann
                              tensor has started, but

NO FREE STG LEFT              there wasn't enough storage.

(RIE 1 2 1 2)                 The  components  before  this  were
                              made, but this component was

NOT MADE                      not made.

*(MCORE 10)<cr>               Get and allocate 10 K more memory.
 --------------

*(CONTINUE)<cr>               Continue the calculation, starting
 --------------

RIE  ENDED                    with the 1 2 1 2 component of  RIE,
                              and finish RIE.

NIL                           The calculation is  finished.   NIL
                              is the value of the MAKE command.

EXAMPLES ON HOW TO USE SHEEP                            Page 2-11


*(WRITE RIE 0 1 0 1)<cr>      Write the first component of RIE.
 -----------------------

            -3 -2B    -2 -2B       -1 -2B        -2B
R     =  -VR  E    +VR  E   B   -VR  E   B    +2E   UB    +
 0101                        ,R           ,RR         ,HR

  -2B          -2B       -2 -2G   2   -2 -2B         -1 -2B
+E   U  B   +2E   B    -R  E   B    +R  E   V   -1/2R  E   V    -
      ,R ,H        ,RT          ,H           ,R             ,RR

  -1 -2B            2 2G-4B   2
-R  E   V  B   +3/4R E     U
         ,R ,R              ,R

NIL                           Value of WRITE command.

*(LPTWRITE ZDD RIE GAM)<cr>   Write ZDD, RIE and GAM out  onto  a
 --------------------------
                              file  that  is  sent  to  the  line
                              printer when logging out  from  the
                              computer.

ZDD  ENDED

RIE  ENDED

GAM  ENDED

((LAM03 .  LPT:) NIL)         Value    of    LPTWRITE    command.
                              LAM03.LPT   is   the  name  of  the
                              generated file.

^C                            Leave SHEEP.
--



2.4  A PERTURBATION CALCULATION

2.4.1  Stating The Problem

The Levy metric is:

  2    2U  2   2K-2U   2    2    2 -2U  2         2       2
dS  = E  dT  -E     (dR  +dZ ) -R E   dF  +X(H00dT  +H11dR  +

     2       2                                     2
H22dZ  +H33dF  +2H01dTdR +2H02dTdZ +2H12dRdZ) + O(X )

where X is a small parameter and U, K, H00, H01, H02,  H11,  H12,
H22  and H33 are functions of T, R and Z.  The dependence on T is
small, i.e. derivatives with respect to T are multiplied with X.
The problem is to compute the Ricci tensor to the first order  in
X for this metric.

EXAMPLES ON HOW TO USE SHEEP                            Page 2-12


2.4.2  An Input File

As the metric is complicated and as the contravariant metric  has
to  be  computed  by hand, first prepare a file with the commands
that define the co- and contravariant metrics and then load  that
file into SHEEP.
Make the file LEVY


File content                  Comment


(TITLE "LEVY METRIC")         Title

(VARS T R Z)                  Variables

(FUNS (U T R Z) (K T R Z) (H00 T R Z) (H01 T R Z) (H02 T R Z)
(H11 T R Z) (H12 T R Z) (H22 T R Z) (H33 T R Z))  Functions

(TPSINIT TENSORS)             Initiate all tensors  as  truncated
                              power series with no terms of lower
                              order than zero.

(PUT '& 'DSHIF '(-1 NIL NIL NIL))       The  -1  in   the   first
                              position of the list
                                       (-1 NIL NIL NIL)
                              means that the order of a  term  is
                              raised   one   step   when   it  is
                              differentiated with respect to  the
                              zeroth  variable  i.e. with respect
                              to  T.   The  NIL  in   the   other
                              positions  of  the list, means that
                              differentiating with respect to the
                              other  variables doesn't affect the
                              order of a term.

(RPL (0) GDD)                 Insert the zero order terms of  the
                              covariant metric.
EXP(2U)$
0$
0$
0$
-EXP(2K-2U)$
0$
0$
-EXP(2K-2U)$
0$
-R^2*EXP(-2U)$

(RPL (0) GUU)                 Insert  zero  order  terms  of  the
                              contravariant metric.
EXP(-2U)$
0$
0$
0$
-EXP(2U-2K)$
0$

EXAMPLES ON HOW TO USE SHEEP                            Page 2-13


0$
-EXP(2U-2K)$
0$
-R^(-2)EXP(2U)$

(RPL (1) GDD)                 Insert first order terms.
H00$
H01$
H02$
0$
H11$
H12$
0$
H22$
0$
H33$

(RPL (1) GUU)                 Insert first  order  terms  of  the
                              contravariant metric.
-H00*EXP(-4U)$
H01*EXP(-2K)$
H02*EXP(-2K)$
0$
-H11*EXP(4U-4K)$
-H12*EXP(4U-4K)$
0$
-H22*EXP(4U-4K)$
0$
-R^(-4)H33*EXP(4U)$           End of the file.



2.4.3  Dialogue



With the file completed, we now start the dialogue with SHEEP

Input/Output                  Comment



.RUN CORD 40<cr>              Start the  CORD  version  of  SHEEP
 ---------------
                              with  40  K  memory as this will be
                              needed in the calculation.

SHEEP-77-01-26                Latest update of SHEEP

*(DSKIN LEVY)<cr>             Call in the file LEVY from the disk
 ----------------
                              memory.   This  will  generate  the
                              following output.

EXAMPLES ON HOW TO USE SHEEP                            Page 2-14


LEVY METRIC                   The title

NIL

(T R Z 3)                     The variables.  We didn't give  the
                              third variable a name.

(H33 H22 H12 H11 H02 H01 H00 K U)       The declared functions.

GDD  ENDED                    The TPSINIT  command  has  started.
                              GDD first.
GDF  ENDED
GAM  ENDED
GDET  ENDED
GINV  ENDED
GUU  ENDED
GAMU  ENDED
RIE  ENDED
RIC  ENDED
RICM  ENDED
RSCL  ENDED
EIN  ENDED
EINM  ENDED
NIL                           End of TPSINIT.

&                             The DSHIF property  of  &  has  now
                              been defined.

GDD  ENDED                    Zeroth order of GDD

NIL

GUU  ENDED                    Zeroth order of GUU.

NIL

GDD  ENDED                    First order of GDD.

NIL

GUU  ENDED

NIL

FINISHED-LOADING              Finished.     Now     start     the
                              computations.

*(WRITE GDD TO 1 1)<cr>       Write some components of GDD.
 ----------------------

       2U           2
G   = E   +H00X +O(X )
 00

EXAMPLES ON HOW TO USE SHEEP                            Page 2-15


               2
G   = H01X +O(X )
 01

               2
G   = H02X +O(X )
 02

         2
G   = O(X )
 03

         -2U+2K           2
G   =  -E       +H11X +O(X )
 11

NIL                           End of WRITE command.

*(MAKE (0) RIC)<cr>           Tell  system  to  make  the  zeroth
 ------------------
                              order  terms  in  the components of
                              the Ricci tensor.
GDF  ENDED
GAM  ENDED
GAMU  ENDED
RIE  ENDED
RIC  ENDED
NIL                           End of MAKE command.

*(MAKE (1) RIC)<cr>           Make first order terms.
 ------------------
GDF  ENDED
GAM  ENDED
GAMU  ENDED
RIE  ENDED
RIC  ENDED
NIL                           End of MAKE command.

*(WRITE (1) RIC 0 1)<cr>      Write the first order terms in  the
 -----------------------
                              0 1 component of the Ricci tensor.


EXAMPLES ON HOW TO USE SHEEP                            Page 2-16


                        2U-2K      2   2U-2K
R  (1) = 2U    -K    -2E     H01U    +E     H01U    +
 01        ,RT   ,RT             ,Z             ,RR

   2U-2K             2U-2K             2U-2K
+2E     H01U  K   +2E     H02U  U   -2E     H02U  K   +
            ,Z ,Z             ,R ,Z             ,R ,Z

  2U-2K          2U-2K           2U-2K              2U-2K
+E     H02U    +E     U  H02   -E     U  H02   +1/2E     H01    -
           ,ZR         ,R   ,Z         ,Z   ,R              ,ZZ

  2U-2K           2U-2K              2U-2K
-E     H01  K   +E     H02  K   -1/2E     H02    +
          ,Z ,Z           ,R ,Z              ,ZR

  -1 2U-2K         -1
+R  E     H01U   +R  K   -2U  U
              ,R      ,T    ,T ,R


NIL                           End of WRITE command.

*(LPTWRITE (0) RIC (1) RIC)<cr>         Write first the zero  and
 ------------------------------
                              then  the  first order terms of RIC
                              out on a file that is sent  to  the
                              line printer at log out time.

RIC  ENDED                    Zeroth order of RIC.

RIC  ENDED                    First order.

((LAM03 .  LPT:) NIL)         Value    of    LPTWRITE    command.
                              LAM03.LPT   is   the  name  of  the
                              generated file.

^C                            Leave SHEEP.
--













                           CHAPTER 3

                     SWITCHES AND CONSTANTS



3.1  CONTROL OF SWITCHES

The identifier SWITCHES has as value a list of all  the  switches
in  the  system.  The switches are controled by the functions ON,
OFF  and  SWISTAT.   All  three  functions  are  FEXPRs  with  an
indefinite  number  of  switches  as  arguments.  ON turns on its
arguments, OFF turns off its arguments and SWISTAT  does  nothing
with  its  arguments.   They  return  as value a list of those of
their arguments that were  on  previous  to  the  action  of  the
function.  E.g.
                   (ON DIAGONAL NOZERO PSUBS)
turns on DIAGONAL, NOZERO and PSUBS.  The  value  is  a  list  of
those of them that were on previously.
The argument ALL is the same as all switches, i.e.
                          (SWISTAT ALL)
returns a list of the switches that are on, and
                            (OFF ALL)
turns off all switches and returns a list of  the  switches  that
were on.
If an argument "x" isn't a switch (or ALL) then the error
                        "x" NOT A SWITCH
occurs.  As the arguments are processed  from  the  left  to  the
right, the switches preceding "x" as arguments have been changed,
but the ones that come after, have not.

Initially all switches are off.



3.2  IMPLEMENTATION OF SWITCHES

The switches use the value of the corresponding identifiers, i.e.
that  NOZERO is on, means that the value of the identifier NOZERO
not is NIL and that DIAGONAL is off means that the value  of  the
identifier DIAGONAL is NIL.

SWITCHES AND CONSTANTS                                   Page 3-2


3.3  CONSTANTS

Some  numerical  constants  in  the  system  are   controled   by
SUBMTIMES, POWER, EXPANDLIM, PARDEEP, LINESPERPAGE and DIFFORDER.
They take one argument and affect  one  constant  each.   If  the
argument  is a positive INUM, the constant is set to the argument
and the value of the  function  is  the  previous  value  of  the
constant.   If  the argument is not a positive INUM, the constant
is not changed and the value of the function is the current value
of  the constant.  Default values of the constants and where they
are used is indicated below.
               default        used in
               -------        ---- --
DIFFORDER      2              SETSUB
SUBMTIMES      3              MSUBS substitutions in SIMP
POWER          4              SMEXPT
EXPANDLIM      4              SMEXPT
PARDEEP        0              PRT
LINESPERPAGE   58             PRT













                           CHAPTER 4

          INTERNAL REPRESENTATION AND RELATED FUNCTIONS



4.1  SYNTAX FOR INTERNAL REPRESENTATION

The following is a formal syntax for SHEEP expressions.

<SHEEP expression>  := <identifier>
                       <SHEEP number>
                       <SHEEP functional>

<SHEEP functional>  := (<EFUN operator> <SHEEP expression>)
                       (<DFUN operator> . <expression list>)

<expression list>   := (<SHEEP expression>)
                       (<SHEEP expression> . <expression list>)

<EFUN operator>     := QUOTE,EXP,LOG,SIN,COS,SINH,COSH,TAN,COT

<DFUN operator>     := &+,*,^,&,#,TPS,TEXT

<SHEEP number>      := <small number>
                       <general number>
                       <complex number>

<small number>      := <small integer>
                       <small rational>

<small integer>     := <INUM>

<small rational>    := (<INUM1> . <positive INUM>)

<general number>    := <general integer>
                       <general rational>
                       <floating number>

<general integer>   := (<AFX> . <LIfix>)

<general rational>  := (<AFX> <LIfix> . <positive LIfix>)

<floating number>   := (<FLO> . <LISP floating point number>)

INTERNAL REPRESENTATION AND RELATED FUNCTIONS            Page 4-2


<complex number>    := <complex integer>
                       <complex rational>

<complex integer>   := (<INUM> <non zero INUM>)

<complex rational>  := (<INUM> <non zero INUM> . <positive INUM>)

<LIfix>             := <any LISP integer>

<INUM1>             := <INUM that is not FLO or AFX>

<FLO>               := <most negative INUM>

<AFX>               := <FLO+1>

An INUM is a small (*) LISP integer.


                              NOTE

               Complex  numbers  with  the  syntax
               defined   abowe   are  usually  not
               implemented, but the variable I  is
               known  and the simplifier knows how
               to handle it.  When complex numbers
               are implemented (for how to do that
               see  appendix  G)   then   <general
               number>   is  not  implemented  and
               INUM1 is the same as INUM.  This of
               cource means a limit to the size of
               numbers allowed in that case.   The
               simplifier expects general rational
               numbers to be normalized (see  SNUM
               below).





4.2  EXAMPLES OF THE INTERNAL REPRESENTATION

In the following examples,  "a",  "b"  and  "c"  will  stand  for
(arbitrary)  SHEEP  expressions  and  "A",  "B"  and  "C" will be
identifiers.

SHEEP expression              Meaning
----- ----------              -------

(2 .  3)                      2/3
(2 3)                         2+3i
(-2 . 3)                      -2/3
(5 6 . 7)                     (5+6i)/7
(&+ a b)                      a+b
(&+ a b 5 A c)                a+b+5+A+c
(* a b c)                     a*b*c
   -----------------------------------------------------------
(*) The magnitude of an INUM is usually less than 2^16.

INTERNAL REPRESENTATION AND RELATED FUNCTIONS            Page 4-3


(^ a b)                       a^b
(^ X 4)                       X^4
(E a)                         EXP(a)
(SIN c)                       SIN(c)
(* (&+ a b) c)                (a+b)*c
(* -1 a)                      -a
(^ a -1)                      1/a



4.3  FUNCTIONS THAT GENERATE SHEEP EXPRESSIONS

The following functions take SHEEP expressions as  arguments  and
returns  new  SHEEP  expressions  constructed from the arguments.
They are all EXPRs, i.e. they operate  on  the  values  of  their
arguments.

(MKPLUS shxp1 shxp2)          If  "shxp1"  is  zero,  "shxp2"  is
               returned as value.  If "shxp2" is zero, "shxp1" is
               returned.  If neither is zero, the list (&+  shxp1
               shxp2) is returned.

(MKTIMS shxp1 shxp2)          If "shxp1" or "shxp2" is zero, zero
               is returned.  If neither is zero the list (* shxp1
               shxp2) is returned.

(COPYL shxp)   Returns a copy of  the  SHEEP  expression  "shxp".
               This function copies all list structures in "shxp"
               except SHEEP numbers.   As  SIMP,  DIFF  and  some
               other  functions  destroy  their  arguments, COPYL
               must usually be used to copy expressions that  are
               given to them.

(DOMULC shxp1 shxp2)          If "shxp1" or "shxp2" is zero, zero
               is  returned.   If  neither is zero and TPS is NIL
               (default), then DOMULC is the same as:
                     (LIST '* (COPYL shxp1) (COPYL shxp2))
               i.e. if TPS is NIL then  DOMULC  is  the  same  as
               MKTIMS with the exception that "shxp1" and "shxp2"
               are copied if the answer not is zero.  If TPS  not
               is  NIL then the value is the term of order TPS in
               the product of two  truncated  power  series  (see
               chapter 13).

(DOCOPY shxp)  If TPS is NIL (default) then DOCOPY is the same as
               COPYL.   If TPS not is NIL then DOCOPY returns the
               copy of the truncated power series term  of  order
               TPS.

(PLUSIM shxp1 shxp2)          The same as
                           (EDIT (MKPLUS shxp1 shxp2)
               I.e. if "shxp1" and "shxp2"  are  simplified  then
               the  simplified  sum  of  "shxp1"  and  "shxp2" is
               returned.

INTERNAL REPRESENTATION AND RELATED FUNCTIONS            Page 4-4


(EDITM shxp)   Negates "shxp"  by  changing  "shxp",  i.e.  COPYL
               might  be  needed.  If "shxp" was simplified, then
               the result is so also.

(SNUM nominator denominator)  Generate a SHEEP number (but not  a
               complex  number) with nominator and denominator as
               nominator   and   denominator.    Nominator    and
               denominator  are arbitray Lisp numbers.  If any of
               them are a Lisp floting  number  then  a  floating
               number  is  created  by  dividing  nominator  with
               denominator.  Otherwise nominator and  denominator
               are  normalized  by dividing with there gcd and if
               the resulting denominator is 1 then an integer  is
               formed,  else  a rational is formed.  Depending on
               size, a small or a general number is formed.

See also chapter 5.













                           CHAPTER 5

                         SIMPLIFICATION



Simplification of expressions, using ordinary rules  of  algebra,
is  done  in  several  parts  of  the  system, using more or less
ambitious simplification functions:

   All input to the formula reader FOIN is simplified  by  SIMPI,
which  tries  to  simplify  all  subexpressions  knowing  how  to
simplify sums, products and exponentials, but  does  not  perform
any substitutions.

   Expressions calculated by the system, e.g. tensor  components,
are   simplified  by  the  function  SIMP,  which  basicaly  only
simplifies sums  and  products,  but  can  be  made  to  simplify
exponentials  and perform substitutions by turning on appropriate
switches.

   The TENVAL function  LSIMP  can  be  used  to  apply  SIMP  on
components   and   identifier   values.   As  these  usually  are
simplified  already,  this  is  mostly  done  in  order   to   do
substitutions.



5.1  SIMP

SIMP is the general simplification function that is used  by  the
system  to  simplify  computed  expressions.   The following is a
short description of the action of SIMP:

     1.  If the switch NOSIMP is on, SIMP does nothing.  This  is
         sometimes useful to debug user defined functions.

     2.  Call SIMP1, that simplifies sums and products.

     3.  If the identifier SUBS has a value different  from  NIL,
         then  make  substitutions,  using  the substitution list
         that is the value of SUBS.

     4.  If the switch ESUBS is on, make substitutions, using the
         ESUL substitution list.

SIMPLIFICATION                                           Page 5-2


     5.  If  any  substitution  was  actually  made  in  the  two
         previous  steps or if the switch POTSIM is on, then call
         SIMP2 that first simplifies all  exponentials  by  using
         SMEXPT  and  then  calls  SIMP1  to  simplify  sums  and
         products.

     6.  End if the switch MSUBS is off.

     7.  Make substitutions using the MSUL substitution list.

     8.  End if no substitutions were made in the previous  step,
         i.e. if no matching expressions were found.

     9.  Call SIMP2.

    10.  Go back to step 7, if this loop has not been passed more
         than  N  times, where N is a constant that is set by the
         function SUBMTIMES (initial value is 3).




5.2  THE SIMPLIFICATION FUNCTIONS

The following functions are all of  the  EXPR  type.   They  take
SHEEP  expressions  as  arguments  and returns a simplified SHEEP
expression as value.  Appendix F.2 contains LISP  definitions  of
some of these functions.

(SIMP1 shexp)  This is the basic simplification routine  that  is
               used  by  all  the  other routines.  It simplifies
               sums and products.  This is done in three steps:

               1.  ZERM applies the rules:
                   0+a        = a
                   +a         = a
                   +          = 0
                   0*a        = 0
                   1*a        = a
                   *a         = a
                   *          = 1

               2.  EXPD  expands   an   expression,   using   the
                   distributive and associative laws.

               3.  EDIT adds and multiplies numbers and  collects
                   like terms together, by summing exponents in a
                   product or adding coefficients in a sum.


(SMEXPT basis exponent)       Constructs      an      exponential
               "basis"^"exponent" and then uses the rules:
               a^0            = 1   Note that 0^0 = 1
               a^1            = a
               0^a            = 0 if a is a positive number.
                              ZERO  DIVISOR  error  if  a  is   a
                              negative number

SIMPLIFICATION                                           Page 5-3


               1^a            = 1
               (a*b)^c        = (a^c)*(b^c)
               (a^b)^c        = a^(b*c)
               (EXP(a))^b     = EXP(a*b)
               (a+b)^n        =  (a+b)(a+b)...(a+b)  if  n  is  a
                              positive   integer   that   not  is
                              greater than a constant set by  the
                              function EXPANDLIM (initially 4).
               r^n            = r*r*r*...*r if r is a number  and
                              n  is an integer with magnitude not
                              greater than a constant set by  the
                              function POWER (initially 4).

(SIMPEX shexp) Simplifies all exponentials in  "shexp"  by  first
               simplifying basis and exponent with SIMP2 and then
               calling SMEXPT.

(SIMP2 shexp)  First simplifies all exponentials using SIMPEX and
               then calls SIMP1.

(SIMP shexp)   This is the general simplification routine that is
               used  in  most  cases to simplify expressions.  It
               has been described earlier in this chapter.

(SIMPI shexp)  Simplifies    all    subexpressions,    performing
               differentiation and calling SIMP2.













                           CHAPTER 6

                          SUBSTITUTIONS



Substitutions can be made that  change  the  expressions  in  the
memory or that only affect the output.

   The substitutions that change  the  existing  expressions  are
applied when the function SIMP is called (see 5.1) and are of two
types:  When the switch ESUBS  is  on,  ESUBS  substitutions  are
applied  once every time SIMP is called and if MSUBS is on, MSUBS
substitutions are applied several times each time SIMP is  called
until  either  no  more  substitutions  are  made  (i.e.  no more
matchings) or the substitutions have been applied N times where N
is a constant set by the function SUBMTIMES.

   If the switch PSUBS is on, PSUBS substitutions will be applied
once  every  time  PRT  or  FPRT is called and then SIMP2 will be
called, but expressions in the memory will not be changed.

   Each type of substitution, uses a separate substitution  list.
A substitution list is a list of substitution pairs:
              ((m1 . s1) (m2 . s2) .... (mN . sN))
When substitutions  are  applied  on  an  expression,  first  all
occurrences  of  the  mask  m1  in the expression are replaced by
copies of the substitute s1,  then  all  m2  are  substituted  by
copies  of  s2  and  so on, until all mN have been substituted by
copies of sN.  The subs. lists that correspond  to  ESUBS,  MSUBS
and PSUBS are ESUL, MSUL and PSUL.



6.1  WHAT CAN BE SUBSTITUTED

There are some limitations on what can  be  substituted.   To  be
replaced  by  the  substitute S, an expression must be matched by
the mask M (in the sense of the LISP function EQUAL).

   Because of the internal representation of sums and products, a
mask  that  is  a  sum  or a product will not match everything it
should match.  E.g. if X+Y is to be replaced by A,  then  (X+Y)+Z
will  be changed to A+Z, but X+Y+Z will not.  A way to substitute
X+Y by A, is to substitute X by A-Y.  The situation for  products
is exactly the same as for sums:  just replace "+" and "-" in the
example above by "*" and "/".

SUBSTITUTIONS                                            Page 6-2


   There is one exception from the fact that the mask must  match
exactly  for  a substitution to be made:  If the switch SUBPOT is
on, and the mask is of the type A^N, where N is an integer and  A
is  a  SHEEP  expression,  then  a similar expression A^M will be
substituted if M has the same sign as N and the magnitude of M is
not less than that of N.
E.g. if X^2 is to be substituted by Y and SUBPOT is on, then  X^3
will  be  changed to Y*X, X^4 will be changed to Y^2, X^5 will be
changed to Y^2*X and so on.



6.2  MANIPULATING PAIRS ON THE SUBSTITUTION LISTS

The  three  functions  SETSUB,  PRSUB   and   REMSUB   manipulate
substitution  pairs.   They  are  all  FEXPRs  with an indefinite
number of arguments.  The identifier LASUB has the  name  of  the
current  substitution  list,  to  which all arguments refer.  The
arguments are processed from the left to the  right.   All  three
functions  have as value the number of subs. pairs on the current
subs. list.



6.2.1  Arguments That Specify Substitution Pairs

The following arguments specify which substitution list and which
pairs  are  to be printed by PRSUB or deleted by REMSUB.  N and M
are understood to be positive numbers in the following.

Argument       Meaning
--------       -------

<name of a subs. list>        The identifier LASUB is set to this
               name.   If  this argument is missing, the value of
               LASUB, set by a previous call to PRSUB, REMSUB  or
               SETSUB,  is  used, i.e. the value of LASUB is used
               as default.

N              The pair number N

(N M)          Pairs N to M (M is included).

(N)            All pairs from N to the end of the list.

ALL            All pairs.

LAST           The last pair.

SUBSTITUTIONS                                            Page 6-3


6.2.2  PRSUB And REMSUB

REMSUB         Deletes the specified substitution pairs.

PRSUB          Uses PRT to print the specified subs. pairs  in  a
               manner  similar  to  that  in which SETSUB defines
               them.  No  substitutions  are  performed  in  this
               output except NAM replacements.



6.2.3  SETSUB

SETSUB first calls REMSUB and then reads a subs. pair and adds it
to  the  current  subs.  list.   It  takes  the same arguments as
REMSUB, but it also takes  some  extra  arguments  that  will  be
described  below.   FOIN  is  used  to  read  the  mask  and  the
substitute in the pair, in the following way:
First the mask is asked for by printing:
                           "n"  FOR  =
where "n" is the number which the new substitution pair will  get
and  "="  is  the  prompter  telling that FOIN now expects input.
After the mask has been inserted, the substitute is asked for  by
printing:
                           SUBSTITUTE  =
where again "=" tells that FOIN now  expects  input.   After  the
substitute  has been inserted, a subs. pair is constructed and if
SETSUB has no extra arguments, it  is  put  at  the  end  of  the
current subs. list.



6.2.4  Extra Arguments Of SETSUB

Except for the arguments used by REMSUB, SETSUB also  takes  some
extra  argument that affect what is done with the subs. pair read
by SETSUB.  These arguments may be  mixed  arbitrarily  with  the
arguments to REMSUB.

Argument       Effect
--------       ------

DIFF           Create  subs.  pairs  to  substitute  all  nonzero
               derivatives  with respect to the default (value of
               DIFF, see chapter 7) set of variables, up to  (and
               including)  order  N  where N is a constant set by
               the function DIFFORDER (default is 2).

&              Similar  to  "DIFF",  but  use  the  "&"  set   of
               variables.   When,  as is usual, the value of DIFF
               is "&", using "&" or "DIFF" gives the same result.

#              Similar  to  "DIFF",  but  use  the  "#"  set   of
               variables.

SUBSTITUTIONS                                            Page 6-4


(DIFF n)       Similar to "DIFF", but use DIFFORDER "n".

(& n)          Similar to "&", but use DIFFORDER "n".

(# n)          Similar to "#", but use DIFFORDER "n".

TRANSF         Is similar to "DIFF", but the derivatives  of  the
               substitute   are   made   with   CHNDIF,  so  that
               derivatives with respect to the complement set  of
               derivatives are generated.  E.g.
                       (SETSUB TRANSF &)
               followed by insertion of a mask and  a  substitute
               that  are  the  same  identifier, A say, the chain
               rule will be used  to  define  substitution  pairs
               that  will  replace  all  derivatives  of  A  with
               respect  to  the  "&"   set   of   variables,   by
               derivatives  with respect to the "#" set, by using
               the chain rule.  Note that the substitution  of  A
               by   A   (but  not  its  derivatives)  is  removed
               automatically from the substitution list.













                           CHAPTER 7

                  DIFFERENTIATION AND FUNCTIONS



Differentiation in SHEEP  is  always  done  with  respect  to  an
independent  variable.   To do variable transformations using the
chain-rule, there are two sets of independent variables, the  "&"
variables and the "#" variables.  The number of variables in each
set is usually 4 (*).  This number can be enlarged by  using  the
function VARMAX.
Some of the functions that need to know which variable  set  that
is to be used, are such that they use the value of the identifier
DIFF (initially "&") as default variable set.   This  means  that
the user that only want to do standard calculations not involving
variable  transformations,  doesn't  have  to  bother  with  what
variable system is to be used.
The variables in each set are  numbered  from  zero  and  upwards
(i.e.  initially  (usually) 0,1,2,3).  The variables can be named
(i.e. associated with identifiers), by using the  function  VARS,
but  the  variable  numbers  can  always  be  used instead of the
identifiers, in fact some functions only accept variable numbers.
When differentiating a SHEEP expression, three  cases  may  occur
(see  definition  of internal representation in chapter 4).  When
the SHEEP expression is:

SHEEP number   The derivative is zero.

Identifier     The derivative is found on the  property  list  of
               the  identifier.   The  functions VARS or FUNS are
               used to put the derivatives with  respect  to  all
               variables on the property list of identifiers.

SHEEP functional              Call a routine that is found on the
               property  list of the SHEEP operator.  The details
               of this can be found in appendix F.4, but they are
               only important to know if you want to define a new
               SHEEP operator.






  ------------------------------------------------------------
(*) The  number  of  variables  is  initially  the  same  as  the
dimension, which usually is 4.

DIFFERENTIATION AND FUNCTIONS                            Page 7-2


7.1  FUNCTION AND VARIABLE DECLARATIONS

7.1.1  FUNS

FUNS is an FEXPR with an indefinite number  of  arguments.   Each
argument defines the derivatives with respect to variables in one
of the two variable sets.   The  value  of  the  identifier  DIFF
defines the initial set.
In the following description of the  arguments  to  FUNS,  "vars"
stands  for from zero to VARMAX variables specified as numbers or
the corresponding identifiers.  "id"  stands  for  an  identifier
that is declared as a function by FUNS.

argument       meaning
--------       -------

&              Use the "&" set until changed by "#".

#              Use the "#" set until changed by "&".

("id" "vars")  Declare "id" as a function depending on  variables
               "vars".  E.g
                               (FUNS (A 0 2) (B))
               Declares A as a function of variables 0 and 2, but
               independent  of  1  and  3.   Also declares B as a
               function of no variables, i.e. a constant.


                                      NOTE

                   Constants must be declared as functions of
                   no variables.



("id" ALL)     Declare "id" as a function of all the variables.

("id" SUBS)    Use  FOIN  to  read  a  SHEEP   expression.    The
               derivatives of "id" are defined by the derivatives
               of this SHEEP expression.

"id"           Similar to ("id" SUBS) except that if "id"  has  a
               non-NIL  value  then this value is used instead of
               reading a SHEEP expression with FOIN.

("id" SPEC "vars")            Use FOIN to read  replacements  for
               the  derivatives  of  "id"  that  are specified by
               "vars".   "id"  must  have  been  declared  as   a
               function previously.

("id" TRANSF)  Use the chain rule to define  the  derivatives  of
               "id" with respect to the current variable set from
               the derivatives with respect to the other variable
               set.   E.g. if we have defined the "&" derivatives
               of A by
                               (FUNS & (A 0 1))
               then we  can  define  the  "#"  derivatives  of  A

DIFFERENTIATION AND FUNCTIONS                            Page 7-3


               expressed   in   "&"  derivatives  of  A  and  "#"
               derivatives of the "&" variables by
                              (FUNS # (A TRANSF))

Identifiers that are declared as functions are put  on  the  FUNS
lists.  If an identifier is already on the FUNS list the message
                            "Id" OLD
is given to tell you that  the  old  FUNS  declaration  has  been
changed.   There  is one FUNS list for "&" and one for "#".  FUNS
returns as value the FUNS list corresponding to the last variable
set used.  E.g.
                             (FUNS)
has as value the default (usually "&") FUNS list.
                            (FUNS #)
has as value the "#" FUNS list.



7.1.2  REMFUNS

REMFUNS is an FEXPR with an indefinite number of arguments.   For
each  argument  it removes the definition of the derivatives with
respect to the variables in one of the two  variable  sets.   The
value of the identifier DIFF defines the initial set.

argument       meaning
--------       -------

&              Use the "&" set until changed by "#".

#              Use the "#" set until changed by "&".

"id"           Delete  "id"  from  FUNS  list  and   remove   the
               derivatives  with  respect  to  the current set of
               variables from the property list of "id".

ALL            Do REMFUNS on all elements of current FUNS list.




7.1.3  VARS

(VARS "vt" "var0" "var1"...  )          VARS is an FEXPR with  an
               indefinite   number  of  arguments.   "vt"  is  an
               optional argument that specifies the variable  set
               ("&"  or  "#").  If "vt" not is present, the value
               of the identifier DIFF is used as "vt".
The identifiers "var0", "var1"...  are declared as  variables  no
0,1...   (of  the  "vt"  set  of  variables).   If there are more
arguments (not counting "vt")  than  variables,  then  the  extra
arguments are ignored.
The effect of VARS is:

DIFFERENTIATION AND FUNCTIONS                            Page 7-4


     1.  REMFUNS the previous variables.

     2.  Define the derivatives of the  variable  identifiers  so
         that  the  derivative  of  each variable with respect to
         itself is one and the derivatives with  respect  to  the
         other variables are zero.

     3.  Put the identifier on the "vt" VARS list (but not on the
         FUNS list).

The VARS list is a list with the the variables ordered  with  the
0:th  variable first.  There are two VARS lists, the "&" list and
the "#" list.  The values of the identifiers "&" and "#" are  the
corresponding  VARS lists.  The value of the function VARS is the
"vt" VARS list.  E.g.
                           (VARS T X)
declares T as variable 0 and X as variable 1.  If there should be
4  variables,  then  the  resulting  VARS list is (T X 2 3).  Any
small number can be used as a  dummy  argument  to  position  the
arguments to VARS correctly.  E.g.
                          (VARS T 5 X)
declares T as variable 0 and X as variable 2.  The resulting VARS
list is (T 1 X 3).


                            EXCEPTION

               The command  (VARS "vt")  does  not
               change  anything,  it  only returns
               the   VARS   list.    To    REMFUNS
               variables without declaring any new
               variables do:
                          (VARS "vt" 8)
               where 8 might be replaced with  any
               small number.





7.1.4  VARMAX

The number of variables in a variable set, can be changed by  the
function

(VARMAX "vt" "vrm")           VARMAX  is  an   FEXPR   with   two
               (optional) arguments.  "vt" specifies the variable
               set ("&" or "#").  If "vt" is missing,  the  value
               of  the identifier DIFF is used as "vt".  If "vrm"
               is missing, VARMAX changes nothing and returns the
               number of variables in the "vt" set.

DIFFERENTIATION AND FUNCTIONS                            Page 7-5


               If "vrm" is a small  integer  not  less  than  the
               value  of  the  identifier  VARMAX  (*),  then the
               number of variables in the  "vt"  set  is  set  to
               "vrm"  and  all variable and function declarations
               with respect to the "vt" set, are deleted i.e.
                                 (VARS "vt" 0)
                                      and
                               (REMFUNS "vt" ALL)
               are executed.
               If "vrm" is not a number or to small a number, the
               error
                                VARMAX TO SMALL
               occurs.
               The value of the function VARMAX is the  old  (the
               current if not changed) number of variables of the
               "vt" set.



7.2  FUNCTIONS FOR DIFFERENTIATION

The following functions are all of the EXPR type.

(DIFF shexp varnu vt)         DIFF   is   a   EXPR   with   three
               arguments.   It is mainly intended for use in DFUN
               functions.
               DIFF differentiates "shexp" with  respect  to  the
               "varnu"th  variable  in the "vt" set of variables.
               DIFF changes "shexp" , which means that you  might
               have   to  copy  before  you  use  DIFF.   A  LISP
               equivalent of DIFF can be found in appendix F.4.

(SDIFF shexp varnu)           SDIFF is a EXPR with two  arguments
               mainly  intended  for use in BULF expressions.  If
               the value of TPSSW is NIL (NIL is  default),  then
               SDIFF is equivalent to
                        (DIFF (COPYL shexp) varnu DIFF)
               where the third  argument  is  the  value  of  the
               identifier  DIFF  i.  e.  the default variable set
               is used.
               When TPSSW not is NIL, it must be an  integer  and
               then the value of SDIFF is the order TPSSW term of
               the derivative of "shexp".

(CHNDIF shexp varnu vt)       Differentiate "shexp" with  respect
               to   the   "varnu"th   variable   among  the  "vt"
               variables, but use the chain-rule to compute  this
               derivative by differentiating "shexp" with respect
               to the other set of variables and  differentiating
               these variables with respect to the "varnu"th "vt"
               variable.

  ------------------------------------------------------------
(*) VARMAX is set to the dimension (DIM) if the TENSOR package is
loaded.   If the number of variables gets less than the dimension
then VARS and FUNS can't construct derivatives  that  the  tensor
algorithms expect.

DIFFERENTIATION AND FUNCTIONS                            Page 7-6


(SCHDIF shexp varnu vt)       When TPSSW is NIL  (default),  then
               SCHDIF is the same as CHNDIF.



7.3  DEFINING NEW SHEEP OPERATORS

As can be seen by the  syntax  for  SHEEP  expressions,  a  SHEEP
expression  is  either  an  identifier,  a SHEEP number or a list
headed by a SHEEP operator.
A SHEEP operator is an identifier with the property EFUN if it is
a  function of one argument, or with the property DFUN if it is a
function with an indefinite number of arguments.
Appendix F.4 has a definition of DIFF and some examples  of  EFUN
and DFUN operators.













                           CHAPTER 8

                      FORMULA INPUT (FOIN)



8.1  FOIN

Functions, like SETSUB or RPL,  that  insert  formulae,  use  the
formula  reading  function  FOIN  that read a formula in a linear
(infix) notation and converts that to the internal (prefix) SHEEP
representation.  This is done in two steps:  First the formula is
read and converted to a pseudo  SHEEP  representation,  which  is
then  simplified  by SIMPI that goes into all sub expressions and
tries to simplify them.
FOIN uses the prompters "=" and "?" to show that  input  goes  to
FOIN instead of to the LISP READ.



8.1.1  Informal Syntax Description

The input to FOIN is made out of:

               Letters        A - Z and a - z

               Digits         0 - 9

               Special characters       ! # $ % & ( ) * + , - . /
                              : ; < = [ ] ^ _

A list of all characters and their meaning to FOIN  is  found  in
appendix E.

From these characters numbers, identifiers and special  operators
are made.

A number is a string of digits.  E.g.
                         1  3  5645  123

An identifier consists of a string of  letters  and  digits  that
begin with a letter.  E.g.
          A  AA  DFG  S1  SJ8M  ASDERVYB693KTM  aS  XyH
To make the formulae look nice, it is usually a good habit to use
single  letter  identifiers as variables and arbitrary functions.
Use identifiers with more than one character as tensors and other
prefix operators.
The identifiers I and E are reserved.  They may only be  used  as

FORMULA INPUT (FOIN)                                     Page 8-2


imaginary unity and basis for natural logarithms.
To allow other characters in an identifier and to allow  a  digit
in  the beginning, the escape character "!" is used.  A character
preceded by "!", is read as if it was a letter.

The operators are in precedence order:
:= or _        assignment operator
+ and -
*
/
** or ^        exponentiation
& and #        differentiation using the & or # variables
: and <
prefix operators of two types, EFUN operators and DFUN operators,
depending  on  if  they  have  one or more arguments.  The prefix
operators takes their arguments as usual mathematical  functions.
In the present version of SHEEP, the following EFUN operators are
included:  EXP, LOG, SIN, COS, TAN, COT, SINH and COSH.
The DFUN operators are all tensors, DF, &+ * ^ & and #.



8.1.2  Meaning Of Some Operators

Most of the operators have an obvious meaning, but some operators
are  more  special  and  their  meaning will be described by some
examples:

Example        Meaning
-------        -------

A/B/C          (A/B)/C

/A             1/A

A&X            The derivative of A with respect to the X variable
               in  the  &  set of variables.  The system will ask
               for information at the end of FOIN if  it  doesn't
               recognize X or A.

A&3            The derivative  of  A  with  respect  to  the  3:d
               variable in the & set.

A#X            The derivative of A with respect to the X variable
               in the # set of variables.

A&(5)X         The 5:th derivative of A with respect to X.

(A+B)&X        The derivative of (A+B) with respect to X.

DF(A,X)        The derivative of A with  respect  to  X.   DF  is
               implemented  to  make  FOIN  able  to  read REDUCE
               output, for  further  definition  of  DF  see  the
               REDUCE manual.

FORMULA INPUT (FOIN)                                     Page 8-3


:A             The value of the identifier A.

:(GDD 0 0)     The value of the LISP expression (this is read  by
               LISP  READ  not  by FOIN!), (GDD 0 0) i.e. the 0,0
               component of the metric tensor.



8.1.3  Different Modes Of FOIN

The input to FOIN is ended by one of the end-characters  "<alt>",
"$", ";" or ".", that affect the modes of FOIN.

   If ";" is used, then FOIN will  use  PRT  to  print  the  read
formula  and if the input is comming from the TTY, then FOIN will
ask for  confirmation  of  the  formula.   This  means  that  the
prompter  "?"  is  printed on the TTY.  If this is answered by an
end-character, that is taken as confirmation of the formula  just
read.   Any  other  answer  is  taken  as  a (corrected) formula,
replacing the previous one.  This new formula is again  ended  by
one  of  the end-characters, if ";" is used, the new formula will
be printed and confirmation will be asked for, and so on.

   If "<alt>" or "$" is used FOIN will end and  return  the  read
formula as value.

   If "." is used, FOIN will confirm the formula as for ";"  save
it  and  then  read a new formula, using the prompter "+=".  This
new formula may again be ended by ".", so that the new formula is
saved and still another formula is read.
When this process is ended, the resulting formula is added to the
previously  saved  formula  and  the result of this is added to a
still earlier one and so on, until all the  saved  formulae  have
been added.
This process allows a long formula to be inserted and confirmed a
few terms at a time.



8.1.4  Syntax Error Handling

If a syntax error is found inside a  formula,  FOIN  inserts  the
character  "%" into the formula, at the position of the error and
then tries to read the rest of the formula.

   When a formula has been read by FOIN, a check is made  to  see
if  an  error has been found.  If that is the case, or if the end
character not is known, then the message:
                      "x" FOIN SYNTAX ERROR
is printed on the TTY.  Here "x" is the end character and is only
present if the end character was illegal.

   After the message has been given  the  unsimplified  (probably
erroneous)  formula  is printed and confirmation is asked for, as
if it had been ended by ";".  If it is confirmed and not replaced
by  another  formula,  then  it  is  simplified by SIMP2, and the
confirmation process is entered  a  second  time.   If  the  (now

FORMULA INPUT (FOIN)                                     Page 8-4


simplified)  formula  is  again confirmed, then it is accepted by
FOIN.













                            CHAPTER 9

                         FORMULA OUTPUT



Expressions can be output (printed) in three different formats:

     1.  The PRT format, a multi-line format similar to  ordinary
         mathematical notation.  This is the format used by WRITE
         and all TENVAL functions with a "W" prefix.

     2.  The FOIN format, a single line format readable to  SHEEP
         and  REDUCE.   This  format  is  as near to mathematical
         notation that a  single  line  format  can  be.   It  is
         similar  to the input format of ALGOL, FORTRAN and other
         languages.  This is the format printed by FPRT which  is
         called by FOUT and LFPRT.

     3.  The internal  SHEEP  format,  LISP  S-expressions  in  a
         simple  prefix notation.  This format is used internally
         and it can be printed and read fast to and from external
         memories  using the LISP functions PRINT and READ.  This
         format is used by LPRINT, SAVE and RESTORE.




9.1  PRT

PRT is the function  that  prints  expressions  in  a  multi-line
format.   This  is  the  format  that  is  usually  used to print
expressions.  The output from PRT can be changed in a few ways as
described below (see further F.3).
If PSUBS is on, make  substitutions,  using  the  PSUL  list  and
simplify  the result by calling SIMP2.  These substitutions don't
affect expressions stored in the memory,  they  only  affect  the
output.
If  PTEVAR  is  on  then  tensor  indices  are  printed  as   the
corresponding variable names instead of index numbers.
If PVARNUM is  on,  then  variables  in  formal  derivatives  are
printed  as  their  variable  numbers  instead  of their variable
names.
If  RATPAR  is  on  then  rational  numbers  are  surrounded   by
parenthesis.
If the output is going to a file  then  the  output  is  normally
broken  into  pages.   The number of lines per page is set by the
function LINESPERPAGE.  If NOOFIT is on then this  breaking  into

FORMULA OUTPUT                                           Page 9-2


pages is not done.
If the output is going to the TTY then the output is normally not
broken  into  pages, but if FITIN is on and NOOFIT is off then it
will.
If the value of CHINPRO is not NIL, then the value of CHINPRO  is
inserted  between  each  term  in products.  If some variables or
functions prints as more than one letter, then it might be useful
to set CHINPRO to *.

If an identifier has the property  NAM  then  the  identifier  is
replaced  by the property value in the output.  The expression on
the property list under the NAM indicator (the  property  value),
must  be  in  the  format  accepted by the function PRTL, i.e. /*
means go down one line and // means go up one line.  To  generate
expressions in this format and putting them on the property lists
of identifiers, the NAM command is useful:
NAM is an FEXPR with  an  indefinite  number  of  identifiers  as
arguments.   For  each identifier NAM will use FOIN to ask for an
expression that is converted to PRTL format and then put  on  the
property list of the identifier with property indicator NAM.



9.2  FPRT

FPRT is the function that is  used  to  print  expressions  in  a
format readable to SHEEP and REDUCE.  The output from FPRT can be
affected by PSUBS in  the  same  way  as  PRT.   Identifiers  are
substituted  in the output by having a NAMF property, in the same
way as the NAM property in PRT.  There is  also  a  NAMF  command
similar to the NAM command.













                           CHAPTER 10

              TENSOR IMPLEMENTATION AND NEW TENSORS



10.1  IMPLEMENTATION OF TENSORS

A tensor in SHEEP  is  an  identifier  with  special  properties.
Together with this identifier is associated an array in which the
tensor components are stored in lexicographical  order.   In  the
same  way  as  a  usual  LISP array a tensor has an array element
referencing function.  So has e.g. the  expression  (GDD 1 2)  as
value  the  1,2 component of the tensor GDD (the covariant metric
tensor).

 Some symmetries are used to reduce the number of elements of the
array.  So is e.g. the 4-dimensional metric tensor represented by
an array with 10 elements.  The value of the expression (GDD 2 1)
is  the  the  same as that of (GDD 1 2).  The symmetries that are
used  to  reduce  the  number  of  components,  are  symmetry  or
anti-symmetry between indices.

 To use further (more complicated) symmetries, some tensors has a
symmetry  expression  (in  short  a  SYMF)  that  finds  out if a
component can be made from the earlier components of  the  tensor
or  if  it can be found directly in some other way, e.g. if it is
zero.  So e.g. GDD has the SYMF SYDIAG which makes  off  diagonal
components zero if the switch DIAGONAL is on.

 Most tensors have a component building expression  (in  short  a
BULF) that computes tensor components from earlier tensors.

 The identifier TENSORS has as value a list of all tensors.



10.2  THE PROPERTY LIST OF TENSORS

A tensor may on its property list have the following properties.

Property name  Property
-------- ----  --------

TENSOR IMPLEMENTATION AND NEW TENSORS                   Page 10-2


TENSOR         A pointer to the tensor definition block.  This is
               the property that defines an identifier as being a
               tensor.  Set by DECLTEN.

BULF           The component generating  expression  (the  BULF).
               Is used by the MAKE command to compute components.
               If this property is missing, the MAKE  command  is
               equivalent to RPL.

DELK           A list of the tensors that are not needed any more
               when  making  the  tensor.   These tensors will be
               LOSEd if they are not KEEP declared.

DEP            A list of tensor that depend on the tensor.   Used
               by LOSDEP.

DFUN           Function that DIFFerentiates tensors  in  symbolic
               form.   Set  by  DECLTEN  to  DIFUN  for nonscalar
               tensors.  Because they  have  the  DFUN  property,
               nonscalar  tensors  are  treated  as  functions by
               FOIN.

PREQ           A list of tensors that are  prerequesite  to  make
               the tensor.  Set by PREQ function.

PRT            The tensors PRT function that prints the tensor in
               symbolic  form.   Set  to  PRTEN  by  DECLTEN  for
               nonscalar tensors.

SYMF           The symmetry expression (the SYMF).

TNSPCH         An association list with special  characters  used
               by PRTEN.

UPINDX         A list of  the  contravariant  indices.   Used  by
               PRTEN.

VALUE          Scalar tensors have  their  only  component  here.
               Set to NIL by DECLTEN.



10.3  DEFINING NEW TENSORS.

Only tensors with certain symmetries (or no  symmetry)  can  have
their  symmetry  used  to  reduce  the  number of elements in the
tensor array.  The types of tensors that are allowed,  are  found
on  the  association  list  that  is  the value of the identifier
RANLIS.

 The different TensorTYPEs are represented by names made  of  the
letters  D,  S, A and R (the scalar type SCL is an exception).  D
stands for a single index with no special symmetry, S stands  for
two symmetric indices, A stands for two antisymmetric indices and
R stands for four indices:  two antisymmetric pairs that  can  be
interchanged  pairwise.   So  e.g. AD is the TTYPE of a tensor of
rank three that changes sign  when  the  two  first  indices  are

TENSOR IMPLEMENTATION AND NEW TENSORS                   Page 10-3


interchanged.  An example of TTYPE R is RIE the Riemann tensor.

 A tensor with symmetries that are not found on the RANLIS  list,
can  be  defined as a tensor with a lower symmetry that is on the
RANLIS list.   Further  symmetries  are  implemented  by  a  SYMF
expression.

 To declare a new tensor DECLTEN is used.

(DECLTEN "id" "typ" "nam")    is an FEXPR with 2 or 3  arguments.
               It  declares  "id"  as  a  tensor  of TTYPE "typ".
               "typ" must be found on the RANLIS list.  If  "typ"
               is not found on this list then the error
                                  WRONG TTYPE
               occurs.   If  the  optional  argument   "nam"   is
               present,   "id"   will  get  NAM  "nam".   DECLTEN
               generates the tensor  definition  block  and  (for
               nonscalar  tensors)  the tensor array.  When "typ"
               is not SCL (scalar tensor), DECLTEN gives "id" the
               properties DFUN, PRT and EXPR.
               If  there  isn't  enough  space  in  the  BPS  for
               definition block and array, the error
                         BINARY PROGRAM SPACE EXCEEDED
               will occur and "id" will not become a tensor.  For
               what to do then see appendix H.

(PREQ "id" "tnm1" "tnm2" .  .  .)       is  an  FEXPR   with   an
               indefinite  number  of  arguments.  The identifier
               "id" is given the PREQ property
                             ("tnm1" "tnm2" . . .)
               and "id" is put on the DEP list of all tensors  on
               the  PREQ  list or reachable via the PREQ lists of
               the tensors on the PREQ list and so on.
Appendix F.5, contains LISP definitions  for  the  CORD  tensors.
See also the tensor compiler.













                           CHAPTER 11

                        TENVAL FUNCTIONS



Most of the top level commands in SHEEP (e.g. MAKE, WRITE, LOSE),
are  of the same form.  They are called TENVAL functions.  TENVAL
functions operate on array element or identifier values, on whole
tensors  or on specified tensor components.  Exceptions from this
are MAKE, WMAKE, TEX, TNOEX, REMAKE and WREMAKE that only operate
on  tensor  components.   In this chapter "element" will refer to
either an identifier, an array element or a tensor component.



11.1  ARGUMENTS OF TENVAL FUNCTIONS

TENVAL  functions  are  FEXPRs  with  an  indefinite  number   of
arguments.   If  there  are any arguments, the identifier SPEC is
set to the argument list.  If there are no arguments the value of
SPEC  is  used  as  default  argument  list.   The  arguments are
processed from left to right, interpreting them in the  following
way:

Argument       Interpretation and effect
--------       -------------- --- ------

ALL            The same as the two arguments TENSORS and VALUE.

TENSORS        The same as giving as arguments all tensors.  E.g.
                                 (LOSE TENSORS)
               Deletes all components of all tensors.
               The identifier TENSORS has as value a list of  all
               tensors.

VALUE          The same as giving as arguments all identifiers on
               the  list  that  is  the  value  of the identifier
               VALUE.  All identifiers that are given a value  by
               a  TENVAL  function,  are  put on this list.  E.g.
               after
                              (RPL A)
                              A= some input
               then A is a member of the VALUE list.

TENVAL FUNCTIONS                                        Page 11-2


DEFA           The same as giving as arguments everything on  the
               list  which  is  the value of the identifier DEFA.
               This is useful when the same  arguments  are  used
               several  times.   DEFA is set to the argument list
               of the function DEFA which is an FEXPR.

<a tensor name>               Sets the  identifier  LTEN  to  the
               tensor   name.    Specifies   a  range  of  tensor
               components, with  the  first  component  as  lower
               limit  and  the  last  component  as  upper limit.
               These limits are modified if the  tensor  name  is
               immediately followed by FROM, TO or a number.  The
               TENVAL function  will  operate  on  the  range  of
               components,  including the upper and lower limits.
               E.g.
                                   (MAKE RIC)
               Make all components of RIC (the Ricci tensor).

<a number>     A tensor component index.  One  or  (depending  on
               tensor  rank)  more indices specify a component of
               the tensor whose name is value of  the  identifier
               LTEN.  If the numbers are not immediately preceded
               by FROM or TO the TENVAL function will operate  on
               this component.
                                (WRITE RIC 0 0)
               Writes the 0,0 component of RIC.  If LTEN has  RIC
               as value (set by a previous TENVAL function), then
                                  (WRITE 0 2)
               writes the 0,2 component of RIC.

FROM           Must be followed immediately by numbers specifying
               a  tensor component, which will be the lower limit
               to a range of components.  E.g.
                              (WRITE RIC FROM 2 2)
               Writes 2,2 2,3 and 3,3 components of RIC.

TO             Similar to FROM, but sets upper limit.

<any other identifier>        The TENVAL function will operate on
               the   value   of   the  identifier.   Some  TENVAL
               functions only work on tensors and  will  give  an
               error when operating on identifiers.



11.2  THE INDIVIDUAL TENVAL FUNCTIONS

In the following description of the individual TENVAL  functions,
those  that are prefixed by "(W)" exist in two versions, one with
and one without "W" in front.  the one with "W" is similar to the
one without, but it also WRITEs the elements on which it operate.


TENVAL FUNCTIONS                                        Page 11-3


(W)MAKE        Doesn't work on identifiers.  Makes components  of
               a  tensor,  using the BULF expression belonging to
               the tensor.  MAKE is equivalent to RPL if there is
               no BULF expression.
               If there  is  a  BULF  expression  MAKE  does  the
               following:

               1.  If no components are NIL MAKE will do  nothing
                   (WMAKE will WRITE) and its value is:
                        (<tensor name> ALREADY EXISTS)

               2.  If NOPREQ is on go to 4,  otherwise  MAKE  all
                   tensors  on  the  PREQ  list  belonging to the
                   tensor.  Use WMAKE instead  of  MAKE  for  the
                   tensors that are members of the PRIN list.

               3.  Use LOSE to delete all tensors on the  tensors
                   DELK  list,  that  not are members of the KEEP
                   list.

               4.  For those components that  are  NIL,  evaluate
                   the  BULF  expression  and store the result in
                   the tensor array.



(W)RPL         Replace element with formula read by FOIN.


(W)LSIMP       Apply SIMP on element.  As  the  elements  usually
               are  simplified  already, the main use of LSIMP is
               to do SUBS, ESUBS and MSUBS substitutions.   Error
               if elements are NIL.


(W)LAPLY       The identifier LAPLY has as value a  user  defined
               S-expression.   LAPLY  replaces  elements with the
               result of evaluating this S-expression.  Error  if
               elements are NIL.
               Initially LAPLY has as value the S-expression
                       (SIMP (MKTIMS (COPYL WLAPLY) RPL))
               that multiplies the  element  (the  value  of  the
               identifier  RPL)  with  a copy of the value of the
               identifier WLAPLY and then simplifies.  WLAPLY  is
               initially set to 1.


WRITE          Use PRT to output elements in a nice multiple line
               format.
               If WRITE operates on a range of tensor  components
               (not an identifier or only a single component) and
               the switch NOZERO is on, only  nonzero  components
               are  output.   NOZERO  has the same effect for all
               "W" prefixed TENVAL functions.
               It is usually an error if an element  is  missing,
               but  if  the  switch  DOMAKE  is  on  and WRITE is
               operating on components of a tensor  with  a  BULF

TENVAL FUNCTIONS                                        Page 11-4


               expression,  then  WRITE is similar to WMAKE, with
               the difference that computed components  are  only
               output  and  not  stored in the tensor array.  The
               components in memory are not changed.


LOSE           Delete  elements   by   setting   them   to   NIL.
               Identifiers are also deleted from the VALUE list.


LSTAT          Has as value a list  of  information  about  which
               elements  exist  in memory i.e. are different from
               NIL.  The elements of this list have the following
               meaning:

               Element        Meaning
               -------        -------

               <tensor name>  All components of the tensor exist.

               <other identifier>       The    value    of    the
                              identifier is not NIL.

               (<tensor name>)          No components exist (i.e.
                              all are NIL).

               (<other identifier>)     Either the identifier has
                              no value or the value is NIL.

               <component specification>          This   is   the
                              first  component of the tensor that
                              is NIL, but not all components  are
                              NIL.

               E.g. if the command
                        (LSTAT GUU A GAM B GDD RIC 0 1)
               returns the following value
                        ((GUU 0 2) A (GAM) (B) GDD RIC)
               then

               1.  (GUU 0 0) and (GUU 0 1) are not NIL, but  (GUU
                   0 2) is NIL.

               2.  A has a value different from NIL.

               3.  All components of GAM are NIL.

               4.  Either B has no value or the  value  of  B  is
                   NIL.

               5.  No  component  of  GDD  is   NIL,   i.e.   all
                   components exist.

TENVAL FUNCTIONS                                        Page 11-5


               6.  (RIC 0 1) is not NIL.



SYMMETRIZE     Except  for  tensors  with  a   SYMF   expression,
               SYMMETRIZE   does  nothing.   SYMMETRIZE  set  the
               symmetry elements in memory by evaluating the SYMF
               expression.   As  this  is also done by all TENVAL
               functions  that   change   elements   in   memory,
               SYMMETRIZE  is  only  needed when some but not all
               components of a tensor, have been  changed.   Used
               by   RESTORE   as   SAVE   doesn't  save  symmetry
               components.


LPRINT         Use  PRINT   to   output   an   element   as   two
               S-expressions  followed  by a "$" sign.  The first
               S-expression  is  an  element  specification,  the
               second S-expression is the element in the internal
               SHEEP representation.
               DOMAKE has the same effect on LPRINT as it has  on
               WRITE,  except  for  that PRINT is used instead of
               PRT.
               Doesn't change components in memory.


(W)LREAD       Replace element with formula read with RDIN in the
               format  produced  by LPRINT.  LREAD can be used to
               read some specified elements from a file.  E.g.
                       (INF AFIL (LREAD RIC 0 0 RIC 0 2))
               will read the 0,0 and the  0,2  component  of  RIC
               from  the  file  AFIL.   Better use RESTORE if you
               want to read an entire file.
               If the switch RDASIS is on LREAD (RDIN)  will  not
               check that the read element is the wanted one.


SAVE           The first argument(which must  be  present)  is  a
               filename  (the  file  doesn't have to exist).  The
               rest of the arguments are given  to  LPRINT,  with
               the  output going to the file (which is on disk by
               default).
                    (SAVE <file name> . <argument list>)
               is equivalent to
               (OUTF <file name> (LPRINT . <argument list>))


LFPRT          Use  FPRT  to  output  an  element  as  a   REDUCE
               assignment statement.
               DOMAKE has the same effect on LFPRT as it  has  on
               WRITE,  except  for  that  FPRT is used instead of
               PRT.
               Doesn't change components in memory.
               If the switch NOFARY is off, tensor components are
               assigned to an array with the tensor name as array
               name and tensor  indices  as  array  indices.   If
               NOFARY  is  on,  tensor components are assigned to

TENVAL FUNCTIONS                                        Page 11-6


               identifiers  that  are  created  by  putting   the
               indices at the end of the tensor name.


(W)LFREAD      Similar to LREAD except for that FRDIN is used  to
               read element in format produced by FPRT.


FOUT           Similar to SAVE  but  LFPRT  is  used  instead  of
               PRINT.  INTENDED for communication with REDUCE.


(W)REMAKE      MAKE tensor components but treat them  as  if  all
               components were NIL.


(W)LINIT       Similar to LAPLY,  but  elements  may  be  NIL  in
               memory  and  the  S-expression that is used is the
               value of the identifier LINIT.  The initial  value
               of  LINIT is an S-expression that copies the value
               of the identifier WLINIT.  WLINIT is initially set
               to 0.


SYMBOLIC       Replace an element with an element specification.


TEX            Works  only  on  tensor  components.    For   each
               component  evaluate  the  S-expression that is the
               value of the identifier TEX, and if the value  not
               is NIL, PRINT a component specification.  The only
               way that TEX may change the components is  by  the
               S-expression to do it (which not is recommended).
               The initial S-expression is just RPL (which has as
               value  the  element).   This  means  that TEX will
               print specifications for the elements  that  exist
               in memory (i.e. that not are NIL).


TNOEX          Similar  to  TEX  but  prints  specifications  for
               components  for  which  the S-expressions value is
               NIL.



11.3  MESSAGES WHEN RUNNING TENVAL FUNCTIONS

Some TENVAL functions can give messages on how they proceed.  For
other types of messages see the chapter on error messages.


TENVAL FUNCTIONS                                        Page 11-7


If

     1.  The TENVAL args specify tensor components.

     2.  Any TENVAL function but LSTAT or LOSE is used.

     3.  The switch NOMSG is off (NIL).

     4.  The TENVAL function would not otherwise  print  anything
         on  the  TTY.  I.e. either output is not directed to the
         TTY, or the TENVAL function is not W prefixed or one  of
         WRITE, LFPRT, LPRINT, TEX or TNOEX.

     5.  The TENVAL function doesn't ask for input from the  TTY.
         I.e. either the input isn't comming from the TTY, or the
         TENVAL function isn't RPL or WRPL.

then, one of the following two messages will be  printed  on  the
TTY (even if ordinary output has been directed somewhere else).

     1.  If the switch ALLMSG is off, the name of the  tensor  is
         printed  when  operation  starts  on  the  first  of the
         specified  components  and  "ENDED"  is   printed   when
         operation  on  the  last  of the specified components is
         finished.  This is done for each tensor.

     2.  If ALLMSG is on, a component  specification  is  printed
         for each component when operation starts on it.




11.4  CONTINUING A HALTED TENVAL FUNCTION

A TENVAL function may be halted by a ^C from the user  or  by  an
error.

CONTINUE       is a EXPR  with  no  arguments.   It  continues  a
               halted  TENVAL  function from the element that was
               unfinished.


                                      NOTE

                   This means  that  the  operation  on  this
                   element  is (partly) repeated, which might
                   give trouble if you operate on  components
                   without  copying  them (e.g. if the switch
                   NOASCOP is on in LSIMP or LAPLY).



TENVAL FUNCTIONS                                        Page 11-8


WHERE          is a EXPR with no arguments.  If the  last  TENVAL
               function  was  halted then the value of WHERE is a
               specification  of  the  element   on   which   the
               operation was halted.



11.5  STEPWISE EXECUTION OF TENVAL FUNCTIONS

When a TENVAL function has been operating on a  range  of  tensor
components  and  either the upper limit is not the last component
or the execution was halted by a ^C or  by  an  error,  then  the
TENVAL  function  can  be executed step by step or to a specified
component.  If the last TENVAL function had been halted, then the
execution  will  start  with  the  element on which operation was
halted (see CONTINUE), otherwise execution will start on the next
component.


NEXTA          Is a EXPR with no arguments.  It executes the last
               TENVAL  function  on  the next component.  If e.g.
               the last TENVAL command was:
                               (WRITE GDD TO 1 1)
               and it wasn't halted, then
                                    (NEXTA)
               writes  the  1,2  component  of  GDD  (the  metric
               tensor).   If  the switch DIAGONAL is on, then 1,2
               is a symmetry component  (it  is  zero  as  it  is
               off-diagonal),        and        the       message
               "SYMMETRY COMPONENT" is printed.


NEXT           Is similar to NEXTA with  the  exception  that  it
               continues  to  the  next  non  symmetry component.
               E.g.  under  the  same  circumstances  as  in  the
               previous example (DIAGONAL is on):
                                     (NEXT)
               writes the 2,2 component.



11.6  SOME RELATED FUNCTIONS

(PRIN <tensor names>)         PRIN is an FEXPR with an indefinite
               number  of  arguments.  The arguments are names of
               tensors.  PRIN puts these tensors on the PRIN list
               i.e.  the list that is the value of the identifier
               PRIN.  The value of the function PRIN is also  the
               PRIN list.


(NOTPRIN <tensor names>)      Similar to PRIN, except for that it
               deletes its arguments from the PRIN list.

TENVAL FUNCTIONS                                        Page 11-9


(KEEP <tensor names>)         Similar to PRIN,  except  for  that
               the  KEEP  list is manipulated instead of the PRIN
               list.


(NOTKEEP <tensor names>)      Similar to KEEP, except for that it
               deletes its arguments from the KEEP list.


(DEFA <TENVAL arguments>)     DEFA is  an  FEXPR  with  the  same
               arguments   that   would  be  given  to  a  TENVAL
               function.  The argument list becomes the value  of
               the identifier DEFA.  This value is used as a list
               of arguments if "DEFA" is given as argument  to  a
               TENVAL function.



11.7  SOME IDENTIFIER VALUES

Identifier     Value
----------     -----


RPL            The current element.  An exception to this is that
               if  the  TENVAL function is of the type that makes
               changes in an element (i.e. (W)LSIMP or  (W)LAPLY)
               and  the  switch NOASCOP is off, then the value of
               RPL is the copy of the current element.
                          ----
               The value of RPL can e.g. be (and is) used in  the
               LAPLY S-expression.


All the following values  are  only  set  and  used  when  TENVAL
functions operate on tensor components.


LTEN           The last tensor specified as a TENVAL argument.


CTEN           The current tensor.  This is the same as LTEN when
               not doing MAKE via the PREQ list.


SYMFOUND       NIL if the current component  not  is  a  symmetry
               component, otherwise not NIL.


INDX1          First index of the current component.

TENVAL FUNCTIONS                                       Page 11-10


INDX2          Second index.  The maximum number of indices  (the
               maximum  rank)  is  decided when SHEEP is compiled
               but the usual number is 5, which means  that  also
               INDX3,  INDX4  and  INDX5  might (depending on the
               current tensors rank) have a value.


SPEC           The argument list of the last TENVAL function that
               had  any  arguments.  This list is used as default
               when a TENVAL function has no arguments.


LOSE           The rest of the arguments on  the  current  TENVAL
               argument list.  The value is NIL outside of TENVAL
               functions  if  the  last  TENVAL  function  wasn't
               halted by an error or a ^C.


LSTAT          For TENVAL functions that have a non NIL value (at
               the  moment LSTAT, SAVE, FOUT and sometimes MAKE),
               values obtained when processing the argument list,
               are  put  on  a list which is kept as value of the
               identifier LSTAT.  When finished, the  reverse  of
               this list becomes value of the TENVAL function and
               LSTAT is set to NIL.













                           CHAPTER 12

                        FILE MANIPULATION



12.1  READING OR PRINTING DISK FILES

12.1.1  Saving Expressions In Disk Files

The following two FEXPR functions print or  read  expressions  in
the internal format of SHEEP to or from disk files.


(SAVE <file> <TENVAL args>)   SAVE  is  a  TENVAL  function  that
               saves  its  specified  arguments on disk in a file
               named "file".  See 11-5.


(RESTORE <file>)              RESTORE is an FEXPR.  It reads into
               SHEEP  the  file  "file",  generated by an earlier
               SAVE command.



12.1.2  REDUCE Interface

The following two FEXPRs are similar to SAVE and restore, but the
expressions are in LFPRT format, which is compatible with REDUCE.


(FOUT <file> <TENVAL args>)   FOUT is similar  to  SAVE,  but  it
               uses  FPRT  to  print  the  specifed elements in a
               format readable to REDUCE.  See 11-6.


(FIN <file>)   FIN is similar to RESTORE but it uses FOIN to read
               expressions  in  the  format printed by FPRT or by
               REDUCE.

FILE MANIPULATION                                       Page 12-2


12.1.3  Reading Commands From Disk Files

(DSKIN <file specifications>) DSKIN reads the file  specified  by
               <file   specification>.    The  format  for  <file
               specification> is the same as that  for  the  LISP
               function  OPEN (see the LISP manual).  DSKIN reads
               LISP expressions and evaluates them  in  the  same
               way as the top level of SHEEP.  This means that it
               can be used to read SHEEP commands  from  a  file.
               See 2-8 for an example of its use.



12.1.4  Writing On The Line Printer

(LPTWRITE <TENVAL args>)      LPTWRITE is a TENVAL function  that
               generates  a  file  with  the  specified  elements
               written in PRT format.  This file is sent  to  the
               line-printer  at  logout  time  and  then deleted.
               LPTWRITE generates itself a name for the file.



12.2  OUTF AND INF

The following two functions are FEXPRs with an  arbitrary  number
of arguments.  They don't print or read anything themselves, they
only temporarily change the destination of output or  the  origin
of  input  and  then  executes  given  commands (that may read or
print).


(OUTF <file> <commands>)      OUTF changes the output destination
               to   the   file   "file",  executes  the  commands
               "commands" one after another and then changes  the
               output  destination back to what it was before the
               OUTF command.


(INF <file> <commands>)       INF  is  similar  to  OUTF  but  it
               changes  the  input  origin  instead of the output
               destination.


INF can e.g. be combined with LREAD in the following way:
                   (INF BORIC (LREAD RIC 0 0))
reads the 0,0  component  of  the  Ricci  tensor  from  the  file
"BORIC".













                           CHAPTER 13

                     TRUNCATED POWER SERIES



This chapter is not yet completed.  For a simple example see 2.4.













                           CHAPTER 14

                        THE CORD PACKAGE



The CORD package computes the Einstein  tensor  in  a  coordinate
frame.



14.1  THE CORD TENSORS

The following tensors are defined.

Name    Print   Computation formula
----    -----   ----------- -------

GDD     G       = User input.
         ij

GDF     G       = Differentiate G
         ij,k                    ij

GAM     GAM     = 1/2*(G    +G    -G    )
           ijk          ij,k  ik,j  kj,i

GDET    GDET    = Determinant of GDD

         -1
GINV    G       = 1/GDET

         ij
GUU     G       = GINV*(Cofactor of G  )   or user input
                                     ji

           i       il
GAMU    GAM     = G  GAM
            jk          ljk

                                             m            m
RIE     R       = GAM     -GAM     +GAM   GAM   -GAM   GAM
         ijkl        ijl,k    ijk,l    mil    jk    mik    jl

                   kl
RIC     R       = G  R
         ij           ikjl

THE CORD PACKAGE                                        Page 14-2


         i         il
RICM    R       = G  R
          j           lj

                   k
RSCL    R       = R
                    k

EIN     T       = R  -1/2*R*G
         ij        ij        ij

         i         i
EINM    T       = R  -1/2*R    The second term only when i = j.
          j         j



14.2  ALTERNATIVE ALGORITHM

There is an alternative way to  calculate  RSCL  and  EINM.   The
command
                           (NORICM T)
changes the algorithms so that RSCL and EINM  are  calculated  in
the following way.

                   ij
RSCL    R       = G  R
                      ij

         i         ik
EINM    T       = G  T
          j           kj

The command
                          (NORICM NIL)
restores the original algorithms.   The  value  of  the  function
NORICM is the previous setting.



14.3  CONTROL OF GDET

As SHEEP hasn't got  polynomial  division,  taking  a  sum  to  a
negative  power  usually  produces  unwanted  (although  correct)
results.  For this reason, when making GINV there is a  check  if
GDET is a sum.  When that is the case, the following happens:

     1.  GDET is put on the  KEEP  list  so  that  the  automatic
         deletion is inhibited.

     2.  The identifier GDET taken to power -1 becomes the  value
         of GINV.

     3.  The message "GDET SYMBOLIC AS IT IS A SUM" is printed on
         the TTY.

When this happens, the system will later find that GDET  not  has

THE CORD PACKAGE                                        Page 14-3


been  declared as a function.  The easiest way to declare GDET as
a function, is to give the command:
                           (FUNS GDET)













                            CHAPTER 15

                        THE FRAME PACKAGE



The FRAME package computes the Einstein tensor in a moving  frame
with a constant metric.



15.1  THE FRAME TENSORS

The following tensors are defined.

Name    Print   Computation formula
----    -----   ----------- -------

         AB
HUU     H       = User input. The frame metric.

         -1
HINV    H       = 1/(Determinant of HUU)

                                     BA
HDD     H       = HINV*(Cofactor of H  )
         AB

ZDD     Z       = User input. The covariant frame vectors.
         Ai

         A         AB
ZUD     Z       = H  Z
          i           Bi

                   AB
GDD     G       = H  Z  Z
         ij           Ai Bj

ASD     Z       = Z    -Z
         A[i,j]    Ai,j  Aj,i

ZDET    ZDET    = Determinant of ZUD

         -1
ZINV    Z       = 1/ZDET

THE FRAME PACKAGE                                       Page 15-2


          i                          A
ZDU     Z       = ZINV*(Cofactor of Z  )   or user input
         A                            i

         jk        AB  j  k
GUU     G       = H  Z  Z
                      A  B

           ij       i  j   i  j        i   j
APZ     Z       = Z  Z  -Z  Z    ( = Z   Z    )
         AB        A  B   B  A        [A  B]

                            ij
LIE     C       = Z      Z         i < j
         ABC       C[i,j] AB

GAM     GAM     = 1/2*(C   +C   -C   )
           ABC          ABC  ACB  BCA

                            i            i
RIE     R       = GAM     Z   -GAM     Z   +
         ABCD        ABD,i C      ABC,i D

                  EF
                +H  (GAM   GAM    -GAM   GAM    -GAM   C   )
                        AEC   FBD     AED   FBC     ABE CDF

                   CD
RIC     R       = H  R
         AB           ACBD

         A         AC
RICM    R       = H  R
          B           CB

                   AB
RSCL    R       = H  R
                      AB

EIN     T       = R  -1/2*R*H
         AB        AB        AB

         A         AC
EINM    T       = H  T
          B           CB



15.2  ALTERNATIVE ALGORITHM

There is an alternative way to  calculate  RSCL  and  EINM.   The
command
                          (NORICM NIL)
changes the algorithms so that RSCL and EINM  are  calculated  in
the following way.

THE FRAME PACKAGE                                       Page 15-3


                   A
RSCL    R       = R
                    A

         A         A
EINM    T       = R  -1/2*R    The second term only when A = B.
          B         B

The command
                           (NORICM T)
restores the original algorithms.



15.3  CONTROL OF ZDET

As SHEEP hasn't got  polynomial  division,  taking  a  sum  to  a
negative  power  usually  produces  unwanted  (although  correct)
results.  For this reason, when making ZINV there is a  check  if
ZDET is a sum.  When that is the case, the following happens:

     1.  ZDET is put on the  KEEP  list  so  that  the  automatic
         deletion is inhibited.

     2.  The identifier ZDET taken to power -1 becomes the  value
         of ZINV.

     3.  The message "ZDET SYMBOLIC AS IT IS A SUM" is printed on
         the TTY.

When this happens, the system will later find that ZDET  not  has
been  declared as a function.  The easiest way to declare ZDET as
a function, is to give the command:
                           (FUNS ZDET)



15.4  STANDARD FRAME METRICS

There are commands that will make the most common frame metrics.

(LORENTZ)      Makes an orthogonal  frame  (tetrad)  with  pseudo
               euclidean metric, i.e. HDD = HUU diagonal with
               H   = 1  and  H   = -1  for A > 0.
                00            AA
               LORENTZ is the default metric that is initially in
               existence in FRAME.

(HNULL)        A frame (tetrad) with two  null  vectors  and  the
               other  vectors orthogonal and space like.  Similar
               to LORENTZ, except for that
               H   = H   = 0  and  H   = 1.
                00    11            01

THE FRAME PACKAGE                                       Page 15-4


(NULLT)        A null tetrad, i.e. a frame with null vectors such
               that HDD = HUU,
               H   = 1  and  H   = -1
                01            23
               and all others = 0.  If the dimension is different
               than 4, then the value of HDD = HUU can be seen by
               the command (WRITE HUU).













                           APPENDIX A

               THE FUNCTIONS AND COMMANDS IN SHEEP



The following is an alphabetical list of functions  and  commands
in SHEEP.  Functions are described in the format:
  <function name>(<function arguments separated by ,>):value
The following notation is used:  a "'" before an  argument  means
that  the argument is quoted, "[" and "]" surrounding an argument
means that there may be indefinitly many arguments of that  type,
"{"  and  "}"  surrounding an argument means that the argument is
optional, "sh-exp" means  a  SHEEP-expression,  "s-exp"  means  a
LISP-expression  as  does  "any", "?" means that the value varies
(see  description  of  the  specific  function),  "id"  means  an
identifier.


ASYMEND([index]):sh-exp
AWRITE([tenval-arg]):NIL
CMULT([sh-exp]):sh-exp
COFAC(tensor-name,line-index,colonn-index,sh-exp):sh-exp
CONTINUE():?
COPYA(list of sh-exp):list of sh-exp
COPYL(sh-exp):sh-exp
DECLFUN(['id]):NIL
DECLTEN('id,'tensor-type,{'output-name}):id
DEFA(['tenval-arg]):list of tenval-args
DET(tensor-name):sh-exp
DFMQ(sh-exp,variable-index,sh-exp):sh-exp
DIFF(sh-exp,variable-index,variable-set):sh-exp
DIFFORDER(integer or any):integer
DOCOPY(sh-exp):sh-exp
DOMULC(sh-exp,sh-exp):sh-exp
DREVRS(list):list
EDITM(sh-exp):sh-exp
EFFACE(list,s-exp):list
EJECT():?
EXPANDLIM(integer or any):integer
FIN('file-name):(file-name,?)
FINSET():
FOIN():sh-exp
FOINP(sh-exp):sh-exp
FOUT('file-name,['tenval-arg]):(file-name,?)
FPRING(sh-exp,sh-exp):sh-exp
FRDIN(element-spec):sh-exp
FUNS(['funs-arg]):funs-list

THE FUNCTIONS AND COMMANDS IN SHEEP                       Page A-2


GETPOW(sh-exp,tps-index):sh-exp
GETSUL(subs-list-name):subs-list
GETVAR(variable-name,variable-set):variable-index
INF(file-spec,[s-expr]):s-expr
INSET():
INVERT(sh-number):sh-number
KAR1(index-list):s-exp
KEEP(['tensor-name]):keep-list
KINC(channel-name):previous channel-name
LAPLY(['tenval-arg]):NIL
LEXP(id,id):T or NIL
LFPRT(['tenval-arg]):NIL
LFREAD(['tenval-arg]):NIL
LINESPERPAGE(integer or any):integer
LINIT(['tenval-arg]):NIL
LOMIN(list,list):list
LOSDEP(['tensor-name]):NIL
LOSE(['tenval-arg]):NIL
LPRINT(['tenval-arg]):NIL
LPTWRITE(['tenval-arg]):(file-name,?)
LREAD(['tenval-arg]):NIL
LSIMP(['tenval-arg]):NIL
LSTAT(['tenval-arg]):spec-list
MAKE(['tenval-arg]):?
MCORE(integer):
MINOR(tensor-name,line-index,colonn-index):sh-exp
MKEXP(sh-exp,sh-exp):sh-exp
MKPLUS(sh-exp,sh-exp):sh-exp
MKTIMES(sh-exp,sh-exp):sh-exp
MOVSUL('id,{'subs-list-name}):NIL or id
NAM(['id]):NIL
NAMF(['id]):NIL
NEDITM(sh-exp):sh-exp
NEXT():?
NEXTA():?
NORICM(T or NIL):T or NIL
NOTKEEP(['tensor-name]):keep-list
NOTPRIN(['tensor-name]):prin-list
OFF(['switch]):list of switches
ON(['switch]):list of switches
ORDERP(id,id):T or NIL
OUTF(file-name,[s-expr]):s-expr
PARDEEP(integer or any):integer
PLUSIM(sh-exp,sh-exp):sh-exp
POWER(integer or any):integer
PREQ('tensor-name,['tensor-name]):list of tensor-names
PRIN(['tensor-name]):prin-list
PRING(sh-exp,sh-exp):sh-exp
PRSUB(['subs-args]):NIL
PRT(sh-exp):sh-exp
PRTL(s-expr):NIL
PUTIL(element-spec,sh-exp):sh-exp
PUTIN(element-spec,sh-exp):sh-exp
PUTSUL(id,subs-list):NIL or id
QTERPRI({any}):{any}
RANK(tensor-name):integer
RDIN(element-spec):s-exp

THE FUNCTIONS AND COMMANDS IN SHEEP                       Page A-3


REMAKE(['tenval-arg]):?
REMFUNS(['remfuns-arg]):NIL
REMSUB(['subs-args]):integer
RESTORE('file-name):(file-name,?)
RETUR({any}):{any}
RPL(['tenval-arg]):NIL
SAVE('file-name,['tenval-arg]):(file-name,?)
SDIFF(sh-exp,variable-index):sh-exp
SEQ0L(integer):list of integers
SETEX(['integer]):setex-status-list
SETSUB(['subs-arg]):integer
SIMP(sh-exp):sh-exp
SIMP1(sh-exp):sh-exp
SIMP2(sh-exp):sh-exp
SIMPE(sh-exp):sh-exp
SIMPEX(sh-exp):sh-exp
SIMPFUN(sh-exp):sh-exp
SIMPI(sh-exp):sh-exp
SMEXPT(sh-exp,sh-exp):sh-exp
SNUM(number,number):sh-number
SPLIP():element-spec
SPLIS():element-spec
SUBL1(sh-exp,subs-list):sh-exp
SUBMTIMES(integer or any):integer
SUBS1(sh-exp,sh-exp,sh-exp):sh-exp
SYMBOLIC(['tenval-arg]):NIL
SYMEND([index]):sh-exp
SYMMETRIZE(['tenval-arg]):NIL
TENP(id):T or NIL
TEX(['tenval-arg]):NIL
TITLE(['any]):(TXT.list)
TIPRGN(sh-exp,sh-exp):sh-exp
TIPRNG(sh-exp,sh-exp):sh-exp
TLOSE(tensor-name):?
TNOEX(['tenval-arg]):NIL
TOELM(['tensor-index],['tenval-arg]):?
TPSINIT(['tenval-arg]):NIL
TPSMUL(sh-exp,sh-exp):sh-exp
TSTAT(tensor-name):status
TTYPE(tensor-name):ttype
VALU(sh-exp):s-exp
VARMAX({'variable-set},{'integer or any}):integer
VARS(['vars-arg]):vars-list
WHERE():NIL or element-spec
WLAPLY(['tenval-arg]):NIL
WLFREAD(['tenval-arg]):NIL
WLINIT(['tenval-arg]):NIL
WLREAD(['tenval-arg]):NIL
WLSIMP(['tenval-arg]):NIL
WMAKE(['tenval-arg]):?
WREMAKE(['tenval-arg]):?
WRITE(['tenval-arg]):NIL
WRONG():
WRPL(['tenval-arg]):NIL













                           APPENDIX B

                      THE SWITCHES IN SHEEP



Switch         Effect when on
------         ------ ---- --

ALLMSG         Causes   some   TENVAL    functions    to    print
               specifications  of  all  tensor  components  being
               processed.  Is inhibited by NOMSG.

ALTSIMP        Causes SIMP1 not to simplify sums before expanding
               with distributive law.

CFILFO         Causes FOIN to ask for confirmation  after  seeing
               ";"  even  if  input  not is comming from the TTY.
               Confirmation is taken from the TTY.

DIAGONAL       Causes the symmetry expression  (SYDIAG)  to  make
               off  diagonal  components  zero.  Tells the system
               that  the  metric  or  the  tetrad   vectors   are
               diagonal.

DOMAKE         Causes the TENVAL output functions (WRITE,  LFPRT,
               LPRINT,   SAVE  and  FOUT),  to  generate  missing
               components instead of giving an error message.

DONTCLOSE      Causes OUTF  and  INF  not  to  close  files  when
               finished.

ESUBS          Causes ESUBS substitutions in SIMP.

FITIN          Causes PRT (PRTL) to fit all  output  into  pages,
               also the output to the TTY.  Inhibits NOOFIT.

FPRT           Causes TIPRNG and TIPRGN to do FPRT output instead
               of PRT output.

FUNSIM         Causes SIMP2 to simplify arguments  to  all  SHEEP
               operators and not only to "&+", "*", "^" and "E".

THE SWITCHES IN SHEEP                                    Page B-2


LEXICO         Causes  SIMP1  (EDIT)  to   put   identifiers   in
               lexicographical order.

MSUBS          Causes MSUBS substitutions in SIMP.

NEW            When the double tensor feature is implemented, NEW
               causes the NEW side of tensors to be used.

NOASCOP        Causes (W)LSIMP and (W)LAPLY to place the original
               instead  of a copy of the current element as value
               of the identifier RPL.

NODGNV         Causes CORD or FRAME not to  take  special  action
               when GDET, HDET or ZDET is a sum.

NOFARY         Causes FPRT and LFPRT to print  tensor  components
               as  several  REDUCE  scalar assignments instead of
               assignments to a tensor.

NOMSG          Causes TENVAL  functions  not  to  inform  when  a
               tensor is entered or left.  Inhibits ALLMSG.

NOOFIT         If FITIN is off  causes  PRT  (PRTL)  not  to  fit
               output into pages.

NOPREQ         Causes  TENVAL  functions  that  generate   tensor
               components  not to check that prerequisite tensors
               are made.

NOPRT          Causes PRT to do nothing.

NOSIMP         Causes SIMP to do nothing.  Sometimes useful  when
               debugging.

NOSYMSG        Causes TENVAL functions not to  inform  when  they
               are processing symmetry components.

NOSYRST        Inhibits the automatic  SYMMETRIZE  after  RESTORE
               and FIN.

NOZERO         Causes  TENVAL  functions  not  to  WRITE   tensor
               components  that are zero, when output is going to
               the TTY.

POTSIM         Causes  SIMP  to  apply   SIMP2   also   when   no
               substitutions have been done.

PSUBS          Causes PSUBS substitutions in PRT.

PTEVAR         Causes  PRT  (VALU)  to  print  tensor   component
               specifications  with  variable  names  instead  of
               variable numbers.

THE SWITCHES IN SHEEP                                    Page B-3


PVARNUM        Causes PRT  to  print  symbolic  derivatives  with
               variable numbers instead of variable names.

PZPOW          Causes PRT when  printing  a  TPS,  to  print  the
               zeroth  order  as the zeroth coefficient times the
               expansion variable to power zero, instead of  just
               the coefficient.

RATORDN        Causes SIMP (EDIT) to order numbers in  increasing
               order,  instead  of ordering rationals first after
               nominator and then after denominator.

RATPAR         Causes PRT to print  parenthesis  around  rational
               numbers in products.

RDASIS         Causes LREAD (RDIN) and  LFREAD  (FRDIN)  to  read
               without  checking  that  the  input  is the wanted
               expression.

RDTPS          Causes  FIN  and   LFREAD   to   interpret   array
               assignments as being TPS coefficients.

SIMPFUN        Causes SIMP2 (SIMPEX) to simplify arguments to all
               operators.

SUBPOT         Causes  substitutions  to  match  masks  that  are
               integral  powers, with expressions that have equal
               basis  and  bigger  or  equal  integral  exponent,
               instead of just with equal exponent.

TRYAGAIN       Causes  LREAD  (RDIN)  and  LFREAD  (FRDIN),  when
               reading  from  a  file,  to  start  again from the
               beginning of the file if a wanted expression isn't
               found.













                           APPENDIX C

                           SOME VALUES



This appendix is not yet completed.













                           APPENDIX D

                  DIAGNOSTIC AND ERROR MESSAGES



In the following description of the messages given by SHEEP, some
messages  are  preceded  or  followed  by  an  expression.   This
expression is indicated by "x" in the description.
Error messages that are not found in this appendix are LISP error
messages, that are found in the LISP manual.



D.1  ORDINARY ERROR MESSAGES

The following errors are  of  the  same  type  as  ordinary  LISP
errors.   This  means  that  execution  of the function where the
error occurred is halted and a backtrace can be given.

Error message                 Meaning
----- -------                 -------

CAN'T CONTINUE                Either  a   continuation   function
                              (CONTINUE,  NEXT,  NEXTA  or TOELM)
                              could not continue the last  TENVAL
                              function,  or  WHERE could not find
                              an  element   specification.    The
                              reason  for  the  error is that the
                              TENVAL function was LOSE  or  LSTAT
                              or  it  was  not  halted  or it was
                              halted because of faulty arguments.

CAN'T SUBSTITUTE NUMBERS      A substitution pair with  a  number
                              as mask, cannot be made by SETSUB.

ERROR                         Incorrect format of  expression  on
                              input file.  Also used as a general
                              error.  Might be system error.

MISSING ARG IN FEXPR          One or more arguments were  missing
                              in  a  call  to  an FEXPR function.
                              The following functions could  have
                              generated  this error:  SAVE, FOUT,
                              FIN, RESTORE, INF,  OUTF,  PUTPREQ,
                              DECLTEN, MOVSUL and TENFILE.

DIAGNOSTIC AND ERROR MESSAGES                            Page D-2


MISSING ELEMENT
DEFINE BULF                   This error can only occur if DOMAKE
                              is  on.   WRITE,  LFPRT  or  LPRINT
                              found a  tensor  with  a  component
                              that  was  NIL and the tensor could
                              not be made, as there was  no  BULF
                              expression.

MISSING TERM IN TPS           A term of  a  necessary  order  was
                              missing.   Compare  with comment on
                              "x" MISSING ELEMENT message.

NO OF INDICES NOT EQ RANK     The  number  of  indices  given  as
                              TENVAL arguments, were to few or to
                              many.

RANK NOT 2                    The functions DET, MINOR and  COFAC
                              only operate on tensors of rank 2.

SHEEP NUMBER OVERFLOW         An arithmetic routine got overflow.
                              This  error  will can only occur in
                              unusual  versions  of  SHEEP   that
                              don't  have  general  LISP  numbers
                              (see chapter 4).

TO MUCH                       See  description   of   the   SETEX
                              function.

VARMAX TO SMALL               An argument to VARMAX that was  not
                              "#"  or "&" was less than the value
                              of  the  identifier  VARMAX.   Note
                              that  the  error  will occur if the
                              argument is neither  a  number  nor
                              "#" or "&".

WRONG TPS LENGTH              If you have not been meddling  with
                              the  TPS  representation,  this  is
                              probably a system error.

WRONG TPS ORDER               A term of lower order in a TPS  was
                              missing  when  a  higher order term
                              was going  to  be  inserted.   This
                              higher order term is saved as value
                              of the  identifier  PUTPS  and  the
                              error occurs.

WRONG TYPE                    The second argument to the  DECLTEN
                              command  was  not  a  member of the
                              list RANLIS.

"x" INDEX ?                   The index "x" was to  great  or  to
                              small.   Note that this will happen
                              if "x" is not a number.

DIAGNOSTIC AND ERROR MESSAGES                            Page D-3


"x" MISSING ELEMENT           The  component  with  specification
                              "x" was NIL.  This will be an error
                              in the  tensor  component  fetching
                              function, in SYMEND and in ASYMEND,
                              in (W)LSIMP and in (W)LAPLY and (if
                              DOMAKE  is off) in WRITE, LFPRT and
                              LPRINT.  A probable reason for this
                              error is that NOPREQ is on, or that
                              a  new  tensor  has  been   defined
                              without  the  PREQ  list  it should
                              have.

"x" NOT A SHEEP NUMBER        One of the arithmetic routines  was
                              given  "x" as argument, but "x" was
                              not a SHEEP number (see  syntax  in
                              chapter 4).

"x" NOT A SWITCH              "x" was not a member  of  the  list
                              SWITCHES.  This error occurs if "x"
                              is given as argument to ON, OFF  or
                              SWISTAT.

"x" NOT A TENSOR              A function that expected  a  tensor
                              name  was  given  "x"  as  argument
                              instead.   Note  that  some  TENVAL
                              functions  (e.g.  MAKE) only accept
                              tensors.  The same is the case  for
                              LOSDEP,  TENFILE, TLOSE, DET, MINOR
                              and COFAC.

"x" NOT LIST                  "x" should have been  a  list.   In
                              some  cases  "x"  should  be a list
                              with at least one element, i.e. the
                              empty  list  NIL  is illegal.  This
                              error usually occurs if expressions
                              are used that don't have the syntax
                              of SHEEPs internal  representation.
                              A possible system error.

"x" NOT MADE                  An error occurred  when  evaluating
                              the  BULF  expression  that  should
                              have made the component "x".

"x" NOT SUBS LIST             A   function   that   operates   on
                              substitution  lists expected "x" to
                              be a SUBS list, but it was  not  an
                              identifier  with the property SUBS.
                              This error  may  occur  in  SETSUB,
                              REMSUB,  PRSUB,  MOVSUL, GETSUL and
                              PUTSUL.

DIAGNOSTIC AND ERROR MESSAGES                            Page D-4


D.2  CALLS FOR DECLARATION

The  following  messages  are  given  when   the   system   needs
information.   they  are  followed  by  the  message  NOW and the
prompter "*" which asks for a declaration command to be executed.
When  the  system  has  got its information, it goes on executing
from where it stopped in order to get needed information.

"x" DECLARE FUNCTION          The  system  doesn't  know  how  to
                              differentiate  the  identifier "x".
                              Use the FUNS command to declare "x"
                              as  a  function,  or  use  the VARS
                              command  to  declare   "x"   as   a
                              variable if that is the case.

"x" DECLARE VARIABLE          As the system didn't  find  "x"  on
                              the  VARS list, it couldn't compute
                              the variable number.  Use  VARS  to
                              declare  variables.   (If  symbolic
                              variables  are  used,  "x"  doesn't
                              have  to  be  on the VARS list.  In
                              this case "x" wasn't known for some
                              other  reason.)  The  function that
                              uses the VARS list is GETVAR, which
                              is used in FOIN, SIMPI and FUNS.

"x" DEFINE DIFF FUNCTION      The expression  "x"  could  not  be
                              differentiated,    as   the   first
                              element   of   "x"   not   was   an
                              identifier  with  a  DFUN  or  EFUN
                              property.  If  you  define  such  a
                              property  (see examples in appendix
                              F.4) the system can continue.

"x" VARIABLE NAME?            The  variable  number  "x"   didn't
                              correspond   to  a  variable  name.
                              Because  of  this,  FPRT   couldn't
                              print  a  symbolic  derivative with
                              the prefix DF,  as  variables  then
                              must be represented by identifiers.
                              Use VARS to name the variables.



D.3  DIAGNOSTIC MESSAGES

NOT FOUND                     The  element   specified   in   the
                              preceding message "x" OUT OFF ORDER
                              was not found on a  file.   Message
                              is  given by (F)RDIN functions that
                              are used by L(F)READ.

SYMBOLIC AS GDET IS A SUM     See 14.3

DIAGNOSTIC AND ERROR MESSAGES                            Page D-5


SYMBOLIC AS ZDET IS A SUM     See 15.3

SYMMETRY ELEMENT              This message is given when a TENVAL
                              function is operating on a symmetry
                              element.   This  can  happen  if  a
                              single  component  is  specified as
                              argument to the TENVAL function  or
                              if  the  TENVAL function is AWRITE.
                              The message can be inhibited by the
                              switch NOSYMSG.

NO MEMORY ELEMENT "x"         A range of  tensor  components  has
                              been  specifed  as  argument  to  a
                              TENVAL   function.    This    range
                              doesn't contain any components that
                              are kept in the memory.  The reason
                              for   this  can  be  that  all  the
                              specified components are defined by
                              the  symmetry,  or  that  the upper
                              limit of the range  is  lower  than
                              the lower limit.
                              The TENVAL function will ignore the
                              range  and  continue  with its next
                              argument or end  if  there  was  no
                              more arguments.  If this happens in
                              a continuation function  (CONTINUE,
                              NEXT,  NEXTA  or  TOELM),  the  the
                              error CAN'T CONTINUE will occur.

"x" ALL FOUND ZERO            No non zero component  of  "x"  was
                              found,  in  the  range specified by
                              arguments  to  a   writing   TENVAL
                              function.   If  NOZERO  is on, this
                              means that no component is  written
                              but the message is given.

"x" ENDED                     A TENVAL  function  has  ended  its
                              operation  on the tensor "x".  (see
                              further 11.3)

"x" FOIN SYNTAX ERROR         See 8.1.4

"x" LOST                      All components of  the  tensor  "x"
                              have been deleted by LOSE.

"x" NO VALUE                  "x" has no value or  its  value  is
                              NIL.   Can happen when "x" is given
                              as argument to a TENVAL function.

"x" OLD                       "x"  has  been  re-declared,  as  a
                              function  by  FUNS  or as tensor by
                              DECLTEN.

"x" OUT OF ORDER              The element with specification  "x"
                              wasn't  found  on  a  file from the
                              previous file position to the  end,
                              but  it  might  be  out of order so

DIAGNOSTIC AND ERROR MESSAGES                            Page D-6


                              that it is  found  on  the  earlier
                              part  of  the file.  If TRYAGAIN is
                              on, the element is searched for  on
                              the  earlier  part of the file.  If
                              the element isn't found there or if
                              TRYAGAIN  is  off  then the message
                              NOT FOUND  is  given  and  NIL   is
                              returned.

"x" SYMMETRY ELEMENT          "x" is a symmetry element.  Message
                              is  given by T(NO)EX or when ALLMSG
                              is on, it is given instead  of  the
                              same message without "x".

"x" SYMMETRY ELEMENT
CAN'T SYMMETRIZE              An error occurred  when  evaluating
                              the   SYMF   expression   for   the
                              component "x".  The TENVAL function
                              that  was  operating  will complete
                              its operation on the tensor without
                              making  any  symmetry elements, but
                              it will act normally on  the  other
                              components.













                           APPENDIX E

                  FOIN CHARACTER INTERPRETATION



ASCII  char.   meaning to FOIN
-----  -----   ------- -- ----

3      ^C      Go to monitor.

7      ^G      (Bell) Go to top  (command)  level  of  SHEEP  (or
               LISP).

22     ^R      Types current input line.

24     ^T      Gives status information.

25     ^U      Delete current input line.

32     ^Z      Starts a comment ignored by FOIN, that  ends  with
               next line feed.

33     <alt>   (Escape on some terminals.) Ends input line.  Then
               similar to "$".

40     <sp>    Ends an identifier, else ignored.

41     !       Is not read, but makes FOIN read next character as
               if it was a letter.

43     #       Differentiate  with  respect  to  second  variable
               system.

44     $       End input to FOIN.  Don't PRT result.

45     %       Preceeds a comment which is terminated  either  by
               ";"  or  by  "<alt>".   Note  that the comment may
               include linefeed.

46     &       Differentiate preceding expression with respect to
               the following variable.

47     '       Unused by FOIN.  Quotes an  expression  to  (LISP)
               READ.

FOIN CHARACTER INTERPRETATION                            Page E-2


50     (       Begins a sub-expression.

51     )       Ends a sub-expression to same level as last "(".

52     *       If followed by "*", equivalent to "^",  otherwise,
               multiplication operator.

53     +       Addition operator.

54     ,       Delimits arguments to DFUN operators.

55     -       Subtraction.

56     .       First  the  effect  of  ";",  then  read   another
               expression and add it to the previous.

57     /       Inversion operator.

60-71          The  digits  0  -  9.   Parts   of   numbers   and
               identifiers.   Can  start  an identifier only when
               preceded by "!".

72     :       Read and EVALuate.  If the next char. is "'",  "("
               or  "[",  then  the reading is done by (LISP)READ,
               else by FOIN read.

73     ;       End  input,  print  it  with  PRT  and   ask   for
               confirmation.

74     <       Execute a user  defined  reading  expression  that
               should be placed as value of the identifier <

75     =       Used  only  in  the  combination  ":=",  which  is
               equivalent to "_".

76-100         Unused.

101-132        The  upper  case  letters  A  -  Z.    Builds   up
               identifiers.

133    [       Begins a sub expression.

134    \       Unused.

135    ]       Ends a sub expression to level of last "[".

136    ^       Exponentiation operator.

137    _       Assignment operator.

140            Unused.

141-172        The lower case letters a  -  z.   Are  allowed  in
               identifiers.

FOIN CHARACTER INTERPRETATION                            Page E-3


173-176        Unused.

177    <rub>   ("<del>" on some terminals.) Delete last character
               of input line.













                           APPENDIX F

               LISP DEFINITIONS OF SOME FUNCTIONS



The  following  LISP  functions  have  not  been  written  to  be
efficient,  only  to  correspond  as  closely  as possible to the
machine coded versions.  Some of the functions are found  in  the
system  as  EXPRs,  some  are  only  used  inside  SHEEP.  In the
following everything in lower shift is a comment.



F.1  SOME HELP ROUTINES

          SNUMP is a predicate that returns the argument if it is
a SHEEP number, otherwise it returns NIL.

<DE SNUMP (SXP) (COND
  (<OR (NUMBERP SXP) (AND (NOT (ATOM SXP)) (NUMBERP (CAR SXP>
   SXP>



          SATOM returns T if the argument is an identifier  or  a
SHEEP number, otherwise returns NIL.

<DE SATOM (SXP) (OR (ATOM SXP) (NUMBERP (CAR SXP>



          COPYL copies a SHEEP expression

<DE COPYL (SXP) (COND
  ((SATOM SXP) SXP)           Don't copy SHEEP atoms.
  ((CONS (CAR SXP) (COPYA (CDR SXP>     As SXP  not  is  a  SHEEP
                              atom it must be a list headed by an
                              atom, so don't copy (CAR SXP).

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-2
Some help routines


          COPYA copies a list also when the first  element  is  a
number.

<DE COPYA (AXP) (COND
  ((ATOM AXP) AXP)            If AXP is a LISP INUM it will cause
                              an  error  in  the version of COPYA
                              actually used  in  SHEEP,  as  that
                              version only test for a list headed
                              by -1.
  ((CONS (COPYL (CAR AXP)) (COPYA (CDR AXP>



          CNDR does CDR N times.

<DE CNDR (X N) (COND
  ((OR (ZEROP N) (NULL X)) X) Stop if NIL is reached.
  ((NOT (MINUSP N)) (CNDR (CDR X) (SUB1 N>        Return NIL if N
                              is negative.



          KAR1 returns N+1:st element of X.  Returns NIL if N  is
negative or if there are less than N+1 elements.

<DE KAR1 (X N) (COND ((SETQ X (CNDR X N)) (CAR X>



          MAPCSUB applyes FN on all but the first elements of X.

<DE MAPCSUB (X FN) (COND
  ((ATOM X) (ERRP X "NOT A LIST"))      X must be a list with  at
                              least one element.
  ((RPLACD X (MAPSUB (CDR X) FN>



          MAPSUB is the  same  as  MAPCAR,  except  for  that  it
replaces  the elements of its second argument instead of making a
new list.

<DE MAPSUB (X FN) (COND
  (X (PROG (A)
    (SETQ A X)
LOP <COND ((ATOM A) (ERRP A "NOT A LIST">
    <RPLACA A (FN (CAR A>
    <COND ((SETQ A (CDR A)) (GO LOP>
    (RETURN X>

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-3
Some help routines


          ERRP prints out an error message on the TTY.

<DE ERRP (EARG ERCOD) (PROGN
  (WRS NIL)                   Do output to TTY
  (PRIN1 EARG)                Print erroneous arg
  (PRIN2 ERCOD)               Print error message
  (TERPRI)
  (ERR>                       Error return



          MAP0T is the same as  MAPCSUB  except  for  that  MAP0T
stops and returns zero when an element becomes zero.  There is no
checking that the argument is correct.

<DE MAP0T (SXP FN) (PROG (A)
  (SETQ A SXP)
A <COND
   (<NULL (SETQ A (CDR A> (RETURN X))
   (<ZEROP (CAR (RPLACA A (FN (CAR A> (RETURN 0>
  (GO A>



          EFFACE deletes all occurrences of the  second  argument
from  the  first argument.  First argument must be a list with at
least one argument and it must end with NIL.  EFFACE uses EQ  and
not EQUAL to compare.

<DE EFFACE (L MASK) (COND
  (L (PROG (A B)
    (SETQ A L)
LOP <COND
     (<NULL (SETQ B (CDR A> (RETURN L))
     <(EQ (CAR B) MASK) (RPLACD A (CDR B>
     ((SETQ A B>
    (GO LOP>



          DEFPUT is a FEXPR with three arguments.  It is  similar
to  PUT  but  it  quotes it's arguments.  DEFUN is not defined in
SHEEP, it is only used in this appendix as a convenient method to
define PRT, EFUN and DFUN properties etc.

(DF DEFPUT (X) (PUT (CAR X) (CADR X) (CADDR X)))

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-4
THE SIMPLIFIER


F.2  THE SIMPLIFIER

          SIMP is the general simplifier.  It  is  controlled  by
several  switches.   When all of them are off SIMP is the same as
SIMP1.

<DE SIMP (SXP) (COND
  (NOSIMP SXP)                Do nothing if NOSIMP is on.
  (T (SIMPE (SIMP1 SXP>



          SIMPE  does  substitutions  and  calls  SIMP2  if   the
appropriate switches are on, otherwise it does nothing.

<DE SIMPE (SXP) (PROG (MCU)
  (SETQ SUBSTW NIL)           Turn off SUBSTW, it is turned on by
                              SUBL1 if anything substituted.
  <COND
   (SUBS
    (SETQ SXP (SUBL1 SXP SUBS>
  <COND
   (ESUBS                     If ESUBS is on,
    (SETQ SXP (SUBL1 SXP ESUL>          try to  substitute  using
                              the ESUL substitution list.
  <COND
   ((OR SUBSTW POTSIM)        If anything was substituted  or  if
                              POTSIM is on,
    (SETQ SXP (SIMP2 SXP>     call SIMP2.
  <COND ((NOT MSUBS) (RETURN SXP>       End if MSUBS is off.
  (SETQ MCU (SUBMTIMES NIL))  Initiate MCU to SUBMTIMES
A (SETQ SUBSTW NIL)
  (SETQ SXP (SUBL1 SXP MSUL)) Try to substitute  using  the  MSUL
                              substitution list.
  <COND
   ((NOT SUBSTW)              If nothing was substituted,
    (RETURN SXP>              end.
  (SETQ SXP (SIMP2 SXP))      Call SIMP2.
  <COND
   (<ZEROP (SETQ MCU (SUB1 MCU>         If  the  loop  has   been
                              passed more than SUBMTIMES times,
    (RETURN SXP>              end.
  (GO A>                      Try MSUBS substitutions again.



          SIMP1 is the basic simplification routine.

<DE SIMP1 (SXP) (COND
  <ALTSIMP (EDIT (EXPD (ZERM SXP>       Use EXPD and EDIT instead
                              of XED if ALTSIMP is on.
  ((EDIT (EXPD (ZERM SXP>

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-5
The simplifier


          XED simplifies sums before EXPanDing with  distributive
law.

<DE XED (SXP) (COND
  ((ATOM SXP) SXP)
  <(EQ (CAR SXP) '!&!+) (EDITPLUS (MAPCSUB SXP 'XED>
  <(EQ (CAR SXP) '!*) (EDIT (TEXPD (MAP0T SXP 'XED>
  (SXP>



          ZERM uses the rules for 0 and 1 in sums and products.

<DE ZERM (SXP) (COND
  ((SATOM SXP) SXP)
  <(EQ (CAR SXP) '!&!+) (RID0RT (MAPCSUB SXP 'ZERM> Apply ZERM on
                              terms of sum, then get rid of terms
                              equal to zero.
  ((NOT (EQ (CAR SXP) '!*) SXP)         Do nothing if it isn't  a
                              product.
  ((MEMQ 0 (CDR SXP)) 0)      Return 0 if any factor is 0.
  ((ZEROP (MAP0T SXP 'ZERM)) 0)         Apply ZERM on the factors
                              and return 0 if any of them becomes
                              0.
  ((RIDRT SXP 1>              Get rid of factors equal to 1.



          RIDRT gets rid of unnecessary elements in SXP.

<DE RIDRT (SXP MASK) (COND
  (<NULL (CDR (EFFACE SXP MASK> MASK)   No args left.
  ((CDDR SXP) SXP)            More than one arg.
  ((CADR SXP>                 Only one arg.



          RID0RT gets rid of zeros.

(DE RID0RT (SXP) (RIDRT SXP 0))

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-6
PRT, FPRT VALU AND PRT FUNCTIONS


F.3  PRT, FPRT VALU AND PRT FUNCTIONS

F.3.1  PRT And FPRT

          PRT writes an expression in multiple line format.

(DE PRT (SXP) (PRING SXP NIL))



          PRING writes an equality statement in PRT format.

<DE PRING (SXP SHD) (PROGN (SETQ FPRT NIL) (TIPRING SXP SHD>



          FPRT writes an expression in a format readable by  FOIN
and by REDUCE.

(DE FPRT (SXP) (FPRING SXP NIL))



          FPRING writes an assignment statement in FPRT format.

<DE FPRING (SXP SHD) (PROGN (SETQ FPRT T) (TIPRING SXP SHD>



          TIPRING is PRING or FPRING depending on  the  value  of
the identifier FPRT.

<DE TIPRING (SXP SHD) (COND
  (NOPRT SXP)                 Do nothing if the switch  NOPRT  is
                              on.
  (T (TIPRIGN (COPYL SXP) SHD) SXP>

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-7
PRT, FPRT VALU and PRT functions.


          TIPRIGN writes in a format  controlled  by  the  switch
FPRT.   If  "SHD"  is  NIL  then  it  writes  the expression SXP,
otherwise it writes SHD=SXP or SHD:=SXP depending on the value of
FPRT.  Both arguments may be changed by the writing process.
Writing is done in two steps:



     1.  VALU converts  a  SHEEP  expression  from  the  internal
         format to PRTL format.



     2.  PRTL writes all atoms on all levels in its argument.  On
         which  line  an  atom  is  placed  is  controlled by the
         identifiers // (UP) and /* (DOWN).  It also knows how to
         break lines in a nice way.

<DE TIPRIGN (SXP SHD) (PROGN
  <COND
   (PSUBS                     If the switch PSUBS is on,
    (SETQ SXP (SIMP2 (SUBL1 SXP PSUL>   do  substitutions,  using
                              the PSUL substitution list.
  (PRTL (COND
    <SHD (CONS (VALU SHD) (CONS (COND
        (FPRT " := ")
        (" = "))
       (VALU SXP>
    (T (VALU SXP>

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-8
PRT, FPRT VALU and PRT functions.


F.3.2  VALU

To know when to surround an expression with parenthesis and where
to put an exponent, VALU uses bit switches that are kept as value
of the identifier PRT.



          Set value of names of switches

(SETQ DIFPAR 1)               Surround with parenthesis  when  in
                              derivative.
(SETQ BASPAR 2)               Surround  with   parenthesis   when
                              basis of exponential.
(SETQ TIMPAR 4)               Surround with parenthesis  when  in
                              product.
(SETQ TRIGPAR 8)              Put an  exponent  between  function
                              and argument(s).
(SETQ TPXPAR 16.)             In TPS coefficient.



          SETPRT sets switches.

<DE SETPRT (X) (SETQ PRT (NUMVAL X>



          TSTPRT tests bit-switches and returns NIL  if  all  are
off.

<DE TSTPRT (X) (NOT (ZEROP (BOOLE 1 (FIX1A PRT) X>



          VALU  converts  a  SHEEP   expression   from   internal
representation to PRTL representation.

<DE VALU (SXP) (PROG (A)
  (SETPRT 0)                  This is the same as (SETQ PRT NIL).
  <RETURN (COND
    ((SETQ A (SNUMP SXP))     A SHEEP number.
     (VNUM A))
    ((ATOM SXP) (VATM SXP))   An identifier.
    ((SETQ A (GET (CAR SXP) 'PRT))      If   there   is   a   PRT
                              function,
     (A SXP))                 use it,
    ((VTRIG (MAPCSUB SXP 'VALU>         else use default.

LISP DEFINITIONS OF SOME FUNCTIONS                       Page F-9
PRT, FPRT VALU and PRT functions.


          VATM exchanges  an  identifier  for  its  NAM  or  NAMF
property   if   it   got  the  property,  otherwise  returns  the
identifier.

<DE VATM (ATM) (PROG (A)
B <COND
   (<NULL (SETQ A
      (GET ATM (COND          Search for
       (FPRT 'NAMF)           NAMF or
       ('NAM>                 NAM property.
    (RETURN ATM))             Return identifier if no property.
    (<NUMBERP (SETQ PRT (CDR A>         CDR of property value  is
                              either NIL or a number.
     (SETPRT PRT>             Set bit switches.
  (RETURN (CAR A>             Return CAR of property value.



          VNUM gets minus signs in numbers and  "/"  in  rational
numbers

<DE VNUM (NUM) (PROG (A)
  (SETPRT (PLUS DIFPAR BASPAR))
  <COND
   <(NUMBERP NUM) (RETURN (COND
      <(MINUSP NUM) (CONS '!- (MINUS NUM>
      (NUM>
   (RATPAR (SETPRT (PLUS DIFPAR BASPAR TIMPAR>
  <SETQ A (CONS '!/ (CDR NUM>
  (RETURN (COND
    <<MINUSP (SETQ NUM (CAR A> (CONS '!- (CONS (MINUS NUM) A>
    ((CONS NUM A>



          VTRIG is the default PRT function.  It puts parenthesis
around arguments, and puts a "," between multiple arguments.

<DE VTRIG (VXP) (PROGN
  (SETPRT (PLUS DIFPAR TRIGPAR))
  (RPLACD VXP (ATPAR (MAPCSUB (CDR VXP) 'ATCOM>



          ATPAR puts parenthesis around VXP.

<DE ATPAR (VXP) (CONS (CONS '!( VXP) '!)>



          ATCOM puts a "," before VXP

(DE ATCOM (VXP) (CONS '!, VXP))

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-10
PRT, FPRT VALU and PRT functions.


          DASHP  returns  T  if  VXP  begins  with  a  "-",   NIL
otherwise.

<DE DASHP (VXP) (AND (NOT (ATOM VXP)) (EQ (CAR VXP) '!->



          ATPLQ puts a "+" before VXP, if VXP doesn't begin  with
a "-".

<DE ATPLQ (VXP) (COND
  ((DASHP VXP) VXP)
  ((CONS '!+ VXP>



          The PRT function for sums.

<DEFPUT !&!+ PRT
 (LAMBDA (SXP) (COND
   (<NULL (SETQ SXP (MAPSUB (CDR SXP) 'VALU>      If empty sum,
    (VNUM 0))                 return zero.
   ((NULL (CDR SXP))          If only one term,
    (CAR SXP))                return term and keep  bit  switches
                              in  PRT  as  they  where set by the
                              call to VALU for the term.
   ((SETPRT (PLUS DIFPAR BASPAR TIMPAR))
    (MAPCSUB SXP 'ATPLQ>      Put a "+" between  the  terms  that
                              haven't got a "-" between them.



          SGNQ gets VALU for a factor in a product.

<DE SGNQ (VXP) (PROGN
  <COND
   (<DASHP (SETQ VXP          If factor begins with a minus sign,
      (VALU VXP>
    (SETQ SGN (NOT SGN))      change sign indicator
    (SETQ VXP (CDR VXP>       and delete sign.
  (COND
   ((TSTPRT TIMPAR)           If the TIMPAR bit switch is on,
    (ATPAR VXP))              surround factor with parenthesis.
   (VXP>

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-11
PRT, FPRT VALU and PRT functions.


          The PRT function for products.

<DEFPUT !* PRT
 (LAMBDA (SXP) (PROG (SGN A)
   (SETQ A (MAPCSUB SXP 'SGNQ))
   (SETQ SXP (RIDRT A 1))     Get rid of 1 in product.
   <COND
    ((NOT (EQ SXP A))         If not a product any more,
     (GO NP>                  go to NP.
   (SETQ SXP (CDR SXP))       Get rid of * in front.
   <COND
    ((OR FPRT CHINPRO)        If FPRT is on or if CHINPRO  has  a
                              non NIL value,
     (MAPCSUB SXP 'INPRO>     Put a separator between factors.
NP (SETPRT (PLUS DIFPAR BASPAR))
   (RETURN (COND
    (SGN (CONS '!- SXP))      SGN is changed by SGNQ.
    (SXP>



          INPRO puts a "*" or the value of CHINPRO  in  front  of
VXP, depending on if FPRT is on or off.

<DE INPRO (VXP) (CONS
  (COND
   (FPRT '!*)
   (CHINPRO))
  VXP>



          VDIFO exchanges a variable number with a variable name.

<DE VDIFO (DXP) (COND
  ((NUMBERP DXP) (KAR1 (EVAL DIFF) DXP))
  (DXP>



          PRTEN is the PRT function that all tensors get  by  the
tensor declaration function DECLTEN.  Its operation is controlled
by the properties UPINDX and  TNSPCH  that  tensors  might  have.
This  function  will  probably  be  slightly  changed in a future
version of SHEEP, in order  to  give  tetrad  indices  a  special
treatment.

<DE PRTEN (SXP) (COND
  <(NOT FPRT) (PROG (A B INDX LINE UPINDX TNSPCH)
    (SETQ INDX (SETQ LINE 0)) Index count and line indicator.
    (SETQ B (CAR SXP))        Name of tensor
    <COND (PTEVAR (MAPCSUB SXP 'VDIFO>  Replace index number with
                              variable name if PTEVAR is on.
    (MAPSUB SXP 'VALU)        Do NAM  substitutions  by  applying
                              VALU on tensor name and indices.
    <COND (<NULL (SETQ A (CDR  SXP>  (RETURN  (CAR  SXP>  End  if

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-12
PRT, FPRT VALU and PRT functions.


                              tensor is a scalar.
    (SETPRT BASPAR)           Note!  DIFPAR is not set.
    (SETQ UPINDX (GET B 'UPINDX))       Get    list    of     the
                              contravariant    indices   of   the
                              tensor.
    (SETQ TNSPCH (GET B 'TNSPCH))       Get association  list  of
                              inserted characters for the tensor.
    <COND
     ((SETQ B (SASSOC TNSPCH INDX))     If there is  a  character
                              for the (nonexsitent) 0:th index,
      (RPLACA A (CONS (CDR B) (CAR A>   put it before  the  first
                              index.
LOP (SETQ INDX (ADD1 INDX))   Next index.
    <SETQ B (COND
      <(SETQ B (SASSOC TNSPCH INDX))    If there is  a  character
                              for the index,
       (CONS (CAR A) (CDR B>  put it behind the index.
      ((CAR A>                else, just get the index.
    <COND ((MEMQ INDX UPINDX) (GO IUP>  If  contravariant  index,
                              go get upper line.
Index is covariant.  Get lower line.
DLP <COND ((MINUSP LINE) (GO ENQ>       Go  for  next  index   if
                              lower line.
    (SETQ LINE (SUB1 LINE))   Down one line.
    (SETQ B (CONS DOWN B))    Put in control identifier for PRTL.
    (GO DLP)                  Try again.
Contravariant index.  Get upper line.
ULP (SETQ LINE (ADD1 LINE))   Up one line.
    (SETQ B (CONS UP B))      Put in control identifier for PRTL.
IUP <COND ((LESSP LINE 1) (GO ULP>      If not upper line, go up.
ENQ (RPLACA A B)              Put     back      into      element
                              specification.
    <COND ((SETQ A (CDR A)) (GO LOP>    If more indices, go lop.
    (RETURN (COND
      ((ZEROP LINE) SXP)      Middle line.
      ((MINUSP LINE) (CONS SXP UP))     Was lower line.  Go up.
      ((CONS SXP DOWN>        Was upper line.  Go down.
The switch FPRT was on.
  ((OR NOFARY TPS) SXP)       If NOFARY is on, or  if  TPS  isn't
                              NIL, then a component specification
                              is output as an identifier.
  ((VTRIG (MAPSUB SXP 'VALU>  Output a component specification as
                              an array element.



F.4  DIFF AND EFUN, DFUN FUNCTIONS

          DIFF differentiates SXP  with  respect  to  the  VNU:th
variable in the VT set of variables.

<DE DIFF (SXP VNU VT) (PROG (A B)
  <COND
   ((SNUMP SXP) (RETURN 0))   A number.
   ((ATOM SXP) (GO B>         An identifier
A <COND

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-13
DIFF and EFUN, DFUN functions


   <(SETQ A (GET (CAR SXP) 'DFUN))      If it is a DFUN,
    (RETURN (A SXP VNU VT>    apply it.
   <(SETQ A (GET (CAR SXP) 'EFUN))      If it is an EFUN:
    (RETURN (COND
      (<ZEROP (SETQ B (DIFF (COPYL (CAR SXP)) VNU VT> 0)
                              Differentiate the argument.  Return
                              it if it is zero.
      ((MKTIMS B (A SXP>      Apply the EFUN  and  multiply  with
                              the derivative.
   ((SETQ A (EASK SXP "DEFINE DIFF  FUNCTION"))  (RETURN  A>  Not
                              EFUN  or  DFUN.  Give a message and
                              read  a  declaration.   If   direct
                              input return that,
  (GO A)                      else try again.
B <COND
   <(SETQ A (KAR1 (GET SXP VT) VNU)) (RETURN (COPYL  A>  Get  the
                              derivative  from  the property list
                              of the identifier.
   ((SETQ A (EASK SXP "DECLARE FUNCTION"))  (RETURN  A>  Did  not
                              find   the   derivative.    Give  a
                              message and read a declaration.  If
                              direct input return that,
  (GO B>                      else try again.



          EASK prints an error message on the TTY and reads  from
the TTY.

<DE EASK (ERO ERCOD) (PROG (A B)
A (SETQ A (WRS NIL))          Force output to go to the TTY.
  (TERPRI)
  (PRIN1 ERO)                 Print the offending S-expression.
  (PRIN2 ERCOD)               Print the error message.
  (TERPRI)
  (PRIN2 "NOW")
  (WRS A)                     Get back old output channel.
  (SETQ A (RDS NIL))          Force input to come from the TTY.
  (SETQ B
   (ERRSET (EVAL (READ)) T))  Read and evaluate an S-expression.
  <COND ((ATOM B) (RDS A) (GO A>        If an error occurred, get
                              back  old  input  channel  and  try
                              again.
  <SETQ B (COND
    ((EQ (CAR B) 'FOINP) (FOINP NIL>    If      direct      input
                              indicated,  read  direct input with
                              FOIN.
  (RDS A)                     Get back old input channel.
  (RETURN B>                  Return NIL or the direct input.



          ODIF differentiates a term in a sum.

(DE ODIF (SXP) (DIFF SXP VNU Vt))

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-14
DIFF and EFUN, DFUN functions


          &+ is a DFUN.  Differentiate each term in the  sum  and
get rid of zeros afterwards.

<DEFPUT !&!+ DFUN (LAMBDA  (SXP  VNU  VT)  (RID0RT  (MAPCSUB  SXP
'ODIF>



          TDIF differentiates a factor in a product.

<DE TDIF (CLM) (PROG (A B)
  (SETQ CLM (DIFF CLM VNU VT))          Differentiate the factor.
  (SETQ A (CDR OLM))
  <COND
   ((ZEROP CLM)               If derivative is zero,
    (SETQ OLM A)              update factor pointer
    (RETURN 0>                and return zero.
  (RPLACD OLM (CDR A))        Delete factor from product and
  (SETQ B (COPYL SXP))        get a copy of the rest.
  (RPLACD OLM A)              Put back factor into product.
  (SETQ OLM A)                Update factor pointer.
  (RETURN (RPLACD B (CONS CLM (CDR B>   Place the  derivative  in
                              the beginning of the product.



          * is a DFUN.  Differentiate a product.

<DEFPUT !* DFUN
 (LAMBDA (SXP VNU VT) (PROG (OLM)
   (SETQ OLM SXP)             Initiate the factor pointer.
   (RETURN (RID0RT (MAPCSUB (RPLACA (COPYL SXP) '!&!+) 'TDIF>



          SIN is an EFUN.  (SIN X)' = (COS X)

(DEFPUT SIN EFUN (LAMBDA (SXP) (RPLACA SXP 'COS)))



          TAN is an EFUN.  (TAN X)' = (TAN X)^2 + 1

(DEFPUT TAN EFUN (LAMBDA (SXP) (MKPLUS (LIST EXPT SXP 2) 1)))



F.5  CORD TENSORS

To define the CORD tensors do the following

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-15
CORD TENSORS


          *DIM is used in contractions

(SETQ !*DIM (SEQ0L DIM))



F.5.1  Symmetry Functions

          SYDIAG makes off diagonal components zero  if  DIAGONAL
is  on.   It  returns  zero  if  INDX1  is not equal to INDX2 and
returns NIL (indicating that the component must be  computed)  if
INDX1 is equal to INDX2.

<DE SYDIAG () (COND
  (<AND DIAGONAL (NOT (EQ INDX1 INDX2> 0)
  (T NIL>



          SYRIE takes care of the 21:st component of the  Riemann
tensor.

<DE SYRIE () (COND
  <(AND                       If
    (LESSP INDX1 INDX3)       INDX1 < INDX3 and
    (GREATERP INDX2 INDX4))   INDX2 > INDX4,
   (COND                      then if
    (NOSYSW 0)                NOSYSW is on return 0  to  indicate
                              that it is a symmetry component,
    ((PLUSIM                  else return the component computed
      (DOCOPY (RIE INDX1 INDX4 INDX3 INDX2))      from earlier
      (DOCOPY (RIE INDX1 INDX3 INDX2 INDX4> components.
  (T NIL>                     Else return  NIL  to  indicate  not
                              symmetry component.



F.5.2  Tensor Definitions

          Define the covariant metric tensor GDD.

(DECLTEN GDD S G)

(DEFPUT GDD SYMF (SYDIAG))



          Define GDF, the derivative of GDD.

(DECLTEN GDF SD G)

(DEFPUT GDF SYMF (SYDIAG))

(DEFPUT GDF BULF (SIMP (SDIFF (GDD INDX1 INDX2) INDX3)))

(PREQ GDF GDD)

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-16
CORD TENSORS


(DEFPUT GDF TNSPCH ((2 . !,)))          Insert "," between second
                              and third index.



          GAM is the Cristoffel symbol of the first kind.

(DECLTEN GAM DS)

<DEFPUT GAM BULF
 (SIMP (MKTIMS '(1 . 2) (MKSUM
    (DOCOPY (GDF INDX1 INDX2 INDX3))
    (DOCOPY (GDF INDX1 INDX3 INDX2))
    (EDITM (DOCOPY (GDF INDX2 INDX3 INDX1>

(PREQ GAM GDF)



          GDET determinant of GDD.

(DECLTEN GDET SCL)

(DEFPUT GDET BULF (SIMP (DET 'GDD)))

(PREQ GDET GDD)



          GINV = 1/GDET

(DECLTEN GINV SCL)

(NAM GINV)
1/G$

(DEFPUT GINV BULF
 (SIMPE (SMEXPT
   <COND
    (<OR NODGNV (ATOM GDET) (NOT  (EQ  '!&!+  (CAR  GDET>  (COPYL
GDET))
    (T (KEEP GDET) (PRIN2 "GDET SYMBOLIC AS IT IS A SUM") 'GDET>
   -1)))

(PREQ GDET)



          Contravariant metric GUU.

(DECLTEN GUU S G)

(DEFPUT GUU SYMF (SYDIAG))

<DEFPUT GUU BULF (SIMP (COFAC 'GDD INDX2 GINV>

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-17
CORD TENSORS


(PREQ GUU GDD GINV)

(DEFPUT GUU DELK (GDET))      Delete GDET before making GUU.

(DEFPUT GUU UPINDX (1 2))     First  and   second   indices   are
                              contravariant.



          GAMU is the Cristoffel symbol of the second kind.

(DECLTEN GAMU DS GAM)

<DEFPUT GAMU BULF
 (SIMP (CONS '!&!+ (MAPCAR
    '!*DIM
    (FUNCTION (LAMBDA (CINX)
      (DOMULC (GUU INDX1 CINX) (GAM CINX INDX2 INDX3>

(PREQ GAMU GUU GAM)

(DEFPUT GAMU DELK (GDF GINV))

(DEFPUT GAMU UPINDX (1))      First index is contravariant.



          Define Riemann tensor RIE with four covariant indices.

(DECLTEN RIE R R)

(DEFPUT RIE SYMF (SYRIE))

<DEFPUT RIE BULF
 (SIMP (MKPLUS
   <MKPLUS
    (SDIFF (GAM INDX1 INDX2 INDX4) INDX3)
    (EDITM (SDIFF (GAM INDX1 INDX2 INDX3) INDX4>
   (RID0RT (CONS '!&!+ (MAPCAR
      '!*DIM
      (FUNCTION (LAMBDA (CINX) (MKPLUS
         (DOMULC (GAM CINX INDX1 INDX3) (GAMU CINX INDX2 INDX4))
         (EDITM (DOMULC
           (GAM CINX INDX1 INDX4)
           (GAMU CINX INDX2 INDX3>

(PREQ RIE GAMU GAM)



          The covariant Ricci tensor RIC.

(DECLTEN RIC S R)


LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-18
CORD TENSORS


<DEFPUT RIC BULF
 (SIMP (CONS '!&!+ (MAPCAR
    '!*DIM
    (FUNCTION (LAMBDA (CINX1)
      (RID0RT (CONS '!&!+ (MAPCAR
         '!*DIM
         (FUNCTION (LAMBDA (CINX2) (DOMULC
            (GUU CINX1 CINX2)
            (RIE INDX1 CINX1 INDX2 CINX2>

(PREQ RIC GUU RIE)

(DEFPUT RIC DELK (GAM GAMU))



          RICM is the Ricci tensor with mixed indices.

(DECLTEN RICM DD R)

<DEFPUT RICM BULF
 (SIMP (CONS '!&!+ (MAPCAR
    '!*DIM
    (FUNCTION (LAMBDA (CINX)
      (DOMULC (GUU INDX1 CINX) (RIC CINX INDX2>

(PREQ GUU RIC)

(DEFPROP RICM (RIE) DELK)

(DEFPROP RICM (1) UPINDX)



          The curvature scalar RSCL.

(DECLTEN RSCL SCL R)

(DEFPUT RSCL BULF (BURSCL))

The default algorithm that generates the  curvature  scalar  from
the mixed Ricci tensor.
<DE BURSCL () (SIMP (CONS '!&!+ (MAPCAR
    '!*DIM
    (FUNCTION (LAMBDA (CINX) (DOCOPY (RICM CINX CINX>


LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-19
CORD TENSORS


The algorithm that is used when the command (NORICM T)  has  been
issued.
<DE BURSC1 () (SIMP (CONS '!&!+ (MAPCAR
    '!*DIM
    (FUNCTION (LAMBDA (CINX1)
      (RID0RT (CONS '!&!+ (MAPCAR
         '!*DIM
         (FUNCTION (LAMBDA (CINX2) (COND
            <(EQ CINX1 CINX2) (DOCOPY (RIC CINX1 CINX2>
            ((GREATERP CINX1 CINX2) 0)
            (T (MKTIMS 2 (DOCOPY (RIC CINX1 CINX2>

(PREQ RSCL RICM)              Default.

(DEFPUT RSCL DELK (RIE))



          EIN the covariant Einstein tensor.

(DECLTEN EIN S T)

<DEFPUT EIN BULF
 (SIMP (MKPLUS
   (DOCOPY (RIC INDX1 INDX2))
   (MKTIMS (-1 . 2) (DOMULC RSCL (GDD INDX1 INDX2>

(PREQ EIN GDD RIC RSCL)



          EINM the mixed Einstein tensor.

(DECLTEN EINM DD T)

(DEFPUT EINM BULF (BUEINM))

The default algorithm calculates EINM from RICM and RSCL.
<DE BUEINM () (SIMP (COND
   <(EQ INDX1 INDX2) (MKPLUS
     (DOCOPY (RICM INDX1 INDX2))
     (MKTIMS '(-1 . 2) (DOCOPY RSCL>
   (T (DOCOPY (RICM INDX1 INDX2>

If the command (NORICM T)  has  been  issued,  generate  EINM  by
raising first indx of EIN.
<DE BUEIN1 () (SIMP (CONS '!&!+ (MAPCAR
    '!*DIM
    (FUNCTION (LAMBDA (CINX)
      (DOMULC (GUU INDX1 CINX) (EIN CINX INDX2>

(PREQ EINM RICM RSCL)         Default.

(DEFPUT EINM DELK (RIC))

(DEFPUT EINM UPINDX (1))

LISP DEFINITIONS OF SOME FUNCTIONS                      Page F-20
CORD TENSORS


          This ends the definition  of  the  tensors  defined  in
CORD.  Other tensors can be defined in a similar manner.



F.5.3  The Weyl Tensor

If truncated power series are to be used, then the calculation of
WEYL  must  be  done  in two steps, in order to avoid multiplying
more than two possible TPS at a time.

First calculate ASG, the antisymetric  product  of  GDD  with  it
self.

(DECLTEN ASG R)

<DEFPUT ASG BULF
 (SIMP (MKPLUS
   (DOMULC (GDD INDX1 INDX3) (GDD INDX2 INDX4))
   (EDITM (DOMULC (GDD INDX1 INDX4) (GDD INDX2 INDX3>

(PREQ ASG GDD)



          Now define the WEYL tensor.

(DECLTEN WEYL R C)

(DEFPUT WEYL SYMF (SYRIE))

<DEFPUT WEYL BULF
 (SIMP (MKPLUS
   <MKPLUS
    (RIE INDX1 INDX2 INDX3 INDX4)
    (MKTIMS (1 . 6) (DOMULC (ASG INDX1 INDX2 INDX3 INDX4) RSCL>
   (MKTIMS (-1 . 2) (MKPLUS
     <MKPLUS
      (DOMULC (GDD INDX1 INDX3) (RIC INDX2 INDX4))
      (EDITM (DOMULC (GDD INDX1 INDX4) (RIC INDX2 INDX3>
     (MKPLUS
      (DOMULC (GDD INDX2 INDX4) (RIC INDX1 INDX3))
      (EDITM (DOMULC (GDD INDX2 INDX3) (RIC INDX1 INDX4>

(PREQ WEYL GDD RIE RIC ASG RSCL)

(REMPROP 'RICM 'DELK)         Inhibit the automatic

(REMPROP 'RSCL 'DELK)         deletion of RIE that is  done  when
                              making RSCL or RICM.













                           APPENDIX G

                        INSTALLING SHEEP





                              NOTE

               The meaning of the device SYS:  for
               SLISP (and SHEEP) can be changed by
               the user.  This can  be  done  when
               starting  the  LISP  system  if one
               answers the question Alloc?   by  Y
               and then answers the question SYS:.
               The default value for SYS:  is RED:
               (directory  <REDUCE>  for the TENEX
               version).  It is also  possible  to
               change  the  meaning  of SYS:  with
               the function SETSYS, c.f. the  LISP
               manual.
               Defining the device RED:   for  the
               monitor  can always be done, but it
               might be more  or  less  easy  with
               different monitors.  In the rest of
               this  appendix,  when  we  talk  of
               device RED:  we mean the device (or
               directory)  that  SLISP  takes   as
               SYS:.


To install SHEEP on a DEC SYSTEM  10  or  20,  do  the  following
(these  instructions have not been fully tested under TOPS-20 and
hardly at all under TENEX):



     1.  Install Standard Lisp from files supplied on tape.
         For a running  system  one  needs  (on  DSK:   or  SYS:)
         SLISP.EXE.   One  further  needs on RED:  the following:
         LISP.SYM, LISP.LOD,  FEND.SL,  FEND.FSL  and  FLOAD.FSL.
         The files FEND.SL, FEND.FSL and FLOAD.FSL are taken from
         the tape.
         For TOPS-10 the other  files  (SLISP.EXE,  LISP.SYM  och
         LISP.LOD)  can also be taken from the tape.  For TOPS-20
         and TENEX, recompiling is necessary.  This is done  from
         the   files   LISP.MAC,  LOADER.MAC  and  SYMMAK.REL  or

INSTALLING SHEEP                                         Page G-2



         SYMMAK.MAC.  The necessary compilation commands  can  be
         found   in   LSPUP.BLD.    Before   this   is  used  the
         assemblerswitches OPSYS in page 2 of LISP.MAC and  TENEX
         in  page  1 of LOADER.MAC must be set to the appropriate
         value.
         It might not be possible in older versions of TOPS-10 to
         have BPS in high core.  In that case, one can generate a
         version of LISP with BPS in low core by turning off  the
         assemblerswitch  HCBPS  in  LISP.MAC  and LOADER.MAC and
         then recompile with the commands in LSPUP.MIC.



     2.  To generate SHEEP it is necessary to have PUTSYM.SL  and
         DSKIN.FSL on RED:.  The rest of the files with extension
         FSL in saveset LISPUSE are  useful  but  not  absolutely
         necessary.  They are described in the file SLISP.HLP and
         HELP.HLP.  Files with extensions FSL or HLP should  also
         be on RED:.



     3.  Now compile SHEEP.  If you want another  dimension  than
         4,  first  change DIM in KONST.MAC.  It is also possible
         to implement complex number algorithms by  changing  the
         switch  CPLX  in LAM.MAC, but this is not recommended as
         it will lead to a limit on the  size  of  integers  (see
         chapter   4).    For  the  compilation  SHPCOM.MIC  (for
         TOPS-10) or SHPCOM.BLD (for TOPS-20 and  TENEX)  can  be
         used.



     4.  To build SHEEP, then use the MIC SHPUP.MIC  for  TOPS-10
         or CORD.BLD and FRAME.BLD for TOPS-20 or TENEX.














                           APPENDIX H

                      GETTING MORE STORAGE



If you run out of storage MCORE is useful.



(MCORE n)      Gets n K of  additional  core  and  allocates  it.
               MCORE  is  a  EXPR  with  one argument.  It can be
               defined as:
                    <DE MCORE (N) (CORE (*PLUS (CORE -1) N>
The allocation of additional core is controlled by  the  function
SETEX.   For a description of the different areas in LISP see the
LISP manual section 2.9.



(SETEX k l m)  SETEX is an FEXPR with 0 to 3 arguments.  When you
               execute   START   from   the   monitor,  then  all
               additional core is allocated as follows:
                    2^(-k) for full words
                    2^(-l) for REG. PDL
                    2^(-m) for SPEC. PDL
               the remainder to free storage and bit tables.
               the usual LISP allocation is thus equivalent to
                                 (SETEX 2 6 6)
               As SHEEP use few full words and little SPEC.  PDL,
               the default for SHEEP is
                                (SETEX 36 6 36)
               which means that no extra core goes to full  words
               or  SPEC.  PDL  and 1/64 goes to REG. PDL, so that
               almost everything goes to  free  storage  and  bit
               tables.
               The value of SETEX  is  the  old  setting  of  the
               allocations.   SETEX  only change those values for
               which it gets a numeric argument.   If  the  parts
               add up to more than 1/2, the error
                                    TO MUCH
               occurs, and nothing is changed.



You should never need more BPS if you run under TOPS-20 or TENEX,
but  if you run under TOPS-10, you can use the function EXCORE to
get more BPS.  The LISP manual describes EXCORE.

                                                     Page Index-1



                              INDEX




&+ . . . . . . . . . . . . . . . F-14

*  . . . . . . . . . . . . . . . F-11, F-14

ALL  . . . . . . . . . . . . . . 3-1, 6-2, 7-2 to 7-3, 11-1
ALLMSG . . . . . . . . . . . . . 11-7
ALTSIMP  . . . . . . . . . . . . F-4
APZ  . . . . . . . . . . . . . . 15-2
ASD  . . . . . . . . . . . . . . 15-1
ATCOM  . . . . . . . . . . . . . F-9
ATPAR  . . . . . . . . . . . . . F-9
ATPLQ  . . . . . . . . . . . . . F-10

BULF . . . . . . . . . . . . . . 10-1 to 10-2, 11-3

CHINPRO  . . . . . . . . . . . . 9-2, F-11
CHNDIF . . . . . . . . . . . . . 7-5
CNDR . . . . . . . . . . . . . . F-2
CONTINUE . . . . . . . . . . . . 11-7
COPYA  . . . . . . . . . . . . . F-2
COPYL  . . . . . . . . . . . . . 4-3, F-1
CTEN . . . . . . . . . . . . . . 11-9

DASHP  . . . . . . . . . . . . . F-10
DECLTEN  . . . . . . . . . . . . 10-3
DEFA . . . . . . . . . . . . . . 11-2, 11-9
DEFPUT . . . . . . . . . . . . . F-3
DELK . . . . . . . . . . . . . . 10-2, 11-3
DEP  . . . . . . . . . . . . . . 10-2
DF . . . . . . . . . . . . . . . 8-2
DFUN . . . . . . . . . . . . . . 8-2, 10-2
DIAGONAL . . . . . . . . . . . . 10-1, 11-8
DIFF . . . . . . . . . . . . . . 7-1 to 7-3, 7-5, F-12
DIFFORDER  . . . . . . . . . . . 3-2, 6-3
DOCOPY . . . . . . . . . . . . . 4-3
DOMAKE . . . . . . . . . . . . . 11-3, 11-5
DOMULC . . . . . . . . . . . . . 4-3
DSKIN  . . . . . . . . . . . . . 12-2

EDIT . . . . . . . . . . . . . . 5-2, F-4
EDITM  . . . . . . . . . . . . . 4-4
EFFACE . . . . . . . . . . . . . F-3
EFUN . . . . . . . . . . . . . . 8-2
EIN  . . . . . . . . . . . . . . 14-2, 15-2, F-19
EINM . . . . . . . . . . . . . . 14-2, 15-2 to 15-3, F-19
Element  . . . . . . . . . . . . 11-1
ERRP . . . . . . . . . . . . . . F-3
ESUBS  . . . . . . . . . . . . . 5-1, 6-1, 11-3, F-4
ESUL . . . . . . . . . . . . . . 5-1, 6-1, F-4
EXPANDLIM  . . . . . . . . . . . 3-2, 5-3
EXPD . . . . . . . . . . . . . . 5-2, F-4

EXPR . . . . . . . . . . . . . . 1-3

FEXPR  . . . . . . . . . . . . . 1-3
FIN  . . . . . . . . . . . . . . 12-1
FITIN  . . . . . . . . . . . . . 9-2
FOIN . . . . . . . . . . . . . . 8-1, 11-3
FOIN format  . . . . . . . . . . 9-1
FOUT . . . . . . . . . . . . . . 11-6, 12-1
FPRING . . . . . . . . . . . . . F-6
FPRT . . . . . . . . . . . . . . 9-2, 11-5, F-6
FROM . . . . . . . . . . . . . . 11-2
FUNS . . . . . . . . . . . . . . 7-1 to 7-2

GAM  . . . . . . . . . . . . . . 14-1, 15-2, F-16
GAMU . . . . . . . . . . . . . . 14-1, F-17
GDD  . . . . . . . . . . . . . . 14-1, 15-1, F-15
GDET . . . . . . . . . . . . . . 14-1, F-16
GDF  . . . . . . . . . . . . . . 14-1, F-15
GINV . . . . . . . . . . . . . . 14-1, F-16
GUU  . . . . . . . . . . . . . . 14-1, 15-2, F-16

HDD  . . . . . . . . . . . . . . 15-1
HINV . . . . . . . . . . . . . . 15-1
HNULL  . . . . . . . . . . . . . 15-3
HUU  . . . . . . . . . . . . . . 15-1

INDX1  . . . . . . . . . . . . . 11-9
INDX2  . . . . . . . . . . . . . 11-10
INDX3  . . . . . . . . . . . . . 11-10
INDX4  . . . . . . . . . . . . . 11-10
INDX5  . . . . . . . . . . . . . 11-10
INF  . . . . . . . . . . . . . . 12-2

KAR1 . . . . . . . . . . . . . . F-2
KEEP . . . . . . . . . . . . . . 11-3, 11-9

LAPLY  . . . . . . . . . . . . . 11-3
LAST . . . . . . . . . . . . . . 6-2
LASUB  . . . . . . . . . . . . . 6-2
LFPRT  . . . . . . . . . . . . . 11-5
LFREAD . . . . . . . . . . . . . 11-6
LIE  . . . . . . . . . . . . . . 15-2
LINESPERPAGE . . . . . . . . . . 3-2
LINIT  . . . . . . . . . . . . . 11-6
LISP . . . . . . . . . . . . . . 1-3
LORENTZ  . . . . . . . . . . . . 15-3
LOSE . . . . . . . . . . . . . . 11-4, 11-10
LPRINT . . . . . . . . . . . . . 11-5
LPTWRITE . . . . . . . . . . . . 12-2
LREAD  . . . . . . . . . . . . . 11-5
LSIMP  . . . . . . . . . . . . . 11-3
LSTAT  . . . . . . . . . . . . . 11-4, 11-10
LTEN . . . . . . . . . . . . . . 11-2, 11-9

MAKE . . . . . . . . . . . . . . 11-3
MAP0T  . . . . . . . . . . . . . F-3
MAPCSUB  . . . . . . . . . . . . F-2
MAPSUB . . . . . . . . . . . . . F-2
MCORE  . . . . . . . . . . . . . H-1
MKPLUS . . . . . . . . . . . . . 4-3

MKTIMS . . . . . . . . . . . . . 4-3
MSUBS  . . . . . . . . . . . . . 5-2, 6-1, 11-3, F-4
MSUL . . . . . . . . . . . . . . 5-2, 6-1, F-4

NAM  . . . . . . . . . . . . . . 9-2, F-9
NAMF . . . . . . . . . . . . . . 9-2, F-9
NEXT . . . . . . . . . . . . . . 11-8
NEXTA  . . . . . . . . . . . . . 11-8
NOASCOP  . . . . . . . . . . . . 11-7, 11-9
NOFARY . . . . . . . . . . . . . 11-5, F-12
NOMSG  . . . . . . . . . . . . . 11-7
NOOFIT . . . . . . . . . . . . . 9-1
NOPREQ . . . . . . . . . . . . . 11-3
NORICM . . . . . . . . . . . . . 14-2, 15-2
NOSIMP . . . . . . . . . . . . . 5-1
NOSYMSG  . . . . . . . . . . . . D-5
NOTKEEP  . . . . . . . . . . . . 11-9
NOTPRIN  . . . . . . . . . . . . 11-8
NOZERO . . . . . . . . . . . . . 11-3
NULLT  . . . . . . . . . . . . . 15-4

OFF  . . . . . . . . . . . . . . 3-1
ON . . . . . . . . . . . . . . . 3-1
OUTF . . . . . . . . . . . . . . 12-2

PARDEEP  . . . . . . . . . . . . 3-2
PLUSIM . . . . . . . . . . . . . 4-3
POTSIM . . . . . . . . . . . . . 5-2, F-4
POWER  . . . . . . . . . . . . . 3-2, 5-3
PREQ . . . . . . . . . . . . . . 10-2 to 10-3, 11-3
PRIN . . . . . . . . . . . . . . 11-3, 11-8
PRING  . . . . . . . . . . . . . F-6
PRINT  . . . . . . . . . . . . . 11-5
Property list  . . . . . . . . . 1-3
PRSUB  . . . . . . . . . . . . . 6-2 to 6-3
PRT  . . . . . . . . . . . . . . 9-1, 10-2, 11-3, F-6
PRT format . . . . . . . . . . . 9-1
PRT function . . . . . . . . . . F-8
PRTEN  . . . . . . . . . . . . . 10-2, F-11
PRTL . . . . . . . . . . . . . . F-7
PSUBS  . . . . . . . . . . . . . 6-1, 9-1, F-7
PSUL . . . . . . . . . . . . . . 6-1, 9-1, F-7
PTEVAR . . . . . . . . . . . . . 9-1, F-11
PVARNUM  . . . . . . . . . . . . 9-1

RANLIS . . . . . . . . . . . . . 10-2
RATPAR . . . . . . . . . . . . . 9-1, F-9
RDASIS . . . . . . . . . . . . . 11-5
REDUCE . . . . . . . . . . . . . 11-5 to 11-6
REMAKE . . . . . . . . . . . . . 11-6
REMFUNS  . . . . . . . . . . . . 7-3
REMSUB . . . . . . . . . . . . . 6-3
REMSUB.  . . . . . . . . . . . . 6-2
RESTORE  . . . . . . . . . . . . 12-1
RIC  . . . . . . . . . . . . . . 14-1, 15-2, F-17
RICM . . . . . . . . . . . . . . 14-2, 15-2, F-18
RID0RT . . . . . . . . . . . . . F-5
RIDRT  . . . . . . . . . . . . . F-5
RIE  . . . . . . . . . . . . . . 14-1, 15-2, F-17
RPL  . . . . . . . . . . . . . . 11-3, 11-9

RSCL . . . . . . . . . . . . . . 14-2, 15-2 to 15-3, F-18

SATOM  . . . . . . . . . . . . . F-1
SAVE . . . . . . . . . . . . . . 11-5, 12-1
SCHDIF . . . . . . . . . . . . . 7-6
SCL  . . . . . . . . . . . . . . 10-2
SETEX  . . . . . . . . . . . . . H-1
SETPRT . . . . . . . . . . . . . F-8
SETQ . . . . . . . . . . . . . . 1-3
SETSUB . . . . . . . . . . . . . 6-3
SIMP . . . . . . . . . . . . . . 5-1, 5-3, 11-3, F-4
SIMP1  . . . . . . . . . . . . . 5-2, F-4
SIMP2  . . . . . . . . . . . . . 5-3
SIMPE  . . . . . . . . . . . . . F-4
SIMPEX . . . . . . . . . . . . . 5-3
SIMPI  . . . . . . . . . . . . . 5-1, 5-3
SIN  . . . . . . . . . . . . . . F-14
SMEXPT . . . . . . . . . . . . . 5-2
SNUM . . . . . . . . . . . . . . 4-2, 4-4
SNUMP  . . . . . . . . . . . . . F-1
SPEC . . . . . . . . . . . . . . 11-1, 11-10
SUBMTIMES  . . . . . . . . . . . 3-2, 5-2, F-4
SUBPOT . . . . . . . . . . . . . 6-2
SUBS . . . . . . . . . . . . . . 5-1, 7-2, 11-3
SUBSTW . . . . . . . . . . . . . F-4
SWISTAT  . . . . . . . . . . . . 3-1
SWITCHES . . . . . . . . . . . . 3-1
SYDIAG . . . . . . . . . . . . . 10-1, F-15
SYMBOLIC . . . . . . . . . . . . 11-6
SYMF . . . . . . . . . . . . . . 10-1 to 10-2, 11-5
SYMFOUND . . . . . . . . . . . . 11-9
SYMMETRIZE . . . . . . . . . . . 11-5
SYRIE  . . . . . . . . . . . . . F-15

TAN  . . . . . . . . . . . . . . F-14
TENSOR . . . . . . . . . . . . . 10-2
TENSORS  . . . . . . . . . . . . 10-1, 11-1
TENVAL . . . . . . . . . . . . . 11-1
TEX  . . . . . . . . . . . . . . 11-6
TIPRIGN  . . . . . . . . . . . . F-7
TIPRING  . . . . . . . . . . . . F-6
TNOEX  . . . . . . . . . . . . . 11-6
TNSPCH . . . . . . . . . . . . . 10-2
TO . . . . . . . . . . . . . . . 11-2
TRANSF . . . . . . . . . . . . . 6-4, 7-2
TSTPRT . . . . . . . . . . . . . F-8

UPINDX . . . . . . . . . . . . . 10-2

VALU . . . . . . . . . . . . . . F-8
VALUE  . . . . . . . . . . . . . 10-2, 11-1, 11-4
VALUE. . . . . . . . . . . . . . 11-1
VARMAX . . . . . . . . . . . . . 7-4
VARS . . . . . . . . . . . . . . 7-1, 7-3
VATM . . . . . . . . . . . . . . F-9
VNUM . . . . . . . . . . . . . . F-9
VTRIG  . . . . . . . . . . . . . F-9

WHERE  . . . . . . . . . . . . . 11-8
WLAPLY . . . . . . . . . . . . . 11-3

WLFREAD  . . . . . . . . . . . . 11-6
WLINIT . . . . . . . . . . . . . 11-6
WLREAD . . . . . . . . . . . . . 11-5
WLSIMP . . . . . . . . . . . . . 11-3
WMAKE  . . . . . . . . . . . . . 11-3
WREMAKE  . . . . . . . . . . . . 11-6
WRITE  . . . . . . . . . . . . . 11-3
WRPL . . . . . . . . . . . . . . 11-3

XED  . . . . . . . . . . . . . . F-4 to F-5

ZDD  . . . . . . . . . . . . . . 15-1
ZDET . . . . . . . . . . . . . . 15-1
ZDU  . . . . . . . . . . . . . . 15-2
ZERM . . . . . . . . . . . . . . 5-2, F-5
ZINV . . . . . . . . . . . . . . 15-1
ZUD  . . . . . . . . . . . . . . 15-1

&+ . . . . . . . . . . . . . . . F-10

