


















          XXXXXX   XX   XX   XXXXXXX   XXXXXXX   XXXXXX
         XX        XX   XX   XX        XX        XX   XX
         XX        XX   XX   XX        XX        XX   XX
          XXXXX    XXXXXXX   XXXXX     XXXXX     XXXXXX
              XX   XX   XX   XX        XX        XX
              XX   XX   XX   XX        XX        XX
         XXXXXX    XX   XX   XXXXXXX   XXXXXXX   XX



                        REFERENCE MANUAL


                        Author: I. Frick

                Institute of Theoretical Physics
                     University of Stockholm
                           Vanadisv. 9
                       S-113 46  Stockholm
                             Sweden



                                   CONTENTS



CHAPTER 1       INTRODUCTION

        1.1     HOW TO READ THIS MANUAL  . . . . . . . . . . . . . 1-1
        1.2     CHARACTER CONVENTIONS  . . . . . . . . . . . . . . 1-2
        1.3     TALKING TO THE COMPUTER  . . . . . . . . . . . . . 1-2
        1.4     LISP . . . . . . . . . . . . . . . . . . . . . . . 1-3


CHAPTER 2       SHEEP LISP


CHAPTER 3       SWITCHES AND CONSTANTS

        3.1     CONTROL OF SWITCHES  . . . . . . . . . . . . . . . 3-1
        3.2     IMPLEMENTATION OF SWITCHES . . . . . . . . . . . . 3-1
        3.3     CONSTANTS  . . . . . . . . . . . . . . . . . . . . 3-1


CHAPTER 4       INTERNAL REPRESENTATION AND RELATED FUNCTIONS

        4.1     SYNTAX FOR INTERNAL REPRESENTATION . . . . . . . . 4-1
        4.2     EXAMPLES OF THE INTERNAL REPRESENTATION  . . . . . 4-1
        4.3     FUNCTIONS THAT GENERATE SHEEP EXPRESSIONS  . . . . 4-2


CHAPTER 5       SIMPLIFICATION

        5.1     SIMP . . . . . . . . . . . . . . . . . . . . . . . 5-1
        5.2     THE SIMPLIFICATION FUNCTIONS . . . . . . . . . . . 5-2


CHAPTER 6       SUBSTITUTIONS

        6.1     WHAT CAN BE SUBSTITUTED  . . . . . . . . . . . . . 6-1
        6.2     MANIPULATING PAIRS ON THE SUBSTITUTION LISTS . . . 6-2
        6.2.1     Arguments That Specify Substitution Pairs  . . . 6-2
        6.2.2     PRSUB And REMSUB . . . . . . . . . . . . . . . . 6-2
        6.2.3     SETSUB . . . . . . . . . . . . . . . . . . . . . 6-3
        6.2.4     Extra Arguments Of SETSUB  . . . . . . . . . . . 6-3


CHAPTER 7       DIFFERENTIATION AND FUNCTIONS

        7.1     FUNCTION AND VARIABLE DECLARATIONS . . . . . . . . 7-1
        7.1.1     FUNS . . . . . . . . . . . . . . . . . . . . . . 7-2
        7.1.2     REMFUNS  . . . . . . . . . . . . . . . . . . . . 7-3
        7.1.3     VARS . . . . . . . . . . . . . . . . . . . . . . 7-3
        7.1.4     VARMAX . . . . . . . . . . . . . . . . . . . . . 7-4
        7.2     FUNCTIONS FOR DIFFERENTIATION  . . . . . . . . . . 7-5
        7.3     DEFINING NEW SHEEP OPERATORS . . . . . . . . . . . 7-5
                                                                Page 2


CHAPTER 8       FORMULA INPUT (FOIN)

        8.1     FOIN . . . . . . . . . . . . . . . . . . . . . . . 8-1
        8.1.1     Informal Syntax Description  . . . . . . . . . . 8-1
        8.1.2     Meaning Of Some Operators  . . . . . . . . . . . 8-2
        8.1.3     Different Modes Of FOIN  . . . . . . . . . . . . 8-3
        8.1.4     Syntax Error Handling  . . . . . . . . . . . . . 8-3


CHAPTER 9       FORMULA OUTPUT

        9.1     PRT  . . . . . . . . . . . . . . . . . . . . . . . 9-1
        9.2     FPRT . . . . . . . . . . . . . . . . . . . . . . . 9-2


CHAPTER 10      TENSOR IMPLEMENTATION AND NEW TENSORS

        10.1    IMPLEMENTATION OF TENSORS  . . . . . . . . . . .  10-1
        10.2    THE PROPERTY LIST OF TENSORS . . . . . . . . . .  10-1
        10.3    DEFINING NEW TENSORS.  . . . . . . . . . . . . .  10-2


CHAPTER 11      TENVAL FUNCTIONS

        11.1    ARGUMENTS OF TENVAL FUNCTIONS  . . . . . . . . .  11-1
        11.2    THE INDIVIDUAL TENVAL FUNCTIONS  . . . . . . . .  11-2
        11.3    MESSAGES WHEN RUNNING TENVAL FUNCTIONS . . . . .  11-6
        11.4    SOME RELATED FUNCTIONS . . . . . . . . . . . . .  11-7
        11.5    SOME IDENTIFIER VALUES   . . . . . . . . . . . .  11-8


CHAPTER 12      FILE MANIPULATION

        12.1    READING OR PRINTING DISK FILES . . . . . . . . .  12-1
        12.1.1    Saving Expressions In Disk Files . . . . . . .  12-1
        12.1.2    REDUCE Interface . . . . . . . . . . . . . . .  12-1
        12.1.3    Reading Commands From Disk Files . . . . . . .  12-1
        12.1.4    Writing On The Line Printer  . . . . . . . . .  12-2
        12.2    OUTF AND INF . . . . . . . . . . . . . . . . . .  12-2


CHAPTER 13      POWER SERIES


CHAPTER 14      THE CORD PACKAGE

        14.1    THE CORD TENSORS . . . . . . . . . . . . . . . .  14-1
        14.2    ALTERNATIVE ALGORITHM  . . . . . . . . . . . . .  14-2
        14.3    CONTROL OF GDET  . . . . . . . . . . . . . . . .  14-2


CHAPTER 15      THE FRAME PACKAGE

        15.1    THE FRAME TENSORS  . . . . . . . . . . . . . . .  15-1
        15.2    ALTERNATIVE ALGORITHM  . . . . . . . . . . . . .  15-2
                                                                Page 3


        15.3    CONTROL OF ZDET  . . . . . . . . . . . . . . . .  15-3
        15.4    STANDARD FRAME METRICS . . . . . . . . . . . . .  15-3


APPENDIX A      THE FUNCTIONS AND COMMANDS IN SHEEP


APPENDIX B      THE SWITCHES IN SHEEP1


APPENDIX C      SOME VALUES


APPENDIX D      DIAGNOSTIC AND ERROR MESSAGES

        D.1     ORDINARY ERROR MESSAGES  . . . . . . . . . . . . . D-1
        D.2     CALLS FOR DECLARATION  . . . . . . . . . . . . . . D-3
        D.3     DIAGNOSTIC MESSAGES  . . . . . . . . . . . . . . . D-4


APPENDIX E      FOIN CHARACTER INTERPRETATION













                            CHAPTER 1

                          INTRODUCTION



This manual has now been  somewhat  updated  to  describe  SHEEP2
rather  than  SHEEP1.   This does not mean that all facilities of
SHEEP2 are described, rather that  when  there  is  a  difference
between  SHEEP1  and SHEEP2, SHEEP2 is described.  The appendices
have only partly been updated.

     SHEEP is a computer algebra system  designed  primarily  for
the needs of General Relativity, but it can also be used in other
fields.

   SHEEP can:

     1.  Read, write, simplify, substitute into and differentiate
         algebraic expressions.

     2.  Define tensors and tensor algorithms.

     3.  Manipulate tensor components.

     4.  Calculate the Einstein tensor from a given metric  in  a
         tetrad or in a coordinate frame.

     5.  Perform perturbation calculations.  Not yet in SHEEP2.




1.1  HOW TO READ THIS MANUAL

This manual is a preliminary version  and  several  chapters  are
still   missing.    It   can   be   used  at  several  levels  of
understanding.

   To calculate one of the built  in  tensors,  like  the  Ricci,
Riemann  or Einstein tensor it is enough in the beginning to look
at the examples in the  user  guide,  with  some  help  from  the
definitions  in  chapters 14 and 15.  The section "TALKING TO THE
COMPUTER" in this chapter will also prove useful.

   To process more complicated metrics, it will be  necessary  to
know  how substitutions are made, as is discussed in 5.1 and 6.1.
Chapter 11 gives more information about how to manipulate  tensor
INTRODUCTION                                             Page 1-2


components  and  values.  Chapter 12 discusses commands that save
expressions on disk and then recalls them.

   To do a calculation that is not built into SHEEP, new  tensors
can  be  defined.   This  is  discussed in chapters 10 and 4.  To
combine these new tensors with series expansions, a knowledge  of
chapter 13 is necessary.



1.2  CHARACTER CONVENTIONS

Some characters that are used by SHEEP, do not print in  a  usual
way  and  some characters are sometimes used as peculiar national
characters.  For these characters the following  conventions  are
used:
__ ____ ______ _____ ____     _______In this manual ASCII code     meaning
^C               3            Control-C
^G               7            Control-G or bell
^O              17            Control-O
^U              25            Control-U
<cr>            15            Return or carriage return
<alt>           33            Altmode or escape or control-[
<sp>            40            Space
#               43            Number sign
$               44            Dollar
@              100            Commercial at sign
<del>          177            Delete or rubout



1.3  TALKING TO THE COMPUTER

The following characters are useful when talking to the computer:

_________      _______Character      meaning

^C             Stop a running  calculation  and  either  enter  a
               special command loop or go to top-level of SHEEP.

^G             Takes you back to the toplevel of SHEEP  if  typed
               when SHEEP expects input.

^O             Suppress printout to the TTY.

^U             Delete  current  input  line,   i.e.   all   typed
               characters back to last <cr> or <alt>.

^Y or ^Z       Leave SHEEP.  Depending on operating  system,  use
               either ^Y or ^Z.

<del>          Delete last typed character if it wasn't  <cr>  or
               <alt>.
INTRODUCTION                                             Page 1-3


1.4  LISP

SHEEP consists of several LISP functions  that  are  loaded  into
LISP  and  the  top  level  of  SHEEP  is  the top level of LISP.
Because of this a few LISP terms will be explained here.

   An identifier is a string of characters that are  loaded  into
the  memory in a special way, together with a list of properties,
the property list of the identifier.  Identifiers can have values
associated.
                           (SETQ A B)
Sets identifier A to the value of B.  I.e. the value of B becomes
the  value  of  A.   To set A to B (and not to the value of B), B
must be quoted.  This is easiest done by using the character  "'"
that  has  a special meaning to the LISP function READ that reads
the input to LISP.  It has to effect that the value  of  'var  is
var, so that
                           (SETQ A 'B)
sets A to B.

   A FEXPR is a function with an indefinite number of  arguments.
It  operates  on its arguments directly, without evaluating them.
Almost all user oriented commands in SHEEP are  FEXPRs  (actually
in  Sheep2 they are MACROs but the effect is the same).  They are
primarily meant to be used at the  top  level  and  not  so  much
inside functions.

   An EXPR is a function with a specific number of arguments,  it
operates  on  the  values of these arguments.  All functions that
are used inside SHEEP, are EXPRs.












                            CHAPTER 2

                           SHEEP LISP



Knowledge of this chapter is only necessary if you are interested
in  the  SHEEP  source  code.   SHEEP  Lisp is not a Lisp dialect
intended for independent use, it is only used to implement SHEEP.
It  is  not  necessarily  complete, only those features needed in
SHEEP are defined.  With a few omissions described  below,  SHEEP
Lisp  is  a  superset of Standard Lisp as defined in the Standard
Lisp Report [??].  The functions in SHEEP Lisp have  been  chosen
so  that  it is reasonably easy to implement SHEEP Lisp on top of
an arbitrary Lisp.

This  chapter  will  eventually  contain  descriptions   of   all
functions  in  SHEEP  Lisp.   At  the  moment  it only contains a
structured list of all functions  and  variables  in  SHEEP  Lisp
(descriptions  can be found in the Standard Lisp Report or in the
source code):

Elementary predicates:
        ATOM PAIRP LISTP IDP NULL NUMBERP STRINGP VECTORP
        CODEP CONSTANTP EQ EQCAR EQUAL  

Arithmetic:

 Any number:
        FIX FLOAT FIXP FLOATP ABS DIVIDE EXPT GCD MAX MIN
        ADD1 INCR SUB1 DECR PLUS DIFFERENCE MINUS
        TIMES QUOTIENT REMAINDER
        ZEROP ONEP EQN EVENP GREATERP LESSP MINUSP 

 Integer < 1000 :
        IADD1 IINCR ISUB1 IDECR IPLUS IDIFFERENCE IMINUS
        ITIMES IQUOTIENT IREMAINDER
        IZEROP IONEP IEQN IEVENP IGREATERP ILESSP IMINUSP

 Integer < 2^16 :
        XIADD1 XIINCR XISUB1 XIDECR XIPLUS XIDIFFERENCE XIMINUS
        XITIMES XIQUOTIENT XIREMAINDER
        XIZEROP XIONEP XIEQN XIEVENP XIGREATERP XILESSP XIMINUSP

 Integer < 2^24 :
        XADD1 XINCR XSUB1 XDECR XPLUS XDIFFERENCE XMINUS
        XTIMES XQUOTIENT XREMAINDER
        XZEROP XONEP XEQN XEVENP XGREATERP XLESSP XMINUSP
SHEEP LISP                                               Page 2-2


 Any arg:
        AEQN XAEQN AONEP AZEROP

Pair or any:
        C....R CONS CONSA XCONS COPY RPLACA RPLACD RPLACW SUBST
        XMEMQ XMEMQL

List structure:
        LIST NCONS
        APPEND APPENDL NCONC NCONCL COPYT DELETE DELQIP
        REVERSE REVERSIP REVERSEX REVERSIP
        INTERSECTIONQ SETDIFFQ UNIONQ ADJOINQ
        AMEMQ XAMEMQ MEMQ MEMBER MEM2Q
        CNDR NTH PNTH
        LASTPAIR LAST2PAIR LENGTH
        XPUSH PUSHQ UNPUSH POP REMPOP

Alist functions:
        AATSOC XAATSOC ATSOC ASSOC SASSOC RATSOC PAIR SUBLA
        SUBLIS

Property lists:
        GET IGET DC DFUN PUTC DEFLIST DPUT PUT REMPROP PLIST XPUT
        (XDEFLIST XFLAGS)
        FLAG FLAG1 FLAGP REMFLAG REMFLAG1 USEDFLAGS
        USEDPROPERTIES

Function calling and evaluation:
        EVAL EVLIS APPLY FUNCALL FEXPRCALL MACEXPD MACEXPD1
        NOEVAGAINP EVCONSTANTP QUOTEP QUOTE MKQUOTE (REEVALFORM)
        RETARG

Function definition:
        DE DMACRO DS DEXPR DFEXPR CMMACRO SAMEDEF NEWFNAME
        OUTDNAME
        FUNCTIONS DECLAREFEXPR ENTRYPOINTS LOCALFUNCTIONS
        EXPAND CPROGN
        EXPRP FEXPRP MACROP FNP
        GETFN GETFNTYPE MOVD PUTD REMD
        ADDHLP

Looping:
        FOREACH FORL FORX XIFORL XIFORX IFORL IFORX REPEATS UNTIL
        WHILE
        PROG GO RETURN PROG1 PROGN

Boolean and conditional:
        COND NOT AND OR XOR (PROGQ XCASE XCOND)

Variable binding:
        EXCHANGE QSET QSETQ SET SETQ SLET PLET 
        FLUID GLOBAL SETCONSTANTS SETFLUIDS SETGLOBALS
        SETLOCALGLOBALS UNFLUID
        (QSETFLUIDS QSETGLOBALS QSETLOCALGLOBALS)
        FLUIDP GLOBALP BOUNDP
SHEEP LISP                                               Page 2-3


Identifiers:
        GENSYM INTERN (INTERNP) REMOB LEXP ORDERP FOREACHID

Compress, Explode etc.
        BLDMSG BLDMSG2 COMPRESS CONCATID CONCATIDL
        MAKEFLO MAKEID MAKEINT MAKESTR
        EXPLODE EXPLODEC PEXPLODE PEXPLODEC
        DIGIT LITER ULCASE SETCASE

I/O:

 Loading:
        DSKIN (FLOAD) INCLUDE LOAD PRELOAD POSTLOAD RELOAD SLOAD
        LOADP LOADX MLOAD

 Channel selection:
        CHANIN CHANOUT FILEIN FILEOUT STDIN STDOUT STDINOUT CLOSE
        OPEN RDS WRS

 Print:
        PRIN1 PRIN2 PRINT PRIN2T PRIN1D PRIN2D EPRIN2 EPRIN2T
        EPRIN2Q
        PRINC BELL EJECT SPACES TTAB QTRPRI TERPRI
        PRIN2L PRIN2LIST PRETTYPRINT
        PRINTF PRINTF2 ERRORPRINTF EPRINTF2 WARNINGF MSGOUT
        MSGOUT3
        PRINTF args: (f) n  b (e) l p r (t) w

 Read:
        READ READCH READCHCASE READIN NOP YESP SKIPTO SKIPWHITE
        (UNREADCH)

 File name handling:
        PREFIXOF FILNAM ADDEXTENSION ADDPREFIX OUTFILENAME
        ADDSUBDIRS
        FINDFILE

 Status:
        LPOSN POSN (PGLINE) LOADEDP SETLOADED SETNOTLOADED BATCHP
        STDINP STDOUTP TTYINP TESTFILE

 Parameters:
        PROMPT PROMPTER SETPROMPTER LINELENGTH FOLDCASE
        SETFOLDCASE
        GCMESSAGE SETGCMESSAGE

Errorhandling:
        ERRSET ERRSETT ERRORF ERRORF3 SHPDEBUG

Conditional coding:
        COMMENT GVALUE IFP
        BOTHTIMES COMPILETIME MACROTIME NOTLOADTIME LOADTIME

Vectors:
        GETV MKVECT PUTV UPBV VECTORP LIST2VECTOR VECTOR2LIST
SHEEP LISP                                               Page 2-4


Status:
        SETSYSTYPE SYSTYPE TIME

Toplevel:
        SLISPINIT SLISPTOP NEWLISPTOP SLSPINI XSLISPTOP ISLISPTOP
        DOINITFILE
        SET!-TOP!-LEVEL
        DFEVAL QUIT RESET

Commandline: (Not available on all systems)
        CHKERARGV INITCOMMANDLINE NEXTONCOMLIN TRYINICHSWITCH
        SEXPRFROMCOM
        INITLINEFN procedures: E G X e f g m 

The following Standard Lisp functions are  not  defined:   (These
        functions might be defined but use others instead)
                DF              Use DFEXPR
                DM              Use DMACRO
                              WARNING             Use WARNINGF
                              ERROR               Use ERRORF
                              ERRORSET  Use ERRSET
                GETD            Use GETFN and GETFNTYPE
                              MAP MAPC MAPCAN MAPCAR MAPCON
        MAPLIST MAPRPL MAPRPLC          Use FOREACH
                              PAGELENGTH          Not available
        in some systems
                              PROG2               Use PROGN or
        PROG1
                              MAX2 MIN2 PLUS2 TIMES2 Use MAX,
        MIN, PLUS or TIMES

Constants:
        !$EOF!$ !$EOL!$ !*ILISPCASEUP !*OSCASEUP !*SHPCASEUP

GLOBAL variables:
        !*MACROTIME DATE!* DOCOMPLAIN!-MSG!* EMSG!* GOFN!*
        INITFILE!*
        INITMESSAGE!* INITPROMPT!* INITS!* LISPFN PUTCHR!* 
        SAVEDO!* SLISPTOP!* SYSINITFILE!* SYSTYPE!* TOPDIR!* 

FLUID variables:
        !*CREF !*DEFN !*ECHO !*INT !*IPRN !*LOADMSG !*MACROEXPAND
        !*MSG
        !*MSGTOFILE !*NOCHECK !*STOPCMPARS !*SUPPRESSANS
        !*TTYECHO
                ASKREPEAT!* DEFAULTEXTENSION!* DFEVAL!* DFPRINT!*
        DSKEXTLIS!*
                DSKSEARCHLIS!* FILELINELENGTH!* HERE HERELIST
        INFN!* MEXTLIS!* 
                SUPPRESSANS!* YESPDEFAULT!* MODULNAM!*
        MSEARCHLIS!* NOPDEFAULT!*

Properties:
        INFN INITLINEFN MACEXPDFN PATH
SHEEP LISP                                               Page 2-5


Flags:
        DFEXPAND EVAL FNARY IGNORE ISAFUNCTION LOSE MACROARG 












                            CHAPTER 3

                     SWITCHES AND CONSTANTS



3.1  CONTROL OF SWITCHES

The identifier SWITCHES has as value a list of all  the  switches
in  the  system.  The switches are controled by the functions ON,
OFF  and  SWISTAT.   All  three  functions  are  MACROs  with  an
indefinite  number  of  switches  as  arguments.  ON turns on its
arguments, OFF turns off its arguments and SWISTAT  does  nothing
with  its  arguments.   They  return  as value a list of those of
their arguments that were  on  previous  to  the  action  of  the
function.  E.g.
                   (ON DIAGONAL NOZERO PSUBS)
turns on DIAGONAL, NOZERO and PSUBS.  The  value  is  a  list  of
those of them that were on previously.
The argument ALL is the same as all switches, i.e.
                          (SWISTAT ALL)
returns a list of the switches that are on, and
                            (OFF ALL)
turns off all switches and returns a list of  the  switches  that
were on.
If an argument "x" isn't a switch (or ALL) then the error
                        "x" NOT A SWITCH
occurs.  As the arguments are processed  from  the  left  to  the
right, the switches preceding "x" as arguments have been changed,
but the ones that come after, have not.

Initially all switches are off.



3.2  IMPLEMENTATION OF SWITCHES

The switches use the value of the corresponding identifiers, i.e.
that  NOZERO is on, means that the value of the identifier NOZERO
not is NIL and that DIAGONAL is off means that the value  of  the
identifier DIAGONAL is NIL.



3.3  CONSTANTS

Some  numerical  constants  in  the  system  are   controled   by
SUBMTIMES, POWER, EXPANDLIM, PARDEEP, LINESPERPAGE and DIFFORDER.
SWITCHES AND CONSTANTS                                   Page 3-2


They take one argument and affect  one  constant  each.   If  the
argument  is a positive INUM, the constant is set to the argument
and the value of the  function  is  the  previous  value  of  the
constant.   If  the argument is not a positive INUM, the constant
is not changed and the value of the function is the current value
of  the constant.  Default values of the constants and where they
are used is indicated below.
               _______        ____ __               default        used in
DIFFORDER      2              SETSUB
SUBMTIMES      3              MSUBS substitutions in SIMP
POWER          4              SMEXPT
EXPANDLIM      4              SMEXPT
PARDEEP        0              PRT
LINESPERPAGE   58             PRT












                            CHAPTER 4

          INTERNAL REPRESENTATION AND RELATED FUNCTIONS



4.1  SYNTAX FOR INTERNAL REPRESENTATION

The following is a formal syntax for SHEEP expressions.

<SHEEP expression>  := <identifier>
                       <SHEEP number>
                       <SHEEP functional>

<SHEEP functional>  := (<EFUN operator> <SHEEP expression>)
                       (<DFUN operator> . <expression list>)

<expression list>   := (<SHEEP expression>)
                       (<SHEEP expression> . <expression list>)

<EFUN operator>     := QUOTE,EXP,LOG,SIN,COS,SINH,COSH,TAN,COT

<DFUN operator>     := PLUS,TIMES,EXPT,DF1,DF2,DFx,TPS,TEXT

<SHEEP number>      := <integer>
                       <floating point number>
                       <rational number>

Integer and floating point number is taken from the Lisp System,
                       the
                       implementation of rational numbers varies,
                       but the usual representation is:

<rational number>   := (<integer . <positive integer>)

where the numerator and denominator are relative prime.



                       4.2  EXAMPLES OF THE INTERNAL
                            REPRESENTATION

                       In the following examples,  "a",  "b"  and
                       "c"   will  stand  for  (arbitrary)  SHEEP
                       expressions and "A", "B" and "C"  will  be
                       identifiers.
INTERNAL REPRESENTATION AND RELATED FUNCTIONS            Page 4-2


                       _____ __________ _______                       SHEEP expression Meaning

                       (2 .  3)         2/3
                       !(2 3) 2+3i
                       (-2 . 3)         -2/3
                       !(5 6 . 7)       (5+6i)/7
                       (PLUS a b)       a+b
                       (PLUS a b 5 A c) a+b+5+A+c
                       (TIMES a b c)    a*b*c
                       (EXPT a b)       a^b
                       (EXPT X 4)       X^4
                       (EXP a)          EXP(a)
                       (SIN c)          SIN(c)
                       (TIMES (PLUS a b) c)       (a+b)*c
                       (TIMES -1 a)     -a
                       (EXPT a -1)      1/a



                       4.3  FUNCTIONS THAT GENERATE SHEEP
                            EXPRESSIONS

                       The   following   functions   take   SHEEP
                       expressions  as  arguments and returns new
                       SHEEP  expressions  constructed  from  the
                       arguments.   They are all EXPRs, i.e. they
                       operate on the values of their arguments.

                       (MKPLUS shxp1 shxp2)       If  "shxp1"  is
                                      zero,  "shxp2"  is returned
                                      as value.   If  "shxp2"  is
                                      zero,  "shxp1" is returned.
                                      If  neither  is  zero,  the
                                      list  (PLUS shxp1 shxp2) is
                                      returned.

                       (MKTIMS shxp1 shxp2)       If  "shxp1"  or
                                      "shxp2"  is  zero,  zero is
                                      returned.   If  neither  is
                                      zero  the list (TIMES shxp1
                                      shxp2) is returned.

                       (COPYL shxp)     Returns  a  copy  of  the
                                      SHEEP   expression  "shxp".
                                      This  function  copies  all
                                      list  structures  in "shxp"
                                      except SHEEP  numbers.   As
                                      SIMP,  DIFF  and some other
                                      functions   destroy   their
                                      arguments,    COPYL    must
                                      usually  be  used  to  copy
                                      expressions  that are given
                                      to them.

                       (DOMULC shxp1 shxp2)       If  "shxp1"  or
                                      "shxp2"  is  zero,  zero is
                                      returned.   If  neither  is
INTERNAL REPRESENTATION AND RELATED FUNCTIONS            Page 4-3


                                      zero   and   TPS   is   NIL
                                      (default), then  DOMULC  is
                                      the same as:
%RUNOFF-W-CJL, Can't output line correctly -- margins too narrow.  Line will not be justified
	on output page 4-3; on input line 60 of page 1 of file "DISK$UPA:[SHEEP.DOC.MAN]C4.RNM;7"
                                                           (SMTIMES2 (COPYL shxp1) (COPYL shxp2))
                                      i.e. if  TPS  is  NIL  then
                                      DOMULC   is   the  same  as
                                      SMTIMES with the  exception
                                      that  "shxp1"  and  "shxp2"
                                      are copied  if  the  answer
                                      not is zero.  If TPS not is
                                      NIL then the value  is  the
                                      term  of  order  TPS in the
                                      product  of  two  truncated
                                      power  series  (see chapter
                                      13).

                       (DOCOPY shxp)    If TPS is  NIL  (default)
                                      then  DOCOPY is the same as
                                      COPYL.  If TPS not  is  NIL
                                      then   DOCOPY  returns  the
                                      copy of the truncated power
                                      series term of order TPS.

                       (SMPLUS2 shxp1 shxp2)      The same as
                                             (SIMP1 (MKPLUS shxp1 shxp2)
                                      I.e. if "shxp1" and "shxp2"
                                      are   simplified  then  the
                                      simplified sum  of  "shxp1"
                                      and "shxp2" is returned.

                       (SMMINUS shxp)   Negates     "shxp"     by
                                      changing "shxp", i.e. COPYL
                                      might be needed.  If "shxp"
                                      was  simplified,  then  the
                                      result is so also.

                       (SNUM numerator  denominator)  Generate  a
                                      SHEEP  number  (but  not  a
                                      complex    number)     with
                                      numerator  and  denominator
                                      as      numerator       and
                                      denominator.  Numerator and
                                      denominator  are   arbitray
                                      Lisp  numbers.   If  any of
                                      them  are  a  Lisp  floting
                                      number   then   a  floating
                                      number   is   created    by
                                      dividing   numerator   with
                                      denominator.      Otherwise
                                      numerator  and  denominator
                                      are normalized by  dividing
                                      with  there  gcd and if the
                                      resulting denominator is  1
                                      then  an integer is formed,
                                      else a rational is  formed.
                                      Depending  on size, a small
                                      or  a  general  number   is
INTERNAL REPRESENTATION AND RELATED FUNCTIONS            Page 4-4


                                      formed.

                       See also chapter 5.












                            CHAPTER 5

                         SIMPLIFICATION



Simplification of expressions, using ordinary rules  of  algebra,
is  done  in  several  parts  of  the  system, using more or less
ambitious simplification functions:

   All input to the formula reader FOIN is simplified  by  SIMPI,
which  tries  to  simplify  all  subexpressions  knowing  how  to
simplify sums, products and exponentials, but  does  not  perform
any substitutions.

   Expressions calculated by the system, e.g. tensor  components,
are   simplified  by  the  function  SIMP,  which  basicaly  only
simplifies sums  and  products,  but  can  be  made  to  simplify
exponentials  and perform substitutions by turning on appropriate
switches.

   The TENVAL function  LSIMP  can  be  used  to  apply  SIMP  on
components   and   identifier   values.   As  these  usually  are
simplified  already,  this  is  mostly  done  in  order   to   do
substitutions.



5.1  SIMP

SIMP is the general simplification function that is used  by  the
system to simplify computed expressions.  SHEEP2 does only rarely
use  SIMP,  rather  expressions  are  computed  when   they   are
simplified  and  at  the end SIMPE is called.  The following is a
short description of the action of SIMP:

     1.  If the switch NOSIMP is on, SIMP does nothing.  This  is
         sometimes useful to debug user defined functions.

     2.  Call SIMP1, that simplifies sums and products.

     3.  Call SIMPE.

The following is a short description of the action of SIMPE:

     1.  If the identifier SUBS has a value different  from  NIL,
         then  make  substitutions,  using  the substitution list
         that is the value of SUBS.
SIMPLIFICATION                                           Page 5-2


     2.  If the switch ESUBS is on, make substitutions, using the
         ESUL substitution list.

     3.  If  any  substitution  was  actually  made  in  the  two
         previous  steps or if the switch POTSIM is on, then call
         SIMP2 that first simplifies all  exponentials  by  using
         SMEXPT  and  then  calls  SIMP1  to  simplify  sums  and
         products.

     4.  End if the switch MSUBS is off.

     5.  Make substitutions using the MSUL substitution list.

     6.  End if no substitutions were made in the previous  step,
         i.e. if no matching expressions were found.

     7.  Call SIMP2.

     8.  Go back to step 7, if this loop has not been passed more
         than  N  times, where N is a constant that is set by the
         function SUBMTIMES (initial value is 3).




5.2  THE SIMPLIFICATION FUNCTIONS

The following functions are all of  the  EXPR  type.   They  take
SHEEP  expressions  as  arguments  and returns a simplified SHEEP
expression as value.  Appendix F.2 contains LISP  definitions  of
some of these functions.

(SIMP1 shexp)  Simplifies sums and products.  This is done in two
               steps:

               1.  ZERM applies the rules:
                   0+a        = a
                   +a         = a
                   +          = 0
                   0*a        = 0
                   1*a        = a
                   *a         = a
                   *          = 1

               2.  XED applies itself recursively and  then  uses
                   SMPLUSL  and  SMTIMESL  to simplify a sum or a
                   product.

               3.  SMPLUSL adds numbers and adds terms by  adding
                   their coefficients.

               4.  SMTIMESL multiplies numbers, expands using the
                   distributive    and   associative   laws   and
                   multiples factors by adding their exponents.

SIMPLIFICATION                                           Page 5-3


(SMEXPT basis exponent)       Constructs      an      exponential
               "basis"^"exponent" and then uses the rules:
               a^0            = 1   Note that 0^0 = 1
               a^1            = a
               0^a            = 0 if a is a positive number.
                              ZERO  DIVISOR  error  if  a  is   a
                              negative number
               1^a            = 1
               (a*b)^c        = (a^c)*(b^c)
               (a^b)^c        = a^(b*c)
               (EXP(a))^b     = EXP(a*b)
               (a+b)^n        =  (a+b)(a+b)...(a+b)  if  n  is  a
                              positive   integer   that   not  is
                              greater than a constant set by  the
                              function EXPANDLIM (initially 4).
               r^n            = r*r*r*...*r if r is a number  and
                              n  is an integer with magnitude not
                              greater than a constant set by  the
                              function POWER (initially 4).

(SIMPEX shexp) Simplifies all exponentials in  "shexp"  by  first
               simplifying basis and exponent with SIMP2 and then
               calling SMEXPT.

(SIMP2 shexp)  First simplifies all exponentials using SIMPEX and
               then calls SIMP1.

(SIMP shexp)   This is the general simplification routine that is
               used  in  most  cases to simplify expressions.  It
               has been described earlier in this chapter.

(SIMPI shexp)  Simplifies    all    subexpressions,    performing
               differentiation and calling SIMP2.












                            CHAPTER 6

                          SUBSTITUTIONS



Substitutions can be made that  change  the  expressions  in  the
memory or that only affect the output.

   The substitutions that change  the  existing  expressions  are
applied when the function SIMP is called (see 5.1) and are of two
types:  When the switch ESUBS  is  on,  ESUBS  substitutions  are
applied  once every time SIMP is called and if MSUBS is on, MSUBS
substitutions are applied several times each time SIMP is  called
until  either  no  more  substitutions  are  made  (i.e.  no more
matchings) or the substitutions have been applied N times where N
is a constant set by the function SUBMTIMES.

   If the switch PSUBS is on, PSUBS substitutions will be applied
once  every  time  PRT  or  FPRT is called and then SIMP2 will be
called, but expressions in the memory will not be changed.

   Each type of substitution, uses a separate substitution  list.
A substitution list is a list of substitution pairs:
              ((m1 . s1) (m2 . s2) .... (mN . sN))
When substitutions  are  applied  on  an  expression,  first  all
occurrences  of  the  mask  m1  in the expression are replaced by
copies of the substitute s1,  then  all  m2  are  substituted  by
copies  of  s2  and  so on, until all mN have been substituted by
copies of sN.  The subs. lists that correspond  to  ESUBS,  MSUBS
and PSUBS are ESUL, MSUL and PSUL.



6.1  WHAT CAN BE SUBSTITUTED

There are some limitations on what can  be  substituted.   To  be
replaced  by  the  substitute S, an expression must be matched by
the mask M (in the sense of the LISP function EQUAL).

   Because of the internal representation of sums and products, a
mask  that  is  a  sum  or a product will not match everything it
should match.  E.g. if X+Y is to be replaced by A,  then  (X+Y)+Z
will  be changed to A+Z, but X+Y+Z will not.  A way to substitute
X+Y by A, is to substitute X by A-Y.  The situation for  products
is exactly the same as for sums:  just replace "+" and "-" in the
example above by "*" and "/".
SUBSTITUTIONS                                            Page 6-2


   There is one exception from the fact that the mask must  match
exactly  for  a substitution to be made:  If the switch SUBPOT is
on, and the mask is of the type A^N, where N is an integer and  A
is  a  SHEEP  expression,  then  a similar expression A^M will be
substituted if M has the same sign as N and the magnitude of M is
not less than that of N.
E.g. if X^2 is to be substituted by Y and SUBPOT is on, then  X^3
will  be  changed to Y*X, X^4 will be changed to Y^2, X^5 will be
changed to Y^2*X and so on.



6.2  MANIPULATING PAIRS ON THE SUBSTITUTION LISTS

The  three  functions  SETSUB,  PRSUB   and   REMSUB   manipulate
substitution  pairs.   They  are  all  MACROs  with an indefinite
number of arguments.  The identifier LASUB has the  name  of  the
current  substitution  list,  to  which all arguments refer.  The
arguments are processed from the left to the  right.   All  three
functions  have as value the number of subs. pairs on the current
subs. list.



6.2.1  Arguments That Specify Substitution Pairs

The following arguments specify which substitution list and which
pairs  are  to be printed by PRSUB or deleted by REMSUB.  N and M
are understood to be positive numbers in the following.

________                      _______Argument                      Meaning

<name of a subs. list>        The identifier LASUB is set to this
               name.   If  this argument is missing, the value of
               LASUB, set by a previous call to PRSUB, REMSUB  or
               SETSUB,  is  used, i.e. the value of LASUB is used
               as default.

N                             The pair number N

(N M)                         Pairs N to M (M is included).

(N)                           All pairs from N to the end of  the
               list.

ALL                           All pairs.

LAST                          The last pair.



6.2.2  PRSUB And REMSUB

REMSUB                        Deletes the specified  substitution
               pairs.
SUBSTITUTIONS                                            Page 6-3


PRSUB                         Uses PRT  to  print  the  specified
               subs.  pairs  in a manner similar to that in which
               SETSUB  defines  them.    No   substitutions   are
               performed in this output except NAM replacements.



6.2.3  SETSUB

SETSUB first calls REMSUB and then reads a subs. pair and adds it
to  the  current  subs.  list.   It  takes  the same arguments as
REMSUB, but it also takes  some  extra  arguments  that  will  be
described  below.   FOIN  is  used  to  read  the  mask  and  the
substitute in the pair, in the following way:
First the mask is asked for by printing:
                           "n"  FOR  =
where "n" is the number which the new substitution pair will  get
and  "="  is  the  prompter  telling that FOIN now expects input.
After the mask has been inserted, the substitute is asked for  by
printing:
                           SUBSTITUTE  =
where again "=" tells that FOIN now  expects  input.   After  the
substitute  has been inserted, a subs. pair is constructed and if
SETSUB has no extra arguments, it  is  put  at  the  end  of  the
current subs. list.



6.2.4  Extra Arguments Of SETSUB

Except for the arguments used by REMSUB, SETSUB also  takes  some
extra  argument that affect what is done with the subs. pair read
by SETSUB.  These arguments may be  mixed  arbitrarily  with  the
arguments to REMSUB.

________                      ______Argument                      Effect

DIFF                          Create subs.  pairs  to  substitute
               all   nonzero  derivatives  with  respect  to  the
               default (value of DIFF,  see  chapter  7)  set  of
               variables,  up  to (and including) order N where N
               is  a  constant  set  by  the  function  DIFFORDER
               (default is 2).

DF1                           Similar  to  "DIFF",  but  use  the
               "DF1"  set  of  variables.  When, as is usual, the
               value of CRDIF!* is "DF1", using "DF1"  or  "DIFF"
               gives the same result.

DF2                           Similar  to  "DIFF",  but  use  the
               "DF2" set of variables.

(DIFF n)                      Similar   to   "DIFF",   but    use
               DIFFORDER "n".
SUBSTITUTIONS                                            Page 6-4


(DF1 n)                       Similar to "DF1", but use DIFFORDER
               "n".

(DF2 n)                       Similar to "DF2", but use DIFFORDER
               "n".

TRANSF                        Is  similar  to  "DIFF",  but   the
               derivatives   of  the  substitute  are  made  with
               CHNDIF, so that derivatives with  respect  to  the
               complement set of derivatives are generated.  E.g.
                              (SETSUB TRANSF DF1)
               followed by insertion of a mask and  a  substitute
               that  are  the  same  identifier, A say, the chain
               rule will be used  to  define  substitution  pairs
               that  will  replace  all  derivatives  of  A  with
               respect  to  the  "DF1"  set  of   variables,   by
               derivatives  with  respect  to  the  "DF2" set, by
               using the chain rule.  Note that the  substitution
               of  A  by  A  (but not its derivatives) is removed
               automatically from the substitution list.












                            CHAPTER 7

                  DIFFERENTIATION AND FUNCTIONS



Differentiation in SHEEP  is  always  done  with  respect  to  an
independent  variable.   To do variable transformations using the
chain-rule, there are two  sets  of  independent  variables,  the
"DF1" variables and the "DF2" variables.  The number of variables
in each set is usually 4 (*).  This number  can  be  enlarged  by
using the function VARMAX.
Some of the functions that need to know which variable  set  that
is  to  be  used,  are  such  that  they use the value of CRDIF!*
(initially "DF1") as default variable set.  This means  that  the
user  that  only  want  to do standard calculations not involving
variable  transformations,  doesn't  have  to  bother  with  what
variable system is to be used.
The variables in each set are  numbered  from  zero  and  upwards
(i.e.  initially  (usually) 0,1,2,3).  The variables can be named
(i.e. associated with identifiers), by using the  function  VARS,
but  the  variable  numbers  can  always  be  used instead of the
identifiers, in fact some functions only accept variable numbers.
When differentiating a SHEEP expression, three  cases  may  occur
(see  definition  of internal representation in chapter 4).  When
the SHEEP expression is:

SHEEP number   The derivative is zero.

Identifier     The derivative is found on the  property  list  of
               the  identifier.   The  functions VARS or FUNS are
               used to put the derivatives with  respect  to  all
               variables on the property list of identifiers.

SHEEP functional              Call a routine that is found on the
               property  list of the SHEEP operator.  The details
               of this can be found in appendix F.4, but they are
               only important to know if you want to define a new
               SHEEP operator.



7.1  FUNCTION AND VARIABLE DECLARATIONS


  ------------------------------------------------------------
(*) The  number  of  variables  is  initially  the  same  as  the
dimension, which usually is 4.
DIFFERENTIATION AND FUNCTIONS                            Page 7-2


7.1.1  FUNS

FUNS is an MACRO with an indefinite number  of  arguments.   Each
argument defines the derivatives with respect to variables in one
of the two variable sets.   The  value  of  CRDIF!*  defines  the
initial set.
In the following description of the  arguments  to  FUNS,  "vars"
stands  for from zero to VARMAX variables specified as numbers or
the corresponding identifiers.  "id"  stands  for  an  identifier
that is declared as a function by FUNS.

________       _______argument       meaning

DF1            Use the "DF1" set until changed by "DF2".

DF2            Use the "DF2" set until changed by "DF1".

("id" "vars")  Declare "id" as a function depending on  variables
               "vars".  E.g
                                      (FUNS (A 0 2) (B))
               Declares A as a function of variables 0 and 2, but
               independent  of  1  and  3.   Also declares B as a
               function of no variables, i.e. a constant.

                                      NOTE

                   Constants must be declared as functions of
                   no variables.


("id" ALL)     Declare "id" as a function of all the variables.

("id" SUBS)    Use  FOIN  to  read  a  SHEEP   expression.    The
               derivatives of "id" are defined by the derivatives
               of this SHEEP expression.

"id"           Similar to ("id" SUBS) except that if "id"  has  a
               non-NIL  value  then this value is used instead of
               reading a SHEEP expression with FOIN.

("id" SPEC "vars")            Use FOIN to read  replacements  for
               the  derivatives  of  "id"  that  are specified by
               "vars".   "id"  must  have  been  declared  as   a
               function previously.

("id" TRANSF)  Use the chain rule to define  the  derivatives  of
               "id" with respect to the current variable set from
               the derivatives with respect to the other variable
               set.    E.g.   if   we   have  defined  the  "DF1"
               derivatives of A by
                                      (FUNS DF1 (A 0 1))
               then we can define  the  "DF2"  derivatives  of  A
               expressed  in  "DF1"  derivatives  of  A and "DF2"
               derivatives of the "DF1" variables by
                                     (FUNS DF2 (A TRANSF))
DIFFERENTIATION AND FUNCTIONS                            Page 7-3


Identifiers that are declared as functions are put  on  the  FUNS
lists.  If an identifier is already on the FUNS list the message
                            "Id" OLD
is given to tell you that  the  old  FUNS  declaration  has  been
changed.   There  is  one  FUNS list for "DF1" and one for "DF2".
FUNS returns as value the FUNS list  corresponding  to  the  last
variable set used.  E.g.
                             (FUNS)
has as value the default (usually "DF1") FUNS list.
                           (FUNS DF2)
has as value the "DF2" FUNS list.



7.1.2  REMFUNS

REMFUNS is an MACRO with an indefinite number of arguments.   For
each  argument  it removes the definition of the derivatives with
respect to the variables in one of the two  variable  sets.   The
value of CRDIF!* defines the initial set.

________       _______argument       meaning

DF1            Use the "DF1" set until changed by "DF2".

DF2            Use the "DF2" set until changed by "DF1".

"id"           Delete  "id"  from  FUNS  list  and   remove   the
               derivatives  with  respect  to  the current set of
               variables from the property list of "id".

ALL            Do REMFUNS on all elements of current FUNS list.




7.1.3  VARS

(VARS "vt" "var0" "var1"...  )          VARS is an MACRO with  an
               indefinite   number  of  arguments.   "vt"  is  an
               optional argument that specifies the variable  set
               ("DF1"  or  "DF2").   If  "vt" not is present, the
               value of CRDIF!* is used as "vt".
The identifiers "var0", "var1"...  are declared as  variables  no
0,1...   (of  the  "vt"  set  of  variables).   If there are more
arguments (not counting "vt")  than  variables,  then  the  extra
arguments are ignored.
The effect of VARS is:

     1.  REMFUNS the previous variables.

     2.  Define the derivatives of the  variable  identifiers  so
         that  the  derivative  of  each variable with respect to
         itself is one and the derivatives with  respect  to  the
         other variables are zero.
DIFFERENTIATION AND FUNCTIONS                            Page 7-4


     3.  Put the identifier on the "vt" VARS list (but not on the
         FUNS list).

The VARS list is a list with the the variables ordered  with  the
0:th  variable  first.   There are two VARS lists, the "DF1" list
and the "DF2" list.  The values  of  the  identifiers  "DF1"  and
"DF2"  are  the  corresponding  VARS  lists.   The  value  of the
function VARS is the "vt" VARS list.  E.g.
                           (VARS T X)
declares T as variable 0 and X as variable 1.  If there should be
4  variables,  then  the  resulting  VARS list is (T X 2 3).  Any
small number can be used as a  dummy  argument  to  position  the
arguments to VARS correctly.  E.g.
                          (VARS T 5 X)
declares T as variable 0 and X as variable 2.  The resulting VARS
list is (T 1 X 3).

                            EXCEPTION

        The command (VARS "vt") does not change anything,
        it  only  returns  the  VARS  list.   To  REMFUNS
        variables without declaring any new variables do:
                          (VARS "vt" 8)
        where 8 might be replaced with any small number.




7.1.4  VARMAX

The number of variables in a variable set, can be changed by  the
function

(VARMAX "vt" "vrm")           VARMAX  is  an   MACRO   with   two
               (optional) arguments.  "vt" specifies the variable
               set ("DF1" or "DF2").  If  "vt"  is  missing,  the
               value  of  CRDIF!*  is  used as "vt".  If "vrm" is
               missing, VARMAX changes nothing  and  returns  the
               number of variables in the "vt" set.
               If "vrm" is a small  integer  not  less  than  the
               value  of  the  identifier  VARMAX  (*),  then the
               number of variables in the  "vt"  set  is  set  to
               "vrm"  and  all variable and function declarations
               with respect to the "vt" set, are deleted i.e.
                                         (VARS "vt" 0)
                                              and
                                      (REMFUNS "vt" ALL)
               are executed.
               If "vrm" is not a number or to small a number, the
               error
                                        VARMAX TO SMALL
               occurs.
  ------------------------------------------------------------
(*) VARMAX is set to the dimension (DIM) if the TENSOR package is
loaded.   If the number of variables gets less than the dimension
then VARS and FUNS can't construct derivatives  that  the  tensor
algorithms expect.
DIFFERENTIATION AND FUNCTIONS                            Page 7-5


               The value of the function VARMAX is the  old  (the
               current if not changed) number of variables of the
               "vt" set.



7.2  FUNCTIONS FOR DIFFERENTIATION

The following functions are all of the EXPR type.

(DIFF shexp varnu vt)         DIFF   is   a   EXPR   with   three
               arguments.   It is mainly intended for use in DFUN
               functions.
               DIFF differentiates "shexp" with  respect  to  the
               "varnu"th  variable  in the "vt" set of variables.
               DIFF changes "shexp" , which means that you  might
               have to copy before you use DIFF.  A definition of
               DIFF can be found in source file DIFF.SL.

(SDIFF shexp varnu)           SDIFF is a EXPR with two  arguments
               mainly  intended  for use in BULF expressions.  If
               the value of TPSSW is NIL (NIL is  default),  then
               SDIFF is equivalent to
                              (DIFF (COPYL shexp) varnu CRDIF!*)
               where the third argument is the value  of  CRDIF!*
               i.  e.  the default variable set is used.
               When TPSSW not is NIL, it must be an  integer  and
               then the value of SDIFF is the order TPSSW term of
               the derivative of "shexp".

(CHNDIF shexp varnu vt)       Differentiate "shexp" with  respect
               to   the   "varnu"th   variable   among  the  "vt"
               variables, but use the chain-rule to compute  this
               derivative by differentiating "shexp" with respect
               to the other set of variables and  differentiating
               these variables with respect to the "varnu"th "vt"
               variable.

(SCHDIF shexp varnu vt)       When TPSSW is NIL  (default),  then
               SCHDIF is the same as CHNDIF.



7.3  DEFINING NEW SHEEP OPERATORS

As can be seen by the  syntax  for  SHEEP  expressions,  a  SHEEP
expression  is  either  an  identifier,  a SHEEP number or a list
headed by a SHEEP operator.
A SHEEP operator is an identifier with the property EFUN if it is
a  function of one argument, or with the property DFUN if it is a
function with an indefinite number of arguments.
Surcefile DIFF.SL has a definition of DIFF and some  examples  of
EFUN and DFUN operators.












                            CHAPTER 8

                      FORMULA INPUT (FOIN)



8.1  FOIN

Functions, like SETSUB or RPL,  that  insert  formulae,  use  the
formula  reading  function  FOIN  that read a formula in a linear
(infix) notation and converts that to the internal (prefix) SHEEP
representation.  This is done in two steps:  First the formula is
read and converted to a pseudo  SHEEP  representation,  which  is
then  simplified  by SIMPI that goes into all sub expressions and
tries to simplify them.
FOIN uses the prompters "=" and "?" to show that  input  goes  to
FOIN instead of to the LISP READ.



8.1.1  Informal Syntax Description

The input to FOIN is made out of:

               Letters        A - Z and a - z

               Digits         0 - 9

               Special characters       ! # $ % & ( ) * + , - . /
                              : ; < = [ ] ^ _

A list of all characters and their meaning to FOIN  is  found  in
appendix E.

From these characters numbers, identifiers and special  operators
are made.

A number is a string of digits.  E.g.
                         1  3  5645  123

An identifier consists of a string of  letters  and  digits  that
begin with a letter.  E.g.
          A  AA  DFG  S1  SJ8M  ASDERVYB693KTM  aS  XyH
To make the formulae look nice, it is usually a good habit to use
single  letter  identifiers as variables and arbitrary functions.
Use identifiers with more than one character as tensors and other
prefix operators.
The identifiers I and E are reserved.  They may only be  used  as
FORMULA INPUT (FOIN)                                     Page 8-2


imaginary unity and basis for natural logarithms.
To allow other characters in an identifier and to allow  a  digit
in  the beginning, the escape character "!" is used.  A character
preceded by "!", is read as if it was a letter.

The operators are in precedence order:
:= or _        assignment operator
+ and -
*
/
** or ^        exponentiation
& and #        differentiation using the DF1 or DF2 variables
: and <
prefix operators of two types, EFUN operators and DFUN operators,
depending  on  if  they  have  one or more arguments.  The prefix
operators takes their arguments as usual mathematical  functions.
In the present version of SHEEP, the following EFUN operators are
included:  EXP, LOG, SIN, COS, TAN, COT, SINH and COSH.
The DFUN operators are all tensors,  DF,  DFx,  PLUS,  TIMES  and
EXPT.



8.1.2  Meaning Of Some Operators

Most of the operators have an obvious meaning, but some operators
are  more  special  and  their  meaning will be described by some
examples:

_______        _______Example        Meaning

A/B/C          (A/B)/C

/A             1/A

A&X            The derivative of A with respect to the X variable
               in  the DF1 set of variables.  The system will ask
               for information at the end of FOIN if  it  doesn't
               recognize X or A.

A&3            The derivative  of  A  with  respect  to  the  3:d
               variable in the & set.

A#X            The derivative of A with respect to the X variable
               in the DF2 set of variables.

A&(5)X         The 5:th derivative of A with respect to X.

(A+B)&X        The derivative of (A+B) with respect to X.

DF(A,X)        The derivative of A with  respect  to  X.   DF  is
               implemented  to  make  FOIN  able  to  read REDUCE
               output, for  further  definition  of  DF  see  the
               REDUCE manual.
FORMULA INPUT (FOIN)                                     Page 8-3


:A             The value of the identifier A.

:(GDD 0 0)     The value of the LISP expression (this is read  by
               LISP  READ  not  by FOIN!), (GDD 0 0) i.e. the 0,0
               component of the metric tensor.



8.1.3  Different Modes Of FOIN

The input to FOIN is ended by one of the end-characters  "<alt>",
"$", ";" or ".", that affect the modes of FOIN.

   If ";" is used, then FOIN will  use  PRT  to  print  the  read
formula  and if the input is comming from the TTY, then FOIN will
ask for  confirmation  of  the  formula.   This  means  that  the
prompter  "?"  is  printed on the TTY.  If this is answered by an
end-character, that is taken as confirmation of the formula  just
read.   Any  other  answer  is  taken  as  a (corrected) formula,
replacing the previous one.  This new formula is again  ended  by
one  of  the end-characters, if ";" is used, the new formula will
be printed and confirmation will be asked for, and so on.

   If "$" is used FOIN will end and return the  read  formula  as
value.

   If "." is used, FOIN will confirm the formula as for ";"  save
it  and  then  read a new formula, using the prompter "+=".  This
new formula may again be ended by ".", so that the new formula is
saved and still another formula is read.
When this process is ended, the resulting formula is added to the
previously  saved  formula  and  the result of this is added to a
still earlier one and so on, until all the  saved  formulae  have
been added.
This process allows a long formula to be inserted and confirmed a
few terms at a time.



8.1.4  Syntax Error Handling

If a syntax error is found inside a  formula,  FOIN  inserts  the
character  "%" into the formula, at the position of the error and
then tries to read the rest of the formula.

   When a formula has been read by FOIN, a check is made  to  see
if  an  error has been found.  If that is the case, or if the end
character not is known, then the message:
                      "x" FOIN SYNTAX ERROR
is printed on the TTY.  Here "x" is the end character and is only
present if the end character was illegal.

   After the message has been given  the  unsimplified  (probably
erroneous)  formula  is printed and confirmation is asked for, as
if it had been ended by ";".  If it is confirmed and not replaced
by  another  formula,  then  it  is  simplified by SIMPI, and the
confirmation process is entered  a  second  time.   If  the  (now
FORMULA INPUT (FOIN)                                     Page 8-4


simplified)  formula  is  again confirmed, then it is accepted by
FOIN.












                            CHAPTER 9

                         FORMULA OUTPUT



Expressions can be output (printed) in three different formats:

     1.  The PRT format, a multi-line format similar to  ordinary
         mathematical notation.  This is the format used by WRITE
         and all TENVAL functions with a "W" prefix.

     2.  The FOIN format, a single line format readable to  SHEEP
         and  REDUCE.   This  format  is  as near to mathematical
         notation that a  single  line  format  can  be.   It  is
         similar  to the input format of ALGOL, FORTRAN and other
         languages.  This is the format printed by FPRT which  is
         called by FOUT and LFPRT.

     3.  The internal  SHEEP  format,  LISP  S-expressions  in  a
         simple  prefix notation.  This format is used internally
         and it can be printed and read fast to and from external
         memories  using the LISP functions PRINT and READ.  This
         format is used by LPRINT, SAVETN and RESTORETN.




9.1  PRT

PRT is the function  that  prints  expressions  in  a  multi-line
format.   This  is  the  format  that  is  usually  used to print
expressions.  The output from PRT can be changed in a few ways as
described below (see further F.3).
If PSUBS is on, make  substitutions,  using  the  PSUL  list  and
simplify  the result by calling SIMP2.  These substitutions don't
affect expressions stored in the memory,  they  only  affect  the
output.
If  PTEVAR  is  on  then  tensor  indices  are  printed  as   the
corresponding variable names instead of index numbers.
If PVARNUM is  on,  then  variables  in  formal  derivatives  are
printed  as  their  variable  numbers  instead  of their variable
names.
If  RATPAR  is  on  then  rational  numbers  are  surrounded   by
parenthesis.
If the output is going to a file  then  the  output  is  normally
broken  into  pages.   The number of lines per page is set by the
function LINESPERPAGE.  If NOOFIT is on then this  breaking  into
FORMULA OUTPUT                                           Page 9-2


pages is not done.
If the output is going to the TTY then the output is normally not
broken  into  pages, but if FITIN is on and NOOFIT is off then it
will.
If the value of CHINPRO is not NIL, then the value of CHINPRO  is
inserted  between  each  term  in products.  If some variables or
functions prints as more than one letter, then it might be useful
to set CHINPRO to *.

If an identifier has the property  NAM  then  the  identifier  is
replaced  by the property value in the output.  The expression on
the property list under the NAM indicator (the  property  value),
must  be  in  the  format  accepted by the function PRTL, i.e. /*
means go down one line and // means go up one line.  To  generate
expressions in this format and putting them on the property lists
of identifiers, the NAM command is useful:
NAM is a MACRO  with  an  indefinite  number  of  identifiers  as
arguments.   For  each identifier NAM will use FOIN to ask for an
expression that is converted to PRTL format and then put  on  the
property list of the identifier with property indicator NAM.



9.2  FPRT

FPRT is the function that is  used  to  print  expressions  in  a
format readable to SHEEP and REDUCE.  The output from FPRT can be
affected by PSUBS in  the  same  way  as  PRT.   Identifiers  are
substituted  in the output by having a NAMF property, in the same
way as the NAM property in PRT.  There is  also  a  NAMF  command
similar to the NAM command.












                           CHAPTER 10

              TENSOR IMPLEMENTATION AND NEW TENSORS



10.1  IMPLEMENTATION OF TENSORS

A tensor in SHEEP  is  an  identifier  with  special  properties.
Together with this identifier is associated an array in which the
tensor components are stored in lexicographical  order.   In  the
same  way  as  a  usual  LISP array a tensor has an array element
referencing function.  So has e.g. the  expression  (GDD 1 2)  as
value  the  1,2 component of the tensor GDD (the covariant metric
tensor).

 Some symmetries are used to reduce the number of elements of the
array.  So is e.g. the 4-dimensional metric tensor represented by
an array with 10 elements.  The value of the expression (GDD 2 1)
is  the  the  same as that of (GDD 1 2).  The symmetries that are
used  to  reduce  the  number  of  components,  are  symmetry  or
anti-symmetry between indices.

 To use further (more complicated) symmetries, some tensors has a
symmetry  expression  (in  short  a  SYMF)  that  finds  out if a
component can be made from the earlier components of  the  tensor
or  if  it can be found directly in some other way, e.g. if it is
zero.  So e.g. GDD has the SYMF SYDIAG which makes  off  diagonal
components zero if the switch DIAGONAL is on.

 Most tensors have a component building expression  (in  short  a
BULF) that computes tensor components from earlier tensors.

 The identifier TENSORS has as value a list of all tensors.



10.2  THE PROPERTY LIST OF TENSORS

A tensor may on its property list have the following properties.

________ ____  ________Property name  Property

TENSOR         A pointer to the tensor definition block.  This is
               the property that defines an identifier as being a
               tensor.  Set by DECLTEN.
TENSOR IMPLEMENTATION AND NEW TENSORS                   Page 10-2


BULF           The component generating  expression  (the  BULF).
               Is used by the MAKE command to compute components.
               If this property is missing, the MAKE  command  is
               equivalent to RPL.

DELK           A list of the tensors that are not needed any more
               when  making  the  tensor.   These tensors will be
               LOSEd if they are not KEEP declared.

DEP            A list of tensor that depend on the tensor.   Used
               by LOSDEP.

DFUN           Function that DIFFerentiates tensors  in  symbolic
               form.   Set  by  DECLTEN  to  DIFUN  for nonscalar
               tensors.  Because they  have  the  DFUN  property,
               nonscalar  tensors  are  treated  as  functions by
               FOIN.

PREQ           A list of tensors that are  prerequesite  to  make
               the tensor.  Set by PREQ function.

PRT            The tensors PRT function that prints the tensor in
               symbolic  form.   Set  to  PRTEN  by  DECLTEN  for
               nonscalar tensors.

SYMF           The symmetry expression (the SYMF).

TNSPCH         An association list with special  characters  used
               by PRTEN.

UPINDX         A list of  the  contravariant  indices.   Used  by
               PRTEN.

VALUE          Scalar tensors have  their  only  component  here.
               Set to NIL by DECLTEN.



10.3  DEFINING NEW TENSORS.

Only tensors with certain symmetries (or no  symmetry)  can  have
their  symmetry  used  to  reduce  the  number of elements in the
tensor array.  The types of tensors that are allowed,  are  found
on  the  association  list  that  is  the value of the identifier
RANLIS.

 The different TensorTYPEs are represented by names made  of  the
letters  D,  S, A and R (the scalar type SCL is an exception).  D
stands for a single index with no special symmetry, S stands  for
two symmetric indices, A stands for two antisymmetric indices and
R stands for four indices:  two antisymmetric pairs that  can  be
interchanged  pairwise.   So  e.g. AD is the TTYPE of a tensor of
rank three that changes sign  when  the  two  first  indices  are
interchanged.  An example of TTYPE R is RIE the Riemann tensor.
TENSOR IMPLEMENTATION AND NEW TENSORS                   Page 10-3


 A tensor with symmetries that are not found on the RANLIS  list,
can  be  defined as a tensor with a lower symmetry that is on the
RANLIS list.   Further  symmetries  are  implemented  by  a  SYMF
expression.

 To declare a new tensor DECLTEN is used.

(DECLTEN "id" "typ" "nam")    is an MACRO with 2 or 3  arguments.
               It  declares  "id"  as  a  tensor  of TTYPE "typ".
               "typ" must be found on the RANLIS list.  If  "typ"
               is not found on this list then the error
                                          WRONG TTYPE
               occurs.   If  the  optional  argument   "nam"   is
               present,   "id"   will  get  NAM  "nam".   DECLTEN
               generates the tensor  definition  block  and  (for
               nonscalar  tensors)  the tensor array.  When "typ"
               is not SCL (scalar tensor), DECLTEN gives "id" the
               properties DFUN, PRT and EXPR.
               If  there  isn't  enough  space  in  the  BPS  for
               definition block and array, the error
                                 BINARY PROGRAM SPACE EXCEEDED
               will occur and "id" will not become a tensor.  For
               what to do then see appendix H.

(PREQ "id" "tnm1" "tnm2" .  .  .)       is  an  MACRO   with   an
               indefinite  number  of  arguments.  The identifier
               "id" is given the PREQ property
                                     ("tnm1" "tnm2" . . .)
               and "id" is put on the DEP list of all tensors  on
               the  PREQ  list or reachable via the PREQ lists of
               the tensors on the PREQ list and so on.
Appendix F.5, contains LISP definitions  for  the  CORD  tensors.
See also the tensor compiler.












                           CHAPTER 11

                        TENVAL FUNCTIONS



Most of the top level commands in SHEEP (e.g. MAKE, WRITE, LOSE),
are  of the same form.  They are called TENVAL functions.  TENVAL
functions operate on array element or identifier values, on whole
tensors  or on specified tensor components.  Exceptions from this
are MAKE, WMAKE, TEX, TNOEX, REMAKE and WREMAKE that only operate
on  tensor  components.   In this chapter "element" will refer to
either an identifier, an array element or a tensor component.



11.1  ARGUMENTS OF TENVAL FUNCTIONS

TENVAL  functions  are  MACROs  with  an  indefinite  number   of
arguments.   If  there  are any arguments, the identifier SPEC is
set to the argument list.  If there are no arguments the value of
SPEC  is  used  as  default  argument  list.   The  arguments are
processed from left to right, interpreting them in the  following
way:

________                      ______________ ___ ______Argument                      Interpretation and effect

ALL                           The  same  as  the  two   arguments
               TENSORS and VALUE.

TENSORS                       The same as giving as arguments all
               tensors.  E.g.
                                        (LOSE TENSORS)
               Deletes all components of all tensors.
               The identifier TENSORS has as value a list of  all
               tensors.

VALUE                         The same as giving as arguments all
               identifiers  on  the list that is the value of the
               identifier VALUE.  All identifiers that are  given
               a  value  by  a  TENVAL  function, are put on this
               list.  E.g. after
                              (RPL A)
                              A= some input
               then A is a member of the VALUE list.
TENVAL FUNCTIONS                                        Page 11-2


DEFA                          The same  as  giving  as  arguments
               everything  on  the list which is the value of the
               identifier DEFA.  This is  useful  when  the  same
               arguments  are used several times.  DEFA is set to
               the argument list of the function DEFA which is an
               MACRO.

<a tensor name>               Sets the  identifier  LTEN  to  the
               tensor   name.    Specifies   a  range  of  tensor
               components, with  the  first  component  as  lower
               limit  and  the  last  component  as  upper limit.
               These limits are modified if the  tensor  name  is
               immediately followed by FROM, TO or a number.  The
               TENVAL function  will  operate  on  the  range  of
               components,  including the upper and lower limits.
               E.g.
                                          (MAKE RIC)
               Make all components of RIC (the Ricci tensor).

<a number>                    A tensor component index.   One  or
               (depending  on tensor rank) more indices specify a
               component of the tensor whose name is value of the
               identifier   LTEN.    If   the   numbers  are  not
               immediately preceded by  FROM  or  TO  the  TENVAL
               function will operate on this component.
                                        (WRITE RIC 0 0)
               Writes the 0,0 component of RIC.  If LTEN has  RIC
               as value (set by a previous TENVAL function), then
                                          (WRITE 0 2)
               writes the 0,2 component of RIC.

FROM                          Must  be  followed  immediately  by
               numbers  specifying a tensor component, which will
               be the lower limit to a range of components.  E.g.
                                     (WRITE RIC FROM 2 2)
               Writes 2,2 2,3 and 3,3 components of RIC.

TO                            Similar to  FROM,  but  sets  upper
               limit.

<any other identifier>        The TENVAL function will operate on
               the   value   of   the  identifier.   Some  TENVAL
               functions only work on tensors and  will  give  an
               error when operating on identifiers.



11.2  THE INDIVIDUAL TENVAL FUNCTIONS

In the following description of the individual TENVAL  functions,
those  that are prefixed by "(W)" exist in two versions, one with
and one without "W" in front.  the one with "W" is similar to the
one without, but it also WRITEs the elements on which it operate.

TENVAL FUNCTIONS                                        Page 11-3


(W)MAKE                       Doesn't work on identifiers.  Makes
               components  of a tensor, using the BULF expression
               belonging to the tensor.  MAKE  is  equivalent  to
               RPL if there is no BULF expression.
               If there  is  a  BULF  expression  MAKE  does  the
               following:

               1.  If no components are NIL MAKE will do  nothing
                   (WMAKE will WRITE) and its value is:
                                  (<tensor name> ALREADY EXISTS)

               2.  If NOPREQ is on go to 4,  otherwise  MAKE  all
                   tensors  on  the  PREQ  list  belonging to the
                   tensor.  Use WMAKE instead  of  MAKE  for  the
                   tensors that are members of the PRINTN list.

               3.  Use LOSE to delete all tensors on the  tensors
                   DELK  list,  that  not are members of the KEEP
                   list.

               4.  For those components that  are  NIL,  evaluate
                   the  BULF  expression  and store the result in
                   the tensor array.



(W)RPL                        Replace element with  formula  read
               by FOIN.


(W)LSIMP                      Apply  SIMP  on  element.   As  the
               elements  usually are simplified already, the main
               use of LSIMP  is  to  do  SUBS,  ESUBS  and  MSUBS
               substitutions.  Error if elements are NIL.


(W)LAPLY                      The identifier LAPLY has as value a
               user   defined   S-expression.    LAPLY   replaces
               elements  with  the  result  of  evaluating   this
               S-expression.  Error if elements are NIL.
               Initially LAPLY has as value the S-expression
                              (SIMP (MKTIMS (COPYL WLAPLY) RPL))
               that multiplies the  element  (the  value  of  the
               identifier  RPL)  with  a copy of the value of the
               identifier WLAPLY and then simplifies.  WLAPLY  is
               initially set to 1.


WRITE                         Use PRT to  output  elements  in  a
               nice multiple line format.
               If WRITE operates on a range of tensor  components
               (not an identifier or only a single component) and
               the switch NOZERO is on, only  nonzero  components
               are  output.   NOZERO  has the same effect for all
               "W" prefixed TENVAL functions.
               It is usually an error if an element  is  missing,
               but  if  the  switch  DOMAKE  is  on  and WRITE is
TENVAL FUNCTIONS                                        Page 11-4


               operating on components of a tensor  with  a  BULF
               expression,  then  WRITE is similar to WMAKE, with
               the difference that computed components  are  only
               output  and  not  stored in the tensor array.  The
               components in memory are not changed.


LOSE                          Delete elements by setting them  to
               NIL.   Identifiers are also deleted from the VALUE
               list.


LSTAT                         Has as value a list of  information
               about  which  elements  exist  in  memory i.e. are
               different from NIL.  The  elements  of  this  list
               have the following meaning:

               _______        _______               Element        Meaning

               <tensor name>  All components of the tensor exist.

               <other identifier>       The    value    of    the
                              identifier is not NIL.

               (<tensor name>)          No components exist (i.e.
                              all are NIL).

               (<other identifier>)     Either the identifier has
                              no value or the value is NIL.

               <component specification>          This   is   the
                              first  component of the tensor that
                              is NIL, but not all components  are
                              NIL.

               E.g. if the command
                                (LSTAT GUU A GAM B GDD RIC 0 1)
               returns the following value
                                ((GUU 0 2) A (GAM) (B) GDD RIC)
               then

               1.  (GUU 0 0) and (GUU 0 1) are not NIL, but  (GUU
                   0 2) is NIL.

               2.  A has a value different from NIL.

               3.  All components of GAM are NIL.

               4.  Either B has no value or the  value  of  B  is
                   NIL.

               5.  No  component  of  GDD  is   NIL,   i.e.   all
                   components exist.
TENVAL FUNCTIONS                                        Page 11-5


               6.  (RIC 0 1) is not NIL.



SYMMETRIZE                    Except  for  tensors  with  a  SYMF
               expression,  SYMMETRIZE  does nothing.  SYMMETRIZE
               set the symmetry elements in memory by  evaluating
               the  SYMF expression.  As this is also done by all
               TENVAL functions that change elements  in  memory,
               SYMMETRIZE  is  only  needed when some but not all
               components of a tensor, have been  changed.   Used
               by  RESTORETN  as  SAVETN  doesn't  save  symmetry
               components.


LPRINT                        Use PRINT to output an  element  as
               two  S-expressions  followed  by  a "$" sign.  The
               first S-expression is  an  element  specification,
               the  second  S-expression  is  the  element in the
               internal SHEEP representation.
               DOMAKE has the same effect on LPRINT as it has  on
               WRITE,  except  for  that PRINT is used instead of
               PRT.
               Doesn't change components in memory.


(W)LREAD                      Replace element with  formula  read
               with RDIN in the format produced by LPRINT.  LREAD
               can be used to read some specified elements from a
               file.  E.g.
                              (INF AFIL (LREAD RIC 0 0 RIC 0 2))
               will read the 0,0 and the  0,2  component  of  RIC
               from  the  file AFIL.  Better use RESTORETN if you
               want to read an entire file.
               If the switch RDASIS is on LREAD (RDIN)  will  not
               check that the read element is the wanted one.


SAVETN                        The first  argument(which  must  be
               present)  is  a filename (the file doesn't have to
               exist).  The rest of the arguments  are  given  to
               LPRINT,  with  the output going to the file (which
               is on disk by default).
                            (SAVETN <file name> . <argument list>)
               is equivalent to
                         (OUTF <file name> (LPRINT . <argument list>))


LFPRT                         Use FPRT to output an element as  a
               REDUCE assignment statement.
               DOMAKE has the same effect on LFPRT as it  has  on
               WRITE,  except  for  that  FPRT is used instead of
               PRT.
               Doesn't change components in memory.
               If the switch NOFARY is off, tensor components are
               assigned to an array with the tensor name as array
               name and tensor  indices  as  array  indices.   If
TENVAL FUNCTIONS                                        Page 11-6


               NOFARY  is  on,  tensor components are assigned to
               identifiers  that  are  created  by  putting   the
               indices at the end of the tensor name.


(W)LFREAD                     Similar to LREAD  except  for  that
               FRDIN  is  used to read element in format produced
               by FPRT.


FOUT                          Similar to SAVETN but LFPRT is used
               instead of PRINT.  Intended for communication with
               REDUCE.


(W)REMAKE                     MAKE tensor  components  but  treat
               them as if all components were NIL.


(W)LINIT                      Similar to LAPLY, but elements  may
               be NIL in memory and the S-expression that is used
               is the value of the identifier LINIT.  The initial
               value  of LINIT is an S-expression that copies the
               value  of  the  identifier  WLINIT.    WLINIT   is
               initially set to 0.


SYMBOLIC                      Replace an element with an  element
               specification.


TEX                           Works only  on  tensor  components.
               For  each component evaluate the S-expression that
               is the value of the identifier  TEX,  and  if  the
               value not is NIL, PRINT a component specification.
               The only way that TEX may change the components is
               by  the  S-expression  to  do  it  (which  not  is
               recommended).
               The initial S-expression is just RPL (which has as
               value  the  element).   This  means  that TEX will
               print specifications for the elements  that  exist
               in memory (i.e. that not are NIL).


TNOEX                         Similar   to   TEX    but    prints
               specifications   for   components  for  which  the
               S-expressions value is NIL.



11.3  MESSAGES WHEN RUNNING TENVAL FUNCTIONS

Some TENVAL functions can give messages on how they proceed.  For
other types of messages see the chapter on error messages.

TENVAL FUNCTIONS                                        Page 11-7


If

     1.  The TENVAL args specify tensor components.

     2.  Any TENVAL function but LSTAT or LOSE is used.

     3.  The switch NOMSG is off (NIL).

     4.  The TENVAL function would not otherwise  print  anything
         on  the  TTY.  I.e. either output is not directed to the
         TTY, or the TENVAL function is not W prefixed or one  of
         WRITE, LFPRT, LPRINT, TEX or TNOEX.

     5.  The TENVAL function doesn't ask for input from the  TTY.
         I.e. either the input isn't comming from the TTY, or the
         TENVAL function isn't RPL or WRPL.

then, one of the following two messages will be  printed  on  the
TTY (even if ordinary output has been directed somewhere else).

     1.  If the switch ALLMSG is off, the name of the  tensor  is
         printed  when  operation  starts  on  the  first  of the
         specified  components  and  "ENDED"  is   printed   when
         operation  on  the  last  of the specified components is
         finished.  This is done for each tensor.

     2.  If ALLMSG is on, a component  specification  is  printed
         for each component when operation starts on it.

%RUNOFF-W-NIA, Negative indent attempted
	on output page 11-7; on input line 224 of page 1 of file "DISK$UPA:[SHEEP.DOC.MAN]C11.RNM;6"



11.4  SOME RELATED FUNCTIONS

(PRINTN <tensor names>)       PRINTN  is   an   MACRO   with   an
indefinite  number  of  arguments.   The  arguments  are names of
tensors.  PRINTN puts these tensors on the  PRIN  list  i.e.  the
list  that is the value of the identifier PRIN.  The value of the
function PRINTN is also the PRIN list.

(NOTPRINTN <tensor names>)    Similar to PRINTN, except for  that
it deletes its arguments from the PRIN list.

(KEEP <tensor names>)         Similar to PRINTN, except for  that
the KEEP list is manipulated instead of the PRIN list.

(NOTKEEP <tensor names>)      Similar to KEEP, except for that it
deletes its arguments from the KEEP list.

(DEFA <TENVAL arguments>)     DEFA is  an  MACRO  with  the  same
arguments that would be given to a TENVAL function.  The argument
list becomes the value of the identifier  DEFA.   This  value  is
used  as  a list of arguments if "DEFA" is given as argument to a
TENVAL function.
TENVAL FUNCTIONS                                        Page 11-8


11.5  SOME IDENTIFIER VALUES

__________                    _____Identifier                    Value

CRELM!*                       The current element.  An  exception
to  this is that if the TENVAL function is of the type that makes
changes in an element (i.e. (W)LSIMP or (W)LAPLY) and the  switch
                                              ____NOASCOP  is off, then the value of RPL is the copy of the current
element.
The value of  RPL  can  e.g.  be  (and  is)  used  in  the  LAPLY
S-expression.


All the following values  are  only  set  and  used  when  TENVAL
functions operate on tensor

LTEN                          The  last  tensor  specified  as  a
TENVAL argument.

CTEN                          The current tensor.   This  is  the
same as LTEN when not doing MAKE via the PREQ list.

SYMFOUND                      NIL if the current component not is
a symmetry component, otherwise not NIL.

INDX1                         First   index   of   the    current
component.

INDX2                         Second index.  The  maximum  number
of  indices  (the maximum rank) is decided when SHEEP is compiled
but the usual number is 5, which means that also INDX3, INDX4 and
INDX5 might (depending on the current tensors rank) have a value.

SPEC                          The  argument  list  of  the   last
TENVAL  function  that  had  any arguments.  This list is used as
default when a TENVAL function has no arguments.

LOSE                          The rest of the  arguments  on  the
current TENVAL argument list.  The value is NIL outside of TENVAL
functions if the last TENVAL function wasn't halted by  an  error
or a ^C.

LSTAT                         For TENVAL functions  that  have  a
non  NIL  value  (at the moment LSTAT, SAVETN, FOUT and sometimes
MAKE), values obtained when processing the argument list, are put
on  a  list which is kept as value of the identifier LSTAT.  When
finished, the reverse of this list becomes value  of  the  TENVAL
%RUNOFF-W-NIC, Another 17 negative indents detected and accumulated. Now being reported
	on output page 11-8; on input line 273 of page 1 of file "DISK$UPA:[SHEEP.DOC.MAN]C11.RNM;6"
function and LSTAT is set to NIL.












                           CHAPTER 12

                        FILE MANIPULATION



12.1  READING OR PRINTING DISK FILES

12.1.1  Saving Expressions In Disk Files

The following two MACRO functions print or  read  expressions  in
the internal format of SHEEP to or from disk files.

(SAVETN <file> <TENVAL args>) SAVETN is a  TENVAL  function  that
               saves  its  specified  arguments on disk in a file
               named "file".  See 11-5.

(RESTORETN <file>)            RESTORETN is an  MACRO.   It  reads
               into  SHEEP  the  file  "file",  generated  by  an
               earlier SAVETN command.



12.1.2  REDUCE Interface

The following two MACROs are similar to SAVETN and RESTORETN, but
the  expressions  are  in  LFPRT format, which is compatible with
REDUCE.

(FOUT <file> <TENVAL args>)   FOUT is similar to SAVETN,  but  it
               uses  FPRT  to  print  the  specifed elements in a
               format readable to REDUCE.  See 11-6.

(FIN <file>)   FIN is similar to RESTORETN but it  uses  FOIN  to
               read  expressions in the format printed by FPRT or
               by REDUCE.



12.1.3  Reading Commands From Disk Files

(DSKIN <file specifications>) DSKIN reads the file  specified  by
               <file   specification>.    The  format  for  <file
               specification> is the same as that  for  the  LISP
               function  OPEN (see the LISP manual).  DSKIN reads
               LISP expressions and evaluates them  in  the  same
               way as the top level of SHEEP.  This means that it
               can be used to read SHEEP commands  from  a  file.
FILE MANIPULATION                                       Page 12-2


               See 2-8 for an example of its use.



12.1.4  Writing On The Line Printer

(LPTWRITE <TENVAL args>)      LPTWRITE is a TENVAL function  that
               generates  a  file  with  the  specified  elements
               written in PRT format.  This file is sent  to  the
               line-printer  at  logout  time  and  then deleted.
               LPTWRITE generates itself a name for the file.



12.2  OUTF AND INF

The following two functions are MACROs with an  arbitrary  number
of arguments.  They don't print or read anything themselves, they
only temporarily change the destination of output or  the  origin
of  input  and  then  executes  given  commands (that may read or
print).

(OUTF <file> <commands>)      OUTF changes the output destination
               to   the   file   "file",  executes  the  commands
               "commands" one after another and then changes  the
               output  destination back to what it was before the
               OUTF command.

(INF <file> <commands>)       INF  is  similar  to  OUTF  but  it
               changes  the  input  origin  instead of the output
               destination.

INF can e.g. be combined with LREAD in the following way:
                   (INF BORIC (LREAD RIC 0 0))
reads the 0,0  component  of  the  Ricci  tensor  from  the  file
"BORIC".












                           CHAPTER 13

                          POWER SERIES



Power series are not yet available in Sheep 2.  This  chapter  is
not yet completed.  For a simple example see 2.4.












                           CHAPTER 14

                        THE CORD PACKAGE



The CORD package computes the Einstein  tensor  in  a  coordinate
frame.



14.1  THE CORD TENSORS

The following tensors are defined.

____    _____   ___________ _______Name    Print   Computation formula

GDD     G       = User input.
         ij

GDF     G       = Differentiate G
         ij,k                    ij

GAM     GAM     = 1/2*(G    +G    -G    )
           ijk          ij,k  ik,j  kj,i

GDET    GDET    = Determinant of GDD

         -1
GINV    G       = 1/GDET

         ij
GUU     G       = GINV*(Cofactor of G  )   or user input
                                     ji

           i       il
GAMU    GAM     = G  GAM
            jk          ljk

                                             m            m
RIE     R       = GAM     -GAM     +GAM   GAM   -GAM   GAM
         ijkl        ijl,k    ijk,l    mil    jk    mik    jl

                   kl
RIC     R       = G  R
         ij           ikjl
THE CORD PACKAGE                                        Page 14-2


         i         il
RICM    R       = G  R
          j           lj

                   k
RSCL    R       = R
                    k

EIN     T       = R  -1/2*R*G
         ij        ij        ij

         i         i
EINM    T       = R  -1/2*R    The second term only when i = j.
          j         j



14.2  ALTERNATIVE ALGORITHM

There is an alternative way to  calculate  RSCL  and  EINM.   The
command
                           (NORICM T)
changes the algorithms so that RSCL and EINM  are  calculated  in
the following way.

                   ij
RSCL    R       = G  R
                      ij

         i         ik
EINM    T       = G  T
          j           kj

The command
                          (NORICM NIL)
restores the original algorithms.   The  value  of  the  function
NORICM is the previous setting.



14.3  CONTROL OF GDET

As SHEEP hasn't got  polynomial  division,  taking  a  sum  to  a
negative  power  usually  produces  unwanted  (although  correct)
results.  For this reason, when making GINV there is a  check  if
GDET is a sum.  When that is the case, the following happens:

     1.  GDET is put on the  KEEP  list  so  that  the  automatic
         deletion is inhibited.

     2.  The identifier GDET taken to power -1 becomes the  value
         of GINV.

     3.  The message "GDET SYMBOLIC AS IT IS A SUM" is printed on
         the TTY.

When this happens, the system will later find that GDET  not  has
THE CORD PACKAGE                                        Page 14-3


been  declared as a function.  The easiest way to declare GDET as
a function, is to give the command:
                           (FUNS GDET)












                           CHAPTER 15

                        THE FRAME PACKAGE



The FRAME package computes the Einstein tensor in a moving  frame
with a constant metric.



15.1  THE FRAME TENSORS

The following tensors are defined.

____    _____   ___________ _______Name    Print   Computation formula

         AB
HUU     H       = User input. The frame metric.

         -1
HINV    H       = 1/(Determinant of HUU)

                                     BA
HDD     H       = HINV*(Cofactor of H  )
         AB

ZDD     Z       = User input. The covariant frame vectors.
         Ai

         A         AB
ZUD     Z       = H  Z
          i           Bi

                   AB
GDD     G       = H  Z  Z
         ij           Ai Bj

ASD     Z       = Z    -Z
         A[i,j]    Ai,j  Aj,i

ZDET    ZDET    = Determinant of ZUD

         -1
ZINV    Z       = 1/ZDET
THE FRAME PACKAGE                                       Page 15-2


          i                          A
ZDU     Z       = ZINV*(Cofactor of Z  )   or user input
         A                            i

         jk        AB  j  k
GUU     G       = H  Z  Z
                      A  B

           ij       i  j   i  j        i   j
APZ     Z       = Z  Z  -Z  Z    ( = Z   Z    )
         AB        A  B   B  A        [A  B]

                            ij
LIE     C       = Z      Z         i < j
         ABC       C[i,j] AB

GAM     GAM     = 1/2*(C   +C   -C   )
           ABC          ABC  ACB  BCA

                            i            i
RIE     R       = GAM     Z   -GAM     Z   +
         ABCD        ABD,i C      ABC,i D

                  EF
                +H  (GAM   GAM    -GAM   GAM    -GAM   C   )
                        AEC   FBD     AED   FBC     ABE CDF

                   CD
RIC     R       = H  R
         AB           ACBD

         A         AC
RICM    R       = H  R
          B           CB

                   AB
RSCL    R       = H  R
                      AB

EIN     T       = R  -1/2*R*H
         AB        AB        AB

         A         AC
EINM    T       = H  T
          B           CB



15.2  ALTERNATIVE ALGORITHM

There is an alternative way to  calculate  RSCL  and  EINM.   The
command
                          (NORICM NIL)
changes the algorithms so that RSCL and EINM  are  calculated  in
the following way.
THE FRAME PACKAGE                                       Page 15-3


                   A
RSCL    R       = R
                    A

         A         A
EINM    T       = R  -1/2*R    The second term only when A = B.
          B         B

The command
                           (NORICM T)
restores the original algorithms.



15.3  CONTROL OF ZDET

As SHEEP hasn't got  polynomial  division,  taking  a  sum  to  a
negative  power  usually  produces  unwanted  (although  correct)
results.  For this reason, when making ZINV there is a  check  if
ZDET is a sum.  When that is the case, the following happens:

     1.  ZDET is put on the  KEEP  list  so  that  the  automatic
         deletion is inhibited.

     2.  The identifier ZDET taken to power -1 becomes the  value
         of ZINV.

     3.  The message "ZDET SYMBOLIC AS IT IS A SUM" is printed on
         the TTY.

When this happens, the system will later find that ZDET  not  has
been  declared as a function.  The easiest way to declare ZDET as
a function, is to give the command:
                           (FUNS ZDET)



15.4  STANDARD FRAME METRICS

There are commands that will make the most common frame metrics.

(LORENTZ)      Makes an orthogonal  frame  (tetrad)  with  pseudo
               euclidean metric, i.e. HDD = HUU diagonal with
               H   = 1  and  H   = -1  for A > 0.
                00            AA
               LORENTZ is the default metric that is initially in
               existence in FRAME.

(HNULL)        A frame (tetrad) with two  null  vectors  and  the
               other  vectors orthogonal and space like.  Similar
               to LORENTZ, except for that
               H   = H   = 0  and  H   = 1.
                00    11            01
THE FRAME PACKAGE                                       Page 15-4


(NULLT)        A null tetrad, i.e. a frame with null vectors such
               that HDD = HUU,
               H   = 1  and  H   = -1
                01            23
               and all others = 0.  If the dimension is different
               than 4, then the value of HDD = HUU can be seen by
               the command (WRITE HUU).












                           APPENDIX A

               THE FUNCTIONS AND COMMANDS IN SHEEP



The following is an alphabetical list of functions  and  commands
in SHEEP1.  Functions are described in the format:
  <function name>(<function arguments separated by ,>):value
The following notation is used:  a "'" before an  argument  means
that  the argument is quoted, "[" and "]" surrounding an argument
means that there may be indefinitly many arguments of that  type,
"{"  and  "}"  surrounding an argument means that the argument is
optional, "sh-exp" means  a  SHEEP-expression,  "s-exp"  means  a
LISP-expression  as  does  "any", "?" means that the value varies
(see  description  of  the  specific  function),  "id"  means  an
identifier.


ASYMEND([index]):sh-exp
AWRITE([tenval-arg]):NIL
CMULT([sh-exp]):sh-exp
COFAC(tensor-name,line-index,colonn-index,sh-exp):sh-exp
CONTINUE():?
COPYA(list of sh-exp):list of sh-exp
COPYL(sh-exp):sh-exp
DECLFUN(['id]):NIL
DECLTEN('id,'tensor-type,{'output-name}):id
DEFA(['tenval-arg]):list of tenval-args
DET(tensor-name):sh-exp
DFMQ(sh-exp,variable-index,sh-exp):sh-exp
DIFF(sh-exp,variable-index,variable-set):sh-exp
DIFFORDER(integer or any):integer
DOCOPY(sh-exp):sh-exp
DOMULC(sh-exp,sh-exp):sh-exp
DREVRS(list):list
EDITM(sh-exp):sh-exp
EFFACE(list,s-exp):list
EJECT():?
EXPANDLIM(integer or any):integer
FIN('file-name):(file-name,?)
FINSET():
FOIN():sh-exp
FOINP(sh-exp):sh-exp
FOUT('file-name,['tenval-arg]):(file-name,?)
FPRING(sh-exp,sh-exp):sh-exp
FRDIN(element-spec):sh-exp
FUNS(['funs-arg]):funs-list
THE FUNCTIONS AND COMMANDS IN SHEEP                      Page A-2


GETPOW(sh-exp,tps-index):sh-exp
GETSUL(subs-list-name):subs-list
GETVAR(variable-name,variable-set):variable-index
INF(file-spec,[s-expr]):s-expr
INSET():
INVERT(sh-number):sh-number
KAR1(index-list):s-exp
KEEP(['tensor-name]):keep-list
KINC(channel-name):previous channel-name
LAPLY(['tenval-arg]):NIL
LEXP(id,id):T or NIL
LFPRT(['tenval-arg]):NIL
LFREAD(['tenval-arg]):NIL
LINESPERPAGE(integer or any):integer
LINIT(['tenval-arg]):NIL
LOMIN(list,list):list
LOSDEP(['tensor-name]):NIL
LOSE(['tenval-arg]):NIL
LPRINT(['tenval-arg]):NIL
LPTWRITE(['tenval-arg]):(file-name,?)
LREAD(['tenval-arg]):NIL
LSIMP(['tenval-arg]):NIL
LSTAT(['tenval-arg]):spec-list
MAKE(['tenval-arg]):?
MCORE(integer):
MINOR(tensor-name,line-index,colonn-index):sh-exp
MKEXP(sh-exp,sh-exp):sh-exp
MKPLUS(sh-exp,sh-exp):sh-exp
MKTIMES(sh-exp,sh-exp):sh-exp
MOVSUL('id,{'subs-list-name}):NIL or id
NAM(['id]):NIL
NAMF(['id]):NIL
NEDITM(sh-exp):sh-exp
NEXT():?
NEXTA():?
NORICM(T or NIL):T or NIL
NOTKEEP(['tensor-name]):keep-list
NOTPRIN(['tensor-name]):prin-list
OFF(['switch]):list of switches
ON(['switch]):list of switches
ORDERP(id,id):T or NIL
OUTF(file-name,[s-expr]):s-expr
PARDEEP(integer or any):integer
PLUSIM(sh-exp,sh-exp):sh-exp
POWER(integer or any):integer
PREQ('tensor-name,['tensor-name]):list of tensor-names
PRIN(['tensor-name]):prin-list
PRING(sh-exp,sh-exp):sh-exp
PRSUB(['subs-args]):NIL
PRT(sh-exp):sh-exp
PRTL(s-expr):NIL
PUTIL(element-spec,sh-exp):sh-exp
PUTIN(element-spec,sh-exp):sh-exp
PUTSUL(id,subs-list):NIL or id
QTERPRI({any}):{any}
RANK(tensor-name):integer
RDIN(element-spec):s-exp
THE FUNCTIONS AND COMMANDS IN SHEEP                      Page A-3


REMAKE(['tenval-arg]):?
REMFUNS(['remfuns-arg]):NIL
REMSUB(['subs-args]):integer
RESTORE('file-name):(file-name,?)
RETUR({any}):{any}
RPL(['tenval-arg]):NIL
SAVE('file-name,['tenval-arg]):(file-name,?)
SDIFF(sh-exp,variable-index):sh-exp
SEQ0L(integer):list of integers
SETEX(['integer]):setex-status-list
SETSUB(['subs-arg]):integer
SIMP(sh-exp):sh-exp
SIMP1(sh-exp):sh-exp
SIMP2(sh-exp):sh-exp
SIMPE(sh-exp):sh-exp
SIMPEX(sh-exp):sh-exp
SIMPFUN(sh-exp):sh-exp
SIMPI(sh-exp):sh-exp
SMEXPT(sh-exp,sh-exp):sh-exp
SNUM(number,number):sh-number
SPLIP():element-spec
SPLIS():element-spec
SUBL1(sh-exp,subs-list):sh-exp
SUBMTIMES(integer or any):integer
SUBS1(sh-exp,sh-exp,sh-exp):sh-exp
SYMBOLIC(['tenval-arg]):NIL
SYMEND([index]):sh-exp
SYMMETRIZE(['tenval-arg]):NIL
TENP(id):T or NIL
TEX(['tenval-arg]):NIL
TITLE(['any]):(TXT.list)
TIPRGN(sh-exp,sh-exp):sh-exp
TIPRNG(sh-exp,sh-exp):sh-exp
TLOSE(tensor-name):?
TNOEX(['tenval-arg]):NIL
TOELM(['tensor-index],['tenval-arg]):?
TPSINIT(['tenval-arg]):NIL
TPSMUL(sh-exp,sh-exp):sh-exp
TSTAT(tensor-name):status
TTYPE(tensor-name):ttype
VALU(sh-exp):s-exp
VARMAX({'variable-set},{'integer or any}):integer
VARS(['vars-arg]):vars-list
WHERE():NIL or element-spec
WLAPLY(['tenval-arg]):NIL
WLFREAD(['tenval-arg]):NIL
WLINIT(['tenval-arg]):NIL
WLREAD(['tenval-arg]):NIL
WLSIMP(['tenval-arg]):NIL
WMAKE(['tenval-arg]):?
WREMAKE(['tenval-arg]):?
WRITE(['tenval-arg]):NIL
WRONG():
WRPL(['tenval-arg]):NIL












                           APPENDIX B

                     THE SWITCHES IN SHEEP1



______         ______ ____ __Switch         Effect when on

ALLMSG         Causes   some   TENVAL    functions    to    print
               specifications  of  all  tensor  components  being
               processed.  Is inhibited by NOMSG.

ALTSIMP        Causes SIMP1 not to simplify sums before expanding
               with distributive law.

CFILFO         Causes FOIN to ask for confirmation  after  seeing
               ";"  even  if  input  not is comming from the TTY.
               Confirmation is taken from the TTY.

DIAGONAL       Causes the symmetry expression  (SYDIAG)  to  make
               off  diagonal  components  zero.  Tells the system
               that  the  metric  or  the  tetrad   vectors   are
               diagonal.

DOMAKE         Causes the TENVAL output functions (WRITE,  LFPRT,
               LPRINT,   SAVE  and  FOUT),  to  generate  missing
               components instead of giving an error message.

DONTCLOSE      Causes OUTF  and  INF  not  to  close  files  when
               finished.

ESUBS          Causes ESUBS substitutions in SIMP.

FITIN          Causes PRT (PRTL) to fit all  output  into  pages,
               also the output to the TTY.  Inhibits NOOFIT.

FPRT           Causes TIPRNG and TIPRGN to do FPRT output instead
               of PRT output.

FUNSIM         Causes SIMP2 to simplify arguments  to  all  SHEEP
               operators and not only to "&+", "*", "^" and "E".

LEXICO         Causes  SIMP1  (EDIT)  to   put   identifiers   in
               lexicographical order.

MSUBS          Causes MSUBS substitutions in SIMP.
THE SWITCHES IN SHEEP1                                   Page B-2


NEW            When the double tensor feature is implemented, NEW
               causes the NEW side of tensors to be used.

NOASCOP        Causes (W)LSIMP and (W)LAPLY to place the original
               instead  of a copy of the current element as value
               of the identifier RPL.

NODGNV         Causes CORD or FRAME not to  take  special  action
               when GDET, HDET or ZDET is a sum.

NOFARY         Causes FPRT and LFPRT to print  tensor  components
               as  several  REDUCE  scalar assignments instead of
               assignments to a tensor.

NOMSG          Causes TENVAL  functions  not  to  inform  when  a
               tensor is entered or left.  Inhibits ALLMSG.

NOOFIT         If FITIN is off  causes  PRT  (PRTL)  not  to  fit
               output into pages.

NOPREQ         Causes  TENVAL  functions  that  generate   tensor
               components  not to check that prerequisite tensors
               are made.

NOPRT          Causes PRT to do nothing.

NOSIMP         Causes SIMP to do nothing.  Sometimes useful  when
               debugging.

NOSYMSG        Causes TENVAL functions not to  inform  when  they
               are processing symmetry components.

NOSYRST        Inhibits the automatic  SYMMETRIZE  after  RESTORE
               and FIN.

NOZERO         Causes  TENVAL  functions  not  to  WRITE   tensor
               components  that are zero, when output is going to
               the TTY.

POTSIM         Causes  SIMP  to  apply   SIMP2   also   when   no
               substitutions have been done.

PSUBS          Causes PSUBS substitutions in PRT.

PTEVAR         Causes  PRT  (VALU)  to  print  tensor   component
               specifications  with  variable  names  instead  of
               variable numbers.

PVARNUM        Causes PRT  to  print  symbolic  derivatives  with
               variable numbers instead of variable names.

PZPOW          Causes PRT when  printing  a  TPS,  to  print  the
               zeroth  order  as the zeroth coefficient times the
               expansion variable to power zero, instead of  just
               the coefficient.
THE SWITCHES IN SHEEP1                                   Page B-3


RATORDN        Causes SIMP (EDIT) to order numbers in  increasing
               order,  instead  of ordering rationals first after
               nominator and then after denominator.

RATPAR         Causes PRT to print  parenthesis  around  rational
               numbers in products.

RDASIS         Causes LREAD (RDIN) and  LFREAD  (FRDIN)  to  read
               without  checking  that  the  input  is the wanted
               expression.

RDTPS          Causes  FIN  and   LFREAD   to   interpret   array
               assignments as being TPS coefficients.

SIMPFUN        Causes SIMP2 (SIMPEX) to simplify arguments to all
               operators.

SUBPOT         Causes  substitutions  to  match  masks  that  are
               integral  powers, with expressions that have equal
               basis  and  bigger  or  equal  integral  exponent,
               instead of just with equal exponent.

TRYAGAIN       Causes  LREAD  (RDIN)  and  LFREAD  (FRDIN),  when
               reading  from  a  file,  to  start  again from the
               beginning of the file if a wanted expression isn't
               found.












                           APPENDIX C

                           SOME VALUES



This appendix is not yet completed.












                           APPENDIX D

                  DIAGNOSTIC AND ERROR MESSAGES



In the following description of the  messages  given  by  SHEEP1,
some  messages  are  preceded or followed by an expression.  This
expression is indicated by "x" in the description.
Error messages that are not found in this appendix are LISP error
messages, that are found in the LISP manual.



D.1  ORDINARY ERROR MESSAGES

The following errors are  of  the  same  type  as  ordinary  LISP
errors.   This  means  that  execution  of the function where the
error occurred is halted and a backtrace can be given.

_____ _______                 _______Error message                 Meaning

CAN'T CONTINUE                Either  a   continuation   function
                              (CONTINUE,  NEXT,  NEXTA  or TOELM)
                              could not continue the last  TENVAL
                              function,  or  WHERE could not find
                              an  element   specification.    The
                              reason  for  the  error is that the
                              TENVAL function was LOSE  or  LSTAT
                              or  it  was  not  halted  or it was
                              halted because of faulty arguments.

CAN'T SUBSTITUTE NUMBERS      A substitution pair with  a  number
                              as mask, cannot be made by SETSUB.

ERROR                         Incorrect format of  expression  on
                              input file.  Also used as a general
                              error.  Might be system error.

MISSING ARG IN FEXPR          One or more arguments were  missing
                              in  a  call  to  an FEXPR function.
                              The following functions could  have
                              generated  this error:  SAVE, FOUT,
                              FIN, RESTORE, INF,  OUTF,  PUTPREQ,
                              DECLTEN, MOVSUL and TENFILE.
DIAGNOSTIC AND ERROR MESSAGES                            Page D-2


MISSING ELEMENT
DEFINE BULF                   This error can only occur if DOMAKE
                              is  on.   WRITE,  LFPRT  or  LPRINT
                              found a  tensor  with  a  component
                              that  was  NIL and the tensor could
                              not be made, as there was  no  BULF
                              expression.

MISSING TERM IN TPS           A term of  a  necessary  order  was
                              missing.   Compare  with comment on
                              "x" MISSING ELEMENT message.

NO OF INDICES NOT EQ RANK     The  number  of  indices  given  as
                              TENVAL arguments, were to few or to
                              many.

RANK NOT 2                    The functions DET, MINOR and  COFAC
                              only operate on tensors of rank 2.

SHEEP NUMBER OVERFLOW         An arithmetic routine got overflow.
                              This  error  will can only occur in
                              unusual  versions  of  SHEEP   that
                              don't  have  general  LISP  numbers
                              (see chapter 4).

TO MUCH                       See  description   of   the   SETEX
                              function.

VARMAX TO SMALL               An argument to VARMAX that was  not
                              "#"  or "&" was less than the value
                              of  the  identifier  VARMAX.   Note
                              that  the  error  will occur if the
                              argument is neither  a  number  nor
                              "#" or "&".

WRONG TPS LENGTH              If you have not been meddling  with
                              the  TPS  representation,  this  is
                              probably a system error.

WRONG TPS ORDER               A term of lower order in a TPS  was
                              missing  when  a  higher order term
                              was going  to  be  inserted.   This
                              higher order term is saved as value
                              of the  identifier  PUTPS  and  the
                              error occurs.

WRONG TYPE                    The second argument to the  DECLTEN
                              command  was  not  a  member of the
                              list RANLIS.

"x" INDEX ?                   The index "x" was to  great  or  to
                              small.   Note that this will happen
                              if "x" is not a number.
DIAGNOSTIC AND ERROR MESSAGES                            Page D-3


"x" MISSING ELEMENT           The  component  with  specification
                              "x" was NIL.  This will be an error
                              in the  tensor  component  fetching
                              function, in SYMEND and in ASYMEND,
                              in (W)LSIMP and in (W)LAPLY and (if
                              DOMAKE  is off) in WRITE, LFPRT and
                              LPRINT.  A probable reason for this
                              error is that NOPREQ is on, or that
                              a  new  tensor  has  been   defined
                              without  the  PREQ  list  it should
                              have.

"x" NOT A SHEEP NUMBER        One of the arithmetic routines  was
                              given  "x" as argument, but "x" was
                              not a SHEEP number (see  syntax  in
                              chapter 4).

"x" NOT A SWITCH              "x" was not a member  of  the  list
                              SWITCHES.  This error occurs if "x"
                              is given as argument to ON, OFF  or
                              SWISTAT.

"x" NOT A TENSOR              A function that expected  a  tensor
                              name  was  given  "x"  as  argument
                              instead.   Note  that  some  TENVAL
                              functions  (e.g.  MAKE) only accept
                              tensors.  The same is the case  for
                              LOSDEP,  TENFILE, TLOSE, DET, MINOR
                              and COFAC.

"x" NOT LIST                  "x" should have been  a  list.   In
                              some  cases  "x"  should  be a list
                              with at least one element, i.e. the
                              empty  list  NIL  is illegal.  This
                              error usually occurs if expressions
                              are used that don't have the syntax
                              of SHEEPs internal  representation.
                              A possible system error.

"x" NOT MADE                  An error occurred  when  evaluating
                              the  BULF  expression  that  should
                              have made the component "x".

"x" NOT SUBS LIST             A   function   that   operates   on
                              substitution  lists expected "x" to
                              be a SUBS list, but it was  not  an
                              identifier  with the property SUBS.
                              This error  may  occur  in  SETSUB,
                              REMSUB,  PRSUB,  MOVSUL, GETSUL and
                              PUTSUL.



D.2  CALLS FOR DECLARATION

The  following  messages  are  given  when   the   system   needs
information.   they  are  followed  by  the  message  NOW and the
DIAGNOSTIC AND ERROR MESSAGES                            Page D-4


prompter "*" which asks for a declaration command to be executed.
When  the  system  has  got its information, it goes on executing
from where it stopped in order to get needed information.

"x" DECLARE FUNCTION          The  system  doesn't  know  how  to
                              differentiate  the  identifier "x".
                              Use the FUNS command to declare "x"
                              as  a  function,  or  use  the VARS
                              command  to  declare   "x"   as   a
                              variable if that is the case.

"x" DECLARE VARIABLE          As the system didn't  find  "x"  on
                              the  VARS list, it couldn't compute
                              the variable number.  Use  VARS  to
                              declare  variables.   (If  symbolic
                              variables  are  used,  "x"  doesn't
                              have  to  be  on the VARS list.  In
                              this case "x" wasn't known for some
                              other  reason.)  The  function that
                              uses the VARS list is GETVAR, which
                              is used in FOIN, SIMPI and FUNS.

"x" DEFINE DIFF FUNCTION      The expression  "x"  could  not  be
                              differentiated,    as   the   first
                              element   of   "x"   not   was   an
                              identifier  with  a  DFUN  or  EFUN
                              property.  If  you  define  such  a
                              property  (see examples in appendix
                              F.4) the system can continue.

"x" VARIABLE NAME?            The  variable  number  "x"   didn't
                              correspond   to  a  variable  name.
                              Because  of  this,  FPRT   couldn't
                              print  a  symbolic  derivative with
                              the prefix DF,  as  variables  then
                              must be represented by identifiers.
                              Use VARS to name the variables.



D.3  DIAGNOSTIC MESSAGES

NOT FOUND                     The  element   specified   in   the
                              preceding message "x" OUT OFF ORDER
                              was not found on a  file.   Message
                              is  given by (F)RDIN functions that
                              are used by L(F)READ.

SYMBOLIC AS GDET IS A SUM     See 14.3

SYMBOLIC AS ZDET IS A SUM     See 15.3

SYMMETRY ELEMENT              This message is given when a TENVAL
                              function is operating on a symmetry
                              element.   This  can  happen  if  a
                              single  component  is  specified as
                              argument to the TENVAL function  or
DIAGNOSTIC AND ERROR MESSAGES                            Page D-5


                              if  the  TENVAL function is AWRITE.
                              The message can be inhibited by the
                              switch NOSYMSG.

NO MEMORY ELEMENT "x"         A range of  tensor  components  has
                              been  specifed  as  argument  to  a
                              TENVAL   function.    This    range
                              doesn't contain any components that
                              are kept in the memory.  The reason
                              for   this  can  be  that  all  the
                              specified components are defined by
                              the  symmetry,  or  that  the upper
                              limit of the range  is  lower  than
                              the lower limit.
                              The TENVAL function will ignore the
                              range  and  continue  with its next
                              argument or end  if  there  was  no
                              more arguments.  If this happens in
                              a continuation function  (CONTINUE,
                              NEXT,  NEXTA  or  TOELM),  the  the
                              error CAN'T CONTINUE will occur.

"x" ALL FOUND ZERO            No non zero component  of  "x"  was
                              found,  in  the  range specified by
                              arguments  to  a   writing   TENVAL
                              function.   If  NOZERO  is on, this
                              means that no component is  written
                              but the message is given.

"x" ENDED                     A TENVAL  function  has  ended  its
                              operation  on the tensor "x".  (see
                              further 11.3)

"x" FOIN SYNTAX ERROR         See 8.1.4

"x" LOST                      All components of  the  tensor  "x"
                              have been deleted by LOSE.

"x" NO VALUE                  "x" has no value or  its  value  is
                              NIL.   Can happen when "x" is given
                              as argument to a TENVAL function.

"x" OLD                       "x"  has  been  re-declared,  as  a
                              function  by  FUNS  or as tensor by
                              DECLTEN.

"x" OUT OF ORDER              The element with specification  "x"
                              wasn't  found  on  a  file from the
                              previous file position to the  end,
                              but  it  might  be  out of order so
                              that it is  found  on  the  earlier
                              part  of  the file.  If TRYAGAIN is
                              on, the element is searched for  on
                              the  earlier  part of the file.  If
                              the element isn't found there or if
                              TRYAGAIN  is  off  then the message
                              NOT FOUND  is  given  and  NIL   is
DIAGNOSTIC AND ERROR MESSAGES                            Page D-6


                              returned.

"x" SYMMETRY ELEMENT          "x" is a symmetry element.  Message
                              is  given by T(NO)EX or when ALLMSG
                              is on, it is given instead  of  the
                              same message without "x".

"x" SYMMETRY ELEMENT
CAN'T SYMMETRIZE              An error occurred  when  evaluating
                              the   SYMF   expression   for   the
                              component "x".  The TENVAL function
                              that  was  operating  will complete
                              its operation on the tensor without
                              making  any  symmetry elements, but
                              it will act normally on  the  other
                              components.












                           APPENDIX E

                  FOIN CHARACTER INTERPRETATION



See the system specific documentation  on  the  terminal  control
               characters  that e.g. delete last typed character.
               The ASCII code is in decimal.


_____  _____   _______ __ ____ASCII  char.   meaning to FOIN

32     <sp>    Ends an identifier, else ignored.

33     !       Is not read, but makes FOIN read next character as
               if it was a letter.

34     "       Starts a string  that  ends  by  another  ".   See
               string syntax in the Lisp-manual.

35     #       (May dissapear in later  SHEEP  versions.   Please
               use  &2  instead.)  Differentiate  with respect to
               second variable system.

36     $       End input to FOIN.  Don't PRT result.

37     %       Starts a comment ignored by FOIN, that ends at end
               of line.  FOIN sees the end of line (and treats it
               like a <sp>) but nothing else.

38     &       Differentiate preceding expression with respect to
               the following variable.

39     '       Unused by FOIN.  Quotes an  expression  to  (LISP)
               READ.

40     (       Begins a sub-expression.

41     )       Ends a sub-expression to same level as last "(".

42     *       If followed by "*", equivalent to "^",  otherwise,
               multiplication operator.

43     +       Addition operator.
FOIN CHARACTER INTERPRETATION                            Page E-2


44     ,       Delimits arguments to DFUN operators.

45     -       Subtraction.

46     .       First  the  effect  of  ";",  then  read   another
               expression and add it to the previous.

47     /       Inversion operator.

48-57          The  digits  0  -  9.   Parts   of   numbers   and
               identifiers.   Can  start  an identifier only when
               preceded by "!".

58     :       Combines with the next character  as  an  extended
               command.   If  the next character is "'", "(", "!"
               or a letter then Read and EVALuate.  If  the  next
               char. is "'", "(" or "[", then the reading is done
               by (LISP)READ, else by FOIN  read.   If  the  next
               character  is "" or ";" see that character.  Other
               combinations are reserved for future expansion.

59     ;       End  input,  print  it  with  PRT  and   ask   for
               confirmation.

60     <       Execute a user  defined  reading  expression  that
               should be placed as value of the identifier <

61     =       Used  only  in  the  combination  ":=",  which  is
               equivalent to "_".

62     >       Unused.

63     ?       End  input,  print  it  with  PRT  without  normal
               simplification and ask for confirmation.

64             Reserved for future expansion.

65-90          The  upper  case  letters  A  -  Z.    Builds   up
               identifiers.

91     [       Begins a sub expression.

92     \       Unused.

93     ]       Ends a sub expression to level of last "[".

94     ^       Exponentiation operator.

95     _       Assignment operator.

96             Unused.

97-122         The lower case letters a  -  z.   Are  allowed  in
               identifiers.
FOIN CHARACTER INTERPRETATION                            Page E-3


122-126        Unused.

127    <rub>   ("<del>" on some terminals.) Delete last character
               of input line.
                                                          Page Index-1


                                INDEX



ALL, 3-1, 6-2, 7-2 to 7-3, 11-1     GDF, 14-1
ALLMSG, 11-7                        GINV, 14-1
APZ, 15-2                           GUU, 14-1, 15-2
ASD, 15-1
                                    HDD, 15-1
BULF, 10-1 to 10-2, 11-3            HINV, 15-1
                                    HNULL, 15-3
CHINPRO, 9-2                        HUU, 15-1
CHNDIF, 7-5
COPYL, 4-2                          INDX1, 11-8
CRDIF!*, 7-1 to 7-3                 INDX2, 11-8
CRELM!*, 11-8                       INDX3, 11-8
CTEN, 11-8                          INDX4, 11-8
                                    INDX5, 11-8
DECLTEN, 10-3                       INF, 12-2
DEFA, 11-2, 11-7
DELK, 10-2, 11-3                    KEEP, 11-3, 11-7
DEP, 10-2
DF, 8-2                             LAPLY, 11-3
DFUN, 8-2, 10-2                     LAST, 6-2
DIAGONAL, 10-1                      LASUB, 6-2
DIFF, 7-5                           LFPRT, 11-5
DIFFORDER, 3-1 to 3-2, 6-3          LFREAD, 11-6
DOCOPY, 4-3                         LIE, 15-2
DOMAKE, 11-3, 11-5                  LINESPERPAGE, 3-1 to 3-2
DOMULC, 4-2                         LINIT, 11-6
DSKIN, 12-1                         LISP, 1-3
                                    LORENTZ, 15-3
EFUN, 8-2                           LOSE, 11-4, 11-8
EIN, 14-2, 15-2                     LPRINT, 11-5
EINM, 14-2, 15-2 to 15-3            LPTWRITE, 12-2
Element, 11-1                       LREAD, 11-5
ESUBS, 5-2, 6-1, 11-3               LSIMP, 11-3
ESUL, 5-2, 6-1                      LSTAT, 11-4, 11-8
EXPANDLIM, 3-1 to 3-2, 5-3          LTEN, 11-2, 11-8
EXPR, 1-3
                                    MAKE, 11-3
FEXPR, 1-3                          MKPLUS, 4-2
FIN, 12-1                           MKTIMS, 4-2
FITIN, 9-2                          MSUBS, 5-2, 6-1, 11-3
FOIN, 8-1, 11-3                     MSUL, 5-2, 6-1
FOIN format, 9-1
FOUT, 11-6, 12-1                    NAM, 9-2
FPRT, 9-2, 11-5                     NAMF, 9-2
FROM, 11-2                          NOASCOP, 11-8
FUNS, 7-1 to 7-2                    NOFARY, 11-5
                                    NOMSG, 11-7
GAM, 14-1, 15-2                     NOOFIT, 9-1
GAMU, 14-1                          NOPREQ, 11-3
GDD, 14-1, 15-1                     NORICM, 14-2, 15-2
GDET, 14-1                          NOSIMP, 5-1
                                                          Page Index-2


NOSYMSG, D-5                        SMMINUS, 4-3
NOTKEEP, 11-7                       SMPLUS2, 4-3
NOTPRINTN, 11-7                     SMPLUSL, 5-2
NOZERO, 11-3                        SMTIMESL, 5-2
NULLT, 15-4                         SNUM, 4-3
                                    SPEC, 11-1, 11-8
OFF, 3-1                            SUBMTIMES, 3-1 to 3-2, 5-2
ON, 3-1                             SUBPOT, 6-2
OUTF, 12-2                          SUBS, 5-1, 7-2, 11-3
                                    SWISTAT, 3-1
PARDEEP, 3-1 to 3-2                 SWITCHES, 3-1
POTSIM, 5-2                         SYDIAG, 10-1
POWER, 3-1 to 3-2, 5-3              SYMBOLIC, 11-6
PREQ, 10-2 to 10-3, 11-3            SYMF, 10-1 to 10-2, 11-5
PRINT, 11-5                         SYMFOUND, 11-8
PRINTN, 11-3, 11-7                  SYMMETRIZE, 11-5
Property list, 1-3
PRSUB, 6-2 to 6-3                   TENSOR, 10-1
PRT, 9-1, 10-2, 11-3                TENSORS, 10-1, 11-1
PRT format, 9-1                     TENVAL, 11-1
PRTEN, 10-2                         TEX, 11-6
PSUBS, 6-1, 9-1                     TNOEX, 11-6
PSUL, 6-1, 9-1                      TNSPCH, 10-2
PTEVAR, 9-1                         TO, 11-2
PVARNUM, 9-1                        TRANSF, 6-4, 7-2
 
RANLIS, 10-2                        UPINDX, 10-2
RATPAR, 9-1
RDASIS, 11-5                        VALUE, 10-2, 11-1, 11-4
REDUCE, 11-5 to 11-6                VALUE., 11-1
REMAKE, 11-6                        VARMAX, 7-4
REMFUNS, 7-3                        VARS, 7-1, 7-3
REMSUB, 6-2
REMSUB., 6-2                        WLAPLY, 11-3
RESTORETN, 12-1                     WLFREAD, 11-6
RIC, 14-1, 15-2                     WLINIT, 11-6
RICM, 14-2, 15-2                    WLREAD, 11-5
RIE, 14-1, 15-2                     WLSIMP, 11-3
RPL, 11-3                           WMAKE, 11-3
RSCL, 14-2, 15-2 to 15-3            WREMAKE, 11-6
                                    WRITE, 11-3
SAVETN, 11-5, 12-1                  WRPL, 11-3
SCHDIF, 7-5
SCL, 10-2                           XED, 5-2
SETQ, 1-3
SETSUB, 6-3
SIMP, 5-1, 5-3, 11-3                ZDD, 15-1
SIMP1, 5-2                          ZDET, 15-1
SIMP2, 5-3                          ZDU, 15-2
SIMPEX, 5-3                         ZERM, 5-2
SIMPI, 5-1, 5-3                     ZINV, 15-1
SMEXPT, 5-3                         ZUD, 15-1
