





P




                               M  A  N  U  A  L

                                      for


           XXXX   XXXXXXXX  XXXXXX  XX     XX    XXXX     XXX    XXXXXX
          XX   X     XX     XX      XX     XX   XX   X   XX XX   XX   XX
         XX          XX     XX      XXX    XX  XX       XX   XX  XX   XX
          XX         XX     XX      XXXX   XX   XX      XX   XX  XX  XX
           XXX       XX     XXXX    XX XX  XX    XXX    XX   XX  XXXXX
             XX      XX     XX      XX  XX XX      XX   XX   XX  XX  XX
              XX     XX     XX      XX   XXXX       XX  XX   XX  XX   XX
         X   XX      XX     XX      XX    XXX  X   XX    XX XX   XX   XX
          XXXX       XX     XXXXXX  XX     XX   XXXX      XXX    XX   XX

                   A System for Indicial Tensor Calculus and

                   Automatic Generation of Tensor Algorithms


                               Lars  Hornfeldt

                       Institute of Theoretical Physics
                            University of Stockholm
                                 Vanadisvagen 9
                              S-113 46  Stockholm
                                    Sweden





                           Edition 6,  November 1986


                                 Version 2.26
                 Beware!  This manual is written in Sweglish.


                                                                  Page 2


.E
                                   CONTENTS

        1       INTRODUCTION: A SAMPLE SESSION . . . . . . . . . . . 4
        2       NOTATIONAL CONVENTIONS:  . . . . . . . . . . . . . . 6


CHAPTER 1       TENSOR FORMULA IN/OUT-PUT

        1.1     USE OF THIS CHAPTER . . . . . . . . . . . . . . . .1-1
        1.2     PDEF - PUT DEFINITION . . . . . . . . . . . . . . .1-2
        1.2.1     SYNTAX OF THE FORMULA INPUT  . . . . . . . . . . 1-2
        1.2.2     INDEX-PREFIXES . . . . . . . . . . . . . . . . . 1-3
        1.2.3     SWITCHES TO PDEF . . . . . . . . . . . . . . . . 1-5
        1.3     DECLT - DECLARE TENSOR PROPERTIES . . . . . . . . .1-5
        1.4     SAMPLE FILE: CORD.DEF . . . . . . . . . . . . . . .1-7
        1.5     INDEX SYMMETRIES  . . . . . . . . . . . . . . . . .1-8
        1.6     WDEF - WRITE DEFINITION . . . . . . . . . . . . . .1-9
        1.7     PERMUTATION NOTATION  . . . . . . . . . . . . . . 1-10


CHAPTER 2       MANIPULATION OF INDICIAL FORMULAS

        2.1     REPRESENTATION OF AN INDICIAL FORMULA  . . . . . . 2-1
        2.2     EDEF - EVALUATE DEFINITION . . . . . . . . . . . . 2-2
        2.3     MORE ON EDEF PROCESSING STEPS  . . . . . . . . . . 2-2
        2.4     REPEATED/RESTRICTED EDEF . . . . . . . . . . . . . 2-4
        2.5     ORDINARY DIFFERENTIATION . . . . . . . . . . . . . 2-6
        2.6     COVARIANT DIFFERENTIATION  . . . . . . . . . . . . 2-6
        2.7     FILETYPES AND DISK IN/OUTPUT . . . . . . . . . . . 2-7
        2.8     "ALL"-ARGUMENTS TO ZDEF-COMMANDS . . . . . . . . . 2-8
        2.9     CREATE BACKUP  . . . . . . . . . . . . . . . . .  2-11
        2.10    TECHNICAL ON EDEF  . . . . . . . . . . . . . . .  2-11


CHAPTER 3       SUBSTITUTIONS

        3.1     OVERVIEW AND EXAMPLE . . . . . . . . . . . . . . . 3-1
        3.2     MATCHING OF INDICES  . . . . . . . . . . . . . . . 3-3
        3.3     MATCHING OF TENSOR NAMES . . . . . . . . . . . . . 3-3
        3.4     WILDCARDS IN SUBSTITUTIONS . . . . . . . . . . . . 3-3
        3.5     SUBSTITUTION WITH SIDECONDITION  . . . . . . . . . 3-5
        3.6     ORDEROK FOR CONDITIONAL SUBSTITUTION . . . . . . . 3-5
        3.7     SETSUB MAY PDEF AND SDEF . . . . . . . . . . . . . 3-6
        3.8     SETSUB PROBLEM WITH @@-CHARACTER  . . . . . . . . . 3-6
        3.9     SPECIAL TENSORS  . . . . . . . . . . . . . . . . . 3-7

                                                         Page 3


        3.10    GENERALIZED KRONECKER DELTAS . . . . . . . . . . . 3-8
        3.11    PFAFFIAN TENSORS . . . . . . . . . . . . . . . . . 3-9
        3.12    LEVI-CIVITA SYMBOLS EPS3-9 . . . . . . . . . . . . 3-9
        3.13    DEL IS DECLARED BOTH SYMMETRIC AND MIXED . . . . . 3-9
        3.14    SUPER SUBSTITUTION LIST  . . . . . . . . . . . .  3-10


CHAPTER 4       OPERATOR ALGEBRA AND ORDERING

        4.1     NON/ANTI-COMMUTATIVITY . . . . . . . . . . . . . . 4-1
        4.2     DIFFERENTIAL OPERATORS . . . . . . . . . . . . . . 4-3
        4.3     POISSON BRACKETS . . . . . . . . . . . . . . . . . 4-4
        4.4     LEFT/RIGHT-PARENTHESIS OBJECTS . . . . . . . . . . 4-5
        4.5     TECHNICAL REMARK . . . . . . . . . . . . . . . . . 4-6
        4.6     ADVANCED SUBSTITUTION EXAMPLES . . . . . . . . . . 4-6
        4.6.1     VARIATION PRINCIPLES   . . . . . . . . . . . . . 4-7
        4.6.2     PARTIAL INTEGRATION  . . . . . . . . . . . . . . 4-7


CHAPTER 5       SPINOR AND SUPERGRAVITY FACILITIES

        5.1     SPINOR AND SHORTNAME INPUT . . . . . . . . . . . . 5-1
        5.2     COMPLEX CONJUGATION  . . . . . . . . . . . . . . . 5-2
        5.3     SPINOR IDENTITIES  . . . . . . . . . . . . . . . . 5-4
        5.4     SEDIT - STENSOR EDITOR . . . . . . . . . . . . . . 5-5
        5.5     (COVARIANT) DIFFERENTIATION OF SPINORS . . . . . . 5-7


CHAPTER 6       SPACE DECLARATIONS, INDEXTYPE, SPLITTING

        6.1     SPACE DECLARATIONS . . . . . . . . . . . . . . . . 6-1
        6.2     INDEXTYPES AND SPLITTING . . . . . . . . . . . . . 6-2
        6.3     SPLITTED SUBSTITUTIONS . . . . . . . . . . . . . . 6-4


CHAPTER 7       AUTOMATIC GENERATION OF TENSOR ALGORITHMS

        7.1     INTRODUCTION . . . . . . . . . . . . . . . . . . . 7-1
        7.2     TCOMP - TENSOR COMPILE . . . . . . . . . . . . . . 7-1
        7.3     TCOMPOUT OR SAVBU - SAVE BULFS . . . . . . . . . . 7-2
        7.4     (TCOMPOUT FILE ALL)  . . . . . . . . . . . . . . . 7-3
        7.4.1     TOP TENSORS SUFFICE -GIVES HIERARCHY:  . . . . . 7-3
        7.5     <> MARKS EVALUATION TO TCOMP . . . . . . . . . . . 7-4
        7.6     DIMENSION USAGE IN TCOMP . . . . . . . . . . . . . 7-4
        7.7     MIXED DIMENSIONS IN TCOMP  . . . . . . . . . . . . 7-4
        7.8     DETERMINANT AND INVERSE OF A MATRIX  . . . . . . . 7-5
        7.9     INTERMEDIATE OBJECTS SELDOM NEEDED . . . . . . . . 7-6
        7.10    PRODUCE A BLF-FILE FOR THE LISP COMPILER . . . . . 7-7
        7.11    FACTORIZATION DONE BY TCOMP  . . . . . . . . . . . 7-7
        7.12    IDENTIFY TERMS WITH SPECIFIC OBJECT  . . . . . . . 7-8
        7.13    FACILITIES FOR CREATING DOCUMENTATION  . . . . . . 7-8
        7.14    OVERLAPPING SYMMETRIES . . . . . . . . . . . . . . 7-9
        7.14.1    INDICIAL COMPUTATIONS WITH OVERLAP-SYM . . . .  7-10

                                                         Page 4


        7.14.2    COMPONENTWISE COMPUTATIONS WITH OVERLAP-SYM.    7-10
        7.15    TENSOR ALIAS, PACKAGE  . . . . . . . . . . . . .  7-11
        7.15.1    QUOTING CHARACTER . . . . . . . . . . . . . .   7-11
        7.15.2    PACKAGE SYMBOL (STENSOR ONLY) . . . . . . . .   7-12
        7.16    ADDITIONAL COMMANDS IN BLF-FILES . . . . . . . .  7-12


CHAPTER 8       WHILE COMPUTING COMPONENTS

        8.1     TIMING . . . . . . . . . . . . . . . . . . . . . . 8-1
        8.2     TRIGONOMETRIC SIMPLIFIER WTRIG . . . . . . . . . . 8-2
        8.3     MIXING STENSOR AND SHEEP . . . . . . . . . . . . . 8-3
        8.4     COMMANDS FOR ORDINARY SHEEP-SUBSTITUTIONS  . . . . 8-5
        8.5     WTERMS - WRITE NBR OF TERMS  . . . . . . . . . . . 8-6
        8.6     IOMAKE - IN/OUTPUT MAKE  . . . . . . . . . . . . . 8-7


CHAPTER 9       BUCKETING, BATCH AND ERRORS

        9.1     BUCKETING AND AUTOMATIC DISK USAGE . . . . . . . . 9-1
        9.2     BATCH FOR REPETITIVE/TEDIOUS WORK  . . . . . . . . 9-3
        9.3     ERROR MESSAGES . . . . . . . . . . . . . . . . . . 9-4
        9.4     REPORTING AN ERROR . . . . . . . . . . . . . . . . 9-5


CHAPTER 10      FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP

        10.1    FUNDAMENTAL LISP-COMMANDS/CONCEPTS . . . . . . .  10-1
        10.2    SPECIAL PRINTING OF TENSOR/INDICES . . . . . . .  10-3
        10.3    PUSHV AND POPV . . . . . . . . . . . . . . . . .  10-4
        10.4    SUBSTITUTION PROGRAMS  . . . . . . . . . . . . .  10-4
        10.5    MAKING SUBSTITUTION PROGRAMS BY HAND . . . . . .  10-5
        10.6    LIBRARY OF PRE-REQUIRED OBJECTS/FUNCTIONS  . . .  10-6
        10.7    FURTHER INFORMATION  . . . . . . . . . . . . . .  10-7


APPENDIX A      

        A.1     COORDINATE TRANSFORMATIONS . . . . . . . . . . . . A-1
        A.2     MACHINES AND INSTALLATION  . . . . . . . . . . . . A-1





                            Edition  6 - November 1986


                              For  version  2.26
.P

                                                                  Page 5


                                   ABSTRACT



        STENSOR is a specialized system for the symbolic manipulation of
        indexed  objects  such as tensors or spinors.  It works together 
        with SHEEP.  Input of expressions  follows  simple  definitions.
        An expression may contain ordinary and covariant differentiation,
        e.g., <L K ,M> + <TSR M L ;K> is admissible.
        Primed spinor indices are understood, and that a repeated index
        is dummy etc.
    
      
        
        The representation is devoted, as the simplifier, which renames
        dummies  automatically  and handles other profound difficulties
        that are totally unknown from ordinary scalar algebra.
        Besides evaluation, differentiation  etc,  STENSOR  substitutes
        sums, e.g.  to exploit sin@^2 x + cos@^2 x = 1 optimally.
        There is a compiler that from any formula generates  a  program
        for  computing  individual  components  by  actually performing
        contractions etc.

                           ^<<SIZE OF STENSOR:^>>


        Blocks  XXXXX REDUCE 3
                XXXXX
        1500____XXXXX           Summed up size of the source code files,
                XXXXX           including their comments, for some
                XXXXX           languages. 1 block on VAX/VMS = 512 bytes
                XXXXX                   (July 1986)
                XXXXX
        1000____XXXXX           xxxxx STENSOR 2.26
                XXXXX           XXXXX
                XXXXX           XXXXX
                XXXXX           XXXXX
                XXXXX           XXXXX
         500____XXXXX           XXXXX
                XXXXX           XXXXX
                XXXXX           XXXXX           XXXXX SHEEP 2.04
                XXXXX           XXXXX           XXXXX
                XXXXX           XXXXX           XXXXX
           0____XXXXX___________XXXXX___________XXXXX____________

Blocks:          1817            1060             400
Source files:  ..SRC:*.*        STS:*.STS       NSHP:*.SL
Number of files:   22              75              61

               All files are very rarely needed simultaneously.

                                                                  Page 6


1  ^<<INTRODUCTION:  A SAMPLE SESSION^>>

The computer interaction is to the left,
with all user input underlined:        	Comments indented to the right:


@$ ^<_stensor^>_	Entry of "stensor" loads the system.  The following
			flag indicates successful loading:


			STENSOR 2.270 (on Sheep 53) welcomes you etc.
			
			The STENSOR prompt "STS>" will appear.

                In computer algebra systems you assign formulae to symbols for
                later reference.  In STENSOR this assigning function is called
                ^<<PDEF^>> (for "Put DEFinition").  Formulae may in STENSOR
                be nonscalar - contain tensors with letters as indices - and
                the system knows eg that a repeated index means summation.
                After the STENSOR prompter, let us now Put a DEFinition on C.
                Use parens around PDEF and argument:

STS> ^<_(PDEF C)^>_	This tells the system to read a formula.  In next line
                it asks with "=".  After it, we type in matrices A times B:

=^<_<A K L> <B L M> @$^>_      Each object with indices should be surrounded
                by "<" and ">".  End the formula with dollar.  Since L is
                repeated, it is understood to be a contraction index in this
                formula, representing summation (as in matrix multiplication).
.E
C   = A  B      The system confirms that the formula was accepted by writing
 km    kl lm    out the DEFinition nicely, with K and M as free indices!

                Formulas are mainly used in two ways:
                EDEF    Evaluates an indicial formula, giving a new.
                TCOMP   Generates a program for computing the components.
                The chapter on SPLITTING describes an hybrid of these.

                The Riemann tensor can be defined by:  ("A34" declares antisym.
STS> ^<_(PDEF RIE1 R A34)^>_          -in indices 3 and 4, "R" = abbreviation)

=^<_<GAMU J K ^[M ,^[L> + <GAMU I K ^[M><GAMU J I ^[L> @$^>_

 j          j           i      j
R     =  GAM        +GAM    GAM
  klm        k^[m,l^]      k^[m    il^]

                                                                  Page 7



                (GAMU had previously an abbreviation GAM, symmetry S23,
                and an index up - causing RIE1 have the same index up.
                    Covariant differentiation is indicated with ";" -

   a        a        a        a                 - thus this formula:
BIA      = R       +R       +R
    bcde     bcd;e    bde;c    bec;d            -could be inserted as:

STS> ^<_(PDEF BIA)   <RIE1  A  B  (C  (D  ;(E> @$^>_
                -Where "(" cause cyclic permutation, see "DOPERM".
.P
    ^<<EDEF^>> evaluates a definition, simplifies and writes.  By calling it
    we can now show that this cyclic sum BIA is zero (the Bianchi identity).
    The effect of evaluation on a covariant differentiation is to replace it
    with ordinary differentiation plus proper contractions with the Christoffel
    symbol GAMU.  BIA then gives initially 15 terms, that combine to 9 due
    to...
.E
STS> ^<_(EDEF BIA)^>_          ...index symmetries. Then EDEF starts its own
15/9 TERMS BIA  Action? ^<_W^>_       dialogue (try "?"). W requests W-riteout:
   a          a        a        a        i      a     i      a     (four
BIA      =  -R       +R       -R       -R    GAM    +R    GAM    -  more
    bcde       bce,d    bde,c    bdc,e    bce    di    bde    ci    terms)
.P
               The system here introduced the dummy symbol "i", after first
               checking that it didn@'t already occur.  The contravariant
               character of the 1:st RIE1-index was used.  This expression is
               now the new definition of BIA.

BIA Action?  ^<_E^>_  We then ask EDEF for E-valuation again (?  for menu).
               Thereby each occurence of RIE1 is replaced with its definition,
               but with correct free indices inserted, and with j as dummy
               since i already was in use.  The result then comes:

42/0 TERMS Became zero!         -Using the symmetries of GAMU and multiple
               derivatives, and by renaming dummies, EDEF finally found that
               all resulting 42 terms in BIA cancelled as they should!
    EDEF is clever; also try (LOAD "IDENTR.DEF") or (LOAD "SMRING.DEF").

A definition was above inserted for RIE1.  With the command:
"(^<<TCOMP^>> RIE1)"   -the DEF of RIE1 is analyzed and a program
corresponding to it is generated (that performs the differentiations of GAMU
and summations over i).  TCOMP also declares "SHEEP-arrays" corresponding to
the ranks and symmetries of GAMU and RIE1 for the storing of their components.
If there are algebraic expressions for the individual GAMU-components, the
TCOMP-generated program directly computes the individual components of RIE1
(and other TCOMPed objects) upon the SHEEP command "(MAKE RIE1)".
                See further the respective chapters on PDEF, EDEF and TCOMP.


                Finally EXIT from STENSOR by keeping the...
STS> ^<_@^Y^>_		...control-key down and push Y.  (@^Z in unix).
@$ ^<_logout^>_		Tell the operating system you want to end the session.

                                                                  Page 8


2  ^<<NOTATIONAL CONVENTIONS:^>>

Within most paragraphs each command, switch, or other subject, is given a
highlightening negative indent, followed by the descriptive text.

A command is written as:  "(COMMAND a1 a2 a3...)" ie first left paren, then the
    commandname in upper case (eg "COMMAND" above), then space, then the
    arguments - also separated by spaces, and finally a closing right paren.
    The commandname is written in upper case to indicate that the name is
    literal, while arguments are usually written in lower case, to indicate
    that they are not literally intended - the a1..  stand for something else,
    not "a1".  Thus in:  "(PDEF tsr p1 p2..)" -the arguments being in lower
    case indicate that they are not literal, and the letter combinations hint
    on their type:  (tsr=tensor, p1=property).

    Also tn or t1 t2,...  are used for tensors, while sym=symbol, nbr=number
    etc.  Also an argument may occur in (partly) upper case if it is (partly)
    literally intended, as TSUL below (a kind of keyword).

Skip parts marked "Technical:" at the first readings.

Square brackets ^[^] are used:
        around arguments that are optional, eg: (SETSUB TSUL ^[sidecondition^]),
        and around default values, eg:          CODIM symbol ^[4^],
        or around default switch settings, eg:  LCASE switch ^[on^].
        Switches are described as when on, regardless of default setting.

INDEX:  The first few words after a new item are often selected to provide a
condensed description, most of which accompanies the item also into the index.
Thus the index constitutes a quick reference guide, and is recommended for
intense use.  Commands occur in index with "()" around eg:  "(METRIC...)
...here some description.."

Symbols or switches (eg CODIM above) are not typed directly after a left paren,
    and thus are without parens in the index.

The SUMMARY starting most chapters, and assembled on the last page, is more a
    reminder and hint to the contents, than something you should always expect
    to fully understand before reading the chapter.













                                   CHAPTER 1

                           TENSOR FORMULA IN/OUT-PUT



SUMMARY:
(PDEF tsr p1 p2...)     <DEL A B>   + <GAMU C C @~B ,A>   + SIN(H)@^2 <W @^B ;A< @$
-Put on tsr props pi,   and DEFinition  (;/, is co/diff)      -ended by dollar.
        In formula, write a tsr as eg  <full .i1 @~i2...>  or  <short i1 @^i2...<
With >-end, Move up/down-info: tsr --> ix.   Use /. for corrective rise/lower.
With <-end, @^-ix are up, rest down.             Also: @@=Quote.
(DECLT (tn p1 p2..) (tnq q1..))     -Declare Tensor-properties pi on tn,..  Ex:
(DECLT (GAMU  GAM  1  S23  "Christoffel symbol 2:nd kind"))   (-initially done)
Mean:Fullnam,short,up,Sym ix 2-3, "helpstring".
  (WDEF t1 t2..)       	Write DEFs of t1..
  (WODEF t1 t2..)      	Write "ODEF",Old DEFinition, the backup
  LCASE(F)     	     	Switches for Lower CASEing of (Free) indices.
  (XDEF t1 t2..)       	eXchange DEF and ODEF, ie restore the backup.
  (XXDEF t1 t2..)      	Restore the very first formula PDEFed at t1, t2,..
  (DSTAT t1 t2..)      	Show nbr of terms in the DEF and ODEF of t1, t2,..
  (DOPERM t1 t2..)     	Expand Permutation, input ^[a ^[b =asym, (a (b =sym.
  PERMULT      	     	Multiply with 1/n when DOPERMing.
  PDEFPERM     	     	PDEF does a "DOPERM",ie automatically expand.



1.1  ^<<USE OF THIS CHAPTER^>>

Indicial formulas, "definitions" are "put up" with PDEF.  Whether you then:

- evaluate them (by EDEF et al) to obtain new formulas, or TCOMP to compute
components, or first EDEF and then TCOMP, or do a mixed component/indicial
computation with SPLIT,

- in all these cases the common raw material are the formulae given to PDEF.
Thus this chapter should always be read, but may then be followed by perhaps
only the TCOMP chapter, depending on your application.

Input commands, like PDEF and DECLT, are impractical to each time type directly
to STENSOR.  Instead they should first be written once for all with an editor
into a file, say:  mytsr.DEF, which you later at any time can reclaim into
STENSOR by:  (LOAD "mytsr.DEF"), or if you name the file STENSOR.INI, it will
be automatically loaded each time you start STENSOR.

TENSOR FORMULA IN/OUT-PUT                                       Page 1-2


1.2  ^<<PDEF - PUT DEFINITION^>>


(PDEF tsr p1 p2..) formula @$  -Put DEFinition on tsr,plus props The arguments
p1,p2,..  are optional properties that you want tsr to have, s.a.  symmetries.
See DECLT.  Here we only discuss the main action of PDEF which is to take the
formula and put it as definition on tsr.

The three parts:    (PDEF..),   formula,   and dollarsign,   -may be on the
same line, or arbitrarily spread over multiple lines.  If you only type (user
input underlined):
^<_(PDEF...)^>_ 	  	-this part, followed by "return" (ie pushing that key).
=      	     	-Then a prompter "=" reminds you that you must
 ^<_formula^>_ 	   	-continue with a formula. Type that in, followed by
 ^<_@$^>_       	  	-a dollarsign, to mark the end of the formula.



1.2.1  SYNTAX OF THE FORMULA INPUT

-is as for any formula input in SHEEP, with the addition that tensors should be
surrounded by "<" and ">", e.g.  <TSR A B>, to indicate where they start and
end.  Separate the indices with blanks.

Example:  Let RIE mean the 4:th rank Riemann tensor.  The contravariant metric
is GUU (built in object which prints out as g with indices up).  To define
object RIC as GUU contracted with RIE,type:
       	     	     	     	(ignore the extra two arguments,
^<_(PDEF RIC S12 "Ricci tensor")^>_ 	      	ie symmetry S12, and "helpstring",
       	     	     	     	these are discussed under DECLT)

=^<_<GUU J L> <RIE I J K L> @$^>_ 	 	-After "="-prompter, type formula,and @$

         jl    	     	     	     	-Then PDEF confirms
RIC   = g   RIE	     	S12  Ricci tensor  	by writing the formula
   ik          ijkl    	     	     	(plus other info).


Note that on RIC are hanging indices i and k.  These were deduced from the
formula to be free indices.  The indices j and l were repeated in the formula,
and thus recognized to represent summation, ie be contraction indices,
according to the Einstein summation convention.

The formula is supposed to refer to the lexico graphically ordered component,
here I K and not K I.  You may override that by replacing the 1:st argument
"TSR" of PDEF with "(TSR I1 I2 ..)" where I1 I2 ...  is your own (nonlexical)
specification of which component the formula refers to.

Eg ^<(PDEF (RIC K I))^>_.  See also REVLEX.

Formulas may as usual also contain:  +,-,/,*,@^ etc (or space for *).

TENSOR FORMULA IN/OUT-PUT                                       Page 1-3


1.2.2  INDEX-PREFIXES

Between < and > a special reading function is applied.  This allows an index to
be immediately preceded by several characters, that are given new meanings in
this particular context.

","  Means differentiation with respect to the variable represented by the
     prefixed index.  Example:          (PDEF GDF)
        =<GDD I K ,L>@$  (differentiation with respect to variable nbr L)


";"  means covariant differentiation.  For example a multiple derivative is
     typed as <VEC A ;B ;C>     (same syntax as for ",").


"@@"  "Hides" the prefixed index from the summation convention.  PDEF checks
     that the free indices (occurring exactly once in a term) are equal in all
     terms.  Those occurring more than once indicate contraction.  The "@@" in
     front of an index will "hide" this occurrence of the index from this
     checking and interpretation.  This gives two possibilities:

.E
     A) Hiding all occurrences of a symbol makes it a parameter. Example:
        (PDEF VEC)              Here "param" is hidden,so not seen as index.
        =<MAT A @@param>@$        VEC then represents one column of MAT,
                                -which one, is represented by "param".
        VEC = MAT               (If you "MAKE" (see TCOMP), a value
           a     aparam          of param will be required)

     B) Hide all occurrences except ONE makes it a FREE index. Example:
        (PDEF VEC)              Here VEC will contain the diagonal
        =<MAT @@A A>@$            elements of MAT, and not the trace.
                                The @@ inhibits the summation convention.
        VEC = MAT               A was unhidden ONCE and is thus FREE ix,
           a     aa             so VEC is a vector -shown with one "a" on it.

"^["  Means "odd cyclic permutation" of the indices prefixed by it.
     In particular, if prefixing two indices, that coincides
     with antisymmetrization:  ^[A ^[B = A B - B A.
     Prefixing three indices, it however means:
     ^[A ^[B ^[C    = A B C   - B C A   + C A B, or four indices:
     ^[A ^[B ^[C ^[D = A B C D - B C D A + C D A B - D A B C
     and so on for more indices.
     Note that you use the same prefix "^[" in front of all indices
     you permute, and don@'t mix in "^]"!

.P

"^]"  Equivalent to "^[", but independent.  This indexprefix is to allow
     specification of another, independent odd cyclic permutation in the same
     term.

TENSOR FORMULA IN/OUT-PUT                                       Page 1-4


"("  Means "even cyclic permutation" of the indices prefixed by it.  In
     particular, if prefixing two indices, that coincides with symmetrization:
     (A (B = A B + B A.  Prefixing more indices, it however means:
     (A (B (C    = A B C   + B C A   + C A B, -and so on, in analogy to "^[".

")"  Equivalent to "(", but independent.  This is to allow specification of
     two, independent even cyclic permutations in the same term.
     Compress your input by using permutation notations.  For eg total asym of
     3:rd rank do:  <TSR (A (^[B (^[C.  Then expand them with DOPERM.  See
     further "PERMUTATION" paragraph below.

"."  A convenient way to lower the index unconditionally, ie .K is replaced
     with a unique dummy (say x) and a factor <GDD K x> is appended.  No check
     is done as to if the .K is on an index position that is already "down".

"@~"  As "." but rises with the tensor "GUU".  Eg <RIE @~A B A C>=<RIE x B A C>
     <GUU x A>, ie RIC.  To use other than GDD and GUU, use METRIC eg:
     (METRIC HDD HUU).  The metric put in depends on the type of the prefixed
     index, if you have several INDEXTYPEs.

":"  Evaluation-prefix ":" in front of tensorname causes immediate evaluation,
     ie that tensor-occurence is replaced with the definition of the tensor
     (with proper free, and noncolliding contraction indices inserted).
     EXAMPLE:  Suppose TE currently has definition: <R A B> + <S A><T B>
          -Then the command:        (PDEF TES) <:TE K L><:TE M N> @$
          -would define TES as <R K L><R M N> + <R K L><S M><T N>..
     Also outside the tensor brackets <>, a colon prefix has a similar meaning
     of immediate evaluation - although in that case the replacement is simply
     the value.  See the SHEEP-manual.


The characters can be combined.  Derivatives should however be first and @@
last.    Example:    <TEN ^[K L ,^[@@L>

An index may be any letter string or a digit.


(Technical:  The definition is put on "tsr" under property DEF.  If tsr had a
    BULF (see TCOMP) it is put away under "OBULF", but can be restored with
    "(XBULF tsr)".
    The PDEF-argument (above "tsr") and each identifier following a "<", is
    considered to be a tensor, and is given a default tensor-printout property
    in case it had none before.)

SHORTNAME INPUT:    In the RIC-definition above, the special object GUU is from
    previously known to have indices up (cfr DECLT).  Ending its input with ">"
    takes that info "towards the right, to the indices", in the sense that the
    GUU index-up-information governs, and cause the indices be written up.  You
    may alternatively put up-information on the indices, as @^J @^L, and end with
    "<" to request up-information to be "taken from the right", the
    index-prefixes.  Then you use a "short-name" of the tensor, here <G @^J @^L<.
    More on the "<"-ending in the spinor chapter.

TENSOR FORMULA IN/OUT-PUT                                       Page 1-5


1.2.3  SWITCHES TO PDEF

Switches are set with ON and OFF, eg:  (ON REVLEX PERMULT) or (OFF LCASEF) etc.
Default settings are shown in brackets:

WPDEF switch ^[on^] causing PDEF to Write the definition assigned.  You should
    normally keep your PDEF-commands in a file, instead of retyping them at
    each session.  Also when loading a file, eg   (LOAD "CORD.DEF")   the PDEFs
    in it writes the formulae being defined.  If you turn the switch off, you
    instead get messages:  <TSR A B> DEFINED, until you turn on:

NOMSG switch ^[off^] -inhibits various messages.

REVLEX switch ^[off^] -define REVERSE lexicographical component ie the input
    functions (PDEF,SETDIFF,PSPLIT) assigns a given formula to the *REVERSE*
    LEXicographically ordered component, eg <TSR D C B A> as opposed to normal
    <TSR A B C D>.  Be careful to turn back off immediately after reversed
    assignments - the standard setting should be off!  Another way to obtain
    this in PDEF is (PDEF (TSR D C B A)), but for SETDIFF and SRPL this switch
    is necessary.

    Warning:  The lexico-ordering orders Upper and lower case indices
    separately, so you will not get eg:  a B C d !!, but B C a d !!!  In PDEF
    you can cure this by typing (PDEF (TSR a B C d)) but in SETDIFF you must
    stick to EITHER upper or lower case in the formula!!

UPINDEX switch ^[on^] -Deduce upix from formula.  Makes PDEF check in each term
    what free indices are up (warns if terms give varying sets.  Cfr "DEL").
    Technical:The positionlist is put as UPINDX-property on the defined tsr.

FORGIVE switch ^[off^] -permit unusual input s.a. <V A>+<W B> which normally is
    refused but after (ON FORGIVE) defines a matrix.  Then turn off!



1.3  ^<<DECLT - DECLARE TENSOR PROPERTIES^>>

(DECLT (tsr p1 p2..) (tsrq q1 q2..)..) -give tsr properties p1,p2..  etc, and
give tensor tsrq properties q1,q2..  The order and number of properties given
is arbitrary.  They are instead, as are extra PDEF arguments, recognized on
their structure; those of p1, p2 etc.  that are:

1. Numbers will cause these index positions to be of contravariant type and
   written upstairs (used by e.g.  covariant diff, FAMILY, TRANSF)

2. Strings, ie text enclosed within double quotes, are taken as
   helpstrings, descriptive text for the object.  Example:
         (DECLT (TN "Long info" "may be broken" "into many helpstrings"))
   (HELP tn) displays helpstrings.  DOCUMENT and (with WDOC on) WDEF shows
   formula, helpstrings, ZEROMSG and symmetry.  See sample CORD.DOC.

TENSOR FORMULA IN/OUT-PUT                                       Page 1-6


3. Symmetries, ie has the syntax of a symmetry clause.  These can be highly
   complicated; see next paragraph.  Best explained with some examples:
   Example:                     Means that object TN is:
   (DECLT (TN S45))             S-ymmetric in "4,5" ie in 4:th and 5:th indices
   (DECLT (TN A12 S56 H89))     Anti-sym in 1,2. Sym in 5,6. H-ermitian in 8,9.
   (DECLT (TN A12 A34))         Anti-sym in 1,2. Independently, A-sym in 3,4.
   Restriction: The symbols Spq etc must have p+1=q<10 ie adjacent indices.
   (DECLT (TN (S A12 A34)))     As above, plus S-ym when swapping 1+2 with 3+4
   (DECLT (TN (S N12 N34)))     Only above swapping-sym, N-o (a)sym in 1,2 etc.
   For total (a)symmetry in several indices, use "TO":
   (DECLT (TN (A 3 TO 6)))      Antisymmetric in indices 3,4,5 and 6.

4. More general symmetries, stated with permutation operators being of
   structure (K (n..  o)..  (p..  q)), where n..o and p..q are numbers, are
   interpreted as explicit symmetry operators (see NIGSAM News 11 1976).
   Example:  (-1 (1 3) (8 13)) -mean that multiplication with -1 should result
   (asym) when doing the permutation (1 3) (8 13) ie exchanging both
   indexpositions 1 and 3, AND positions 8 and 13.  (Technical:  do not affect
   array storing)

5. of type ("nbr" .  "id") are listed under property name TNSPCH.  This tells
   the SHEEP-writer to insert "id" after index number "nbr" of the tensor.
   E.g.  (2 . !,) causes "," to be typed after the 2:nd index.  The extra "!"
   is since "," is a "funny" character (see that word).

6. (prop value) -where prop must be a member in the list:
   TENPROPERTIES  -list of tensor property names known to DECLT.
   Some of these are:

   ZEROMSG -stringmessage printed if object found zero.
          Example: (DECLT (RIC "Ricci tensor" (ZEROMSG "vacuum solution")))

   NAM -abbreviation, shortname, used at printout.  A simple symbol can be
       given directly (7 below), eg R in (DECLT (RIC R "Ricci tensor")), but to
       have eg S12 accepted as name(!) you must do (DECLT (TN (NAM S12))).

       UP/DOWN -NAM-keywords for shift, can be used in properties NAM and
       TNSPCH, eg (DECLT (TN (NAM UP !+ DOWN T))) -cause TN be printed as T
       with a plus up to the left.

7. At most one of the p1 p2..  should now remain (else error message:  "too
   many nams"); This is taken as printout/shortname, ie abbreviation at
   printout.

DECLT is in practice only used for basic objects, that lack definition.  For
objects that you give a DEF, it is most convenient to let PDEF declare the
other properties at the same time, eg:      (PDEF TN p1 p2 p3...) formula @$
which puts up the formula, but also the pi properties interpreted as above.

If TN already has properties, and you do another (DECLT (TN p1..)) then these
most recent properties pi will replace any earlier given of the same kind, ie
not accumulate.  Eg (DECLT (TN S12)) and then (DECLT (TN S34)) causes the
symmetry S12 to be lost and replaced with S34.  To entirely remove a property,

TENSOR FORMULA IN/OUT-PUT                                       Page 1-7


you could thus overwrite with a dummy, eg (DECLT (TN 0)) to make the set of
upindices be only the nonexistent 0:th.



1.4  ^<<SAMPLE FILE:  CORD.DEF^>>

-In non-trivial cases followed by echoed formulae obtained when read.  (DELK
and SYMF are two more properties in TENPROPERTIES.  Described later.) See also
other DEF-files, eg GFRAME.DEF
.E
(DOC) CORD.DEF Definitions of the CORD-tensors to create the CORD-package, .BLF
      CORD.BLF is automatically created from STENSOR with (TCOMPOUT CORD ALL)
      CORD.DOC is automatically created from STENSOR with (DOCUMENT CORD)     @#

(OFF PERMULT)        @% Ensure convention that Permutation-notation omits factor

(DECLT (GDD g S12 "Metric=user input" (SYMF DIAGSYM))) @%To obey switch DIAGONAL

(PDEF GDET "Determinant of GDD")     DET <GDD @@A @@B> @$
      GDET = DET(g)             Determinant of GDD 

(PDEF GINV "1/GDET")                   1/<GDET> @$

(PDEF GUU g S12 1 2 "Inverse of GDD" (SYMF DIAGSYM) (DELK GDET)) 1/<GDD A B> @$
      ab        -1
     g   = (g  )
             ab

(PDEF GDF g (2 . !,) S12 "Derivative of metric"
 (SYMF (LAMBDA (I1 I2 I3) (DIAGSYM I1 I2)))  ) <GDD A B ,C> @$

(PDEF GAM S23  "Christoffel Symbols of 1:st kind")
   1/2 ( <GDF A B C> + <GDF A C B> - <GDF B C A> ) @$

     GAM    = 1/2g     +1/2g     -1/2g
        abc       ab,c      ac,b      bc,a

(PDEF GAMU GAM S23 "Christoffel Symbols of 2:nd kind" (DELK GDF))
      <GUU I A>  <GAM I B C> @$

(DOC)
  In RIE below, the input is greately shortened by using bracket ^[ in
front of two indices, eg "^[D ,^[C". That represents antisymmetrization.
  Note that input requires the SAME bracket, ^[, as prefix in front of
BOTH indices. At output however, the second occurence is turned around
and put after the index, thus displaying "^[d ,c^]" as usual.     @#

(PDEF RIE R (S A12 A34) "Covariant Riemann")
     <GAM A B ^[D ,^[C> +  <GAM J B ^[C> <GAMU J A ^[D> @$
                                    j
      R     = GAM        +GAM    GAM
       abcd      ab^[d,c^]     jb^[c    ad^]

TENSOR FORMULA IN/OUT-PUT                                       Page 1-8



(PDEF RIC R S12 "Covariant Ricci" (DELK GAM GAMU))
   <GUU K L> <RIE K A L B> @$
             kl
      R   = g  R
       ab       kalb

(PDEF RICM R "Mixed Ricci" (DELK RIE))         <GUU K L> <RIC L M> @$
(PDEF RSCL R "Ricci scalar"  (DELK RIE))       <GUU K L> <RIC K L> @$

(PDEF EIN G S12 "Covariant Einstein")
    <RIC A B> - 1/2 <RSCL> <GDD A B> @$

      G   = R   -1/2Rg
       ab    ab       ab

(DOC)
  In WEYL below, ^[ means anti-symmetrization as in RIE. However, also ^]
has here come to use to indicate a second, independent anti-symmetrization,
which at output is displayed with prime "^[@'L ... M^]@'" to distinguish it.
  The antisymmetrizations in Weyl and Riemann are with PERMULT OFF,
ie no multiplication by 1/2 when performing the permutations.@#

(PDEF WEYL W (S A12 A34) "Covariant Weyl tensor")   <RIE I K L M>
  - 1/2<RIC ^]L ^[I> <GDD ^[K ^]M> + 1/6 <RSCL> <GDD L ^[I> <GDD ^[K M> @$

WEYL  W     = R     -1/2R     g      +1/6Rg   g
       iklm    iklm      ^[@'l^[i k^]m^]@'       l^[i k^]m
.P



1.5  ^<<INDEX SYMMETRIES^>>

The summary and examples given in 3 above should suffice for normal purposes.
For extreme needs, here are further explanation of the syntax:
(DECLT (TN s1 s2 s3.. sn))      -where si are any nbr of symmetry-clauses:

Symmetry-clause :==
        Symbol xpq, where x=S,A,H or N, and p,q adjacent digits, max 9,
        or (x p q)  or (x p TO q)       -where p,q are any, also nonadjacent,
        or (x  <symmetry-clause>   <symmetry-clause>)
The last, nested case, represent symmetries where two SETS of indices should
entirely change place, are indicated by an S(A,H or N) in front of the two
index-sets.  Eg (S N12 N34) mean Sym when swapping ix-set 1+2, with ix-set 3+4.
N here mean N-o sym within each ix-set, and is present only so as to identify
and separate the two ix-set specifications.  If TCOMPing, swaps must be between
adjacent ix-sets.  For arbitrary swaps, use 4 above.
Cyclic symmetry means a SUM of at least 3 terms equal zero (eg Riemann).  That
is exploited by replacing any TWO if found, with minus third.  Finding such a
SUM is profoundly much more difficult than turning gki to gik, and is handled
quite differently.  See the SUMSUBStitutor.

TENSOR FORMULA IN/OUT-PUT                                       Page 1-9


Note:  The declaration S12 A23 is perfectly ok in STENSOR although these
clauses overlap in index 2.  SHEEP however do not manage this; for salvage see
TCOMP;Overlapping symmetries.

(REMSYM t1 t2..) Remove symmmetries from tensors t1,t2,...



1.6  ^<<WDEF - WRITE DEFINITION^>>

(zDEF TEN1 TEN2 TEN3 .  .  .)   There are several functions whose names end
with "DEF".  In the next chapter are also the functions (W)EDEF and (W)SDEF
described.  They all take an indefinite number of identifiers as arguments.
These should usually have been given definitions by the use of PDEF, i.e.  be
"tensors" in that sense.


(WDEF tsr1 tsr2...) -Write DEFinitions of the tensors ie their DEFinition
    formulas (stored under property DEF).  If the DEFinition was missing or was
    NIL, nothing is written.

(WODEF tsr1 tsr2...) -Write Old (backup-) DEFinition -as WDEF but writes a so
    called "Old DEF", or "backup-DEFinition", stored under property ODEF.  See
    XDEF.

(DSTAT tsr1 tsr2...) -Definition STATus.  Returns for each tensor the
    information:
                      (<tensor>  <DEF-stat>  <ODEF-stat>)
    -where both status-indicators
    are one of:                 Meaning:
    "NIL"          -if DEF/ODEF is missing, else
    <number>       -nbr of terms in formula (see also EDEF, switch TERMS)
    "zero"         -formula was 0.

(XDEF tsr1 tsr2...) -Exchange DEF and Old DEF (backup-definition) for each of
    tsr1,tsr2,...
    In particular, if the backup-definition was empty, XDEF will instead make
    the DEFinition empty.  This makes the tensor undefined as far as EDEF or
    TCOMP is concerned, since those only take interest in the DEFinition, not
    the backup-definition.  Thus EDEF (see next chapter) won@'t evaluate
    occurrences of the tensor in formulas, until you with another XDEF make the
    backup-definition become the current DEFinition again.
    You may store two alternative definition-formulas by issuing, conveniently
    in an input-file, the commands PDEF, XDEF and PDEF again, on the same
    tensor.  Then at interaction you switch by only calling XDEF.
    Returns the resulting DSTAT for each tensor.

(XXDEF t1 t2..) Restore most original definition ie what was PDEFed on t1,t2,..
    the first time.  Thus XXDEF can salvage when XDEF can not, ie from
    accidental redefinitions, and from more than one regretted EDEF (at the
    price of restarting from the beginning).  XXDEF merely reinstalls the most
    original formula as being current, loosing what was previously current.
    The ORGDEF will continue to exist for future XXDEFs.

TENSOR FORMULA IN/OUT-PUT                                      Page 1-10


    Thus there are two backups; the second last, and for emergency the most
    original.  These are by experience the most useful.

LCASE switch ^[on^] -causing indices be written in Lower CASE (at least dummies)
    by W(O)DEF as long as left on.  Thus you can conveniently use upper case
    throughout at input, also for indices.  If you however use eg both K and k
    at input, both will be confusingly written k at output.  Thus stick to
    typing in eg upper case, unless you need both for different indextypes -
    and then do (OFF LCASE).

LCASEF switch ^[on^] -causing Free indices be in Lower CASE -subswitch, that only
    has effect if the previous is on.  Then you may by:  (OFF LCASEF), inhibit
    lowering of the free indices (while dummies are in lower as usual).  Thus
    the free indices, in upper case, stand off better from the dummies in a
    formula with many indices where you otherwise easily forget which is which.



1.7  ^<<PERMUTATION NOTATION^>>

The index prefixes (,^[,),^] represent (even and odd) CYCLIC PERMUTATION of
indices, see PDEF.  This is a more general notation than, and can replace,
ordinary (anti)symmetrization.
.E
Examples: If you have typed (PDEF TSR) and give
-formula:                -then it means:    -and (DOPERM TSR) Gives:
<T2           ^[c   ^[d>    A-sym part,of rnk 2 obj.  Nbr of terms:  2
<T3      (b  (^[c  (^[d>    A-sym part,of rnk 3 obj.                 3!
<T4  ^]a ^](b ^](^[c ^](^[d>    A-sym part,of rnk 4 obj.                 4!
Thus with also the last symbol ")", objects up to rank 5 can be (anti-)
symmetrized directly. For higher ranks, introduce intermediate objects.
  Example: For total sym of a rank 5 object T5, first Sym over LAST 3 only
in object LAST3S, then rest in ALL5S:   DOPERM on them then gives:
    (PDEF LAST3S) <T5      a   b  (c ()d ()e>@$       2*3 nbr of terms
    (PDEF ALL5S)  <LAST3S (a ()b ()c ()d ()e>@$       4*5 nbr of terms
.P
After (EDEF ALL5S) each of the 4*5 LAST3S-terms are replaced with 2*3 terms,
giving all the 5!  terms of a total symmetrization.

Note:  Dont (EDEF ALL5S) with both LAST3S and ALL5S unexpanded!  If both
contain the same symbol eg !(, that would give TWO !( -marked index-sets in the
same term, and STENSOR presently wont understand them to be independent.  Thus
PPDEF away () from at least either tensor before EDEFing, to avoid this
collision!  (Unless one was !( other !(G.  Cfr PPDEF).  Some notation could be
kept since E/SDEF and substitutions understands them.

(DOPERM t1 t2..) -Expand all PERMutations in t1,t2,..  ie all permutation
    notations ^[,(,^],) disappear from the DEF of tensors t1,t2,..  The most
    convenient way to expand away all such notation, is:  (DOPERM ALL), or
    prior to any PDEFs turn on:

TENSOR FORMULA IN/OUT-PUT                                      Page 1-11


PDEFPERM switch ^[off^] -cause PDEF call DOPERM on formula input ie every object
    PDEFed thereafter is hit with DOPERM, expanding permutation notation used
    in the formula if any.  If regretted, use XXDEF.

(PPDEF tsr prm1 prm2..) -Perform Permutation notations prm1, prm2..  in DEF of
    tsr.  Only the permutation notations that are indicated are performed, so
    permutation notations in the DEFinition formula which aren@'t listed to
    PPDEF will remain unchanged in the DEF-formula.  Notations given, that
    don@'t occur in the DEFinition formula, have no effect.
    Note:  the permutation-symbols must be "slashified" in this command.
    Example:  (PPDEF tsr !^[ !( )     See Lisp-intro, funny chars.
    Note:  Permutation symbols used for 2 indices, are internally for less
    confusion renamed to have a G (-eneral) after it.  On those do eg (PPDEF
    tsr !^[G).

PERMULT switch ^[off^] -Permutation MULTiplies ie DOPERM/PPDEF multiplies with
    1/(cyclelength) when Performing Permutations.  Thus eg ^[A ^[(B ^[(C becomes
    (Totasym)(1/3)(1/2), ie including the usual 1/factorial.

PERMUSED list of "Permutations used"   Technical.  Record of permutation
    symbols used so far.  Used by DOPERM and TCOMP which PPDEFs them in each
    DEF being TCOMPed.  Thus the user need do no DOPERM before TCOMPing.













                                   CHAPTER 2

                       MANIPULATION OF INDICIAL FORMULAS



SUMMARY:
(EDEF t1 t2..)         	Eval the DEF of t1,.. If EDEFASK is on, then the
Char:  Runs command:   	Which means, comments:
W     (WDEF t1 t2..)   	Write DEF (each zDEF-command also has a WzDEF-form)
E     (EDEF t1) again. 	Type alternating E and W for successive evaluation.
S     (SDEF t1) again. 	Just Simplify DEF, no Evaluation. Same backup kept.
X     (XDEF t1)        	eXchange DEF/ODEF, ie bring back the backup def.
= t f @$ (PDEF t) f @$   	Define new object. Prompts for tsr t and formula f.
?    -Shows further character commands, eg Q-uit (to next tsr t2 if any)
(EEDEF t1 t2..)        	Eval repeatedly until only basic objects remain.
(FDEF..)   (GDEF..)    	Faster, def-Grabbing EDEFs.   (HDEF..) Holds backup.



2.1  ^<<REPRESENTATION OF AN INDICIAL FORMULA^>>

Each term in an indicial formula typed to PDEF is separated into a scalar and a
tensor part.  The indices are classified according to whether they occur just
once in each term (free) or more (dummy).  PDEF ends up with the following
internal representation of the indicial formula:

             ("ALG"   <free>   <dummies>   <trm1>   <trm2>  . . . )

and puts it under property "DEF" of the tensor.  Here:

"<free>"        is the list of the free indices in lexicographical order, e.g.
               "(I K M)", which also specifies the component of the tensor to
               which the def refers.

"<dummies>"     is a list of all the different contraction indices that occur
               in any of the terms.
Each term has the structure (<scalar part> .  <tensor part>), where <scalar
part> has ordinary SHEEP-formate (often a sum).

     The reason for separating the tensors is that they of course need special
attention and treatment (whole of ISMPE except 3c ^[and fast part of 4^] treats
tensor part).  The separation gives two advantages:

MANIPULATION OF INDICIAL FORMULAS                               Page 2-2


     1.  Tensor part contains only tensors and can thus be processed more
         systematically.

     2.  Less tensor parts to treat (as factorized, see 3b below).


     The present chapter describes how to manipulate this representation.



2.2  ^<<EDEF - EVALUATE DEFINITION^>>

EDEF (or WEDEF) is the main function for Evaluating DEFinitions.  Of course, it
also simplifies.  In all, the EDEF-processing of an indicial formula consists
of four steps:
        1.  Evaluate
        2.  Substitute products
        3.  Simplify
        4.  Substitute sums

     Functions below acting on DEFinitions of tensors have names ending with
"DEF":


(EDEF tsr1 tsr2..)      Evaluate and simplify the DEF.  Replaces the
     DEF-inition of TSR1 ..  with the resulting formula.  A backup of the
     original DEF is however stored under property "ODEF" (restored with XDEF).
     What was stored under ODEF earlier (if any), is lost.

(WEDEF T1 T2...) Same as EDEF but also applies WDEF to write out the resulting
     DEFinitions.

 (SDEF T1 T2...) Simplify DEF.  As EDEF, but applies only step 3 (simplify) of
     EDEF.  The backup isn@'t replaced for this (smaller) change.

(WSDEF T1 T2...) Same as SDEF but also applies WDEF to results.

(TENCAL) Of no arguments, starts a read eval loop.  Applies EDEF-processing to
     an indicial formula directly inserted by the user (rather than use a
     DEF-property), and writes out the result.  Exit with @^G.



2.3  ^<<MORE ON EDEF PROCESSING STEPS^>>

In more detail the EDEF processing-steps mean:

     1.  Evaluate and differentiate tensors, and expand.

         If switch SYMZERO is on, terms with double contractions between an
         asym.  tensor and a symmetric (or multiply occurring vector) are first
         discarded, since that is zero (later integrated into 3a).

MANIPULATION OF INDICIAL FORMULAS                               Page 2-3


         To evaluate a tensor means to replace it with its definition, with
         proper free indices and noncolliding dummies inserted (chosen from
         INDEXTYPES and included in the dummy list in the resulting
         IND-representation).  If not defined, the tensor is left as it is.

     2.  Substitute tensor products, demanding contraction or not.

     3.  a) On the tensor part of each term:
                 Order symmetrical indices              (free prior to dummies)
                 order tensors (If NOREN is on, exit here)
                 rename dummies         (using freedom due to sym.; (*))
                 order indices again
                 order tensors again.
         b) Add terms with same tensor parts (makes scalar part a sum).
         c) Copy (not until now) scalar part and let SHEEP simplify it.

     4.  On the canonicalized result, substitution of sums of tensor products
         (*) can be done in reasonable time.

                 If the switch:

         WSUBS  -is on, then the write-out functions; WEDEF, WSDEF, WDEF and
                 WODEF, will all be affected to perform an additional step:

     5.  Substitution at printout, not affecting the stored formula.  You may
         easily set own substitutions to be performed in step 2,4 or 5 by using
         SETSUB with arguments TSUL, SSUL and WSUL respectively.  However, for
         step 5 a general substitution-rule is also built in that (if switch
         WSUBSG is on) makes the system automatically replace each contraction
         between the metric and any tensor, with simply another (autom.
         created) form of that tensor.  This is for compactness at output,
         while the internal formula for canonicity sticks to just one form
         (explicitely contracted in several ways).



EDEFASK        Switch, which if on causes EDEF to ask for
     interactive evaluation orders.  This is highly recommended, both for
     novice users, and if you eg have many tensors in the formula to be
     evaluated.  As EDEF combs through a formula, and finds that eg TSR has a
     DEFinition, it asks:

     TSR Eval?  You can then type "?" which gives the following help:
     Y,N,Z-ero this time,W-def,S-tatus,X-def,I-nspect,B-reak
        -which means:
     Y-es, evaluate TSR (use its DEF)
     N-o don@'t evaluate
     Z =replace TSR with Zero in this evaluation, regardless its DEF
     W =apply WDEF on TSR, then ask again
     S =apply DSTAT on TSR, then ask again
_______________

(*) unique features as far as known.

MANIPULATION OF INDICIAL FORMULAS                               Page 2-4


     X =apply XDEF on TSR
     I =Inspect.  The TSR is written, and the term where it occurs.  Then you
     answer Y or N, and that answer only affects that occurrence individually,
     so you will be asked again at the next occurrence of TSR in the formula.
     Ie selective evaluation.

     After e/S-DEF has completed its treatment, of say TOPTSR, it also asks:
                                   TOPTSR Action?
     Again, type ?  to see the new menu.  Among other things you can choose:
     U       to U-se a new substitution list. Then type @'MYSUL to choose that,
             or @'(TSUL MYSUL TSUL) to also start, and end, by using the TSUL.
             Thus you can choose any sequence, and number of, substitution lists.
     V       to V-iew the current subslist. If NIL, solely TSUL is assumed.
     T       to change T-ensor to be acted on. Answer @'MYTSR.

     The rest of the menu is selfexplanatory.



TERMS   Switch ^[off^] which if on causes EDEF to write:  "n/m terms", where
     "n"=number of terms directly after the evaluation-step (1), (but before
     simplification), while "m" is number of terms that remains after
     simplification.


HODEF   Switch ^[off^] which if ON means "Hold Old DEFinition", ie (W)EDEF is
     made to not use the normal backup-mechanism.
     Thus as you call (W)EDEF, what currently is stored as ODEF will remain
     there, but at the price that the formula stored under DEF will be lost
     (not backed up) when replaced by the result of applying EDEF on it.  See
     also XDEF, DSTAT and WODEF.



2.4  ^<<REPEATED/RESTRICTED EDEF^>>

(EEDEF tsr1 tsr2...) Applies EDEF repeatedly as long as its definition contains
    any tensors with definition, ie as long as there is anything to evaluate,
    thus ending up with a formula where only undefined, so called basic,
    objects remain.  Then the same for tsr2 etc.

Note:  Do not use substitutions that go back from basic objects to defined!
    Remark:  Works by EDEF setting a flag whenever finding a definition, and
    then the EDEF is repeated if the flag was set (definition found).  Now say
    that the goal with only basic tensors remaining was achieved through the
    n:th EDEF.  Then not until the n+1:st EDEF this flag-setting will fail, ie
    an extra EDEF is consumed to detect that all objects were basic.  If the
    result is very long (and n small), you may thus save some cpu-time if you
    by reasoning/inspection can do the correct n EDEFs by hand instead.
    Controlled evaluation is also recommended for complicated, first time
    calculations.  But for calculations that are tried out or are known to
    result in shorter expressions, EEDEF is very convenient.

MANIPULATION OF INDICIAL FORMULAS                               Page 2-5


EDEFRPT flag ^[off^] that if on causes EDEF to repeatedly call itself as long as
    definitions are found.  EEDEF simply calls EDEF with EDEFRPT locally set
    true.

Extentions of EDEF:
    EDEF is to be seen as part of a series of functions, especially:  EDEF,
    FDEF, GDEF.  As the letters E,F,G indicate, these are all related and their
    difference is that they do less and less as you go down the alphabet.  All
    of H,F and G-DEF holds Old DEFinition.  Beside that, they are degraded
    variants of EDEF, with HDEF being least degraded, FDEF more, GDEF most.

FDEF F-ast, stripped EDEF (holds, as HDEF), is as EDEF, but for the first step
    on the ladder removed, that is substitutions, and uses a Faster
    simplification algorithm.

GDEF only G-ets the definitions, and expands.  As FDEF, but no simp whatsoever
    is done.

HDEF H-olds Old DEF, else as EDEF.  Ie with HODEF temporarily on.

LASTENSOR symbol bound to the fullname of the last tensor that eDEF was applied
    to.

(ASKNOT cmd1 cmd2..) Takes any number of commands as arguments, and performs
    these with the switch EDEFASK temporarily turned off.
    Example:    (ASKNOT (WEDEF TSR) (GDEF T2) )
    -causes TSR and T2-formulae to be processed with EDEFASK in off-position.
    This command is useful in a file, where you are sure that you want
    evaluations, and where any asking temporarily would be of a nuicence, but
    you dont want to affect the users setting of the EDEFASK-switch
    permanently.
    After (ASKNOT ..) the EDEFASK-switch is back to whatever value it had
    before.

EONLYLIST Global symbol ^[nil^] which if set to a list (te1 te2...) of tensors,
    causes only these to be considered for evaluation.  All the eDEF-commands
    are still affected by the switch EDEFASK if it is on, but then asking will
    only take place for tensors in EONLYLIST.

eDEF denotes EDEF,WEDEF,FDEF,GDEF or HDEF in this manual.

(EONLY (eDEF t1 t2..) te1 te2...) Carries out the eDEF-command, allowing ONLY
    te1, te2,...  to be evaluated.
    This is equivalent to doing (eDEF t1 t2) with EDEFASK on, and then always
    answer the "TSR Eval?" -questions with N-o, except for answering for
    exactly te1, te2,...  with Y-es.
    Works by temporarily setting EONLYLIST to (te1 te2...), and as for ASKNOT
    temporarily turning off the switch EDEFASK.
    Both symbols are afterwards set back to whatever values they had before.

MANIPULATION OF INDICIAL FORMULAS                               Page 2-6


2.5  ^<<ORDINARY DIFFERENTIATION^>>

Ordinary mathematical differentiation is indicated with prefix "," and
performed with EDEF.

(SETDIFF TSR1 TSR2..)    DEFine result of indicial DiFferentiation, i.e.  diff.
     with respect to the i:th coordinate.  For each argument (tensor or scalar
     (*)) the system asks for input by prompting with a "=".  Then you should
     specify the derivative (of TSR1 ...).  For this you may type any indicial
     formula (of proper rank) in the same way as for PDEF.  If the free indices
     in the input (ordered) turn out to be e.g.  (A B C), the formula is taken
     to specify the result of <TSR A B ,C>.

     (SETDIFF X)        If x is the vector used to represent the variables,
     =<DEL I K> @$       specify as derivative the built in Kronecker delta.

     If the derivative is unknown, do e.g.

     (SETDIFF (GAMU I K L))     Then derivatives of GAMU will be written
     symbolically.



2.6  ^<<COVARIANT DIFFERENTIATION^>>

  - is indicated at PDEF input, and then by EDEF replaced with one ordinary
derivative plus contractions with the Christoffel symbol, called "GAMU".  Only
the outermost differentiation is for control performed at each evaluation.  For
multiple diff.  just apply EDEF several times.

Given two anticommuted covariant differentiations, e.g.  <TSR A ;^[B ;^[C> , the
system uses instead the Ricci identity, and returns contractions containing the
mixed Riemann tensor (with 1:st index up), internally called "RIE1".  Above
objects are special due to an initial:  (AFFINITY GAMU RIE1).  You may redo
that with other names.

The DEFinition of TSR will be "shielded" by the ";" and not used until all
_______________

(*) When typing a formula to PDEF, scalars can be inserted in two ways,
affecting their location in the STENSOR representation:

     1.  <SCL>  is placed in tensor part as 0 rank tensor

     2.  SCL    is placed in scalar part to be treated by ordinary SHEEP.

The first way must be used if SCL has a definition, anti/non-commutes or occurs
in a sum to be substituted.
Else, method two should normally be used.
Derivatives of a scalar are in both cases specified with SETDIFF.  The
differentiation is in the second case performed by SHEEP, using a change by Jan
Aman.  The created vectors in the result are then transferred to the tensor
part.

MANIPULATION OF INDICIAL FORMULAS                               Page 2-7


these covariant differentiations have been performed.



2.7  ^<<FILETYPES AND DISK IN/OUTPUT^>>

SUMMARY:
 Filetype: For whom:  Contents:         How to create:
      DEF human/prog  PDEF-commands  Human input to editor,creating file.DEF
      SEF program     Saved DEFs     (SAVDEF file ALL)
      TEF program     Temp. saved    Automatic, see BUCKETOUT
      WEF human       Writed DEFs    (OUTF "file.WEF" (WDEF ALL) (PRSUB TSUL)..)
  For these see TCOMP chapter and appendix:
      BLF program     BULF programs  (TCOMPOUT file ALL)
      DOC human       Writed DEFs    (DOCUMENT file)

  STENSOR.INI is loaded automatically, else use:
    (LOAD "file.xxx") to load.       If no response, use  (RELOAD...).

        A simple filespecification has the form:   filename.extension.
Example:  CORD.DEF -has filename "CORD" to hint the application, whereas the
extension or filetype is used to indicate the technical form of the contents,
here by convention "DEF" for PDEF-commands.
Some filetypes not discussed elsewhere:

DEF -extension for file with PDEF and related user commands.  This is the only
    file both the user and program can read (column "For whom:" above).  It is
    the source by which all other files can be created, and is therefore the
    most important.  Type changes and new formulae into a DEF-file rather than
    directly to STENSOR, so you can simply load that at the next session
    instead of having to type it all again.
    A particular DEF-file is:

STENSOR.INI -file loaded at startup of STENSOR if existing at current
    directory.  This saves you from typing (LOAD "STENSOR.INI").  You can have
    a subdirectory for each application, each with its STENSOR.INI that contain
    all PDEF and some EDEF-commands for that project, or else rename the
    previous STENSOR.INI -file to a more descriptive "name.DEF" before creating
    a new STENSOR.INI for the next application.

SEF -extension for file with Saved dEFs - created by:

(SAVDEF file tsr1 tsr2...) -SAVe DEFs of tsr1,tsr2...  in a file with name
    "file.SEF".  To force other extension than SEF, use for filename instead:
    (file .  ext), or "file.xxx".  SAVDEF is typically used to save computed
    formulas to avoid unneccessary recomputation.  Not only DEF, but all
    properties in the list SAVDEFPROPERTIES are saved.  To ensure that all side
    effects on all objects are restored however, you should still start each
    session by loading the DEF-file(s) that set up these declarations, and only
    after that load the SEF-file.

MANIPULATION OF INDICIAL FORMULAS                               Page 2-8


(OUTF file.WEF cmd1 cmd2..) -Out-force to file the output from cmd1,2,..
    Sheep-function.  The cmdi can be any number of commands, eg WDEF and PRSUB,
    whose output will be re-directed to the file.

A WEF-file is NOT understood by the program if loaded (see "For whom"); to
resume computations you need the DEF and SEF-files.  These can also recreate
the WEF-file.  Thus the lexical order DEF, SEF and WEF in the above table
normally tells the (reversed) order in which to delete files if needing disk
space.

Technical:  Some lisp symbols of importance here:

MSEARCHLIS* -List of directories to scan by loading commands.

MEXTLIS* -List of extensions to scan if a load command used only a filename
    without extension.

MLIST* -List of Modules(files) loaded hitherto, without extension.  Therefore
    after eg (LOAD "F.DEF") F is thought to be loaded, so you need RE-load for
    another F-file, eg (RELOAD "F.SEF").



2.8  ^<<"ALL"-ARGUMENTS TO ZDEF-COMMANDS^>>

SUMMARY:
Typical use:  (ALLIN list1), PDEF-cmds, (ALLIN list2), PDEF-cmds..
              (WDEF ALL list1), (WDEF ALL RANK 3)     -etc,
or in general: (zDEF ALL-clause t1 .. tn ALL-clauseB ...)
Where ALL-clause = ALL followed by (list-names and) KEYWORD(s).
1-arg keywords: IN list, ON chrs, BY SETSUB, RANK nbr, RANKL nbr, RANKG nbr
        (Recursively) PREvious/DEPendent: PRE tn, DEP tn, RPRE tn, RDEP tn
Prefix keyword: NOT     Eg: (EDEF ALL NOT BY SETSUB)

INTRODUCTION:  The zDEF-commands (WDEF,XDEF,(W)EDEF,(W)SDEF etc) takes an
    arbitrary number of (PDEF-defined) tensors as arguments.  So does eg DECLT,
    TCOMP and also the commands TCOMPOUT, SAVDEF and EONLY except for their
    first argument (that should be a file, or command).
    Often these commands should be applied to a large number of tensors.  Then
    it is very handy to reference these tensors en masse, eg by (TCOMP ALL)
    which compiles (in chronological order) ALL tensors PDEF-ed hitherto.  PDEF
    keeps a record of these in the list PDEFINED, which is what the ALL-symbol
    expands to.
    (Also in:   (WDEF ALL tsrq)  -the ALL is expanded similarly, so ALL are
    written (including tsrq), and then tsrq is written once MORE.  By (WDEF
    tsrp ALL tsrq ALL) -each object is written twice, but tsrp and tsrq a 3:rd
    time, before and in between.)
    ALL may be followed by one or more "list-names", and/or "keywords", to
    reference more restricted sets than ALL itself.  This is called an
    ALL-clause.

MANIPULATION OF INDICIAL FORMULAS                               Page 2-9


ONE-ARGUMENT KEYWORDS, used as eg (WDEF ALL RANK 3), are:

    ALL RANK nbr  =objects of rank = "nbr".  Similarly,
    ALL RANKL nbr  =objects of rank L-ess than nbr, and
    ALL RANKG nbr  =objects of rank G-reater than nbr.

    ALL IN lstnam  =objects IN lstnam, made by (ALLIN lstnam), or after loading
            a file, objects therein are accessed by:  ALL IN file.  Eg after
            (LOAD "CORD.DEF") you can do:  (WDEF ALL IN CORD) - or NOT IN.

    ALL ON xyz  =objects with names starting ON xyz

    ALL BY prop  =objects that possess the property prop ie selects BY the
            criteria "possessing prop".  Most common use is "BY SETSUB" which
            tests for property "SETSUB", which is flagged on a tensor when it
            is given a definition by the SETSUB-command.

    ALL PRE tsr  =objects PREceding tsr ie that occur in the DEF of tsr.

    ALL RPRE tsr  =objects Recursively PREceding tsr ie that occur in the DEF
            of tsr, *or in the DEF of any of these*, or ...  recursively.
            Objects are listed with increasing level, with the most basic
            first, so this is convenient for computations "from bottom", eg
            (EDEF ALL RPRE WEYL), while "from top" is done as:  (EEDEF WEYL).

    ALL DEP tsr  =objects DEPendent on tsr ie with DEFs in which tsr occurs
            explicitely.

    DEP -is also a tsr-property holding above set, examined with "BY DEP".
            Since top-objects lacks it, they are accessed with:
                                   (EDEF ALL NOT BY DEP)

    ALL RDEP tsr  =objects Recursively DEPendent on tsr ie with DEFs in which
            tsr occur explicitely or hidden.

Simple examples:  ALL + keyword + argument:
    (WDEF ALL ON RI) -Write all with names starting ON "RI", eg RIE, RIC,..
    (EDEF ALL RANK 1) -Evaluate the DEFs of all vectors (one index objects).
    (SDEF ALL RANKL 2) -(Rank L-ess than two) SDEF all scalars and vectors.
    ALL + NOT + keyword + argument -Negates a keyword:
    (TCOMP ALL NOT ON RI) -compiles all, EXCEPT for:  RIE, RIC,...

(ALLIN list-name) Cause also this list to accumulate tensors being PDEFed from
    now on (extends the number of accumulators, see list ACCUMS).
    Then (WDEF ALL list-name)   -writes those tensors only.
    Usage: 1) (ALLIN list1)                -add list1 as accumulator
            2) Do some PDEF-commands,        -which add also into list1
            3) (ALLIN list2)                -add list2 as accumulator
            4) more PDEF-commands           -now adding to list2
            .... etc.
            Now these subsets can be referenced separately: (WDEF ALL list2)

    Syntax of an ALL-clause:                ALL, ALL+listname(s), ALL+keyword(s)

MANIPULATION OF INDICIAL FORMULAS                              Page 2-10


            End of an all-clause:  End of arglist, or tensor (non-keyword/listname)
    More examples:       (Several All-clauses may be given, and mixed with tsrs)
    (WDEF ALL)           All in PDEFINED-list ie defined hitherto
    (WDEF ALL mylist)    All PDEFed between (ALLIN MYLIST) and other ALLIN-cmd
    (WDEF ALL IN mylist TSR)    Same. In this example, also TSR finally written
    (WDEF ALL lst1 lst2 .. lstn)   1:st those in lst1, then in lst2,..last lstn
    (WDEF ALL IN lst1 IN lst2 ...)    Only A and others occuring in ALL lists.
    (WDEF ALL lst1 lst2 IN lst3)            in (lst1 + lst2) IF ALSO IN lst3

    (WDEF ALL RANK 3  ALL RANKG 4  ALL RANKL 1)  3 objectsets: r=3, r>4, r<1.
    (WDEF ALL ON xyz)       All with names starting on the character string xyz
    (WDEF ALL lst1 IN mylist ON xyz)   Those in lst1 of mylist with names xyz...

    (EONLY (EDEF ALL lst1 lst2 ON xyz) ALL RANKL 1)
               EDEF xyz... in lst1 and lst2, ONLY plugging in defs of scalars!

    (WDEF ALL NOT IN mylist)        In PDEFINED, but not in MYLIST
    LATE -the latest objects defined, not included in any ALLIN yet,

LAST references the expanded argumentlist of the last zDEF-command.  Thus eg
    (EDEF ALL ON RI) -works on RIE, RIC,.., and then eg (WDEF t1 ALL LAST t2)
    -writes in addition t1 and t2 (before/after).

(KEYWORD sym ^[init^] body) declares new keyword to ALL.  The keyword must be
    used with one argument, eg   (WDEF ALL "sym" arg)   -which then causes
    reference to all tensors, x, for which "body" evaluates to non-nil.  The
    body must reference the "arg" with ARG, and tensor candidate with X.
    Example:  (KEYWORD BY (GET X ARG))   -is exactly the definition of the BY
    keyword.  Then eg   (WDEF ALL BY WSUL)   -writes those having a write-subs
    property.  The use:  "BY SETSUB" checks for property "SETSUB", which is a
    property put on a tensor when it is given a definition by the
    SETSUB-command.

  "init" is an optional argument, which should be an expression to be evaluated
    first, as a setup before the tensors X are tested.  See the definition of
    keyword "ON" in file PDEFAL.STS

  If "body" is the symbol NIL, ie no selection predicate is given, then this is
    used to indicate a different method of selection:  then "init" is supposed
    to have set the symbol ARG directly to a selected list.  This list is then
    intersected with PDEFINED (or subset thereof given by other parts of the
    ALL-clause if any), but the relative ordering in the list ARG is kept in
    the result (while with a predicate the order is as in PDEFINED ie
    chronological).

    This is used for RPRE and RDEP to always ensure ordering from bottom,
    regardless of the order in which objects were defined (PDEFINED):
                (KEYWORD RPRE (SETQ ARG (RUNIONGET ARG @'PREQ)) NIL)
                (KEYWORD RDEP (SETQ ARG (RUNIONGET ARG @'DEP)) NIL)
            (Discussing the Recursive Union-GET here would lead to far)

MANIPULATION OF INDICIAL FORMULAS                              Page 2-11


2.9  ^<<CREATE BACKUP^>>

(TWINDEF T1 T2) -makes T2 a twin of T1 obtaining the same DEFinition.  Also
    same ODEF, and all the properties in the list TENPROPERTIES are inherited
    from T1.  Used in a multi-step computation, when the current, intermediate
    definition on T1 is worth keeping for some time, while some further
    evaluations can be tried out on T2.  If the result then turns out to be
    unsatisfactory, one can return to the original T1.
    No copying is done.  Thus an immediate (SDEF T2) is not recommended, since
    SDEF affects the expression itself, which also is the DEF of T1.

(COPYDEF T1 T2) -makes T2 a copy of T1.  Exactly as TWINDEF, except that one
    property, the DEF- expression, is COPIED from T1.  Being a copy, the
    T2-DEFinition can be changed without danger for T1, ie also (SDEF T2) can
    be done without danger.  COPYDEF can be used as a standard, and TWINDEF
    when T1 has hundreds of terms so space becomes an issue.

(REMFIRST n tno tnc) Removes 1:st n tensorial factors in all tno-terms and puts
    result on tnc as definition.  As COPYDEF, but for the removal.  Which
    indices are free and dummy is reanalyzed, so tnc gets proper rank.

    Use ORDER+SDEF to have those objects desired to be removed, moved leftmost,
    before calling REMFIRST.

    NOTES:
    The first n factors MUST be identical in each of the terms, inclusive of
    their indices (user responsibility).
    NO diff-factors like <GDD A B ,C> are removed - only SIMPLE tensors!

    If (a)symmetric contracted objects were removed, you might consider to take
    the (a)symmetric part of the resulting copyobject tnc.



2.10  ^<<TECHNICAL ON EDEF^>>

EDEFTOP switch ^[on^] restricting evaluation to topobjects ie with relative
    topmost objects being plugged in first, postponing replacement of lower.

    Example:  In the file CORD.DEF (see appendix) the object WEYL is expressed
    among other things in terms of the objects RIC, and RSCL (that contain RIC
    ie is higher).  With (EDEF WEYL) EDEF would find these to have definitions,
    and therefore candidates for being plugged in.  Doing so, the following
    replacement would occur:
        RIC  ---> other objects (RIE times GUU)
        RSCL ---> RIC times GUU
    -the RICs removed in the first line would therefore be reintroduced when
    RSCL is replaced, resulting in an expression with RIC only partially
    replaced, which in general might inhibit cancellations.  With EDEFTOP on,
    this is avoided; only the topmost objects, here just RSCL, will be
    considered for replacement, not RIC (or RIE which also occur in WEYL),
    since they are lower than RSCL (ie occurs in RSCL).

MANIPULATION OF INDICIAL FORMULAS                              Page 2-12


    The candidate RSCL will, if EDEFASK is off, be directly replaced.  If
    EDEFASK is on (default), RSCL is the only object proposed for replacement,
    not bothering the user with lower objects.  The next highest (RIC) can then
    be plugged in at a new evaluation-pass (requested by simply typing an E).


Internal control, seldom needed:

NFSMP flag ^[nil^] -No Fac SiMP   -quit simp of factorized tensor part.

NCSMP flag ^[nil^] -No Coe SiMP   -quit simp of coefficient part.

ORDNUMG global ^[T^] order numbers growing.

ORDSUM global ^[nil^] -ORDER affect sum ordering (v.  2.26).

ORDSI2 flag ^[T^] -Order SymIx twice   -and factors.  Renaming inbetween.

ORPANLIM global ^[5^] ORder PArtNers LIMit   -max depth when ordering by checking
    the partners contracted to.  Increase if high power of a tsr.













                                   CHAPTER 3

                                 SUBSTITUTIONS



SUMMARY:
(SETSUB TSUL ^[cond^]) mask @$ replacement @$ Other situations: SSUL,WSUL(Writeout)
        Let optional sideCONDition inspect indices by:
        (ORDEROK i j)   May put on ORDERASK, ORDEROKASK for interaction.
        (GETINDEXTYPE k)  Gives name
(PRSUB TSUL)            PRint SUBstitutions of that kind.

Wildcards: ?ANY ?END ?DIFFOPERATOR ?T   -Introduce new ones by:
(WILDCARD symb pred)    PREDicate should reference TIX eg = (GUU A B) 



3.1  ^<<OVERVIEW AND EXAMPLE^>>

Functions that set substitutions are SETSUB, TRMAT, TRTEN and SETSUMS.

(SETSUB xSUL)mask@$ substitute@$

     -is a function in ordinary SHEEP which sets one of three kinds of
     substitutions depending on whether the argument is ESUL, MSUL or PSUL.
     Here the function has been changed to allow as arguments also:  TSUL (most
     common), SUMSUBS or WSUL.  These arguments are effective to specify the
     stage/situation in which the substitution is to be tried.  NOTE:For each
     of the arguments there is a corresponding controlling switch, which must
     be turned on for the substitution to take place!

     SETSUB arg:  Switch ^[Deflt^] Situation:     Conserned functions:
     TSUL         TSUBS ^[T^]      PRIOR simp   WEDEF,EDEF,WSDEF,SDEF
     SSUL         SSUBS ^[NIL^]    AFTER Simp   Same (for Sumsubstitution).
     WSUL         WSUBS ^[T^]      W-riteout    WEDEF,     WSDEF,WDEF

(PRSUB xSUL) Print substitutions of type xSUL that are set hitherto.

SUBSTITUTIONS                                                   Page 3-2



EXAMPLE:                        To get more minuses to keep track on,
*(ANTICOMMUTE A B)              -let us also declare A and B anticommuting.

*(SETSUB TSUL)                  SETSUB asks what structure to be replaced:
Replace structure=<A K L I><B L>@$       (the mask), -and with what:
with=7K <C I K> @$               (the substitute). The user types in the answers
                                in the same formate as to PDEF and SETDIFF.

*(DECLT (A 2))                  Tells that the 2:nd index of A is to be
                                written upstairs (here just aesthetical)


*(PRSUB)                          PRints the SUBstitution
                                     An indicial mask will match for any
          l                       indices (of course, in this case the
1  FOR  A   B   SUBSTITUTE  7kC   contraction is required, but also dummy
         k i l                 ik name is arbitrary).
                                  Moreover (anti-)symmetrization notation
                                  (arbitrarily nested) is allowed:

*(WDEF EX)                      Write an example (which has been inserted as
            j                   <B ^[K> <A L J ^[J> )  with  anti-sym.   ^[kj^].
EX   = B  A                     Of  the two terms (+ and -) inherent in this
  kl    ^[k l j^]                 notation, the  contraction  that  should  be
                                substituted   only  occurs  in  the  second
                                (minus) term.

*(WEDEF EX)                     EDEF (first fails to eval. A and B and then)
           j                    -discovers  the  substitution although
EX   =  -A   B  +7kC            indices are different and the tensors occur
  kl      l j k     kl          in  reversed  order BA (note, another minus,
                                makes + 7kC).  So ^[^]-notation is expanded.
(EX)                            Finally, at simplification the remaining BA
                                product is reversed.



The next two functions TRMAT and TRTEN give fast substitutions, but these won@'t
work with (anti-)symm.  notation:

(TRMAT mat scl) -TRace of MATrix.  Causes <mat J J> to be replaced with scl =
     any scalar expression in internal SHEEP formate.

(TRTEN tsr n1 n2 tr scl) -Cause TRace of "tsr" between indices number N1 and N2
     to be replaced with TR times SCL, i.e.
     <tsr..  J..J.> replaced by <tr ..  ..  .> scl The remaining indices in tsr
     will remain in the same order in tr.  Scl is optional.

LASUB   Last SETSUB argument, initial value TSUL.  Symbol indicating for TRTEN
     etc the type of substitution they should set.  Change symbol-value with
     SETSUB or directly.

SUBSTITUTIONS                                                   Page 3-3


(FAMILY tsr1 tsr2..) -Up/down variants.  If TSUBSG (switch ^[on^]), and the main
     switch TSUBS are on, then contractions between GUU or GDD with one family
     member is replaced with another family member.  Upindices must first be
     correctly declared, eg with DECLT.

(SETSUMS tsr) -SET SUM Substitution, tsr-DEF to 0.  The sum should have been
     inserted with "(PDEF TSR).." and canonicalized "(SDEF TSR)".  If SUMSUBS
     is on, the sum will then be replaced with zero.
     If ALLASK is off, missing weights are chosen so replacement is done when
     more than half of the terms in the def of tsr are found.
     With ALLASK on, SETSUMS will ask for "missing weights" for the terms.  An
     occurrence of the sum will then be replaced with zero even if some of the
     terms are missing, as long as the sum of their missing weights are less
     than 100.
     So, a substitution A + B --> C is done as A + B - C --> 0 with missing
     weights e.g.  "100 100 n" with 0<n<100.  (Much more written later.  See
     also TRIG)



3.2  ^<<MATCHING OF INDICES^>>

-are in STENSOR by default of type "for all", ie in templates indices (or
symbolic functional arguments) will match anything.  Restrictions on this
matching you achieve with side conditions.  To demand LITERAL match, precede
symbol everywhere in the template with atsign:@@.

That makes the index-symbol a global in the template (not free or dummy), and
for globals exact matching is demanded, as for digits of course.  Thus, by
shielding an index with @@ everywhere, all but two, and all but one, you get:
Exact:          <T @@A>..<R @@A>  @@-Shielded makes A only represent itself
Contraction:    <T  A>..<R A>   Any contraction index matches
Arbitrary:      <T @@A>..<R A> or <T A>..<R @@A>  -Any free index matches.
Note that also a free ix may be arbitrarily repeated, as long as UNshielded
exactly ONCE.  For elaborate examples and tests of this, see file TESUBS.DEF.



3.3  ^<<MATCHING OF TENSOR NAMES^>>

For tensor (function) names in the template, exact matching is default.  To
achieve "for all" matching of these, WILDCARDS are used.  These are specific
symbols, that already carry "for all"-declarations in various senses.  To set
up many substitutions, thereby becomes more simple and compact, since what
corresponds to:  "for all X that <condition>", is required at most once (when
the user introduces a wildcard not built in).



3.4  ^<<WILDCARDS IN SUBSTITUTIONS^>>

A symbol that can match without being literally the same as what it is
matching, is called a wildcard.  Cfr the monitor command "DIRECT FI*.S?S" that

SUBSTITUTIONS                                                   Page 3-4


will direct all files with name starting with FI and extension SAS,SBS..

(WILDCARD symb pred) -cause "symb" match any object fulfilling "pred".  The
    predicate should investigate the variable TIX, bound to the candidate, eg
    (GUU A B).
        Built in wildcards (The conventional "?" is at input typed "!?"):
    Wildcard:     Matches any tensor that:        For examples, see:
    ?ANY          -Any, no restriction
    ?T            -prints as "T", as Gammas 	FIERTZ.SBS, for Gamma matrices.
    ?END          end of a term         	TRACE.DEF (trace of ")
    ?DIFFOPERATOR -declared DIFFOPERATOR or xBIDIFFOPERATOR      SIGMA.DEF

    Helproutines when defining wildcards (no arguments, they self refer to TIX):
    (ISNEVERCOMMUTING), (ISALWAYSCOMMUTING), (GETRANK), (ISPAREN)
    Eg:  (WILDCARD ?const (ISALWAYSCOMMUTING))  -then <?const> match nonops etc
         (WILDCARD ?rnk2  (EQ 2 (GETRANK)))             -then <?rnk2> match matrixes

Replacement:  In the replacement, the tensors matched in the mask can be
    refered back to by using the same wildcard.  For a multiply used and
    matched card, indicate order of occurence with a number:  <!?T 1>, <!?T 2>,
    <!?T 3>,..  For the first occurence one may omit the 1:  <!?T >.
        Example:
    To swap the two tensors following OPR, if they border a gamma, do:
    (SETSUB)
    <OPR><!?ANY>  <!?T><!?ANY> @$     This matches: TensorA,Gamma,TensorB
    <OPR><!?ANY 2><!?T><!?ANY 1> @$   The replacement refers to the arbitrary
                         objects A and B in opposite order creating "OprBTA".

RESTRICTION:  The first factor in a mask may NOT be a wildcard!
    That is because a substitution is carried out by the first factor in the
    mask, and the program can not place that task on the anonymious,
    unprecisized tensor that the wildcard represents.
    If your substitution must have a wildcard start, multiply your expression
    (and your mask and replacement) from the left with some tensor DUMMY, so
    that tensor becomes the substitution carrier instead of the wildcard.
    Since every term starts with DUMMY, you will have the substitution tried on
    every term, and in effect "starting" with a wildcard.  Give the DUMMY a
    space as display-name (nam) by:    (DECLT (DUMMY !  )) -where "!  "
    represents <space>, see "funny characters".

    A wildcard may occur in formulas as any other tensor, so you may *build* up
    a complicated substitute.  Eg.   (PDEF INTO) ...<?ANY> ..<S2>...  and (PDEF
    S2)...  and then (EDEF INTO) to get the expanded formula, which is given to
    SETSUB as:   (SETSUB) mask @$ <:INTO> @$ -where ":" causes evaluation of INTO
    into its computed DEFinition.

WILDCARD MAY EXTEND RANK
    In a replacement you may hang on extra indices on the wildcard, eg:
    (SETSUB) <OP><!?T> @$     <!?T 1 J K L><AFF J K L> @$ (If you append indices,
    the id-number, "1" here, must be included.) If the mask matched eg
    <OP><THH A B>  , then the J,K,L will add one D each to the matched name,
    THH here, *CREATING A NEW OBJECT* <THHDDD A B I J K> (which inherits
    printout properties from THH if it had none before).  Added indices

SUBSTITUTIONS                                                   Page 3-5


    inserted will be of *SAME INDEXTYPE* as the I,J,K used, but names might
    differ to avoid collision.



3.5  ^<<SUBSTITUTION WITH SIDECONDITION^>>

(SETSUB xSUL condition)..Extra "condition" for replacement to be done.
An extra argument to SETSUB is taken as prerequirement for the substitution to
take place.  The requirement should be an unquoted lisp-expression, with
balancing parenthesis, plus the final parentheses to match the one before
SETSUB.
Normally such requirements are not needed; a mask like eg <A K L< <B K M< @$
will automatically request a contraction between the 1:st ix of A and B.
However, in some cases we might want this to be done only if L and M come in
the wrong order, ie M and L in the correct order.

A lisp-function to check order is ORDEROK.  Thus we can write eg:
        (SETSUB TSUL (ORDEROK M L))
        <A K L<<B K M< @$
        <AB M L< @$
This mask will first be tested for as usual.  Only if the match is successful,
will the extra requirement be tested - of course with the proper indices
replacing M and L here.  And only if all the requirements are non-false, will
finally the replacement with the substitute take place.



3.6  ^<<ORDEROK FOR CONDITIONAL SUBSTITUTION^>>

(ORDEROK ix1 ix2) Order predicate.    Function of two arguments which tells if
    the arguments are in canonical order.  Mostly used in conditional
    substitutions to decide on order between indices.  Normally identical to
    ORDERP, but can be overruled if put in interactive mode by turning on
    either of two switches:

ORDERASK switch ^[off^]   which if on causes the function ORDEROK to:

    1.  Nicely print the term that the substitution currently is tried in.

    2.  Print the number for that term in the sum - according to their order in
        the expression as stored; if WSUBS is on, the written out expression
        has metric contractions substituted away and terms reordered
        (simplified) before printing, so the terms may come in completely
        different order when written.  This reshuffling may decrease the more
        to the right (high ordernumber) you order the metric, but don@'t
        disappear until (OFF WSUBS).

    3.  Print the two indices being compared.

    4.  Ask if the order is OK (then answer Y) or not (answer anything else).


SUBSTITUTIONS                                                   Page 3-6


ORDEROKASK Switch ^[off^]   which works as orderask but is more discriminating,
    in that asking is done only if the order passed the test of ORDERP saying
    it was OK.  Thus you have last say and can accept or overrule a
    substitution, but are not bothered by all non-OK cases.

    Strategy:  For a long expression keep the switches off and see if some
    compression occurs.  Then e/S-DEF with ORDEROKASK on, and finally for the
    reasonable size expression turn off ORDEROKASK and instead on ORDERASK to
    manually cause remaining cancellations, but not until the previous steps
    have taken care of what could automatically be cancelled.

    If you order the objects with the ORDER-tested indices rightmost, then
    other objects (to the left) will decide the dummy-names, so the standard
    comparison with ORDERP that compares names will also correctly discriminate
    between the different kinds of terms, so the switches can both be turned
    off and the substitution will successfully be performed entirely
    automatically.



3.7  ^<<SETSUB MAY PDEF AND SDEF^>>

SETSUBDEF switch ^[on^] -cause: (SETSUB) formula@$ tsr@$  -define tsr -ie when the
    replacement is a lone tensor without contractions, eg:  "<tsr A B>"  -then
    besides setting the "forward" substitution, the "tsr" is as a "backwards"
    side effect also given the formula as DEF if it had none before (careful
    with EEDEF).

Evaluation-prefix ":" in eg <:tsr A B> evals tsr in formula input.  Used in the
    context:    (SETSUB) formula@$ <:tsr A B>@$   -then (if tsr is undefined) the
    SETSUBDEF mechanism first defines tsr as "formula", and then the evaluation
    prefix cause tsr be replaced with that "formula", *whereafter result is
    simplified*.  The substitution thus becomes:
    (SETSUB) formula@$ simped-formula@$.    The simplification should after
    nontrivial computation give a so compact result, as to be worth saving as a
    separate substitution to be directly used instead of recomputing it each
    time the pattern "formula" is found.  (This was used in the GAMMA library,
    where the simplification was elaborate, involving alternate use of several
    substitution lists through the "action" parameter described there.)
    If tsr happened to have a (previously computed or reloaded) definition,
    then that formula is simply taken for the substitution without further
    actions.  Thus the identical SETSUB-library can still be loaded (as in
    GAMMA).

SETSUBPERM switch ^[on^] -cause SETSUB call DOPERM on mask/replacement.



3.8  ^<<SETSUB PROBLEM WITH @@-CHARACTER^>>

The @@-character in PDEF can cause problems for substitutions:  Suppose we have
set <A i<<B i< to AB.  With @@-usage, eg <A i<<B k<<C @@k<, then by quite natural
and legal contraction setting free indices i and k equal, one can get the nasty

SUBSTITUTIONS                                                   Page 3-7


expression:
                               <A i<<B i<<C i<.
The AB-subst will match this!  However, that is a mistake, since the <C i<
constitutes a differing weight on each of the <A i<<B i< -terms!
        Two solutions are recommended:
First substitute <A i<<B i<<C i< to some object ABC (as side effect defines
ABC), then do the <A i<<B i<< substitution to AB.  You can always EDEF back ABC
to its original value afterwards if needed.
Alternatively use different types of indices (se INDEXTYPE), and check them as
a sidecondition.



3.9  ^<<SPECIAL TENSORS^>>

There are several objects that are important due to their special properties,
namely DEL, GDD, GUU, GDEL2, GDEL3,..,
They are listed here, together with their properties, that are:

DECLT-properties are those simpler kinds, that are given with a DECLT command.
    See DEL below.

TSUL - the main kind of tensor substitution property, which is applied as the
    first step in the simplification procedure, unless deactivated by (OFF
    TSUBS).

WSUL - substitution only affecting writeout, not the stored expression.
    Deactivated by (OFF WSUBS).
The objects are permanently present in STENSOR unless otherwise stated.  They
do not comply (except GDD/GUU) to short-name standards.  Thus at input always
end them with > (never <), eg <DEL A B>.

DEL Kronecker delta.  Has ordinary properties as from command
    (DECLT (DEL d 2 S12)), ie printoutname d, index 2 up, symmetric in indices
    1 and 2 (though normally indices of different types should not be
    exchangeable).  The DECLT-commands are from now on given uncommented.

                                  
    TSUL    Replace structure:  d`a''b` ?ANY`b'    with:    ?ANY`a'

             Dito if the COvariant index is dummy.
                                    
            Replace structure:     d`a''a`        with:  (value of) CODIM
                                    
            (Value is taken from elsewhere if the index (a) has been
             included in an INDEXTYPE statement: see that word)

        CODIM Symbol^[4^] Result of <DEL A A>. Set by (DIM n).    Initially (DIM
            4) is done.  CODIM set by DIM is independent of the SHEEP-object
            DEFAULTDIMENSION!* set by DIMENSION, and may in contrast to that
            have a symbolic value:  Do eg  (DIM N)  -if you want a dimension
            independent result containing N (or any symbol of your choice).
            This contraction result of DEL is the only place where the

SUBSTITUTIONS                                                   Page 3-8


            dimension comes in at purely indicial computations.

GDD Covariant metric tensor. (DECLT (GDD g S12)) SULs as GUU.

GUU Contravariant metric tensor. (DECLT (GUU g S12 1 2))

    TSUL     Replace structure:  g'ab`g`bc'      with:   d`c''a

    WSUL     Replace structure:  g'ab` ?ANY`b'     with:   ?ANY'a`

    The WSUL causes GUU (and similarly GDD) disappear at write out if
    contracted, causing the other dummy occurence be displayed up (or down for
    GDD).  Done by a less sophisticated method than if set by SETSUB, and does
    not check if commutativity really allows GDD/GUU to move up to the other
    object.  Thus if you have DIFFOPERATORs or other NEVERCOMMUTEing objects,
    the display might become misleading (though the stored expression is OK)
    and you might turn off the following switch:

WSUBSG Switch ^[on^] which if off deactivates the above W-substitution on
    GDD/GUU.  Sub to main switch WSUBS which turns off ALL WSUL-substitutions.



3.10  ^<<GENERALIZED KRONECKER DELTAS^>>

These are not permanent, but defined in file GDELTA.DEF, so you must first do:
(LOAD "GDELTA.DEF").

GDEL2 Generalized Kronecker delta rank 4:(DECLT (GDEL2 d A12A34 3 4))
    The file GDELTA.DEF defines GDEL2 in terms of DEL, by:
    (PDEF GDEL2)   <DEL A ^[P><DEL B ^[Q> @$
    -where the permutation ^[ is then performed by (DOPERM GDEL2).  Command
    (W)EDEF can then replace occurences of GDEL2 with the two-term expression
    in DEL.  Note that GDEL2 in itself has no substitution properties; it has
    to be EVALUATED into DELs, which finally does substitutions.

GDEL3 Generalized Kronecker of rank 6:  (DECLT (GDEL3 d (A 1 TO 3) (A 4 TO 6) 4
    5 6))
    Defined as:
    (PDEF GDEL3)   <DEL A (P> <GDEL2 B C (Q (R> @$
    -which by DOPERM immediately is turned into a 3-term definition,
    corresponding to expansion of the 3x3-determinant along the 1:st line.
    When plugged in, this 3-term definition gives DELs that can do their
    substitution work, and GDEL2s that due to its symmetries might cause terms
    to combine.  Then in the NEXT evaluation the remaining GDEL2:s are replaced
    by DELs, so no dummy will remain.

GDEL4 Generalized Kronecker rank 8.  Defined similarly through GDEL3:
    (PDEF GDEL4)   <DEL A ^[P> <GDEL3 B C D ^[Q ^[R ^[S> @$
    This shows the power of (cyclic) permutation notation.

SUBSTITUTIONS                                                   Page 3-9


Similarly GDELn+1 can be defined in terms of GDELn up to any n required.  When
    used, it is essential that n is decreased with only 1 for each EDEF, to
    allow intermediate simplification compress an expression as much as
    possible.  Entirely expanding a GDELn determinant directly into all DELs,
    would create n!  terms, which easily could overflow the memory.



3.11  ^<<PFAFFIAN TENSORS^>>

-Are NOT as yet defined, but could very easily be, by copying the file
GDELTA.DEF, and then:
1) Rename all GDELn to for instance PFAn (however keep DEL itself).
2) Change all ^[ into ( which turns all minuses into pluses.
3) Remove all ANTI-symmetric-declarations of PFAs, (or turn to symmetries,
using S12 S34 and (S 1 TO 3) (S 4 TO 6).



3.12  ^<<LEVI-CIVITA SYMBOLS EPS3-9^>>

These are inserted as eg <EPS3 A B C> and <EPS4 A B C D>.  They are only
declared totally antisymmetric, and given printout names "e".
The file EPSEPS.DEF -sets substitutions for epsilon-epsilon products, without
any contractions.  That kind is the most fundamental, since if the product has
contractions, the long replacement will collapse accordingly.  For large
computations however, it is probably more efficient to first set substitutions
for contracted cases, to have them caught and turned into a smaller
DEL-determinant directly.  If needed, it MUST be set BEFORE the general, ie:
(SETSUB TSUL) <EPS3 A B I> <EPS3 D E I> @$ ......  @$
(SETSUB) <EPS3 A B C> <EPS3 D E F> @$ ......  @$
If set in reverse order, the A B C-substitution would catch also the A B
I-cases, so they would never be used!



3.13  ^<<DEL IS DECLARED BOTH SYMMETRIC AND MIXED^>>

This is a compromize between needs in relativistic and euclidean computations:

a) Relativistic computations:  keep S12 against user-input errors:
Here DEL should have mixed indices, eg second index being the contravariant
one.  Normally this would also mean nonsymmetric indices, so a properly
inserted up index is kept up by SDEF.  The user might however easily by mistake
give some input with indices in reverse order (that presupposes first DEL-ix
up).  When this is mixed with other DEL-input, or system created DELs (through
<GDD A J> meeting <GUU J B>), that might create term pairs that differ only by
one factor being <DEL B A> and <DEL A B> respectively.  Then if DEL had not
been sym-declared, these terms would not combine (if A and B were free
indices).  With perfect input however, I presently can not think of any advert
side-effects of doing (REMSYM DEL).  On the other hand however, its presence is
a guarantee for simplification and has only an esthetic drawback.

SUBSTITUTIONS                                                  Page 3-10


b) Euclidean computations:
When there is no difference between co- and contravariant components, delta (as
everything) is 1:  commonly written with both (all) indices DOWN, and 2:
symmetry is presupposed.  The built in DEL then satisfies the 2:nd need.  It
fails the 1:st, but since that is only esthetical, the fix (REMPROP @'DEL
@'UPINDX) or (DECLT (DEL 0)) (put up the harmless (0) as list of up-positions)
-is left to the user to do if he wants perfect output.

Thus the command (DECLT (DEL 2 S12)) is a compromize:  "2" is for relativity,
"S12" for euclidean computations.  One might ask why not introduce TWO
kronecker deltas, one for each purpose:  The big problem is then canonicity;
The user might by mistake introduce both delta symbols in the same expression,
and be stunned that ...<DEL..> + <EDEL..> are not combined (if he ever notices
- these terms might be far separated in a long expression).  Cfr "UPINDEX".

If the user is not satisfied with this compromize,he can always inhibit it by:
(REMSYM DEL)                    -for relativity (supposing perfect input!), and
(REMPROP @'DEL @'UPINDX)  -for euclidean computations.



3.14  ^<<SUPER SUBSTITUTION LIST^>>

-Or "SUP" for short, is a list of symbols, each being an ordinary substitution
list, "SUL".  Thus a "SUP" is a list of "SUL"s.  Initially there are three
SUPs, one for each situation, namely TSUP, SSUP and WSUP.  These have initially
values (TSUL), (SSUL) and (WSUL), but they may be extended to contain any
number of ordinary substitution lists.  Then for that situation, all the
enlisted substitution lists would be checked for, in that particular order.

(SETSUP sup sul1 sul2..) Set SUPer substitution list sup to consist of the
    individual substitution lists sul1 sul2...

    Example:  After (NEWISUL SUL1)...  and ..SUL2 to introduce two new Indicial
    substitution lists, then:
                         (SETSUP TSUP TSUL SUL1 SUL2 TSUL)
    -causes SUPerlist TSUP to be (TSUL SUL1 SUL2 TSUL), which means that normal
    TSULs are first searched for, then SUL1 and 2, and finally TSUL again
    (which might now succeed).  Thus the SUPerlists are means for easifying the
    administration of large amounts of substitutions; You organize the
    substitutions in groups, in their individual SULs, and can then easily
    activate/deactivate them, and put them in desired order, with SETSUP.













                                   CHAPTER 4

                         OPERATOR ALGEBRA AND ORDERING



STENSOR provides versatile controls to specify various degrees of
noncommutativity, through NONCOMMUTE, NEVERCOMMUTE and NEVERCOMMUTEBUT.  ORDER
and ANTICOMMUTE affects in what way objects commute, and various operators can
be declared.
Commutator information is inserted as eg (SETSUB) <OP2><OP1> @$ <OP1><OP2>+...@$
The substitutions take account of the commutativity properties with the objects
that might occur in between the OPi factors (nontrivial).

In summary:
(NEVERCOMMUTE op1 op2 ...)       These won@'t commute with anything.
(NEVERCOMMUTEBUT (op1 op2..) k1 k2..)   Same, but with exceptions.
(COMMUTEWITH (o1 o2..) k1 k2 k3..)      Additional exceptions.
(ALWAYSCOMMUTE k1 k2 k3...)      k1 k2...  commutes with everything else.
(NONCOMMUTE ^[n^] o1 o2..)         Members of same family won@'t commute.
(ORDER  t1 t2 ...)               Set preferred relative order.
(ANTICOMMUTE t1 t2 ...)          These anticommute.  Also see ANTICOMMUTEODD.
(DIFFOPERATOR op1 op2 ...)       OPn spreads over factors to the right.
(ABIDIFFOPERATOR op1 op2 ^[op3^])  The 2 (or 3) objects delimit two slots, each
                              being differentiated.  Slots are Anti-symmetric.
(SBIDIFFOPERATOR ....)           Same, but slots are Symmetric.



4.1  ^<<NON/ANTI-COMMUTATIVITY^>>

(NEVERCOMMUTE OP1 OP2...) Declares each of the arguments to NEVER commute, ie
    not with ANYTHING else.

AUTONEVERCOMMUTE Switch ^[off^] which if on causes each tensor inserted in a
    formula from now on to automatically be declared NEVERCOMMUTE.

(NEVERCOMMUTEBUT OPL KONST1 KONST2 ..) Declares OPL to NEVER COMMUTE, BUT with
    objects KONST1, KONST2...  Ie what you tell here is what OP commutes with,
    all else noncommutes.  NONCOMMUTE does the reverse:  you specify what
    noncommutes, all else commutes.
    OPL may be a symbol, or a list of symbols, each one to be similarly
    declared.

OPERATOR ALGEBRA AND ORDERING                                   Page 4-2


(COMMUTEWITH (O1 O2..) K1 K2 K3...)   Declares additional "Constants" under Oi.

(ALWAYSCOMMUTE t1 t2 t3...) causes t1..  to commute with everything else.  Use
    it for such special objects as DEL and EPS that you know should commute.
    Returns the accumulated list ALWAYSCOMMUTEL:

ALWAYSCOMMUTEL is the accumulated list of ALWAYSCOMMUTE-declared objects so
    far.  Beware of tampering with this list.  Every NEVERCOMMUTE or
    NEVERCOMMUTEBUT -command sets up a reference to this very list as common,
    extra NEVERCOMMUTEBUT-exceptions.  Since the reference is to this very
    list, and ALWAYSCOMMUTE extends the list kirurgically, so that every
    previous NEVERCOMMUTE(BUT) -command will be updated with any later
    ALWAYSCOMMUTE-exceptions given.
    But if you (SETQ ALWAYSCOMMUTEL ...) these previous NEVERCOMMUTE(BUT) will
    cease to be affected.

(NONCOMMUTE ^[n^] O1 O2..) Declares objects (tensors) O1 O2 ...  to be a
    noncommuting family.  With that, we mean that they don@'t commute with each
    other but do commute with all other objects (except such said to
    NEVERCOMMUTE).

        You may declare any number of noncommuting families.  If you now
    declare another noncommuting family:  (NONCOMMUTE P1 P2 P3) a mixed product
    P3 O1 P2 O3 P1 O2 will be simplified into O1 O3 O2 P3 P2 P1 ie different
    families:

    1.  won@'t have its members reshuffled, but

    2.  will penetrate through other families, and

    3.  a family will be ordered relative other families or objects according
        to the optional numerical first argument.


(ORDER ^[n^] A ^[m^] B C..) Declares A B..  to have that canonical order in
    products, sums etc, which SDEF/EDEF hereon simplifies.  It should be used
    on symbols, such as tensornames (internal), or indices.
    Works by giving a priority number to the symbols A, B...  These are then
    ordered according to growing order-priority, highest priority rightmost.
    As priority number, the current value of ORDERNUM will be assigned.  For
    each argument, ORDERNUM (initially 500) is incremented by ORDERINC(=10) so
    each argument gets a different priority, larger than the leftmost args, and
    also than args at previous calls, since ORDERNUM is saved between calls.

        You may change the value of ORDERNUM by interposing numerical arguments
    to ORDER:

        (ORDER -100 LFT 100 RGHT MOST) All UN-declared symbols are compared (to
    a declared) as if having priority ZERO.  Thus you may both dictate some
    right, and some LEFT (neg nbr) of all undeclared objects.
    Thus the above command causes products to canonicalize to:
    LFT X1 X2...  RGHT MOST     -where X1..  are undeclared factors.
    And (ORDER A B 100 C D -100 E) causes the ordering:  E X C D A B, and

OPERATOR ALGEBRA AND ORDERING                                   Page 4-3


    causes ORDERNUM to afterwards be -90 (if ..INC=10)
    ORDER returns the numbers that it has assigned, as a list.
    ***(ORDER) -with no args, turns off ORDERCHECK*** which makes all
    commutation-restricting commands hitherto given ignored, until a new such
    command is issued again (that turns on ORDERCHECK).
    NONCOMMUTE works by assigning the same ORDERNUM to ALL its arguments, and
    the ordering won@'t swap factors with identical order-priority.
    Warning:  If you with (ORDER OP1) give another ORDER-priority, you cause
    OP1 to commute with the other family members.

(WORDER t1 t2..) -Write order (nbr/commutativity) of tensors/objects.  This
    function displays for each object both its ordering-number (set by ORDER),
    and its commutativity-properties if any.  Handy form:  (WORDER ALL) etc.
    Sample output:  (...  (t1 510) (t2 (520 NEVERCOMMUTEBUT tsra tsrb)) ...)
    -means that (ORDER 500 t1 t2) and (NEVERCOMMUTEBUT (t2) tsra tsrb) have
    been done.  Change by reissueing these, or inhibit them altogether by means
    of two functions:

(REMORDER t1 t2..) Remove ordernumbers of t1,t2,..  Then t1,..  will
    subsequently regain its internal ordering as of before the ORDER-command.
    Note 1:  As side effect, this inhibits any previous NONCOMMUTE in that it
             excludes t1..  from a NONCOMMUTE family of identical ordernumbers.
    Note 2:  Avoid this on diff-operators, or commuting objects with higher
             order may confusingly (though correct) occur on its RIGHT side.

(COMMUTE t1 t2..) Let commute -ie remove any NEVERCOMMUTE-declarations of
    t1,t2..  ie inhibit any NEVERCOMMUTE-command previously done on t1,..
    If no such had been done, then COMMUTE has no effect.
       Declarations of other objects are not inhibited, eg if:
    (NEVERCOMMUTE tsra tsrb..) -was previously done (or -BUT or DIFFOPERATOR),
    then t1 etc will after:  (COMMUTE t1..) still of course NOT commute with
    these special objects tsra...  (due to *THEIR* NEVERCOMMUTE-ativity).  To
    force such commutation, do also:  (COMMUTEWITH (tsra...) t1 t2..), or use:
    (ALWAYSCOMMUTE t1 t2..).

(ANTICOMMUTE T1 T2...)  Puts a flag on T1 T2...  telling that they mutually
    anticommute.  Later commands puts this identical flag on additional
    tensors.  The simplifier later changes sign at swapping two objects only if
    BOTH have this flag.  The flag is independent of the other commands.  Thus
    e.g.  the NONCOMMUTE-declaration of two families O1 O2..  and P1 P2...
    above, can be complemented with ANTICOMMUTE on them all, which will then
    cause signchanges when an O and P is swapped, while as before no swap is
    done whatsoever of two objects in the same family.

ANTICOMMUTEODD switch ^[off^]   While on, causes all odd-rank objects typed in
    the input to PDEF to be declared ANTICOMMUTING.  A convenient way to make
    sure that all Majorana spinors you introduce are declared properly.



4.2  ^<<DIFFERENTIAL OPERATORS^>>

For the commands below to take effect, the switch TSUBS must be on, using TSUL!

OPERATOR ALGEBRA AND ORDERING                                   Page 4-4


All non-commuting or differentiating objects may have indices, with symmetries
and index-prefixes as any ordinary tensor, though suppressed in the examples.

(DIFFOPERATOR OP1 OP2 ...)     Declares each of the tensors OP1, OP2 ...  to
    behave as multiplicative differential operators.  They are inserted in
    formulas as ordinary tensors, but will operate on all factors standing to
    the right in the same term.

        The operation itself means:

    A product will be spread over, as differentiation of a product.  Eg
    <OP><F1><F2> becomes:  <F1><OP><F2> + <F2><OP><F1>

    If there is only one factor to the right, nothing happens - unless you have
    specified differentiation results for individual factors using SETSUB.  Eg
    (SETSUB TSUL) <OP > <FCTR > @$ result @$

    Independence, ie zero differentiation-results under OP, are easier
    specified en masse with:  (NEVERCOMMUTEBUT OP F1 F2 ...); since then F1,
    F2,...  will commute through.  If no factors remains right of OP, zero
    results.
    Note 1:  Specifications made with SETDIFF are ignored here, since those are
    for ordinary differentiations requested with "," which is a totally
    separate method.
    Note 2:  The more convenient ","-method won@'t work correctly for
    differentiation of non- or anti-commuting objects; there use DIFFOPERATOR
    to declare a multiplicative operator instead.  In addition, you may declare
    any number of other (eg various covariant) differentiations.
    An implicit NEVERCOMMUTE is done on OP1 OP2..., so if the operands have
    definitions that are evaluated, the operators will be properly spread over
    the terms with preserved order (as for any object declared to have
    restricted commutativity).



4.3  ^<<POISSON BRACKETS^>>

(ABIDIFFOPERATOR POI SON ^[ENDPOI^]) -Declares it@'s two arguments to together
    constitute an Anti-symmetric BI-DIFFerential operator, ie an operator with
    two operands/slots, in which it is anti-symmetric.  Example:  The
    Poisson-bracket.
    A PAIR of object-names is required, since TWO slots should be delimited.
    Input is in the form <POI>...  <SON>...
    Example:  A poisson bracket like @{f1*f2*f3,g1*g2*g3@} is then inserted as:
    <POI> <F1><F2><F3> <SON> <G1><G2><G3> ie what is between POI and SON
    constitutes one slot, what@'s to the right of SON constitutes the other.
    Example 2:
    (PDEF TE)  <POI>   <F1> <F2>   <SON>     <G>     @$
    Meaning:      @{      slot 1        ,      slot2  @}  
    (EDEF TE) now spreads (here only slot 1 require it, giving):
        <F1>    <POI>  <F2>  <SON>  <G>
    +   <F2>    <POI>  <F1>  <SON>  <G>
    -ie with only one object in each slot.  If Slotobjects are defined, their

OPERATOR ALGEBRA AND ORDERING                                   Page 4-5


    defs are put in, and spreading will be done.

    If you then know the results when slots contain single-objects, set up
    substitutions into those results!

    Example:    (SETSUB TSUL)  <POI> <F1> <SON> <G>@$    result @$

^[ENDPOI^] -You may give a third, optional argument (ABIDIFFOPERATOR POI SON
    ENDPOI)      -to specify an explicit end-indicator of slot two.  Then all
    input must also use that delimiter, ie be of form:
    <POI>...<SON>...<ENDPOI>

(SBIDIFFOPERATOR op1 op2 ^[endo^]) -As ABIDIFFOPERATOR, but symmetric in the two
    slots, not antisymmetric.  Exchange of slot-contents will always be done as
    part of the canonization.



4.4  ^<<LEFT/RIGHT-PARENTHESIS OBJECTS^>>

LPAREN and RPAREN are 0-rank, NEVERCOMMUTE-declared objects, that write as (
and ) and act as delimiters for the action range of differential operators.
You may insert them as <LPAREN> ....  <RPAREN>.
Suppose D,B..  are diffoperators, and a,b..  are not.  Then () are inserted at
spreading:    D a b c is turned into (D a) b c ~- a D b c, where the RPAREN in
(D a) shields b c from being hit by D.  If "a" has a DEF, and EDEF plugs it in
giving eg (D a1 a2..) then the D will spread up to ")" as expected.

The LPAREN special object has TSUL-substitutions that:
        1) Turns (a D...) into: a (D...)
        2) Turns () into: 1
        3) Turns ((...) ....) into: (...) (....)

Substitution programs (SPs) are searched for from left to right, so after "("
the SPs of the D-objects will be activated, which does spreading (and moves
through objects it commutes with, turns (D) to 0, and tries user-set SPs), so
when reaching the ")" no (D a b) will remain, only one-operand objects like
(D a) or (D B a) etc.

The RPAREN special object has TSUL-substitutions that:
1) Turns (D..a) b into:  - b (D..a)   if a and b commutes.  If b has the
anticommute flag, then minus results if also "(D..a)" is anticommuting, ie
there are an odd number of objects in (D..a) that has the anticommute flag.

2) May swap (D a) (D@' b)  into:  - (D@' b) (D a) if this gains canonicity and a
and b (anti)commutes.  Minus if both paren-pairs anticommute as above.

NOTE:    if your algebra is so weird that the assertion:  a (anti)commutes with
b, does NOT imply that (D ..B a) commutes with b, then you must do:
                            (REMPROP @'RPAREN @'TSUL)

The properties of L/RPAREN are declared when DIFFOPERATOR et al are first used.

OPERATOR ALGEBRA AND ORDERING                                   Page 4-6


COMMUTAND global ^[nil^] which if T activates a faster spread algorithm which
    presumes a differential operator and its operand (D a) to commute (with no
    sighchange) with the other factors when spreading over a product, eg:
    D a b c    is turned into   a D b c + b c D a   where the 2:nd term already
    is in final form, compared to the normal - a D b c + (D a) b c.  Wrong eg
    if you have more than one D factor in any term.  Thus don@'t set COMMUTAND
    unless you know what you are doing.

NODIFFOPERATION switch ^[off^] -inhibit normal diffop-action that objects have
    after being declared by DIFFOPERATOR or A/SBIDIFFOPERATOR.

DIFFRPT symbol ^[1^] -govern repeated rerun of diffoperators.  Technical.
    Spreading over a product is done in elementary steps, after each of which
    DIFFRPT tells what factor is searched for a substitution program next:
    1 (default) restart from 1:st factor.  Thus other substitutions found.
    NIL  next factor.  Might give unsimplified result.  Others:See SDEF.STS



4.5  ^<<TECHNICAL REMARK^>>

STENSOR substitutions are carried out by individual PROGRAMS, so called SP:s.
(substitution programs).  Such a SP is generated, or "compiled", from each
individual template-replacement pair.  (A substitutor based on that
construction principle, is therefore called a "compiling" substitutor, as
opposed to one driven by data also at execution.  Code generation is an
important, intriguing, but demanding possibility in LISP which STENSOR exploits
even more in TCOMP.  In artificial intelligence this is also used.  Compared to
a data-driven substitutor, a compiling one is initially harder to construct,
but gives, beyond a certain complexity level, a wider flexibility and
generality than can be achieved with a fixed program driven by data.)

TIME ESTIMATE:  The generated SP-program is put on the property list of one of
the factors in the template.  To "substitute" then means to search for and
execute this property.  Suppose n objects Ai have SP:s on them, and A17 is one
term of many in an expression.  Then the SP for A17 is immediately found and
run in the same time, as if the other n-1 substitutions had not been set, ie
independent of n.  The data-driven substitutor however, has n templates to try
out, so time usually grows a factor n.



4.6  ^<<ADVANCED SUBSTITUTION EXAMPLES^>>

The SP-generator takes account to switches SRCHONCE, -RIGHT to allow tailoring
of individual SPs differently, and commutativity properties.  The wildcard ?END
is also entirely absorbed at generation time.
.E
?END is a wildcard for matching the end of a product. Very useful eg.
        with operators. Thus the situation of OP acting on just one operand:
        <OP><?ANY><?END>                @% is identified by this template,
        <OP><?ANY><?ANY><?END>          @% -and on exactly two like this, etc.
.P

OPERATOR ALGEBRA AND ORDERING                                   Page 4-7


For examples see file TRACE.DEF, implementing TRACE of gamma matrix products,
and the Chisholm identity for reducing gamma products.



4.6.1  VARIATION PRINCIPLES

-are easily implemented by declaring a symbol, eg VAR by (DIFFOPERATOR VAR),
which causes spreading so VAR finally only acts on (ie multiplies) single
factors.  Then set substitutions for VAR times the specific independent basic
objects, into the individual known results.  Then for remaining objects the
chain rule:  <VAR><?ANY> into <DF><?ANY> times <VAR> on the object ?ANY
depended on.  Possibly create different wildcards to use instead of ANY, to
match differently dependent objects.

For an example of the above, see the file SIGMA.DEF, which checks a paper on
sigma models.  It carries out a supersymmetry variation of an action that in
turn contain various other differential operators.  After varying under the
integral sign, there and elsewhere it is often necessary to perform:



4.6.2  PARTIAL INTEGRATION

In the file SIGMA.DEF, all operators were expressed in one, DF, which then was
mirrored to act on the other factors in each term by PINT:
.E
(DIFFOPERATOR PINT)         -Makes PINT an operator that spreads over a product,
so eg <PINT><A><B><DF><C>       -generates THREE terms (DF for derivative) being:
=<B> (<PINT><A>) (<DF><C>)      To make this agree with partial integration,
+<A> (<PINT><B>) (<DF><C>)      -first 2 should have the <DF> removed: So we
       ----  - - - @^@^           must recognize this underlined, and replace
                                it with the same,except for DF. Reference pa-
    (SETSUB)    <PINT><?ANY><RPAREN><LPAREN><DF> @$      renthesis explicitely.
                 -<DF><?ANY><RPAREN><LPAREN> @$          Kill PINT, move DF.
                        DF moved out gives (<C>) which goes to <C> by itself.
                        One term remains from the spreading step:

+<A><B> <PINT><DF><C>   This THIRD and last term, we remodel so it represent
                        the nonintegral term in the partial integration. In
                        this case we are not varying the boundaries, so here:
.P
        (SETSUB) <PINT><DF>@$    0@$      -simply substitute this term to zero!
The DIFFOPERATOR and SETSUB commands (given in the above order!), cause PINT to
have substitution programs (under TSUL) such that the desired actions are
carried out in all terms, upon the E- or SDEF commands.


DIFFERENTIAL FORMS -are defined in file DIFORM.DEF













                                   CHAPTER 5

                      SPINOR AND SUPERGRAVITY FACILITIES



5.1  ^<<SPINOR AND SHORTNAME INPUT^>>

In textbook formulas, it is common to use the same letter for several tensors,
e.g.  R for both the Riemann and the Ricci tensors, as long as the reader from
the number of indices attached can decide which tensor was intended.
Shortnames can be assigned with DECLT, affecting the STENSOR output.
However, if you confine yourself to a standard for the corresponding fullnames,
you may ALSO use these shortnames at INPUT, which is very convenient.

Shortname-indication:  To tell PDEF that you used a shortname, you END the
     tensor-reference with ANOTHER "<" instead of ">", e.g.     <T A B<
     indicates T being a shortname.

After a shortname, you may on the indices beside the usual PDEF special
     characters also use "@^" and "@'" which mean:

     "@^"  prefixing an index means that it should be CONTRAvariant.  While
          ABSENCE of the "@^"-prefix means it is COvariant.  Thus you can type
          things like:  <T A B< <T @^A @^B< i.e.  you can conveniently reference
          various up/down configurations with   the same shortname.  (While as
          when you use a fullname, you have to  remember the particular up/down
          configuration declared for it with    DECLT and raise/lower with 
          and .  relative to that)

     "@'"  A prime AFTER an index will make the object (spinor) display with a
          prime on that index, and also affect spinorial covariant
          differentiation and complex conjugation.

   The number of primes and their positioning also serves, together with the
rank, as information distinguishing between objects with the same shortname.
Thus you may type e.g.:     <T A< <T B@'< <T @^A @^B@'<   which in accordance with
ordinary textbook conventions will be interpreted as three new different
spinors (the first two mutually complex conjugate).

Initial translation:  Suppose that PDEF finds that the shortname has not been
     used before with both that number of indices, and prime positioning.  Then
     PDEF generates a descriptive fullname by itself, by appending one more
     character to the shortname, for each index.  The characters used are D,U,L

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-2


     or H depending on if the index is D-own or U-p (or for PRIMED
     spinor-indices L-ow or H-igh) For the example at the beginning, there were
     two indices, both being "Down", thus creating the fullname "TDD".  The
     last, three-object example creates "TD", "TL" and "TUH".

Successive occurrences of that shortname with the same rank and
     prime-configuration will then be replaced with the constructed fullname,
     with the proper rising/lowering contractions added (if necessary) to
     adjust the up/down configuration to what was requested at that particular
     occurrence.
     The unique fullname object gives internal canonicity.  Still W(E)DEF shows
     the desired up/down configuration, suppressing the contractions, if
     switches WSUBS and WSUBSG are on.

(FULLNAME t r p1 p2..)   Tells what fullname (if any) that has been created for
     the object with shortname t, rank r, and primes on positions p1,p2...  .
     (W)EDEF takes beside fullnames as arguments also lists (t r p1 p2).



5.2  ^<<COMPLEX CONJUGATION^>>

SUMMARY:
CONJ<TDD A B>          	    In formula, usually for TCOMP
<T A@' B<               	    In formula, conjugate of <T A B@'<
(CONJUGATE ta tb)      	    Conj the DEF of ta, put result on tb
(REAL a1 a2..)         	    Declare symbols a1.. to be real.
(IMAGINARY..), (COMPLEX..), (UNITARY..)         Analoguous
(SETCONJ a1 c1 a2 c2..) Set conjugate of a1 to c1, of a2 to c2,..
(RPLCONJ a1 a2...) c1@$ c2@$      As SETCONJ, but read cn as formula, ended by @$.

CONJ<TDD A B>  Conjugate of TDD (in formula).  This is usually in formulas
    intended for TCOMP.  You may use or not use round parentheses around the
    argument, as for operators DET and COFAC.  Used also for true scalars, as
    CONJ X or CONJ(X).

Shortname convention, or DU-object: has name ending with D-own,U-p, L-ow or
    H-igh in proper combinations.  Most easily introduced by using the
    "<"-endcharacter.

To represent the conjugate of a DU-object in some formula input is simply done
by putting prime on unprimed indices, and remove primes from primed indices,
compared to the original DU-object.

This is as done for spinors in textbooks.  Examples:

.E
Object:         Conj(object):   Internal names:
<T A<           <T A@'<,         TD and TL   New
<T A B<         <T A@' B@'<       TDD and TLL New
<T A B@'<        <T A@' B<        TDL and TLD
<T A@' B<        <T A B@'<        Objects as above, but now another conjugation.
                                Then gives original object back, as expected.

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-3


.P
If TDD has a definition, you might need to do (CONJUGATE TDD TLL).

SYMCX switch ^[on^] that for non DU-object A create AX as conjugate,and writes as
    A with a star up to the right.  If SYMCX is off, the conjugate is asked
    for.

(CONJUGATE ta tb)  Conjugate ta-DEFinition,put result on tb ie tb gets as
    definition the result of the conjugation.  Read:"CONJUGAte TE-nsor".
    The order of arguments, with the original as 1:st and some result put on
    2:nd, is the same as for eg TWIN/COPYDEF and as the VMS commands:  RENAME
    and COPY (in unix mv and cp).

(REAL a1 a2..)  Declare symbols a1.. to be real.

(IMAGINARY a1 a2..)  Declare symbols a1.. to be imaginary.

(COMPLEX a1 a2..)  Declare symbols a1.. to be complex ie nothing particular is
    known about the conjugate.  For the conjugate, this command introduces the
    symbol a1X (ie X after each argument symbol), which prints out as a1 with a
    star up to the right.

(UNITARY a1 a2..)  Declare symbols a1.. to be unitary ie conj(a1) = 1/a1.  Use
    on scalar symbols only, not on indexed objects.

(SETCONJ a1 c1 a2 c2..)  Set conjugate of a1 to c1, of a2 to c2, etc.  Must be
    given an even number of arguments, or "odd number"-error is issued.  If ci
    is a symbol, then reversely the conjugate of ci is also set, to ai.

    The ci may be expressions, but then in lisp-form.  To put in formulas,use:

(RPLCONJ a1 a2..) c1@$ c2@$  As SETCONJ, but read each ci as a formula ended by a
    dollar.  Cfr RPL (replace) that reads in formula.

(SETSUBCONJ ^[xsul ^[pred^]^])   Sets a substitution exactly as SETSUB but in
    addition automatically sets the complex conjugated substitution, to save
    you typing.  Works by locally setting SETSUBCONJ true and call SETSUB.  .
    ;If PSETSUB is true and the replacement is a single object, then normally
    that object would be defined.  Now in addition also its complex conjugate
    would be defined.

SETSUBCONJ flag ^[nil^]   which if true causes SETSUB to after having set the
    substitution proceed with complex conjugating the given mask and
    replacement and also set that substitution.
    Normally set the flag only locally by using the function SETSUBCONJ, so you
    can reserve SETSUB as alternative for substitutions that of some reason
    should not be conjugated.
    Eg if a mask is real then that substitution would if conjugated be doubly
    set, which when used waistfully causes a doubled search.

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-4


5.3  ^<<SPINOR IDENTITIES^>>

For higher-dimensional spinors, the Fiertz transformation is carried out by the
file FIERTZ.DEF in the STENSOR library directory.  See that file.

For 2-dimensional spinors, due to that the metric is the antisymmetric epsilon,
the Fiertz identity has a correspondence in the following important "exchange"
identity:

.E
                                                 C
        S          =  S           +  EPS     S
         ..A..B..      ..B..A..         AB    ..C ..
.P
-ie you may exchange any indices, if you compensate by adding a trace.  The
indices (A and B here) may be on different spinors.  Doing this on a term
replaces it with two terms as above, but these new terms might combine with
other terms already present in the expression.  By repetetive use, this
sometimes results in a large reduction of the overall size.

The user has to decide which term(s) has to be changed as above and point them
out.  The STENSOR EDITOR, "SEDIT", is used for this; Easiest startup:

SEDIT is entered from EDEF with a ">" -symbol, when EDEF asks for "Action"
    (unless you have turned off EDEFASK).  While the other Action-alternatives
    deal with the whole object, you may think of ">" as "moving (down) into the
    definition".

    Thereafter you talk to SEDIT, and can move a pointer around in the DEF.
        There ">" truly means "move down (right) in the definition".  You are
        at entry initially situated at the DEF-head, which is the indicator ALG
        (which "P-rint current pointer" would reveal).  Therefore, do ">>>" or:
        3>      -to move right, past "free" and "dummy" indices, to first term.
        Then play with the following, most important, character commands:
        P       Print current term. Good to show where you are (pointer).
        W       Write out a few terms around where you are.
        > and < move right/left one term (or numeric prefix).
        When P shows a term you want to exchange indices C and E in, type
        (XDD C E) etc as below.  W shows result.  Move and request exchange
        again.  When satisfied, exit SEDIT:

SEDIT is climbed up from, with a "@^" -symbol.  Then you are back at the
    "Action"-question, and can request S-def.  If that does not combine some
    terms, X-def back an older DEF and try exchange in some other terms.

(XDD a b)  eXchange Down-indices a and b and compensate with a trace-term as
    above.  The order in which index arguments are given does not matter, ie
    (XDD b a) give same result being that these indices are localized in the
    current term and then exchanged.

(XDU a b)  eXchange down-index a, and up-index b compensating with a trace
    times <DEL A B> this time.

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-5


(XUU a b)  eXchange Up-indices a and b and compensate with a trace-term
    analogous to that for XDD.

(XCHIX tsr)  Starts SEDIT, use XDD etc, then SDEFs.

(WXCHIX tsr)  Starts SEDIT, use XDD etc, then WSDEFs.  These are mostly used
    when EDEFASK is off so EDEF do not offer ">"-action.



5.4  ^<<SEDIT - STENSOR EDITOR^>>

Besides entering with ">" from EDEF, you can enter directly with command SE as
stated below.  When in SEDIT, type eg ?I to get the introduction.  The whole
helptext below can be read on-line.  Push "?x" to skip directly to subject x
(below marked "HELPON").  Then Y for each successive subject you want to read.


(HELPON @'I)ntroduction
SE - Stensor Editor
is an editor for manual inspection and change of formulas and S-expressions
stored in memory. Commands are of two kinds:
A) Built in, SINGLE character commands. Those are read CHARACTER-BY-
   CHARACTER - ie NO <RETURN>-s are needed (Eg this refers do DEC).
   Those single-char-commands cause actions of all sorts, eg of type:
        1) move pointer along a list, enter an element, exit
        2) PRINT the  element where the pointer is
        3) delete, insert replace etc. after the pointer
B) User provided LISP-commands; Whenever a @'(@' is typed, line-input
        mode is entered, ie you must end with <CR>, may use <DEL> etc.
        The expression you continue to type in, up to next balancing
        paranthesis, is LISP- evaluated. Your command could make use of
        @'L@', @'P@' etc that indicates the pointer location; see ?Gnrl
Any command, of type A or B, may be prefixed by a repetition number.
When applied on LISP-functions, Lisp prettyprinting is used.
With the B)-facility above, one can thus testrun the program,
while actually editing it.
When applied on algebraic expressions, SHEEP formula printer is used.
This text is part of SEDIT.HLP. For a demo, do @'DO DESSHP SE@' (on DEC).
@#
(HELPON @'C)alling formates are with 0,1,2 or 3 args:
(SE <atom>  <prop>) starts edit of property <prop> of <atom>. 2:nd or
     both args may be omitted. Then last values of SEATOM,SEPROP  are
     used.
If <atom> is nonatomic, it is evaluated. So eg (SE (GDD 0 0)) edits a
     specific array element.
Given 3 args, the 1:st is taken as copy-goal. Example:
(SE CPY SUM  <prop>)  is  exactly  as (SE SUM <prop>) except that CPY
     also gets a <prop>, which is initially empty,  but  for  a  head
     that  is taken to be the same as that of SUM (eg @'+@'). Then move
     the pointer in SUM to a part (term) of interest. Typing @'C@' will
     now  extend  the CPY-property with a copy of the SUM-part (term)
     pointed at. Move and type  @'C@'  again  to  extend  this  partial

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-6


     sum/CPY  further.
@#
(HELPON @'G)eneral info: The
    values of the symbols *L0 *P and *L have the following meanings:
*L0 (pointer to) the beginning of current list (=sum, product, S-expression)
*P  (pointer to) an element in  -- @'@' --
*L  (pointer to) the part of list *L0 from *P and on.
    These symbols are sometimes below referred to without "*".
@#
(HELPON @'B)R and BRE:Break point is installed
AROUND function F1 by typing (from in- but also *OUTSIDE* SE):
        (BR F1 <nbr> F2..)              Inverse:(UNBR F1 F2..)
        Optional <nbr>=initial break-mode for F2.., can be changed
        also during tracing, TYPE ? TO BOTH PROMPTERS FOR INFO!
INSIDE prog FN, by from SE give: I@'(BREAK0), I@'(BRE flag) or I@'(BRE flag expr)
        where opt <expr>=lispexpr to be eval-and returned, and
        optional  <flag>=identifier, that has two roles:
        (BRE . flag) is typed at break (good when having several)
        <flag> MUST BE GIVEN VALUE! If NIL,no break,until set T.
    Around SUBprogram at P-ointer:(SETQ SEREAD @'(EREAD)) and
        R(LIST @'BRE @'flag P)
    (BR myfun) puts in (BRE BRmyfun body), with flag set T.
P-ROCEED by typing P.   (Exmine variable P by (LIST P))
INHIBIT:*ALL* breaks temporarily  by (SETQ ALLBR NIL)
        INDIVIDUAL break temporarily by same on the individual <flag> 
@#
(HELPON @'M)ove pointer (P)
"<", ">" and B: Move P in current L0:
        ("<" moves 1 term left,  ">" right,  and "B" to Beginning)
        Eg 9> moves 9 terms to the right. Eg 7B is same as B (Idempotent)
E    Enters pointer-element. Old P=>L0, new P is 2:nd element in P
@^    back to earlier level. Inverse of E. To finish do 9@^ or @^G
@#
(HELPON @'F)ind-command: @'F@' will:
1) Ask for a <mask> (insert it in formula- or lisp-form (same as object))
2) Find the first element in the current list that contains <mask>
        maximum F-DEPTH levels down (default=8).
P is set to that element. The current list-level is unchanged.
@#
(HELPON @'P)rint commands that return internal-/pretty- forms respectively:
 ./P  =pointer           L/W  =from P and on     <blank> =@'>.@' ie move+@'.@'
The pretty form uses Sheep-printer for formulas, grinder for S-expr.
@#
(HELPON @'A)lter commands:
D-elete (inhib by Y-ank)        I-nsert         R-eplace
Sold@$new@$  =Substitute          ^\  =exchange P and next
I  inserts PRIOR to the pointer. Thus if pointer is on last element,
   @'Ix@' puts @'x@' 2:nd last. To move @'x@' last, you must do @'^\@'.
I,R,S read input from the user in two ways depending on if a LISP
program, or a SHEEP formula, is being edited. The reading is done
by evaluating different S-expressions.
For LISP code, the value of SEREAD is evaluated, default= @'(EREAD)@'
For SHEEP F-ormula, @'@'   @'@' SEREADF is evaluated,default= @'(FOIN)@'

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-7


EREAD does (EVAL (READ)), so you must quote. Or (SETQ SEREAD @'(READ)).
If you do  (SETQ SEREADF @'(SIMP P))     -then R-command will R-eplace
pointed term with result of SIMPing it (you may substitute selectively).
*** Easy way to Set reader to other value is by eXtended command. Do @'X?@' ***
@#
(HELPON @'Y)-command Y-anks last Delete from SEKILL.
@'Y@' does Insert of the expression that was Deleted at
the last D-elete command. So if you did D-elete by mistake,
it is inhibited by a @'Y@' at the same place, or you may move
the expression, maybe to another object by doing (SE OBJ),
and there do @'Y@'.
        The NEXT @'Y@' inserts the 2:nd last D-elete,
then the 3:rd last Delete etc. Ie you get any number of
DELETIONS BACK in the REVERSE order as you deleted them.
        When the only remaining deletion is the 1:st one you did,
then repeated @'Y@'-s will yield MULTIPLE COPIES of that expression.
Each @'D@' adds the P into the list @'SEKILL@' from which @'Y@' eats.
SEKILL is global,saved between edits. If empty, Y gives @'(BRE)@'.
@#
(HELPON @'X)
                        EXTENDED COMMANDS
                        =================
  These are an additional set of commands, that are separate from the
ordinary menu. You get into this commandset by typing the single character
@'X@' (as to all non-lisp commands, you should NOT end with carriage return,
all commands are read character by character, and a <CR> may abort the cmd)
  Then SEDIT acknowledges the shift by filling in (after X): @'-tended cmd:@'
  The next character you type is then interpreted completely different from
the main commandset.  In special, you may type a question-mark. Then you
will get a help-menu for these EXTENDED commands (and not the ordinary
commands). Try this. Type  eg   @'X?S@'   -where:
  X     -chooses eXtended commandset
  ?     -shows helpmenu for those, and eg:
  S     -then selects the help on the S-et command.
  Then you are OUT of X-tended set, and must preceede with @'X@' in order
to USE the set-command, ie you type the two chars @'X@' and @'S@' (then
you get another menu for what to set).
@#
(PRIN2 "More:do eg ?A
SE>"  )



5.5  ^<<(COVARIANT) DIFFERENTIATION OF SPINORS^>>

SUMMARY: @# Choose mode for ordinary and covariant differentiation with:
    (SPINOR NIL) for normal, 1-index mode. Co-diff use info from (AFFINITY..)
    (SPINOR T) for spinorial, 2-index mode. Covariant differentiation uses an
            AFFIN that adds contractions with AFFINPRIMED(=WHL2) for primed,
            and AFFINUNPRIMED(=WUD2) for unprimed indices.
    (SPINOR un prim)    To set other spinor affinities.
Normally each differentiation index ",i" means one differentiation, and the
(W)EDEF command causes covariant derivative indices ";i" to be expanded (one

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-8


for each eDEF) into ordinary derivative plus contraction with an affinity
symbol, which initially and after (SPINOR NIL), is taken from the value of the
symbol AFFIN (initially set to @'GAMU).

(SPINOR T/NIL) Choose (co)diff-mode.    The command (SPINOR T) causes both
    ordinary and covariant differentiation ot work in SPINOR-mode.  Then the
    contractions added when expanding a covariant derivative depends not only
    on if a particular index is up or down, but also:  If an index is primed,
    the object contracted with is taken from the value of AFFINPRIMED,
    initially = WHL2, and if the index was unprimed then the object is taken
    from the value of AFFINUNPRIMED, initially = WUD2.  (Technically, AFFIN is
    in spinor mode set to be a function, which when evaluated checks for prime
    and makes the choice.)

Note:  You should in spinor mode always write eg <PSI A ;B ;C> or
                <PSI A ,B ,C> and never use single ";B" or ",B" !!
    -Ie only *DOUBLED* (or even number of) semicolons or commas may be expanded
    while (SPINOR T) since you always differentiate wrt a PAIR of indices - one
    unprimed and one primed.
    The 2:nd diff-index is by eDEF automatically considered to be a primed
    index, and you should *NOT* as yet indicate it explicitely with "@'".  The
    "@'" only works in shortname, or "<"-mode, in which you as yet can not use
    ";" and ",".

OTHER SPINOR AFFINITIES - are requested by giving arguments to SPINOR.  (SPINOR
    T) is equivalent to (SPINOR WUD2 WHL2).  The below is old or technical.
    You may PDEF the WUD2 and WHL2 (as GAMU) to whatever you want, and EDEF
    your expressions to contain other objects than WUD2 etc.

    Alternatively, you may have your own affinity symbols inserted already at
    ;-expansion by changing values through eg:    (SETQ AFFINUNPRIMED @'MYAFF)
    and (SETQ AFFINPRIMED @'MYAFFP).
    Then redo (SPINOR T) since that in addition performs the following command:
        (DECLT  (MYAFF 1 (4 . !@'))  (MYAFFP 1 (1 . !@') (2 . !@') (4 . !@')) )
    -which causes the MYAFF-objects (or whichever other values that the symbols
    AFFIN(UN)PRIMED had) to have 1:st index up, and some indices primed.
    These are thus also the properties originally given WUD2 and WHL2 (2 is
    here mnemonics for an unprimed/primed index pair).

OTHER TENSOR AFFINITY is requested by giving arguments to AFFINITY.  Initially,
    (AFFINITY GAMU RIE1) is made.  The below is old or technical.
    For the spinor case the AFFIN value (the function) had in turn to be
    EVALUATED.  Therefore the AFFIN value is always evaluated.  This is also
    the reason why the normal AFFIN-value is @'GAMU:  that evaluates to GAMU
    (evaluation strips one quote).  The Lisp function to set values, SETQ,
    evaluates its second argument which we must inhibit with an extra quote,
    thus we must type (SETQ AFFIN @'@'GAMU) to cause the AFFIN value be @'GAMU -
    though all this was of course explained in case you want some other symbol
    than GAMU.

    Both tensor and spinor affinities should have index 1 up, and the rest
    down.  Contractions are with the 1:st or 2:nd indices.  The covariant
    differentiation index (-pair if spinor) being expanded, will be put in the

SPINOR AND SUPERGRAVITY FACILITIES                              Page 5-9


    remaining index slot(s).
    (Technical:  You can easily change file SPINOR if you ever wish
    (co-)differentiation to be done with n>2 indices at a time.


UPSPIN.STS -file that sets up for spinors.  Loaded by eg:  (LOAD UPSPIN).
    Mainly this sets up the metric to be two-dimensional EPD and EPU (ie
    shortname input mode not to be used on these), and declaring these to be
    antisymmetric objects with indices down and up respectively, and contract
    with each other to DEL according to "downhill" convention.
    The EPD,EPU also have WSUL-properties that if WSUBS is on makes them
    dissappear if contracted, and instead causing up/down shift of indices (as
    GUU/GDD).













                                   CHAPTER 6

                   SPACE DECLARATIONS, INDEXTYPE, SPLITTING



6.1  ^<<SPACE DECLARATIONS^>>

SUMMARY:
Declarations for usual(default) space,"DSPACE", or special indextype/space:
  (DIM sym)            	Dimension. Number or symbol that <DEL A A> should give.
  (DIMENSION nbr)      	Numeric dim for arrays in SHEEP. Ignore this,but for TCOMP.
  (METRIC co contra)   	The two metric symbols. Initially GDD and GUU.
  (CMETRIC co contra)  	Dito, if sure no noncommuting objects present.
  (AFFINITY aff ^[ric^]) 	What ";" (covariant diff) uses.Initially GAMU and RIE1
  (SPINOR unprim prim) 	Affinity for spinorix depend on if primed,ie TWO symbols
Issued at top-level,above declarations d1,d2.. affect the default space DSPACE.

To let them affect another space "nam",type d1,d2.. INSIDE an INDEXTYPE-command:
(INDEXTYPE nam  d1 d2 d3..  i1 i2 i3..) Reserve indices i1.. for space "nam",
 -and do declarations d1 d2.. for space nam. May then abbreviate, eg:
(INDEXTYPE spatial (D spadim) (ME GSD GSU) (AF CHR RIE1) j k l m n)

(DIM sym)  Dimension for STENSOR, what <DEL A A> gives.  The "sym" may be any
    number, symbol, or algebraic expression.  It is saved as symbol CODIM if
    DSPACE, on indices otherwise.

(DIMENSION nbr)  Numeric dim for arrays in SHEEP.  Listed here for
    completeness.  Not to be confused with (DIM sym) in STENSOR.  You will not
    need this command until computing individual components of tensors (that
    require arrays needed for storing).  Then use DIMENSION before TCOMP.
    Argument must be numeric.  Saved in symbol DEFAULTDIMENSION!*.

(METRIC mDD mUU)  Declare mDD/mUU as co/contravariant metric.  Always give two
    arguments (any symbols).  The properties of the default metric GDD and GUU
    are due to the initially issued command:  (METRIC GDD GUU).  Symmetry (if
    any) must first be declared.

    Example: To select HDD/HUU instead, which are say antisymmetric,
                then first do: (DECLT (HDD A12) (HUU A12))
           Only thereafter do: (METRIC HDD HUU)
    METRIC reads off any symmetry, and sets up substitution properties
    accordingly.  Besides TSUL and WSUL-properties, the HDD,HUU plus DEL are
    set up as FAMILY and WFAMILY.  HUU is caused to have both indices up.

SPACE DECLARATIONS, INDEXTYPE, SPLITTING                        Page 6-2


    Any previous metric (for this indextype) gets its T/WSULs removed.

(CMETRIC mDD mUU)  Declare Commuting metric.  As METRIC, but gives a WSUL
    property that lowers/rises indices on any object at any distance ignoring
    any noncommuting objects in between.  METRIC sets up a WSUL which only is
    the same as TSUL.

(AFFINITY aff ^[ric^])  What ";" (covariant diff) uses.  Initially GAMU and RIE1.
    Second argument (optional) tells what object to be used in the
    Ricci-identity, ie when expanding a double, antisymmetrized covariant
    derivative:  <T A ;^[B ;^[C<.  Both objects get their first index declared
    up, rest down.  They should have ranks 3 and 4.

(SPINOR unprim prim)  Affinity for spinor-ix depend on if primed, ie TWO
    symbols.  Causes all differentiations w.  r.  to indices of this type to be
    done in spinor-mode, ie w.  r.  to PAIRS of indices (one unprimed and one
    primed).  Both objects get just the first index up.  They should both have
    rank four.



6.2  ^<<INDEXTYPES AND SPLITTING^>>

SUMMARY:
(INDEXTYPE nam  d1 d2 d3..  i1 i2 i3..) Type nam: Declare: d1.., Indices: i1..
(REMINDEXTYPE nam)       Remove nam from being an indextype.Pools indices freed
(SETSPLIT totsp sub1 sub2 ..) 	Splittings below should take totsp into subi
(DOSUM tsr)                   	Split contraction indices, eg tt into ss + pp
(SPLIT tsr1 tsr2..)           	Split also free indices, giving multiple DEFs
                              	-Also first done of those below, if needed:
(ESPLIT tsr1 tsr2..) or (W..  	Evaluate SPLITted formulae of tsri
(SSPLIT tsr1 tsr2..) or (W..  	Simplify SPLITted formulae of tsri
(XSPLIT tsr1 tsr2..)          	eXchange SPLITted formulae with original
(PSPLIT tsr1 tsr2..)          	Put individual SPLITted formulae on tsri

(INDEXTYPE name d1 d2.. i1 i2 i3...) declare i1..  (indexsymbols) to constitute
    a specific class, or type, of indices.  That entire class is given the name
    "name" for future reference.  The d1..  is info on "name", at least a (DIM
    symbl), optionally any other of those above.  DIM etc may be abbreviated.
    Any number of indextypes can be introduced.

    A main use is to indicate a multitude of spaces.  Eg to cause A,B...  to
    refer to a 3-dimensional space, that we call SPATIALSPACE, one can type
    (INDEXTYPE SPATIALSPACE 3 A B C D..).  Then to set up K,L...  to refer to a
    4-dimensional "FOURSPACE" also type (INDEXTYPE FOURSPACE 4 K L M N...).

    Thereafter, a formula input as (PDEF TE)<R A B><Q L M>@$ will be understood
    to refer to two spaces, with consequences to both TCOMP and eDEF/SDEF:
    TCOMP will turn eg a dummy A (or K) into summation 0-2 (or 0-3)
    SDEF turns eg a <DEL A A> into 3 and <DEL M M> into 4.

SPACE DECLARATIONS, INDEXTYPE, SPLITTING                        Page 6-3


    Every symbol that is used as an index but NOT belong to any of these
    indextypes, is supposed to refer to the "default" space "DSPACE".  As
    dimension of this is in various contexts taken the symbol
    DEFAULTDIMENSION!*, or its value.
    Thus as range for a DSPACE-contractionindex, TCOMP uses DEFAULTDIMENSION!*.
    Thus if you have done:  (DIMENSION 7) @$ and (PDEF TE)
    <TSR1 B B><TSR2 K HI><TSR3 HI K> @$ then (TCOMP TE) turns the contraction
    over B into sum 0-2, over K into sum 0-3, while the index "HI" was unlisted
    above and therefore is taken to refer to the default space, thus causing
    summation 0-6.

(SETSPLIT totsp sub1 sub2 sub3...) declares the space totsp to be split into
    subspaces sub1 sub2 sub3...  .  This declaration is used by, and should
    precede, any use of the commands SPLIT and DOSUM.  The arguments must be
    names introduced with INDEXTYPE (or be the system-introduced DSPACE, which
    is most common for totsp), but for one-dimensional subspaces you may also
    use the number for the corresponding coordinate.

 Restriction for One-dimensional subspaces:
    One-dimensional subspaces must if numerically given be numbered from zero
    on and given in that order to SETSPLIT, ie ordered before multi-dimensional
    subspaces.  Eg to split a n-space into a 1 dimensional and a n-1
    dimensional subspace, you must number the 1-dimensional as coordinate 0,
    thus do (SETSPLIT DSPACE 0 SPATIAL) and not eg (SETSPLIT DSPACE SPATIAL 3).
    (The last method would also have been disadvantageous in obviously
    requiering the dimension to be explicitely stated.) If you introduce an
    indextype TIME you can do (SETSPLIT DSPACE SPATIAL TIME), but at the cost
    of obtaining TIMEspace dummies instead of simpler numeric indices).  A
    split into 1+1+...+1+k+j+..  is thus stated (..0 1..n Kspace...) with the
    space names in arbitrary order after the monotone series of integers.

 TECHNICAL on ANTISYMMETRIES:  SPLIT on a tensor containing antisymmetries,
    will automatically cause declaration of an array with those replaced with
    symmetries.  This is necessary for storing the "diagonal" elements, ie with
    both indices belonging to same space.  The minus is obtained by stensor
    when canonizing, so all elements later picked up from the array are those
    actually stored, and no symmetry elements that otherwise would lack the
    proper sign corrections are accessed.

    Indices of different types/spaces are ordered according to the order in
    which the types occur in the list INDEXTYPES, ie chronological since
    INDEXTYPE adds a new type at the end of the list.  After a (SETSPLIT DSPACE
    SUB1 SUB2...) the list INDEXTYPES is however partially reordered to conform
    with the ordering SUBi given in the SETSPLIT command.

    Warning:  If you do a *SECOND* SETSPLIT that specify a DIFFERENT ordering
    of SUBi, that will make current formulas noncanonical.  Then do (SSPLIT
    ALL) to canonize (at least on those containing antisymmetric objects)
    before any further ESPLIT, or else sign errors may occur.

(SPLIT tsr1 tsr2..)  TENVAL function.  After (PDEF TSR)...@$, the command (SPLIT
    TSR) take the DEF of TSR and creates formulae where both dummy and free
    indices are split.  Write with WSPLIT or WRITE.

SPACE DECLARATIONS, INDEXTYPE, SPLITTING                        Page 6-4


For each (W)zDEF-command that acts on a DEFinition, there is a corresponding
    zSPLIT command.  These are all TENVAL functions, so you can specify
    (WESPLIT TSR FROM 0 1 TO 1 2) etc, for splitted subspaceformulae.
    Otherwise these functions work exactly as expected from the zDEF-commands,
    with backup under TSRORG.  So do (WRITE TSRORG..) to see the backup,
    xchange all or individual components with XSPLIT.

(SAVSPLIT file t1 t2..)  -Save Splitted formulas.  Saves the total-space DEF
    etc exactly as SAVDEF, but also the splitted subspace-defs, ie the contents
    of the arrays of t1, t2..  (and of t1ORG,t2ORG...) are saved.

    The file also gets statements that, when the file is loaded, declare these
    arrays for t1,t1ORG,...  if they are missing at a later loading time (as
    with SAVBU/TCOMPOUT).

    By saving a result, and the next session do (LOAD file), the t1, t2...  are
    restored to the initial situation after the SPLIT commands (and ESPLIT
    commands if any).  This can save much time if the unsplitted DEF contain
    multiple contractions.  You can afterwards load files containing further
    SPLITs on the same tensors since these have no effect when already done.

(UNSPLIT t1 t2..) -Undo SPLIT-command.  Repeated SPLIT on a tensor has no
    effect, unless the previous SPLIT is undone.



    6.3  ^<<SPLITTED SUBSTITUTIONS^>>

<DEL A J> = 0 for A and J of different subspaces (see SETSPLIT).
    Examples (supposing indextypes SUBABC and SUBIJK have been introduced):
    (SETSPLIT DSPACE SUBABC SUBIJK) Sets SUBABC and SUBIJC as subspaces.
        -then eg: <DEL A I>, <DEL A J>, <DEL B I>,...     -all give zero.
        -while <DEL 0 I> does not (supposing SUBABC might be zero-dimensional).
    (SETSPLIT DSPACE 0 SUBABC)              Sets 0 and SUBABC as subspaces.
        -then eg: <DEL 0 A>, <DEL 0 B>, <DEL A 0>,...     -all give zero.
    (SETSPLIT DSPACE 0 SUBABC SUBIJK) Sets 0,SUBABC and SUBIJC as subspaces.
        -then eg: <DEL 0 A>, <DEL 0 I>, <DEL A I>,...     -all give zero.
            -While <DEL 1 A> etc is left unchanged, until you do:
            (SETSPLIT DSPACE 0 1 SUBABC)

A SPACE-CHECKING SUBSTITUTION:

    (SETSUB xSUL
     (AND (EQ @'SSPACE (GETINDEXTYPE A))
          (EQ @'DSPACE (GETINDEXTYPE J)) ) )   -this is an example of a suitable
        setsub condition if you want a substitution to take place only if A is
        SSPACE and J is DSPACE. "AND" may take any number of arguments (here two
        EQ-statements).
          (Automatic checking of space might possibly be introduced; Complication
           however: A mask should be searched regardless of spaces, THEN the choice
           (between presumably many replacements) should be done depending on the
           indices)













                                   CHAPTER 7

                   AUTOMATIC GENERATION OF TENSOR ALGORITHMS




SUMMARY:
 Create file.DEF      Edit to contain PDEF-commands
 (LOAD "file.DEF")    -Take into STENSOR
 (TCOMPOUT file ALL) -allows you to MAKE, and creates file.BLF for later use
 (DOCUMENT file)     -creates file.DOC which tells anyone what BLF-package does



7.1  ^<<INTRODUCTION^>>

The SHEEP-command "(MAKE TSR)" computes the individual components of a tensor.
To do so, SHEEP needs a program for that particular tensor, a so called
BULF -BUiLding Function.  The BULF is automatically generated from the DEF of a
tensor, by the command (TCOMP tsr), so you then can do (MAKE tsr).  (Technical:
Briefly, MAKE works as follows:

     1.  updates some global variables (INDX1 INDX2 ..) specifying a component

     2.  executes the BULF that performs the computation

     3.  stores the result under the current component

     4.  back to 1 for the next (independent) component, if any.)




7.2  ^<<TCOMP - TENSOR COMPILE^>>

(TCOMP TSR1 TSR2 ..)    Generates programs for COMPuting Tensor COMPonents.

Each argument should be an identifier with a definition given with PDEF.  For
each argument, TCOMP analyzes this indicial formula and generates:

           1.  BULF = a program that for each component performs the operations
               that are indicially symbolized in the definition

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-2


           2.  PREQ = a list of the prerequisited tensors

           3.  DEP = a list of the dependent tensors


TCOMP finally puts these results on the identifier under properties BULF, PREQ
resp.  DEP, and types them (if WTCOMP switch ^[on^] is left on).

(Technical:If ALLASK switch ^[off^] is on, TCOMP asks some questions as it works:


"x" decl sym with DECLT, if none NIL    The last chance to declare correct
               index symmetries of the tensor "x".  If "x" e.g.  was sym.  in
               2:nd and 3:rd indices, type (DECLT ("x" S23)), if it had no
               sym., type anything, e.g.  T or NIL.

"x" basic tensor, copy it?  (Y,N,H)     To this question, it is always correct
               to answer "Y" (Yes), and this should be the answer if there is
               any doubt.)



7.3  ^<<TCOMPOUT OR SAVBU - SAVE BULFS^>>

(TCOMPOUT file tsr1 tsr2 ..)    Saves the building functions (+ other
properties) of the tensors on a disk file named "FILE.BLF".
This command is advisable to do since:

     1.  You don@'t have to regenerate the BULFs at each session you need them.

     2.  With this file you can compute the components in a naked
         SHEEP-version, excluding PDEF and TCOMP programs (saves memory).

The BLF-file contains everything needed for computing the components, it
constitutes an "application package".

For each tensor TCOMPOUT types the tensor name and then the names of the
properties that were found and saved:
TSR
 (TYPE DS) PREQ DEP TNSPCH NAM UPINDX (CBTSR)= BULF
Here "(TYPE DS)" is the SHEEP tensor type (when reading in the file, an array
declaration is done unless TSR already was declared), and "(CBTSR)" is the
Compiled Bulf for TSR.  Between these are listed the names of the properties
found.

To save additional properties with names PNA1 .., just replace the argument TSR
in TCOMPOUT with (TSR PNA1 PNA2 ..).

(XBULF tsr1 tsr2...)    Exchanges the programs stored under properties BULF and
        OBULF.  Good when you wish to switch between alternative programs for
        comparison, or when different components of the same tensor are better
        computed with different programs.
        A corresponding and helpful command is XDEF (see chapter PDEF).

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-3


        Example:
        Input:          Comments:

        (PDEF TSR)      Put one definition on a formula

        (TCOMP TSR)     Tensor COMPile it, creating a BULF on TSR

        (PDEF TSR)      Put an alternative definition.  PDEF calls XBULF,
               supposing that any existing BULF is invalid, since you now
               re-define the tensor.

        (TCOMP TSR)     Creates a new BULF-property, from the new DEFinition.
               Now you have both a BULF and an OBULF.

        (TCOMPOUT file (TSR OBULF))     Saves the BULF (and other properties),
               and in addition the OBULF (since you specified so).  Thus your
               "file" will contain a BULF and an OBULF, built on different
               formulas.



7.4  ^<<(TCOMPOUT FILE ALL)^>>

ALL -is special argument to TCOMP, TCOMPOUT, WDEF, WODEF and all eDEF commands
    etc.  The effect is to use as argument all the objects defined hitherto (ie
    on the property list of TOTAL, the main accumulator in ACCUMS).  See
    EDEF-chapter.  (You may manipulate this list; eg setting it to the empty
    list by



7.4.1  TOP TENSORS SUFFICE -GIVES HIERARCHY:

Suppose the formula for TSRA contained objects TSRA1, TSRA2 and TSRA3.  Then
the "PREQ-list" of TSRA becomes (TSRA1 TSRA2 TSRA3), and declarations of arrays
and properties are also done for the TSRAi and put in the file.
If TSRA1 had a definition then TCOMPOUT offers to compile that as well, asking:
                               TSRA1  Use TCOMP?
Then answer Y or N.  If Y then a program for TSRA1 is produced and included in
the file as if TSRA1 was among the original arguments.  Compilation is also
offered for the PREQ-objects for TSRA1 in turn and so on recursively until the
bottom, basic objects (or you answer N).
The whole hierarchy in order from the bottom up to TSRA is put in the file,
which becomes:  A-hierarchy B-hierarchy...  (avoiding repetition).  Thus you
only need to specify the topmost object(s).

NOASK switch ^[off^] which if on suppresses all asking, causing all questions
    answered Y.  Thus "Use TCOMP?" is not seen, and whole hierarchy is TCOMPed
    and saved.  Batchjobs work as if NOASK was on.

SAVBU is identical to TCOMPOUT, except that it does not locally turn on NOASK.
    Thereby you get "TCOMP?" -questions that otherwise are answered Y.  Answer
    Y for each additional object you want to compile.

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-4


7.5  ^<<<> MARKS EVALUATION TO TCOMP^>>

If you want an object to have (and reference) a value, then you should
reference it as a tensor in the tensor formula, ie surrounded with < and >.  If
the object has zero rank doesn@'t matter:  it still should be inserted as eg
<CHI> if you want the value of CHI to be used.
Otherwise eg  "2*CHI*<VEK A>"  will TCOMPile into a program that only lets CHI
turn up in the result in the form of the CHI symbol itself.  To get rid of
these CHI would then require the user to set a specific substitution from CHI
to its value (:CHI).
With the proper formula 2*<CHI>*<VEK A> the value of CHI will be inserted in
the normal way not requesting user intervention, and also cause CHI to
automatically be computed or asked for, prior to the dependent objects (the
PREQ/DEP -mechanism).

    Arbitrary powers may occur, thus in 2/<CHI>@^(1/2) the CHI-value is still
used in the TCOMPed program.



7.6  ^<<DIMENSION USAGE IN TCOMP^>>

DEFAULTDIMENSION!* is a sheep symbol set by (DIMENSION n) to a positive integer
    value.  When a tensorarray is declared, it obtains as dimension this value
    (unless otherwise stated).

    When you TCOMP a tensor, TCOMP declares arrays for that tensor, and also
    for the tensors occuring in its definition.  Therefore you should SET THE
    DESIRED DIMENSION before TCOMPing!  Eg:
        (DIMENSION 3)   -default is 4.

    Also do this before loading a x.BLF file!  The same file can be used in
    various dimensions, since the summations go up to the symbol
    DEFAULTDIMENSION!*, but arrays (for n) are declared as the file is loaded,
    so first do (DIMENSION n).

TCOMPDIM can be used to change that default.  TCOMPDIM is initially set to be,
    not a number, but the SYMBOL "DEFAULTDIMENSION!*".  Thus change TCOMPDIM if
    you want something else as explicit summation limit.



7.7  ^<<MIXED DIMENSIONS IN TCOMP^>>

You may want some other limit for summations, either some symbol that you later
give some value, or maybe a number, to make the blf-file restrict to a specific
dimension.

    You may also mix different dimensions in the same computation or tensor.
Just first declare the indextypes you need, each with its dimension.  Then
PDEF, choosing indices from the appropriate indextypes.  Then TCOMP will
declare tensors with appropriate dimension for each indexposition.

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-5


    Example:  Given seven vectorfields, compute their squares and rotations.
Then for simplicity introduce just one vector symbol, but with an extra index
to label all seven.  That index is entirely different from the others, so you
need to reserve some special symbol(s) for it.  We say we introduce a new index
type, arbitrarily named LAB(-el):
                                @% Declare a new indextype, of dimension 7
(INDEXTYPE LAB (DIM 7) A B C D) @% and consisting of index symbols A,B..D
(DIMENSION 3)                   @% Set normal dimension in SHEEP (affects other
                                @% indices;how many components they represent).

(PDEF SQU "Square of each VE")          @% (The "help-string" is optional)
        <VE A J>  <VE @@A J> @$           @% Depress summation over A,gives<SQU A>
(PDEF ROT "ROT of each VE")             @% Gives <ROT A J>, a 7x3-matrix, as
        <EPS3 J K L> <VE A K ,L> @$      @% also VE will be declared.

Then   (TCOMP ALL),   (RPL VE)   and   (WMAKE SQU ROT)   -will compute the
seven SQU components (scalars), and 21 ROT-components (seven 3-vectors).

With:           (INDEXTYPE LAB (DIM LABDIM) A B C D)

-the labeldimension is set to the symbol LABDIM instead of explicitely 7.  This
is allowed in DIM, for indicial computations, but before TCOMP you must either
change that sole property of LAB by:

(INDEXTYPE LAB (DIM 7))     -or do:      (SETQ LABDIM 7)



7.8  ^<<DETERMINANT AND INVERSE OF A MATRIX^>>

SUMMARY:  Define the determinant by eg (PDEF MDET) DET <MAT @@A @@B> @$ and then
its reciprocal and the matrix inverse as 1/<MDET> and 1/<MAT A B>.  Then TCOMP
the objects in that order.

A DETERMINANT is indicated DET<MAT @@A @@B>.  TCOMP translates this into a
    program that computes the determinant of a matrix MAT.  The result should
    be stored as a separate symbol, ie you PDEF a new symbol to only be the DET
    of the matrix, and reference later to that symbol instead of recomputing
    it.

        Example (indicating some alternative forms of syntax):
        (PDEF MDET)          followed by one of four equivalent formulas:
        DET(<MAT @@A @@B>) @$   The DET-operator can have or not have parentheses
        DET <MAT @@A @@B>  @$   around its single argument. Cfr SIN(X) and SIN X.
        DET(MAT) @$
        DET MAT  @$
    If MAT has been previously introduced, the last two formulae will in
    interactive mode cause FOIN to complain about the lack of indices.
    Therefore the first two ways are recommended.
    The symbols "@@" in front of the indices there are necessary in order to
    "hide" them from being interpreted as full graded, symbolic indices.
    Otherwise the formula would become of second rank, or with the same index
    repeated summation would be understood, both interpretations equally wrong!

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-6


RECIPROCAL of a scalar is indicated 1/<SCL> or <SCL>@^-1.
    Thus define the reciprocal or inverse of the above MDET by:
    (PDEF IMDET)1/<MDET >@$
    Then TCOMP MDET and IMDET.  If TCOMPed in that order, MAT will under the
    property "IDETis" get the symbol IMDET, which is later needed at inversion.

Negative powers eg 1/<MDET> are TCOMPiled into a program that checks if the
    denominator (MDET) is a sum.  In that case, the MDET is not evaluated, but
    kept as a symbol (through function SMBOL).  If Sheep later differentiates
    this, it will ask for the functional dependence of MDET.  The easiest
    answer is then:  (FUNS MDET).

MATRIX INVERSE is indicated 1/<MAT A B> so type eg (PDEF IMAT)1/<MAT A B>@$.
    With (TCOMP IMAT), a BULF-program is then set up that in principle follows
    the Kramer formula:  IMDET * COFAC <MAT B A>, although through a special
    function (which, as COFAC, neither supposes nor exploits any possible
    symmetry of MAT).  TCOMP obtains the name of the necessary object IMDET
    from the property "IDETis" of MAT, provided the DET and IDET was TCOMPed
    first.  If not, TCOMP will ask you to do so.

COFACTOR is indicated COFAC<MAT A B> -note that to do inversion using COFAC
    literally through the above formula is somewhat slower, but if you persist
    dont forget to transpose:  COFAC<MAT B A>.

CONJUGATE is indicated CONJ<MAT A B>.



7.9  ^<<INTERMEDIATE OBJECTS SELDOM NEEDED^>>

SUMMARY:  IFNEED - Declare tensor to only have NEEDED components computed
        -by:    (DECLT (TSR (IFNEED T)))   or   (PDEF TSR (IFNEED T)) ...

        AT THE MOMENT, TCOMPING THEN MUST BE DONE WITH SYMBOL LCOMP TRUE!
        (SETQ LCOMP T) also if .blf-file is to be Lisp-compiled.

   Some objects are interesting in themself, so you want to have all their
components computed and see them all, regardless of whether each of their
components are really needed for the succeeding computations or not.  Then the
PREQ-mechanism ensures all its components are computed before proceeding to a
higher tensor.

   Other objects again might NOT be of that interest, but are merely introduced
of efficiency reasons for storing an intermediate expression that had otherwise
been recomputed several times.

   In the latter case it can be a waste to start by computing all of the
components of the intermediate tensor (say ITEN), namely if some of the ITEN
components are not requested during the later computations.  Then the IFNEED
declaration causes the ITEN-components to be computed only when and if needed.

Example:  Suppose ITEN only is needed for computing ANS= <ITEN K><SPARSE K> and
some of the SPARSE components are zero.  The normal way is to first compute all

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-7


ITEN, then all SPARSE, then ANS.  Then those ITEN components where the
corresponding SPARSE-component was zero, has been computed in vain.
If instead you had defined ITEN by (PDEF ITEN (IFNEED T)) ..., then (TCOMPOUT
file ANS) compiles both ANS, ITEN and SPARSE as usual, but the ANS-program is
different, and only SPARSE (not ITEN) will be on the PREQ-list of ANS, so (MAKE
ANS) causes SPARSE be computed, then ANS is started upon, and during that
computation some ITEN components are computed underhand as they are needed.
Those computed are stored and reused elsewhere if needed.



7.10  ^<<PRODUCE A BLF-FILE FOR THE LISP COMPILER^>>

SUMMARY:     Before TCOMPing any of the .BLF-formulas, do:
    (SETQ LCOMP T)      -intended for "Lisp COMPiler" *MUST* be done!
    (SETQ MCOMP T)      cause Macros be used by tCOMP (recommended)
    (LOAD SUMBOP)       REDEFINE SUM.. as macros      (recommended)
    (ON MACROEXPAND)    Cause macros be expanded      (recommended)
    Also: see next paragraph.

TCOMP/TCOMPOUT normally tries to minimize the code-volume of the programs
produced, assuming the programs should be run "directly" ie using the "Lisp
interpreter".

For higher computation speed, you may however prefer to have a frequently used
BLF-file lisp compiled:  That implies other preferences!  So after the above
commands a produced BLF-file will be larger, with apparantly more longwinded,
but after Lisp compilation better, programs.

LCOMP global ^[nil^] ="for Lisp Compiler".    This *MUST* be set true before
    TCOMPing, else after Lisp-compilation the file will error out for eg
    tensors defined through products.  (Turns tensor-calls into (longer)
    GETEN-calls)

MCOMP global ^[nil^] ="Macros from tCOMP".    Technical.  Causes mainly
    (PROGANS...) be used instead of (PROG (ANS) ...  (RETURN ANS)), and
    subsequent analyze be done by the macro PROGANS.

MACROEXPAND switch ^[off^] cause expansion of macros:  SUMBOU,PROGANS...

(LOAD "SUMBOP.STS") loads a file that redefines functions in SUMBOU to be
    macros (old version:  SUMBOM.STS).  SUMBOP-macros expands to lisp code that
    is OPen-coded by the lisp compiler, which means the contractions are turned
    into loops that are very fast, requiring little overhead.  This speedup can
    sometimes be small as compared to the unavoidable algebraic work of
    undiminished complexity needed for each loop, but the importance of the
    speedup grows rapidly with the dimension and number of contractions.



7.11  ^<<FACTORIZATION DONE BY TCOMP^>>

For facorization, which can highly improve the resulting tensor programs,

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-8


especially from EDEF-derived, longer formulas,
****** you must at the moment do (recommended)
****** (LOAD QTCFAC)  -before TCOMPing. Then:

FACTORTYPES list (FCTEN FCNUM)   -is a list of factorization functions that
    TCOMP will call (in turn from left) in a try to recursively factorize the
    formula for improved efficiency.  You can exclude or reorder elements if
    you of some reason want to inhibit/change order of, any of these attempts
    for some individual tensor program.

    FCTEN collects terms that contain a common tensor, giving T1*(T2*T3 + ..).
    Search is through 1:st term, from left through product, searching a tensor
    that also occurs in any later term.  Then go through term 2 etc.  Thus you
    can affect multi-choice situations by rearranging the factors/terms by
    using ORDER and E/SDEF (or avoid E/SDEF, then original termorder remains,
    and ORDER only affects factor order, since TCOMP canonizes by termwise
    calling E/SDEF).

    FCNUM (thereafter) collects terms that simply are Number * Single-tensor,
    turning them into:  Number * (T1+T2+..).



7.12  ^<<IDENTIFY TERMS WITH SPECIFIC OBJECT^>>

Suppose W is arbitrary, and you search the X that makes this object zero:

(PDEF ZERO) <T a b c><R b><W c>     +     <U b><X b><W a> @$ -then do:
(PDEF ZEROW)<T a b c><R b><W c><DEL c d> +<U b><X b><W a><DEL @@a d>@$
    (or     .......d><...><W @@d>    +  ...)
-thereby introducing d as additional free index.
Then (TCOMP ZEROW) and (WMAKE ZEROW) shows through the extra index the W-terms:
ZEROW 0 0      is <ZERO 0>, only the <W 0>-terms,
ZEROW 0 1      is <ZERO 0>, only the <W 1>-terms, etc.
Add a DEL for each index, eg if W was of 3:rd rank, replace
(PDEF ZERO) ......<W a b c>....         with:
(PDEF ZEROW) .....<W a b c><DEL @@a d><DEL @@b e><DEL @@c f>....
(Could be automized if needed) If eg b already was a dummmy, then prefixing
the added b with a @@ is not necessary but not hurting either.



7.13  ^<<FACILITIES FOR CREATING DOCUMENTATION^>>

SUMMARY:
In file.DEF put: "helpstrings" to PDEF/DECLT, and/or
        (DOC n)	-followed by n lines of text, and/or
        (DOC)  	-followed by any nbr of textlines,
               	-until a line ended with "@#".
Then (DOCUMENT file) -produces file.DOC, with that info.
The command (DOCUMENT file) produces a file "file.doc" which only contains the
formulas of file.DEF nicely written out, together with your descriptive texts.
Thus in plain language presenting to anyone what that package does.

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                       Page 7-9


A package is useless to other people without such a documentation.  To create
formula output by hand with indices up and down is usually more tedious than
the flat one line formula input to PDEF.  Thus a PDEF-file which you hit with
DOCUMENT is the cheapest way to get even that minor part of the job done, the
documentation, - let aside that you with TCOMPOUT then have the main product,
the program package, absolutely free!  And the efficiency/compactness has
normally turned out to be slightly better than if written by hand!

PDEF:  A string (or strings) of text can be included anywhere among the extra
    arguments to PDEF and DECLT.  This is a help-string, eg a description of
    the tensor, which is displayed by WDEF together with the actual formula.

(HELP tsr) only displays the string(s) on your terminal.

NOMSG switch ^[off^], suppresses if on eg WDEF/DECLT writing of help strings.

(DOC nbr)        This command either skips or writes the next nbr lines.  Used
    in a file to precede nbr lines of documenting text, which then normally is
    ignored (as if preceeded by @%).

WDOC switch ^[off^] if non-nil causes (DOC nbr) to Write the next nbr of lines
    instead of ignore them.  Temporarily set true within DOCUMENT.

(DOCUMENT file)   Creates a file "file.DOC" by loading "file.DEF" with WPDEF
    on, so WDEF is used on each tensor being defined in that particular
    .DEF-file.
    You are recommended to insert all text into the .DEF-file in that way.
    Then all your typing can be confined to only one file, and when you change
    a PDEF-formula you are more likely to adjust the accompanying text
    accordingly.  Thus the .DEF-file is a compact source file, from which both
    an up to date .DOC-file and .BLF-file can be automatically regenerated at
    any time.

        Often there are TCOMP or TCOMPOUT commands in the .DEF-file that you
    are doing DOCUMENT on.  To avoid their output polluting the resulting
    documentation file, the TCOMP and TCOMPOUT functions are temporarily
    inactivated by DOCUMENT (using flag SLEEP), to do absolutely nothing.
    Other commands in the file are executed as when loading normally, and their
    output go into the .DOC-file (but most functions only return a value and do
    no printing by themselves).



7.14  ^<<OVERLAPPING SYMMETRIES^>>

A special situation is when one and the same index is involved in two different
symmetries (of the same level), ie two symmetries "overlap".  This is allowed
in STENSOR 2.20 and later, and is indicated as eg:  (DECLT (TN S12 A23))  
-where we have DECLared for the Tensor TN that its 2:nd index is symmetric with
the 1:st (S12), but at the same time this 2:nd index is also antisymmetric with
the 3:rd (A23) ie the S and A overlap on index 2.

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                      Page 7-10


7.14.1  INDICIAL COMPUTATIONS WITH OVERLAP-SYM.

-will use this properly at simplification, turning eg <TN A B A> into
<TN B A A> = 0, and <TN A B C>=-<TN A C B>=-<TN C A B>=-<TN C B A>, ie asym in
1:st and 3:rd is implied (though might require two SDEFs unless you with a
(DECLT (TN S12 A23 S12)) force it into one SDEF).



7.14.2  COMPONENTWISE COMPUTATIONS WITH OVERLAP-SYM.

However, overlapping symmetries are NOT allowed in SHEEP, ie in the arrays for
storing the individual COMPONENTS!  Therefore, TCOMP(OUT) can not transfer the
STENSOR declaration to SHEEP.  For componentwise computations, you have to
select a simpler symmetry.  There are three ways to compensate for that loss:

1) DROP LEAST IMPORTANT SYMMETRY

    In the above example, one of S12 and A23 has to be dropped.  Then keep the
    A23, since that saves the machine from vastefully computing both one
    off-diagonal side, AND the DIAGONAL components.  It is better to drop the
    S12, since that merely will add one off-diagonal side.  Thus do:
    (DECLT (TN A23)).    -Do TCOMP(OUT), which now won@'t complain over the
    symmetry, and then you can compute the TN components (though some
    excessive).

2) USE FROM-TO INTERVALS

    If time is an issue, one can with FROM TO-constructs compensate for also
    the dropped S12, by issuing:

    (DOFOR x (0 1 2) (WMAKE TN FROM x x (ADD1 x) TO x 2 3))

          -or repeat the WMAKE command by hand with numbers for x.


    Note:  Had there been leading indices, so FROM-TO should compensate eg a
    dropped S56, then each set of these leading indices require a make-call
    each, ie (MAKE FROM 0 0 0 0 0..) and (MAKE FROM 0 0 0 0 1..) etc to
    (MAKE FROM 3 3 3 3 0...) and (MAKE FROM 3 3 3 3 3..) ie 4@^4 * 3 intervals.
    Clearly, TN should then be redefined with indices in such a different
    order, so that the dropped symmetry instead comes to concern the 1:st and
    2:nd indices as above, requesting 3 intervals!

    With the above FROM-TO trick, it does not matter if you drop the A or S, so
    if the sym originally was A12 S23, replace the A12 with FROM-TO.


    To insure against forgetting the FROM-TO in operations however, you could
    decrease the consequential slowdown by having the indices in the order of
    S12 A23, and drop the S12.

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                      Page 7-11


3) "IFNEED" TO INHERIT SYMMETRY FROM ABOVE:

    Suppose you use TN as follows:  (PDEF ANS S12) <TN A B C><VEK C>@$ -Then eg
    <ANS 3 0> will not be computed, since ANS was declared S12.  That will
    cause some TN-components never be asked for!  Then just make sure they are
    not computed until they are needed, by (DECLT (TN (IFNEED T))) and TCOMP
    with LCOMP true.  The S12 is "imposed" on TN from the higher ANS.  This
    only works for some definitions, and if ANS has the dropped symmetry.



7.15  ^<<TENSOR ALIAS, PACKAGE^>>

The same set of objects can often be computed in different formalisms.  Then
you might have two (or more) alternative DEF-files for these same set of
objects.  Typical of this is in relativity, where objects RIE, RIC etc can be
computed in a coordinate basis (file CORD.DEF) or in a moving frame (eg file
GFRAME.DEF).  The RIE object for instance, will then have differing definition,
and components, in CORD and GFRAME.  To avoid collision if both files are
loaded, their internal names of RIE are different, RIEC (in Cord) and RIEF (in
gFrame).  The user may use these internal names, but he may also use RIE and
have the system translate by means of an aliaslist, TENALIAS!* global ^[nil^].
If its value is (...(RIE RIEF) ...) then the input RIE is interpreted as RIEF
in:
        -formula input, like:    <RIE A B C D><GUU A C>@$     -and in:
        -all commands, like:    (PDEF RIE), (TCOMP RIE) and (MAKE RIE)
        (but not pure lispcommands).

Formulas/commands in a file being loaded are not excepted from translation.  At
the start of CORD and GFRAME.DEF, a TENALIAS!* is set up, so the PDEF commands
use names without any F/C.  Then the same input line in CORD and GFRAME:
(PDEF RIE) <GAM..    is interpreted differently due to translation, eg as:
(PDEF RIEF)<GAMF..    -in GFRAME.
Thus when typing (MAKE RIE), the formalism used for the computation depends on
the current TENALIAS* value.

The strategy is to minimize explicit names in your DEF-files; then a file
defining eg the RIE square could be equally well loaded into CORD as GFRAME.
By using "." and "@~" in PDEF you need not explicitely name the metric
either.

TCOMPOUT puts in the BLF-file also the current value of TENALIAS*, so it is
restored when loading the BLF-file also into pure SHEEP.  If you load both
BLF-files, the resulting TENALIAS*-value comes from the file last loaded.



7.15.1  QUOTING CHARACTER

The translation can be escaped by either:
-referring to the internal name:  (MAKE RIEC) or (PDEF RIEC) <GAMC ..., or
-preceding the name with a single quote:  "@'".  This latter works in both
commands and formulae, but only in STENSOR, eg (PDEF @'RIE) <@'GAM ...

AUTOMATIC GENERATION OF TENSOR ALGORITHMS                      Page 7-12


7.15.2  PACKAGE SYMBOL (STENSOR ONLY)

You need not construct the TENALIAS* yourself; Example:  by (SETQ PACKAGE @'F)
at start of GFRAME.DEF, an F would be appended on each new tensorname
henceforth, and also the TENALIAS* being built up.  Objects that you want
untranslated, would then however need a @' eg @'GDD.



7.16  ^<<ADDITIONAL COMMANDS IN BLF-FILES^>>

TCOMPOUT puts the current value of POSTBLF!* ^[global^] at end of each BLF-file
it creates.  This is for communicating extra commands/information from the DEF
file to the BLF file.
If your DEF file has:    (SETQ POSTBLF!* @'(PRINC "Copyright Kilroy"))   -then
TCOMPOUT puts this (PRINC.. ) at the end of the blf-file, so whenever later
loaded, the blf-file will each time end by executing that PRINT command.
This is used for arbitrary extra setup commands.  Often you want the command
executed already when the DEF-file is loaded too; then enclose with eval there:
        (EVAL (SETQ POSTBLF!* @'(PRINC "Copyright Kilroy")))
                See CORD and GFRAME.DEF for examples.

PREBLF!* ^[nil^] list of function names.  At the beginning of the BLF-file,
    TCOMPOUT puts the definitions of all functions named in this list.  Add to
    it, to have TCOMPOUT save also your private functions if any.













                                   CHAPTER 8

                          WHILE COMPUTING COMPONENTS



8.1  ^<<TIMING^>>

(TI cmd) -executes cmd, and prints cputime taken.  Returns whatever value cmd
    returned.    Example:
                (TI (SIMP RIE))         -causes the printout:
                      (Ex.-GC time= (1 23 45 678)  GC=60000)
    -means that the Execution-time minus GC-time was 1hour 23 min 45sec 678ms
    -and that the GC (Garbage Collection) -time, was 60seconds.

TIBELL ^[15000ms^] -Times larger rings a bell when done, ie if (TI..) measured
    more than 15 seconds cputime, you are feared to have fallen asleep
    meanwhile, and woken up.  Thus relax with your coffee - your attention is
    recalled when due.

TIMSG ^[nil^] optional message put in: ("string" Ex.-GC time...) at print out
    (used to identify the timing).

TIM switch ^[off^] -activates multiple timings in eDEF/SDEF.  Each of the three
    steps Evaluation, TSUL-substitution and simplification are individually
    timed, plus an overall timing.  Each with an identifying TIMSG.

TIARG switch ^[off^] cause TI display its cmd-ARGument together with the timing
    report.  Example:
    (TI (MAKE RIE))             -the command may result in several lines that:
    ....                        -initially are uninteresting, ended with the line:
    (** (MAKE RIE) Ex.-GC time=1 23  GC=23)     -that summarizes the above
    The last line now comprise the most essential information:  the command,
    that it succeeded, and how heavy the computation was.

    Batch command files often produce voluminous log-files, tedious to
    investigate.  But if you put TI around all major commands, the resulting
    log-file will contain such lines as the above.  They have a ** in them to
    make them easy to find - you can peruse just the **-lines with:
    In VMS:     SEARCH  file.log  "**"
    In unix:    grep    "**"  file.log
    -which directly enables a first judgement of the computation, especially
    since also warnings (marked ***) and errors (*****) will be caught.

WHILE COMPUTING COMPONENTS                                      Page 8-2


8.2  ^<<TRIGONOMETRIC SIMPLIFIER WTRIG^>>

The basic trigonometric sum-relation:  sin@^2 (x) + cos@^2 (x) = 1 has always
been a nuisance, since it is of sum-type, which imposes profound difficulties.

(TRIG t1 t2..) -Trig-simplify tensors using the sumrelation described above
    optimally.

(WTRIG t1 t2..) -As TRIG, but write result.  These are what in Sheep is called
    "tenval functions" (expects TENsor or VALue arguments), ie you can do eg:
                            (WTRIG RIC FROM 0 0 TO 0 2)

(WTRIGLOOP) read/eval-tester.  Input :XS for 1-cos@^2, :XC for 1-sin@^2 etc.

Hyperbolic functions are SINH,COSH,TANH,COTH,SECH,CSCH.  (W)TRIG understands
    these, and exploits the sumrelation COSH(X)@^2 - SINH(X)@^2 = 1 analogous to
    the trigonometric relation.  All switches affect hyperbolic simplification
    exactly as trigonometric, even if not explicitely stated below.

SECCSC switch ^[on^] -use SEC and CSC (and SECH,CSCH) for negative powers of COS
    resp SIN, to compress output.  All six trig-functions (and hyperbolics) are
    always allowed at input.  To compactify the results, all six are normally
    also selected from at output.  Since SEC/CSC are not known to eg REDUCE
    however, sometimes you must avoid them in output through (OFF SECCSC).

FACTRIG Switch ^[off^] -cause PDEF to factorize trigonometric functions given at
    input, ie PDEF puts all trigs into the tensorial part of the term.  This is
    necessary in order for the trigonometric simplifier to work, and is
    internally set by (W)TRIG.  But if you also want trigonometric
    simplification when working with indexed objects, then turn this and
    SUMSUBS on, and use e/S-DEF.

   For expressions so huge as to make time an issue, and which are intermediate
so a bit less than optimal compression is acceptable, then either or both of
TRIGHARD and TRIGB below might be turned off:

TRIGHARD^[on^] cause repeated search after change, ie expr to be worked through
    repeatedly, until a pass made no change.  If ^[off^] only one pass is done.

TRIGHARDRPT ^[5^] -maximum number of passes that TRIG does - limit for practical
    reasons.  You might increase it, or reissue TRIG-commands.

TRIGB^[on^] activates search also "backwards", into combinations of trigonometric
    powers that are missing altogether.  Such "holes" can otherwise be overseen
    by the alone TRIGN procedure.  However, if all (most) trigpowers are
    represented, regardless with what coefficient, you might turn off TRIGB
    with no (small) loss in reduction.

TRIGN^[on^] activates the Normal, main search.  Should be left on regardless of
    TRIGB.

WHILE COMPUTING COMPONENTS                                      Page 8-3


TRIG0^[off^] activates "quick and dumb" search.  Better than trivial one-way
    substitution though.  If used, turn off those above.

EXPANDLIM!* global ^[4^] -max power causing expansion when typing (A+B)@^n to
    SHEEP.  Increased by (WTRIGLOOP).

SINCOSKEEP switch ^[off^] -Keep SINCOS internally.  Technical:  sin(x)@^p cos(x)@^q
    is internally represented as the more compact (SINCOS X P Q) by TRIG, which
    normally translates back when done.  By (ON SINCOSKEEP) the SINCOS is kept,
    saving space and time.  Drawback:  Little immediate SHEEP-simplification
    occur when multiplying such SINCOS-expressions; most reduction is then
    postponed to the TRIG-step.



8.3  ^<<MIXING STENSOR AND SHEEP^>>

Currently, substitutions in normal SHEEP require exact matching, ie a template
A*C will not match eg A*B*C or even B*A*C or 2*A*C.  As STENSOR substitutions,
matching will of course succeed (when proper,ie not in A*B*C if B noncommutes).

On a virtual machine, extra code does not matter so much, so all SHEEP-commands
may at little extra cost instead be run from within the STENSOR executable
image (which contains all SHEEP-code too), with all STENSOR facilities at hand
in case problems turn up.  Here are some hints on what can be done.

                  ADVANTAGES OF RUNNING SHEEP THROUGH STENSOR
                        - are that you at any time may:

1) -interactively PDEF and MAKE new tensors at will, satisfying any hunch.

2) -fully simplify tensors containing trigonometric functions,
                        by simply typing eg. (TRIG RIE) or (WTRIG RIE)

3) -Use own STENSOR substitutions occasionally through WTRIG
        Example, turning constants A*B to symbol AB as above:
        (SETSUB TSUL)   <A><B>@$         <AB>@$
        (WTRIG RIE)     -will now find A*B also in 2 A*C*D*E*B*F etc.

4) -Use STENSOR-formate throughout for your componentwise calculation:
        (SETSPLIT DSPACE 0 1 2 3)       @% Set up TOTAL split (ie componentwise)
        (LOAD "GFRAME.DEF")             @% -or CORD, or whatever.
        (ESPLIT GDF GAM ... RIE) etc.   @% (Compute GUU normally)

                ^<_OCCASIONAL STENSOR ACTION THROUGH (W)TRIG^>_

In 2 and 3, (W)TRIG does the following things:

 a) Translates from SHEEP- to STENSOR- representation, thereby "separating"
                ie putting into the "tensor" part functions with a FACTOR-flag,
                which is trig functions, but also A and B since they are pre-
                ceeded in the SETSUB template with a "<".


WHILE COMPUTING COMPONENTS                                      Page 8-4


 b) Affects RIE-components (all or those specified) with the SDEF actions:
        I: Runs TSUL-substitutions,turning sin,cos,..csc into "SINCOS" but
                also carries out whatever TSUL-substitutions you have set up!
       II: Simplifies, and combines terms with the same "separated"-part,
                giving eg (k+x@^2-3y..) SIN(X) (A) (B). This "partial
                factorization" may give huge storage savings compared to the
                normal SHEEP-formate of everything expanded.
      III: Runs SUM-substitutions, ie for the trig-simplification, but
                YOU MAY ALSO ADD YOUR OWN SUM-SUBSTITUTIONS!

 c) Translates back from STENSOR- to SHEEP-representation, but keeping
                the storage-economic "partial factorization".

This is done on all tensor components, or on those specified, eg by
                (WTRIG RIE FROM  0 2 1 3  TO  2 3 2 3)

(Tmp Note: After TRIG on some tensors, like GDD, do (LSIMP GDD) to expand the
        partial factorization before (MAKE GDET), since GDET prequires a GDD
        in normal canonical SHEEP-formate. So does any BULF for adding a lone
        tensor with something else, ie that lone tensor must be canonic.)

The above translations may be avoided:

                ^<_COMPONENTWISE COMPUTATIONS ENTIRELY IN STENSOR FORMATE^>_

Ie 4) above, is recommendable when you have:
        1) -substitutions that are many,and/or should be used in many tensors,
        2) -need to specify ORDERING of objects;affecting writeout/grouping.
                        Use ORDER and/or BUCKET
        3) -need Truncated Power Series. Slower than DEC-SHEEP,but more general
        4) -storage problems, since factorization may cut need a factor 2 or 3
                by suitable choice of objects to factor (and easier to read),
        5) -LARGE storage problems, which are solved by BUCKETING (see manual)
        6) -Non/Anti-commuting objects involved, since SHEEP presumes everything
                commutes. This has been used eg for differential forms.
                (A possibility also for 3) is to represent at entry the product(s)
                as strings, eg AB, which are not resolved and acted on until by
                STENSOR in a TSUL called by WTRIG,and then in SSUL-s stringify)


                ^<_MIXED COMPONENT/INDICIAL COMPUTATIONS^>_

In the instructions for 4) high above, the (SETSPLIT DSPACE 0 1 2 3) sets up a
TOTAL split, but in many so called "component-wise" computations carried out,
not all of the coordinates are on different footings. Often, due to
space-time symmetries, two (or more) coordinates occur in the metric in the
same fashion (eg both missing, or with equally unknown functions f and g).
Or if the metric is (anti)-block-diagonal.

  Then one should NOT treat these coordinate directions separately, but let
SYMBOLIC indices represent them both! Thereby contractions are not expanded
into: "0+1+2+3" but into say "0+1+a" -ie with a symbolic dummy index
representing coordinates 2 and 3! Since a hierarchy of tensors involve many

WHILE COMPUTING COMPONENTS                                      Page 8-5


contractions, this PARTIAL SPLITTING can give large earnings in machinetime,
and improve clarity and readability of the result!


For partial splitting, load GFRAME.DEF, or CORD.DEF etc, and:

- Agree these coordinates are last, say (2,3) -just numbering convention.

- Introduce the subspace they span, giving it some name, tell its dimension,
        (INDEXTYPE SUB (DIM 2) A B C..)         @% -and indices to represent it.

- Then, you instead of FULL split do a PARTIAL:
        (SETSPLIT DSPACE 0 1 SUB)       @% -into SUB (-space) instead of 2,3. 
        (ESPLIT GDF GAM...RIE)          @% This (splits and) evaluates the splitted



8.4  ^<<COMMANDS FOR ORDINARY SHEEP-SUBSTITUTIONS^>>

-that can be called from naked SHEEP after (LOAD "SELFLD.STS"):

(SETSUBFOR sulis x a1 a2..an) mask(x)@$ repl(x)@$ -Sets up n substitutions:
    mask(a1) into repl(a1),..., mask(an) into repl(an), ie the single
    substitution pair provided (mask,repl) is duplicated with x being a1...an.
    Example:  (SETSUBFOR ESUL X A B C D) SIN(X)@^2@$ 1-COS(X)@^2@$   -sets up four
    substitutions:  SIN(A)@^2 into 1-COS(A)@^2,....and SIN(D)@^2 into 1-COS(D)@^2

  Variable list:  If a1...an are omitted, then the variables as declared by
    VARS are used instead.  Eg after (VARS A B C D) the above could be done as:
    (SETSUBFOR ESUL X) SIN(X)@^2@$ 1-COS(X)@^2@$   Sulis and x may NOT be omitted.

  In-symbol-change:  When duplicating the single mask(x)/repl(x)-pair, the
    x-character is replaced with a1...an also INSIDE SYMBOLS - this is for easy
    introduction of new "kernels" to save working space.
    Example:  (SETSUBFOR ESUL X A B C) X@^(1/2)@$ SQRTX@$   -sets up substitutions
    A@^(1/2) into symbol SQRTA,..and C@^(1/2) into symbol SQRTC.
    Example 2:  (SETSUBFOR ESUL X H FI) COS(X)@^2@$ COSX2@$
    -sets up substitutions for:  COS(H)@^2 into COSH2 and COS(FI)@^2 into COSFI2.

  Diff-know-how:  When the replacement is a symbol (as SQRTC or SINFI2 in above
    examples), differentiation properties are set up (if missing) for each
    symbol by differentiating the template (ie C@^(1/2) etc) w.r.to all
    variables.  Thus SHEEP automatically knows how to differentiate any new
    kernel introduced.

  Warning:  Since "In-symbol-change" is done in mask/repl, use a rare character
    as 2:nd arg s.a.  X,Y or Z.  Else eg (SETSUBFOR ESUL I) SINI2 @$ 1-COSI2@$
     -would cause substitutions for SANA2, SBNB2,...
    In-symbol-change is inhibited if a MULTIcharacter 2:nd arg is used.
    Technical:  In-symbol-change is done on ALL symbols inside mask/repl at ANY
    lisp-depth, example:  (SETSUBFOR ESUL X) TAN(X)@^2 @$ SINX2/COSX2 @$  -where
    repl is not a symbol, but a deep lisp-structure in which eg symbol COSX2 is
    found and changed to COSA2 in one of the substitutions set up.

WHILE COMPUTING COMPONENTS                                      Page 8-6


    However, "indicators", ie symbols occuring FIRST in lists, are excempted.

(INVSUBS sulis t1 t2..) -invert substitutions "sulis" on tensors t1,t2,...
    Does LSIMP on t1,t2...  with a temporary ESUL made by inverting sulis.
    The argument "sulis" should be either:
                1:  -a list of (mask repl)-pairs explicitely given, or
                2:  -a symbol which has a list as value.
    The explicit list eventually pointed at, may be, or not be, a proper
    substitution list, ie start or not start with "SUBS".
    Good for eg inverting a previous temporary kernelization, after that the
    work-space critical computations have been successfully performed.

(ESULON esul t1 t2..) LSIMP tensors t1 t2..  with esul as ESUL-list.

(INVSULDO sulis cmd1 cmd2..)  -as INVSUBS, but you specify the commands.  Eg
    (INVSULDO suli (MAKE tsr..))



8.5  ^<<WTERMS - WRITE NBR OF TERMS^>>

(WTERMS tsr) -Write the number of TERMS in each tensor component.
    Takes tensor-specifications as args (in same way as MAKE and other TENVALs)
        -and W-rites the number of TERMS that each tensor component contains,
        -or if just ONE term, indicates the type of term.
    Example: (WTERMS RIC FROM 0 2 TO 2 3) -might cause the following:
       -row-by-row output:   	-showing that the specific component contains:

       ((RIC 0 2) PLUS . 97)   	- *** a SUM of 97 TERMS ***  This is the usual.
                           	Let us suppose the remaining components did NOT
                           	contain sums. Then instead of PLUS, some other
                           	symbol is used,telling that the single term is:
       ((RIC 0 3) TIMES . 9)   	-a product of 9 factors, or only
       ((RIC 1 2) EXPT . 2) 	-an EXPonenTial, sin, cos etc(with n args), or
       ((RIC 1 3) 64)      	-simply an "atom": then entire value is shown
       ((RIC 2 3) 9 . 17)   	-also when value was a RATIONAL number(9/17)

    (ON NOZERO)         -excludes zero-components from being listed.

    Used to eg:
        -Obtain an instant overview of the computational COMPLEXITY.
        -Compare results,to find OPTIMAL combination of multiple SUBSTITUTIONS.
        -Forecast computability of the next object. The hard way to know,is to
                        waste cpu-days, just to finally find memory exhausted.
                        A "nogo" lets you know that further action is worthwile
                        eg economize by "kernalizing". See SETSUBFOR in SHPSUB.

(DOFOR x (v1 v2..) do1 do2..) Perform do1,do2..  for x = v1,v2..  Carries out
    commands do1,do2,...  with x everywhere replaced with v1.  Then again, but
    with x replaced with v2 etc.  The commands do1,do2,..  may be any commands,
    eg FEXPRs, since the x is substituted for in all the do-commands (binding
    of x would not work in fexprs).

WHILE COMPUTING COMPONENTS                                      Page 8-7


    Example:  To compute, save and lose RIC row by row, type:
    (DOFOR x (0 TO 3) (MAKE RIC FROM x x TO x 3) (SAVETN x) (LOSE))
    -whereby files 0,1,2,3.SHO each will contain a row of the ricci-tensor.
    The LOSE at the end rids primary memory from the components just computed,
    so they do not infer on the working space for the next computations.
    In heavy computations this is often a must.
    DOFOR is often put around an IOMAKE, which does several operations on an
    individual component (x):
    (DOFOR x (0 TO 3)           @% Ie for X = 0,1,2,3
      (IOMAKE (PREFIX) (VEK x)  @% Get file VEK0.SHO (VEK1..) 
           (LOAD "SUBSTA.SUB")
           (PREFIX A) (VEK x)   @% Lsimp and save result as AVEK0.SHO
           (SETQ ESUL @'(SUBS))  @% Reset sublist for next eval of the IOMAKE.
      ))
    Note:For do-commands expecting formula input, formulas must be supplied
    AFTER the DOFOR-command, and in enough amount, each formula ended with @$.



8.6  ^<<IOMAKE - IN/OUTPUT MAKE^>>

(IOMAKE t1 ^[cmd^] t2..) -MAKE that does In/Output to files, and by itself
    intelligently combines MAKE,LOAD,SAVETN,OUTF,WRITE etc.
    Mostly for doing large computations, with IOMAKE-commands in a commandfile.
    When the commandfile is first run, IOMAKE does "MAKE" ie tensors are
    computed, but are in parallell saved on disk.  Eventually, a large job is
    normally stopped due to CPU-time or memory overflow, since it is difficult
    to know on forehand exactly what substitutions etc that are optimal.
    Except for such "tuning" of the commandfile, you then let it run again,
    unchanged.  This time, the same command (IOMAKE t1..) will not recompute
    t1, but find the previously computed result on disk, load it, and after
    negligible time reach the previously memoryblowing tensor t2, maybe succeed
    in computing it, but stopping on t3.  Then new adjustments and reruns from
    last position, but all the time the same commandfile suffice, since IOMAKE
    adjusts and exploits previous history.

    Intervened between tensor arguments, any commands may be given, eg turning
    ON/OFF switches.

NOLOAD -switch ^[off^] which if on cause IOMAKE to ignore previous results on
    disk, so recomputing in core, and (unless NOSAVE on), store anew on disk.
    Turn on NOLOAD (or delete the previous file) if recomputation is desired.
Other switches, most normally off:
SLEEP	Cause IOMAKE do nothing for args being tsr/value symbol
NOSAVE	No (SAVETN tsr tsr) after computed
NOLOAD	Dont try load before make
WOUT    	Write to tsr.LAM after make
MTERMS	WTERMS on tsr if just M-AKEd (not if loaded)
FTERMS	WTERMS output into a File tsr.WTE (default)
MTRIG	TRIG on tsr if just M-AKEd (not if loaded)

WHILE COMPUTING COMPONENTS                                      Page 8-8


(PREFIX sym) Cause files to have names starting on "sym", so eg RIC is saved as
    "symRIC.SHO".  Reset by (PREFIX).  Sets PREFIX!*.
Sample use:
(PREFIX GDL)            @% Possibly setup string for filenames to start on.
(IOMAKE  (ON SLEEP) GUU GSGUU   (OFF SLEEP WOUT) GAM            @% Compute GAM
         (ON WOUT) RIEGS)               @% Cause WriteOUT when computing RIEGS
         RIE (LOAD SUBS) (PREFIX C)     @% Set new prefix since new subs
         RIE )          @% This 2:nd RIE cause LSIMP, and SAVE in file CRIE.*
The two RIE-versions are saved as RIE and CRIE to distinguish between them.  If
prefix un-changed, then do nothing at repeated RIEs.
Enclose interval specification in parens, eg (IOMAKE (RIC FROM 1 1 TO 2 3))
        -here file will be:  RICF11T23.SHO













                                   CHAPTER 9

                          BUCKETING, BATCH AND ERRORS



9.1  ^<<BUCKETING AND AUTOMATIC DISK USAGE^>>

SUMMARY:
(BUCKETS (X) (Y) (Z))           -specify which buckets to use; in general,
(BUCKETSFOR TSR (X) (Y) (Z W))  -and for TSR specifically.
(BUCKET TSR)              sweep the TSR-def into TSRB1, TSRB2, TSRB3...
(eDEF TSRDEP)             TSRDEP inherits TSRs bucketing, through evaluation.
 BUCKETOUT switch ^[off^]     cause automatic disk i/o of bucketexpressions
(BUCKETINIT TSRDEP)       reestablishes link to disk-TSRDEPBn made yesterday
 BUCKALG  = ((1 o1 o2..) (2 p1 p2..)..)  -Algebra: which out for which in.
        When sweeping out to a bucket more than once, you are noted on the
        existence of the file, and given the choices:
                1) Updating file thru fast mergeing to previous bucketcontents
                2) Choosing another extension of new file
                3) Overwriting previous file
                With NOASK on, 1) is performed as default without asking.
BUCKEXT global ^[TEF^] "Bucket file Extension". Read TEF as "Temporary dEF".
BUCKETCHAR global ^[B^]  Symbol used when constructing bucketnames, eg tsrB3


                                 INTRODUCTION:

If a long (unsimplified) expression "ANS" among other objects contain X, Y and
Z, then for two terms to possibly combine, these two must contain X, Y and Z in
the same combinations.  We can therefore make a fast partitioning, or "rough
sorting", of ANS into such different parts, hereon called "buckets", and can
then proceed to treat the moderately sized buckets separately one at a time.
This is a common strategy for handcalculations, it cuts the total time for term
sorting, but above all:  Only one bucket at a time need be present in core.

With BUCKETOUT on, STENSOR loads and writes buckets to disk automatically as
needed, and can thus treat expressions of sizes that are limited by diskspace
and CPU-time only (in a current application on a VAX, 20.000 terms, of about 10
factors each, has been treated).

The basis X, Y, ...  need not be invariant under the substitutions etc involved
in the computations - "spillover" between buckets is automatically merged.  The
bucket sets may themselves change, as specified by the "Bucket algebra".  This

BUCKETING, BATCH AND ERRORS                                     Page 9-2


would as a special case include the most general truncated power series
expansion.

                                   MECHANISM

(eDEF TSR1 TSR2...):  -is affected as follows:
If any object, say BZ, in the TSRi-definition is found to be bucketized, then
only the 1:st bucket of BZ rather than its whole def, is inserted in the
TSRi-formula.
Also a flag is set to tell that a bucketized object occured in TSRi.

After simplification of the resulting expanded TSRi-definition, this flag
causes the result to be separated, sweeping all bucket-one-type terms to the
def of a new symbol TSRiB1.  In exchange for these terms being removed from the
TSRi-definition, a term TSRiB1 is inserted instead.

Then the TSRi-DEF is evaluated again, now choosing the 2:nd buckets instead,
and after simplification, type 2 bucket terms are sweeped away from the result.

Treatment of one bucket at a time continues, until an evaluation did not find
any bucketized object with that high a bucketnumber.

The result is a TSRi-definition consisting of TSRiB1+TSRiB2+...+rest where the
remaining rest-terms occur only if they did not fit into any bucket.  TSRi
itself will have a BUCKETS property, ie be "bucketized", and thus if TSRi
occurs in the definition of some higher object TOP, then (eDEF TOP) will in
turn cause TOP to be bucketized as above.

To start bucketing, one thus only need to do (BUCKET tsr) on some basic object
tsr, and that will cause dependent objects be bucketized when eDEFed - ie
bucketization is "contageous".

BUCKETOUT -switch ^[nil^]   which if true causes buckets be put out on disk when
    computed.

(BUCKETS o1 o2 o3..) -Bucket specifications.    Specifies that those terms that
    contain all the objects listed in the list o1, should go into bucket 1.
    Then of the remaining terms those that contain all the objects in the list
    o2 should go into bucket two etc.  Thus note that the order in which you
    give the lists o1 o2..  may be important.  If any commutativity
    restrictions have been given (sets ORDERCHECK) then the ordering in oi is
    also important; a list oi=(X Y) will only sweep terms where Y occurs after
    X.
    Sets and returns the global symbol BUCKETS*.

(BUCKETSFOR tsr o1 o2..) -Individual bucket spec.    As BUCKETS, but specifies
    an individual bucketspecification to be used when bucketizing the object
    tsr, whereas BUCKETS specifies a bucketing which is used globally, for any
    object that has no individual specification through BUCKETSFOR.

(WDEFB tsr) -WDEF all tsrBi ie buckets of tsr (or try ..ALL ON tsr).

BUCKETING, BATCH AND ERRORS                                     Page 9-3


(EDEFB tsr) -EDEF all tsrBi ie buckets of tsr (or try ..ALL ON tsr).

(BUCKETINIT tsr1 tsr2...) -Initialize DEFs on tsri to only contain a sum of the
    bucketsymbols.  This is for use on tsri that have no current definition in
    core, but at a previous session was computed and had its buckets saved on
    disk.  Thus BUCKETINIT re-establishes the connection to any previously
    saved set of buckets on disk.

(BUCKETINIT ALL) is allowed, with the same meaning as for the zDEF-commands.
    This is convenient when resuming a calculation with many objects bucketized
    on disk.  Objects that already had a definition will be asked about and not
    replaced unless you confirm so.

WRITEXT global symbol ^[nil^] for a temporary extension different from BUCKEXT.
       You set this to non-nil  ** through the program **
       You reset it to nil by (SETQ WRITEXT NIL)

    Setting is when you answer No on the question "merge with existing file?".
    Then you get the prompter:

                      "Change ... extension?  Y for sticky."
    If then typing XXX (eg UEF), that is taken as new extension, but reasking
    will occur next time.

    If typing Y, a name inquiry will be repeated, but the XXX you then answer
    is made STICKY, so that whenever later answering N to the merge-question,
    writing of ...Bn.XXX will be done without the "Change ...  extension.."
    -question above.  The XXX is stored under WRITEXT and used until you do:
    (SETQ WRITEXT NIL).


                       RESTARTING FROM SPECIFIC BUCKETNUMBER

BUCKETSTART global ^[1^]  1:st in-bucket.    Tells the number for the first
    in-bucket to be taken.  Then successive buckets are loaded.  The default
    value causes the 1:st bucket to be inserted first, but by eg:
    (SETQ BUCKETSTART 3)   -you restart from the 3:rd if you have already
    computed the previous 2 and want to resume from there on.
    In case of memory crash, you see from the dates of the bucketfiles that
    have been written (and BUCKALG), which the last completed in-bucket was.




9.2  ^<<BATCH FOR REPETITIVE/TEDIOUS WORK^>>

-This can be eg recreating a .BLF-file whenever you have done some modification
to a set of definitions.  Then you can eg put all commands in STENSOR.INI and
create a batch-file with the single contents:  STENSOR
Name the batch file as (on VMS:  myfile.COM, on DEC:  myfile.MIC), and run it
by typing:    SUBMIT or COJOB myfile   -then the STENSOR-command will be issued
as a separate job (ie you can do something else meanwhile).  As usual it loads
STENSOR.INI and performs all its commands, among which can eg be:  (TCOMPOUT

BUCKETING, BATCH AND ERRORS                                     Page 9-4


tsrfil ALL).
The interaction is recorded in some file like "myfile.LOG".  To see the
commands together with response however, they must be in the batch file, not in
STENSOR.INI (on DEC then change each "@'" into "@'@'").
Work done in batch is usually allowed more memory and CPU-time.  You can also
at day submit a file to be run later at night (at low load) and investigate the
result next day.  Try monitorcommand HELP with argument COJOB, BATCH, SUBMIT.
On VMS, try STECOJ.
              Strategy for LARGE CALCULATIONS (experienced only):

     1.  Create a temporary MYSTENSOR-version, with a MYSTEUP extended to load
         the DEF-files (with all the PDEFs, SETSUBs etc that you are sure on)
         for your application.

     2.  Work some days interactively, testing out what questionable further
         substitutions etc are best to use.  At each startup of MYSTENSOR you
         are saved from awaiting the 100 or so SETSUBs etc from step 1.

     3.  When sure on rules to apply on say ANS, submit a file containing eg:
         (EDEF ANS), some SDEFs on it, creation of a SEF- and (maybe from part,
         with SE) a WEF-file (see those).

     4.  Next day read WEF- and LOG-, and size of SEF-file.

     5.  If the ANS wasn@'t satisfactory, add necessary extra rules (to eg the
         batch file) and before the e/s-DEF commands put in:    (LOAD
         "ansfil.sef") -to restore the result from previous night for e/s-DEF
         to work further on.

     6.  Submit the new batch file (go to step 3).

Interaction is however to prefer, if you can work at off-peak hours.



9.3  ^<<ERROR MESSAGES^>>

Warning messages (***) are in the source code marked "@%:war".
Explanations of them are marked "@%:w".
For error (*****) messages, corresponding marks are "@%:err" and "@%:e".
Do a search for these as explained in last chapter, switch TIARG (Cfr
ALLKEY.COM) The text is too voluminous to include here.  In later versions, try
HELP or so after err/warning, that is planned to look up the further
explanation.

If from LISP, then try cures below.  Then redo error with !*BAKGAG true.

"Undefined function" -check your spelling of the command.  Selfloading?  Make
    sure "earlier" files are loaded by running topfunctions first, PDEF, EDEF,
    SETSUB..  , or load by hand, eg:  (LOAD TSRSP).  See if given in
    STE:BASOLD.STS.  Look for definition by (on VMS):
                         SEARCH STE:*.STS "somefunction".
    Might be unessential - try:  (DF somefunction (X) NIL) or ..T) or ..X).

BUCKETING, BATCH AND ERRORS                                     Page 9-5


"Can@'t find file"   -try to load by hand, specifying directory.  To operating
    system do   DIR   on file on different directories.  Take from tape?

"Directory not found"   -check directories STS, SHP, LSP.  (On VMS by eg:  SHow
    LOGical STS).  Should be specially set on your installation by changing
    some file (On VMS:  xyz:DEFLISP.COM, which should be run by LOGIN.COM.   
    On DEC:  PATH.CCL run by SWITCH.INI)

"Too many (or few) actual parameters"   -occurs when a function was called with
    more (or less) arguments than it was designed for.  There are at least two
    possible reasons:
    1) When setting a substitution, the user actually designs a function, on
    the "active tensor".  This takes as arguments its indices.  If the user
    then substitutes on an expression containing the same tensor (full-) name,
    but with a different number of indices (wrong rank), then this error will
    occur.
    2) A program error.  Then report, see below.



9.4  ^<<REPORTING AN ERROR^>>

Please send a report if you find an error which is really due to the program.
Try to reproduce the error from startup in as few commands and on as simple
expression as possible, and if the symbol !*BAKGAG has value NIL, then before
generating the error type eg:
                               (SETQ !*BAKGAG T)
-which then causes Lisp to give a backtrace of which functions and lisp
structures were entered when the error occurs (most recent, acutely causing the
error, first).  Send in the interaction from startup (including STENSOR.INI if
any) to and including the first page of the backtrace.
If you have no printing terminal, run it as batch (see that), print and send
the log-file.

Fast help offered by phone:  Best is afternoon to midnight, at home (where I
work) in Stockholm:  (your foreign prefix and:) 46 8 837114.  It doesn@'t cost
many seconds to put forward a question if it is prepared.













                                  CHAPTER 10

                FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP



Although these facilities can be very useful in their context, they are so
special that the novel user can do without them and ignore this chapter at
first reading, or only aquire a superficial comprehension of when the
facilities may apply.

If need occurs though, do not pull back because of some LISP is involved; most
of it is explained as we introduce it.  Also therefore this is a separate
chapter, to avoid cluttering the rest of the manual.



10.1  ^<<FUNDAMENTAL LISP-COMMANDS/CONCEPTS^>>

This paragraph explains to the novice user the Lisp-terminology used in some
places elsewhere in this manual.

Value of a symbol   -is obtained simply by typing the symbol, eg:

    ORPANLIM<return>    Type this funny symbol, then end as usual by
                        pressing the <return>-key.
    5                   The system answers back the value of ORPANLIM.
    STS>                        -Then prompts the user to type something more.

UNBOUND VARIABLE   Only some symbols have (are bound to) values, else they are
    said to be "UNBOUND".  If you eg type:  HELLO <return there will be a
    nonunderstanding reply "HELLO unbound variable".  Upper and lower case
    symbols are normally different, thus eg "orpanlim" is unbound.  NIL and T
    are special symbols that have themselves as values (try).  Also numbers
    evaluate to themselves.

(Lisp-)Evaluation is the name of the process that obtains values as above -
    however also parenthesized expressions can be evaluated, eg if you type:
     (A B C)  The meaning of this is that "A" is a function that should be used
    with "B" and "C" as arguments.

Lisp-functions are symbols that are equipped with a recipy for dealing with
    some arguments.  Since "A" has no such recipy, the above typing will result
    in:  "A undefined function".  To call a function, you must preceed its name

FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-2


    with a "(" which after possible arguments (with spaces in between) must be
    matched by a closing ")".  Nothing will happen until that closing
    parenthesis is typed, even if you push returns.  Remember this when you
    give commands, since all STENSOR commands are examples of functions and
    must be typed in this fashion.  Each argument may itself be a parenthesized
    expression - then it should also be locally balanced.

EVAL Lisp evaluator.    The lisp-thing that does the miraculous evaluation in
    between two prompters, is additionally available to you in the form of a
    function; it is called "EVAL".  Here is another, very simple function:

QUOTE or "@'" -inhibits evaluation:  Try to type (QUOTE stupidvax)   -and back
    comes the result:    stupidvax.  Whatever argument given, the special
    function QUOTE does its job by returning it unchanged without objections.
    This obeyance is of such a demand, that an abbreviation exists; a single
    "@'" -prefix, eg   @'stupidvax.  This is evaluated to:    stupidvax, ie
    evaluation strips a prime, ie (EVAL @'x) is the identity operator, ie "@'" is
    the (right) inverse of "EVAL".

(SETQ EXPANDLIM!* 7) -sets value.  This was only a common example.  SETQ is a
    Lisp function that wants a symbol as 1:st argument, and its desired value
    as second.  Eg do:  (SETQ ORPANLIM 6) and retype the example under
    "Value..." above!  Try set a SYMBOL as value, and you@'ll notice that the
    second argument was evaluated (isn@'t noticed for numbers - a 6 evaluates to
    a 6).  To neutralize that evaluation, you QUOTE the symbol with "@'"
    remember?  Eg:  (SETQ stupidvax @'liar) makes the following dialogue
    possible:

    STS> stupidvax              The user types in the symbol
    liar                        -and the EVALuator picks up and prints the
                                value that we have just set
    STS>                        -and is ready for more offences.
    "SETQ" stands for "SET, but Q-uote 1:st argument" -as you could see above,
    we put no "@'" on the 1:st argument - that is inherent in the function.
    A frequent jargon is "set humhum true". This means do: (SETQ humhum T)

Funny Characters -are accepted with "!" in front of the character.  Eg
    :;,?@%@$+-*/ etc.  If we only type:    stupid vax   -this is interpreted as
    TWO symbols.  For the blank (or anything else non-alphanumeric) to be
    accepted as part of the symbol, preceed with an exclamation-mark.  Ie
    everywhere above use the (new) symbol:    stupid!  vax.  Used in eg DECLT
    for funny printout.

    SETQ is special in that it Q-uotes one arg, and not the other.  Most
    functions does either on all arguments.  User commands normally quotes, and
    are of a type called F-EXPRs:

FEXPR -function not evaluating its arguments:most commands are of this type.
    In the source code, these are lisp-defined by eg:  (DF EDEF (LST) ...)
    where

    DF means: Define Fexpr.

FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-3


EXPR -function that Evaluate its arguments, internal functions mostly - in code
    you can see eg:  (DE ATOMR (X) ...) where

    DE means: Define Expr.  In lisp itself, most functions are EXPRs.  The
    functions below are therefore mostly used with @' on arguments.

    For a given function you can by:  (GETD @'FN) -Get lispDefinition - see what
    kind FN is.  Below, @' is supressed.

(PLIST atm) -Property List of a symbol.  Result is of type:  (p1 v1 p2 v2..)
    -with alternating p-ropertynames and corresponding values.  After PDEF a
    tensor gets:  (DEF (alg...)  PRT PRTEN  FACTOR ((rank) sym...) etc.  Try on
    operators and tensors after SETSUB, which gives many properties.  Cfr
    TENPROPERTIES.
    (GET atm prop)	-get just one property.
    (PUT atm prop value)	-put up property.
    (REMPROP atm prop)	-remove property if any.
    LIST, CAR, CDR, CONS, APPEND etc will later be described



10.2  ^<<SPECIAL PRINTING OF TENSOR/INDICES^>>

SUMMARY:If the effects of NAM, up/down and TNSPCH (see DECLT) do not suffice,
you may construct your own printing functions PRT0,1,...  and choose them
generally with (SETQ PRINTFN @'PRT0) and/or individually with
(DECLT (tsr1 (PRT PRT1)) (tsr2 (PRT PRT2))...).  TCOMPOUT saves also the PRTs.

PRINTFN symbol ^[PRTEN^] The value of PRINTFN is put as PRT-property on each
    symbol following a "<" in a PDEF-formula (and the one defined).  This
    PRT-property is used at printout, and should be a function name or lambda
    expression, taking as single argument the whole list of the tensor name and
    its indices/arguments.
    It should return the same list with up/down indicators inserted (see
    SHEEP-manual).  This last step can normally be trusted the function PRTEN,
    but first changing the indices can be useful:


      Example: To cause numeric indices 1 and 2 print as "+" and "-" then first
      define a function that investigates a single index:
      (DE PLUMIN1 (I) (COND           @% DE = DEfine, COND = Conditional, when:
        ((EQUAL I 1) @'!+)             @% the Index is 1, then return + instead. Same
        ((EQUAL I 2) @'!-)             @% for 2. @'=quote. ! must precede funny chars.
        (T            I) ))           @% If T (=True, ie always otherwise) return I,
            @% ie all other number or symbolic indices are returned unchanged.

      @% Use that, when DEfining the new PRT-function, that should take as argument
      (DE PLUMIN (L)  @% a list L of tensor and indices, eg "(TSR 0 2 1 3)"
       (PRTEN         @% Let PRTEN do the job. (PRTEN L) would give standard result,
        (CONS         @% but here build up a different L: CONS pushes on a list,
         (CAR L)      @% the 1:st element of L, ie TSR, onto a
         (MAPCAR      @% changed indexlist, namely the result of replacing each
          (CDR L)     @% element in the tail of L, ie of (0 2 1 3),

FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-4


          @'PLUMIN1    @% with result of PLUMIN1 used on the index,giving (0 - + 3).
          ) ) ) )     @% Close all left parentheses that were opened from (DE...
      @% Final argument to PRTEN then becomes: (TSR 0 - + 3) with desired effect.
      @% (You can omit comments, and write all code in one line)

      @% To cause all subsequently introduced objects to get this function
      @% as PRT-property, we set it as value of PRINTFN:
      (SETQ PRINTFN @'PLUMIN)

    To occasionally put up the different PRT-property, instead use:
    (DECLT (tsr (PRT PLUMIN)) )     @% where tsr is the tensor, or as usual:
    (PDEF  tsr (PRT PLUMIN)) ... @$  @% -if also assigning a formula.
    TCOMPOUT saves also the PRT-property of a tensor, if it was not the usual
    PRTEN.

TENPROPERTIES symbol whose value is a list of property names.  Default value is
    (PREQ DEP TNSPCH NAM UPINDX ZEROMSG).  This list is used by DECLT/PDEF and
    TCOMPOUT:  To cause TSR to under propertyname Pn have VAL, do:  (DECLT
    (TSR Pn VAL)) or (PDEF TSR (Pn VAL)) ...@$.
    TCOMPOUT saves for each tensor those of its properties that are in this
    list (plus the PRT-property if nonstandard).
    If you by typing:  (SETQ TENPROPERTIES (CONS @'MYPROP TENPROPERTIES)) extend
    this list, you can thereafter assign your own MYPROP-values with
    DECLT/PDEF, and save with TCOMPOUT.



10.3  ^<<PUSHV AND POPV^>>

(PUSHV atm val) is equivalent to SETQ, except that the old value(s) is stacked
    on a list under property PUSHV, and can be restored by POPV.  The stack can
    have any length, ie PUSHV/POPV can be repeated or nested.  Used to eg allow
    a library file to set globals then pop back at end of file.

(POPV atm) restores the most recent previous value of atm, and returns the
    remaining stack of values.  Example:  A file containing:
        (PUSHV EDEFASK NIL)     ; turn off asking
        ...P- and EDEF-commands etc...
        (POPV EDEFASK)          ; turn back asking to whatever previous value.



10.4  ^<<SUBSTITUTION PROGRAMS^>>

     Technically, an STENSOR substitution is carried out by a tensor changing
its environment through an individual "substitution program" or "SP",
associated to it.

     The SP consists of a "Sensory" part (checks e.g.  neighbouring
factors/terms) and a "Processing" part (through which, if the sensor was
trigged, any arbitrarily distant changes may be done in the formula - important
for e.g.  the sumsubstitutor).

FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-5


     All commands that set STENSOR substitutions are doing so by creating an
appropriate SP from the input.  For the example:

     (SETSUB) <A ...><B ...> ...        setting a substitution of a product of
two tensors A and B, SETSUB will for tensor A create a SP which:  searches if
tensor B with proper indices occurs in the same term, and if so replaces A with
C and removes B.

     The first tensorial factor in the input, here tensor "A", is chosen as
"active" tensor (for which to create the SP) just as a convention.  (However,
if both objects with, and without, commutation restrictions occur in the mask,
the former have preference as active.) You can thus (for speed) preferably put
the most rare tensor first when specifying substitutions.
The same tensor may have any number of SPs.  They are executed in order.

     The switches below are tested only at SETSUB call-time, and affects the
design of the SP created.  Thus by changing them in between SETSUB-calls, you
may give different permanent characteristics to different substitutions.

SRCHRIGHT switch^[off^] -restrict searches rightwards in products (while normally
        substitutions search throughout the whole term).  Thus, an SP on A,
        that search B would not be trigged in B...A, only in A...B.

SRCHONCEswitch ^[off^] -inhibit normal re-searching of the SPs to the left in a
        term, after one SP has changed it.



10.5  ^<<MAKING SUBSTITUTION PROGRAMS BY HAND^>>

This paragraph is for the LISP-programmer only; the substitution programs that
SETSUB et al create automatically should suffice for most practical purposes.
One should especially study the interaction between different substitutions and
wildcards; intelligent combinations of them can achieve surprisingly much.  But
if you are sure you need a substitution-program so irregular that it can@'t be
created through SETSUB, here is described how to make one by hand.

If commands (SETSUB xSUL) <TSR..>..  @$ have been issued k times, then TSR will
get a property xSUL (normally TSUL) that is a lambda-expression of r arguments
(the rank of TSR) where the body is a COND-expression:
(LAMBDA (INDX16-r ... INDX16)     ;(all arg-lists are various pointers into
 (COND                            ; one and the same list, to save space)
  (SP1)                 ;SP to sence and perform the first substitution set
  (SP2)
  ...
  (SPk) ) )             ; dito for the last substitution set.
The SP1-SPk are the substitution programs created with the k SETSUB commands.

(HNGIS xsuprop tix sp) HaNG/Initiate Sp-program.  This is the function to use
   for hanging up a new sp at the end of an existing lambda-cond expression,
   where:

FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-6


sp is the new sp-program

xsuprop should be "(GET TSR LASUB)" for picking up the current lambda-cond
   expression, if any.  If that was non-nil, then sp will be hung on it.  If it
   was NIL, then it will first be initiated, so TSR, under the property
   indicated by the value of LASUB, gets (LAMBDA (...) (COND ((SP)) ))

tix is (TSR i1..ir), where the i@'s are only used to indicate the rank so the
   lambda argumentlist (...) above can be created when initiating.
Each SP is a single Lisp S-expression, containing both sensor and processing
part.  The SP should reference two global symbols that one could call "headed"
pointers, ie.  they point into lists, but on the element BEFORE the current.
!*RTNL "Remaining TeNsor List", pointer into the current term/product; current
tensor is (CADR !*RTNL) and not CAR.
!*SUM dito sum, ie current term is (CADR !*SUM).  An SP processes the
environment by using RPLACA/RPLACD on these lists, although through some
functions, eg:

(SPCTZ)         Cuts away current term (Substitution to Zero)
It is important what the SP returns. Here are allowed returnvalues/meanings:
NIL             The COND will check next substitution. TSR supposed to remain.
.... see further SDEF.STS
For simple interactive consultation one could eg use SP=(PROGN (BREAK0) (READ))
(again, this is better used as sidecondition that is run only after a normal
mask has been matched).



10.6  ^<<LIBRARY OF PRE-REQUIRED OBJECTS/FUNCTIONS^>>

You may use <DEL A B>,<RDEL A B>, <PMMM A>, <EPS3 A B C> and <EPS4 A B C D> in
your input.
When TCOMPing, arrays are then not declared for storing those special objects.
Instead a component value is readily recomputed whenever needed.  If calling
TCOMPOUT, the appropriate routines for computing values are saved and put in
the beginning of the produced .BLF-file, for them to function also in a naked
SHEEP.

   There might also be other lisp code put in the beginning of a .BLF-file,
that defines functions needed for computing some of the tensors TCOMPed
hitherto.  A few very small routines that always are needed are defined in
SUMBOU, but there are other routines that not always are necessary, and
TCOMPOUT putting those in the .BLF-file only when needed, thereby ensuring that
no workspace is wasted.

   If you TCOMPOUT two files of different tensors, then the 2:nd might contain
some routines only needed in the first.  This slight waste is most easily
avoided by restarting STENSOR for the 2:nd file.
Notes on other ways for this, and compilation, in QTCOMP.STS.

   If such a help routine has been over-written by a compiled user-function,
the following warning is issued:
                 "Preq-fn compiled,can@'t save it. Name-clash?"

FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-7


10.7  ^<<FURTHER INFORMATION^>>

See files *.hlp, man, doc and def.  Especially SEDIT.HLP and the *.DEF-files.

@%:hlp -a key in source code files, in a try to mark out some of the more
    important comment blocks, that give further information that might be of
    interest for the advanced user, but is too special or technical to (yet) be
    included in the manual.  A topic description follows at the same line.
    These are listed below, to give a table of contents.  It was produced by a
    search for "@%hlp" through all *.STS -files.  Redo to update it.  Here the
    "hlp" etc are stripped.  Filenames to the left.

          Table of contents for topics discussed in the source code:


 ALLKEY.HLP     File describing Keywords used as markers in comments
            and on VMS also tool to create a listing KEY.HLP    -by means
            of:   @@ALLKEY.HLP  KEY              -where KEY is any of:
            Key:        Meaning:
            UP (installation information),
            H (Help on STENSOR usage/functions. HLP for just headlines),
            E (Errormessages plus explanations),
            W (Warningmessages plus explanations),
            B (Basic,generally useful lisp-routines),
            S (some widespread Subroutines in stensor)
@%: hlp          -Marks a headline for a larger chunk of useful comments.
@%:      Headerfile by (on VMS):         SEARCH/OUT=hlp.hlp  *.STS  
@%:      Use @%: instead of  to include also the actual TEXT(with headlines)
@%:      Besides ,some old headlines are still marked @%hlp, so search both!
        ERROR-explanations by(on VMS):  SEARCH/OUT=errtext.hlp  STE:*.STS "@%:e"
        Dito for WARNINGS by (on VMS):  SEARCH/OUT=warntxt.hlp  STE:*.STS "@%:w"
        MNEMONICS FOR SPECIAL CHARACTERS USED IN VARIABLES/FUNCTIONS:

 EPSEPS.DEF  *****  Substitutions for EPSilon-EPSilon products ******

 FRAME0.DEF     Common fundamental part for all FRAME-versions.

 GDELTA.DEF     Generalized Kronecker DELtas, GDEL2 to GDEL4 defined.

 IDENTI.DEF  -a collection of tensor identities. Read below!

 IOMAKE.STS     IOMAKE combines MAKE,LOAD,SAVETN,OUTF WRITE,...
 (DOFOR x (v1 v2..) do1 do2..) Perform do1,do2.. for x = v1,v2..

@# MAKEFILE.      ******  Makefile to compile and make STENSOR  ******@%:up

 OPERAT.DEF     Examples of various operators, noncommutativity etc.
 (ZEROIFEVENBETWEEN T/NIL OPA OPB)  -cause OPA count indices n up to OPB,

        (COMMUTE t1 t2...) -invalidates any NEVERCOMMUTE(-BUT) -commands
        (WORDER t1 t2..) Write out the ORDER properties of t1, t2,...

PACKAGE.JEF;1

FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-8


 OPERAT.DEF     Examples of operators

PDEF.STS;61
        COPYRIGHT (c) RESERVED - LARS HORNFELDT
 Recognized to set in DECLT/PDEF as (prop val),and (CDR)saved by TCOMPOUT:

PDEFR.STS;69
        PARSPREFIX!*    GLOBALPREFIX!*  are sheep-globals used by FOIN that
 (FACTOR A B C..) declares functions A,B,C.. be put in tensor-part, ie
(SETQ MAXPOWER 9)  Turn <T>@^8 into <T><T><T>...,but put <T>@^9 in sclr part
        (DIFFPREFIX sy1 sy2..)  -gives symbols syi the same STENSOR properties

PDSYMN.HLP;1    Symmetry declarations

PDSYMN.STS      Symmetry declarations (that translate to Sheep)

QTCFAC.STS;3    FACTORIZATION done by TCOMP (experimental)

 QTCFCT.STS     **** Factorization available as user-commands *****
 Ex. (FACTORINTO GDET KOE SUM) - Makes KOE and SUM so that GDET=KOE*SUM

QTCOMP.STS;145
 LIBRARY OF CONDITONALLY PRE-REQUIRED OBJECTS AND FUNCTIONS.
 Vector PMMM is (+1,-1,-1,...) in any dimension:
 IFNEED - Declare tensor to only have NEEDED components computed
 Before TCOMP: Put FAC-property on tensors to have values of FAC-formate!
 PERMUSED       Internal symbol. List of PERMUTATION symbols ^[,^],(,).. used so

 README.TXT     S T E N S O R    INSTALLATION    GUIDE

SDEF.STS;17 **** STRUCTURE AND WORKINGS OF SUBSTITUTION PROGRAMS ****

 SEDIT.STS    EDITOR FOR STENSOR/Sheep/S-exprs.  See SEDIT.HLP,or do (SE)?
        SEDIT has MACRO-facility:

 SHPSUB   (SETSUBFOR sulis X) -very useful for setting Sheep-substitutions
 (SETSUBFOR sulis X A B...) -is like repeating SETSUB, for X being A,B..
 (INVSUBS sulis t1 t2..) invert substitutions sulis on tensors t1,t2,...

STECOJ.COM;24!@$ The command STECOJ submits a job that runs STENSOR. Examples:

!@$ STEUP.COM  In reserve to create STENSOR.EXE on VAX/VMS (Modify on UNIX)

TEDEF.STS;46 *** ROUTINES FOR INTERNAL BOOK KEEPING OF CONTRACTION INDICES: ***

TEDEFS.STS;16 OLD:  CDEF  *CONDITIONALLY*  PLUGS  IN  A  DEFINITION, ELSE AS EDEF

 TEDEFX.STS   Toplevel eXtensions, not always needed. Eg for GAMPRG.STS
 (MIT t2)       Does (PDEF MIT) <:last> - <t2>@$ Take last result MInus Tsr t2.
 (DI A B) Does (PDEF MIT) <:A> - <B>@$ Ie sets MIT as difference of A and B
 **** (TWINDEF T1 T2) and (COPYDEF T1 T2)  Give T2 same DEF as T1 ****
 (WEDIF t1 t2..) On each tsr: "repeat WEDEF until no change in its DEF"


FACILITIES THAT REQUIRE SOME KNOWLEDGE OF LISP                 Page 10-9


TEITYP.STS;17 INDEXTYPE-command is extended to set more properties, eg:

        TESUBS.DEF      Test of Substitutions. Illistrative examples.
" TESUBS.WEF (or the distributed version -.REFerence): SUBSTITUTION TEST.

 TESUBS.WEF (or the distributed version -.REFerence): SUBSTITUTION TEST.

(DOC) TRACE.DEF  TRACE operator and KAHANE-algorithm for gamma algebra

 TRACEV.DEF     Verifying some identities from TRACE.DEF

TSR23.STS;43 MAIN FUNCTIONS: (W)E,S and X-DEF on eL-ementary subspace-formulas:

TSRMI.STS;13 **** SMPFN for permuting MI of >= 2 indices:

 TSRSPO.STS SP-application: Substitution Programs,that implement Operators
 SINGLE STEP DIFFERENTIAL OPERATION, FOR INTERMEDIATE SIMP OF LARGE EXPRS
 ILLUSTRATIVE SP-EXAMPLE:       *** DELIMITER FOR DIFFOPERATORS: L/R-PAREN *** 
        (Anti)commutativity of object supposed remain after diffoperation:

TSRSPW.STS;5    (WILDCARD SYMB BODY)    HOW TO DEFINE NEW WILDCARDS:
 WILDCARDS: ?ANY, ?T, ?DIFFOPERATOR, ?END.      Extend easily using:
 PREDICATES for wildcards: ISNEVERCOMMUTING, ISALWAYSCOMMUTING, GETRANK

TSRSPY.STS;14 SPYING ON SP-PROGRAMS BY SETTING BREAK ON WILDCARDS/PREDICATES *

TSRTR.STS;60    More on the TRIG-simplier, election procedure info.

        UPSPIN.STS      *********  set UP for SPINors:  ********

WTERMS.STS;22 (WTERMS tsr) Writes the number of TERMS in each tensor component.

 TAPE.HLP -Help on programs that read and write tapes on various machines.

  VMS.HLP       ********   INTRODUCTION    TO    V A X / V M S   **************













                                  APPENDIX A




A.1  ^<<COORDINATE TRANSFORMATIONS^>>

E.g.  a given metric can be transformed by doing:
(TRANSF GDD)    TRANSF then asks for the coordinate connection etc.
TRANSF is a TENVAL function (autoloading).  The result is seen by typing
(WRITE NEW GDD) derivatives occurring in GDD should be substituted
separately by the use of:
(SETSUB TRANSF) -see section 6.2.4 in the SHEEP manual.



A.2  ^<<MACHINES AND INSTALLATION^>>

STENSOR runs with SHEEP on:
The DEC VAX-11 family of machines, unix but also VMS if you emulate unix,
                                        -using Franz-lisp, emulating Slisp.
The ORION from High Level Hardware Ltd, -using Culisp.
Other Culisp machines are planned, like the Cambridge workstation and BBC B
microcomputer with NS32016 second processor.  Small machines are very
interesting for STENSOR, thanks to its automatic disk usage; STENSOR would
probably even on the BBC manage larger computations (though taking weeks) than
other systems would on a VAX (In a recent 30h-computation, the VAX virtual
memory capacity was stretched a factor 100).

INSTALLATION
-is described in the file STS:README.TXT, ie <SHEEP.SHP.STSSRCREADME.TXT
Or on unix @$sts/README.txt ie /sheep/shp/stssrc/README.txt.
You essentially type "make stensor" to unix from the right directory.
This, as well as @@STEUP, does the following:

1) starts SHEEP, and loads STEUP.STS, which in turn:
2) Loads STEUPV.STS     -which loads most important parts, -a naked STENSOR.
3) Loads some further files. Adjust that set for your own purposes by
        editing STEUP.STS.

    The below is PARTLY OUT OF DATE!
STENSOR consists of approximately 54 files of LISP-code.  Previously these were
available in three lisp-dialects:  Lisp 1.6, Slisp and MacLisp - to run with
MACSYMA.  The Lisp 1.6 version was the source and has extension STE.  From that

                                                                Page A-2


translation programs then create the Slisp-version (extension STS), and the
MacLisp version (STN).  In summary:

Extension:      Contains:       Translator on:  VAX/VMS TOPS-10  ITS:

STE     (STEnsor *source* code (Lisp1.6)).
STS     (STenSor for Slisp/SHEEP)       TR.COM  TRA.MIC
STN     (STeNsor for Nil/MacLisp/MACSYMA) EMACS:  M-X Load Lib LISP16 TEC
Now STS is the source for STN


The filenames lexical order usually depicts their position in the hierarchy:

        Contains
File-   routines de-   Remarks:      Hierarchic importance/dependence:
family: scribed in:

BAS*            Basic routines.      (Most) Are required in all below.
PDEF*   Ch 2    PDEF and related routines.      Required in all below
                Cmnds described in chapter "IN/OUT-PUT.."
QTCOM*  Ch 4    The Tensor compiler (not required below, requiring above)
SDEF*           Simplifier (SDEF)
TEDEF*  Ch 3    Evaluator (EDEF)
TSR*    Ch 3    Additionals
U*              SUpergravity facilities

The rest about the old version on DEC:  In the translation process to Slisp,
the comments in .STE don@'t survive into *.STS.  So to be able to read the
code-comments requires a copy of the STE-files.
The main commands have short selfloading definitions in the small file
SELFLD.STS.
This should be loaded permanently into the EXE-file versions of SHEEP.

First replace in SELFLD.STS the single occurrence of "(124.  625.)" with the
proper (decimal, if ".") PROJECT-programmer number for the disk area where
*.STS are located (or () if they are on your default).

The file SELFLD.STS should be loaded either at the end of laying up the EXE
file or after .RUN CORD etc.
After doing

(DSKIN (SELFLD.STS))

instructions are also given how to take in LAP files without leaving LAP in the
resulting SAV file.
These instructions should be followed to take in also the short file SUMMER.lap
and, if making CORD or FRAME.sav, RICCPL.lap which is a compiler construction
for computing RIC which is faster than the standard one.
End up with
@^C              and
@.save cord

                                                                Page A-3


.E
.P



